#ifndef NKC_IMAGE_FILE_JPG_L3_H
#define NKC_IMAGE_FILE_JPG_L3_H
#include "NKC_Image_File_JPG_L2.h"
#include "NKC_Image_File_JPG_ExifTags_L1.h"

/*
	m[c|@p File I/O Interface: Jpeg Interface Level-3 Class

	Copyright(C) 2001 Ichikawa Soft Laboratory

	ClassJpegLevel-3Access邽߂Interface ClassłB

*/

//@@Output: ECOLORSPACETYPE& type tH[}bg̎ށBȉ̒lԂ܂B
//@@@@@@@@ERGB c ʏ RGB
//@@@@@@@@ECMYK c CMYK tH[}bg
//@@@@@@@@EGRAYSCALE c OCXP[J[
//@@@@@@@@EINDEXCOLOR c CfbNXJ[ɂ RGB
typedef enum {
	ERGB = 0,
	ECMYK = 1,
	EGRAYSCALE = 2,
	EINDEXCOLOR = 3,
	EUNKNOWN = 4,
} ECOLORSPACETYPE;

// (NIFIO0020)
class NKC_Image_File_JPG_L3 : public NKC_Image_File_JPG_L2 {
public:
	// ۑ`̐ݒp萔̒ǉ ////////////////////////////////////////////////////
	enum {
		modeWriteExifLevel3 = 4,
		AllOpenModeExifLevel3 = 7
	};
public:
	virtual ~NKC_Image_File_JPG_L3() {};
public:
	// EXIF ̃^O擾
	virtual BOOL GetExifTags(NKC_Image_File_JPG_ExifTags* pTags) = 0;
	/*
	Output: pTags	^O񂪂Ɋi[B
	Return: ǂ
	*/

	// EXIF ̃^O
	virtual BOOL SetExifTags(NKC_Image_File_JPG_ExifTags* pTags) = 0;
	/*
	Input: pTags ރ^O
	Return: ǂ
	*/

	// TlC̏ݒ肷
	virtual BOOL SetExifThumbnailInfo(CSize size, BOOL bIsExistYohaku, int nQuality) = 0;
	/*
	Input: 
		size	TlC̃TCY
		bIsExistYohaku	w肵TlCTCY̏cɑ΂
			摜̏c̃sNZ䂪ႤꍇɂǂU镑w肷B
			TRUE ... 摜ŜTlCɎ܂悤ɂB
			]ł邪A] RGB = (255, 255, 255) Ŗ߂B
			FALSE ... ]Ȃ悤ɂBTlCTCY͂ݏoꍇ
			B̏ꍇA͂ݏo̓TlCɊ܂܂ȂB
		nQuality	TlC JPEG ̕iWB -1 ` 100 włB
			0 ` 100 ̏ꍇ͎w肵lgB-1 ̏ꍇ͌摜̕iWgB
	Return: ǂ
	*/

	// JPEG̃J[Xy[X擾
	virtual BOOL GetOriginalColorSpace(ECOLORSPACETYPE& type) = 0;
};
#endif	// NKC_IMAGE_FILE_JPG_L3_H
