// NpsBcThread.cpp: CNpsBcThread NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsBcThread.h"
#include "SendCmdBuffer.h"
#include "NpsPrinterChecker.h"
#include "PseudoIPAddr.h"

extern DWORD g_dwConnectMode;		// iڑ[h

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : int WINAPI NpsBcThreadEntry()
//	ABSTRACT : MXbh̃Gg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.05.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
unsigned int WINAPI NpsBcThreadEntry( LPVOID pParam )
{
	CNpsBcThread* pNpsBcThread = (CNpsBcThread*)pParam;

	NPS_LOGOUT( ">>> Nps Bc Thread Start" );
	if ( TRUE == pNpsBcThread->ThreadInitInstance() )
	{
		pNpsBcThread->ThreadExecProc();
		pNpsBcThread->ThreadExitInstance();
	}
	NPS_LOGOUT( "<<< Nps Bc Thread End" );

	return 0;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::CNpsBcThread()
//	ABSTRACT : RXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : S.Heya		2008.10.24
//////////////////////////////////////////////////////////////////////////////
CNpsBcThread::CNpsBcThread(CNpsPrinterChecker* pNpsPrinterChecker /*= NULL*/)
{
	m_bUnicast	= FALSE;

	m_Socket = INVALID_SOCKET;

	m_dwInAddr = NkcComApi::htonl(INADDR_ANY);

	m_pNpsPrinterChecker = pNpsPrinterChecker;		// 2008.10.24 S.Heya
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::~CNpsBcThread()
//	ABSTRACT : fXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsBcThread::~CNpsBcThread()
{

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::SendSearchCmd()
//	ABSTRACT : v^mR}hM
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : T.Isogai		2008.9.17 RD-129 HUBXΉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread::SendSearchCmd()
{
	int nResult;
	WORD wPort;
	SOCKADDR_IN ServAddrIn;
	CSendCmdBuffer SendCmdBuf;

	if ( INVALID_SOCKET == m_Socket )
	{
		return FALSE;
	}

	// |[gԍ̎擾
	int nSize;
	SOCKADDR SockAddr;

	nSize = sizeof( SockAddr );
	::ZeroMemory( &SockAddr , nSize );
	::getsockname( m_Socket, &SockAddr, &nSize );
	wPort = (WORD)( SockAddr.sa_data[0]<<8 ) + (UCHAR)SockAddr.sa_data[1];

	// T[o[̃Zbg
	ServAddrIn.sin_family		= AF_INET;

	// T.Isogai 2008.9.17 RD-129 HUBXΉ
	if( m_bUnicast )
	{
		ServAddrIn.sin_addr.s_addr	= NkcComApi::htonl( INADDR_LOOPBACK );
	}
	else
	{
		ServAddrIn.sin_addr.s_addr	= NkcComApi::htonl(INADDR_BROADCAST);
	}

	ServAddrIn.sin_port			= NkcComApi::htons(NPS_UDP_SERVER_PORT);

	// MR}h̍쐬
	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		return FALSE;
	}
	SendCmdBuf.AddHeader( 0x000F, 0x0100 );
	SendCmdBuf.AddTagFooter();

	// M
	nResult = ::sendto( m_Socket, (const char*)SendCmdBuf.GetBuffer(), SendCmdBuf.GetBufferLen(), 0, (SOCKADDR*)&ServAddrIn, sizeof(SOCKADDR_IN) );

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::SendSearchCmd2()
//	ABSTRACT : v^m2R}hM
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread::SendSearchCmd2()
{
	int nResult;
	WORD wPort;
	SOCKADDR_IN ServAddrIn;
	CSendCmdBuffer SendCmdBuf;

	if ( INVALID_SOCKET == m_Socket )
	{
		return FALSE;
	}

	// |[gԍ̎擾
	int nSize;
	SOCKADDR SockAddr;

	nSize = sizeof( SockAddr );
	::ZeroMemory( &SockAddr , nSize );
	::getsockname( m_Socket, &SockAddr, &nSize );
	wPort = (WORD)( SockAddr.sa_data[0]<<8 ) + (UCHAR)SockAddr.sa_data[1];

	// T[o[̃Zbg
	ServAddrIn.sin_family		= AF_INET;

	// T.Isogai 2008.9.17 RD-129 HUBXΉ
	if( m_bUnicast )
	{
		ServAddrIn.sin_addr.s_addr	= NkcComApi::htonl( INADDR_LOOPBACK );
	}
	else
	{
		ServAddrIn.sin_addr.s_addr	= NkcComApi::htonl(INADDR_BROADCAST);
	}

	ServAddrIn.sin_port			= NkcComApi::htons(NPS_UDP_SERVER_PORT_2);

	// MR}h̍쐬
	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		return FALSE;
	}
	SendCmdBuf.AddHeader( 0x000F, 0x0200 );
	SendCmdBuf.AddTagFooter();

	// M
	nResult = ::sendto( m_Socket, (const char*)SendCmdBuf.GetBuffer(), SendCmdBuf.GetBufferLen(), 0, (SOCKADDR*)&ServAddrIn, sizeof(SOCKADDR_IN) );

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::ThreadInitInstance()
//	ABSTRACT : XbhJn
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : H.Kamiya		2015.12.03 v^mv2Mǉ
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread::ThreadInitInstance()
{
	BOOL bBroadcast = TRUE;

	//----------------------------------------
	// M\Pbg̍쐬
	//----------------------------------------

	SOCKADDR_IN AddrIn;
	int nResult;
	BOOL nRet = FALSE;

	AddrIn.sin_family			= AF_INET;
	AddrIn.sin_addr.S_un.S_addr	= m_dwInAddr;
	AddrIn.sin_port				= NkcComApi::htons(0);

	// \Pbg쐬
	m_Socket = ::socket( AF_INET, SOCK_DGRAM, 0 );

	if ( INVALID_SOCKET == m_Socket )
	{
		return FALSE;
	}

	// u[hLXgLɂ
	nResult = ::setsockopt( m_Socket, SOL_SOCKET, SO_BROADCAST, (CHAR*)&bBroadcast, sizeof(BOOL));

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	// \Pbg̃oCh
	nResult = ::bind( m_Socket, (SOCKADDR FAR *)&AddrIn, sizeof(SOCKADDR_IN) );

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	//----------------------------------------
	// mR}hM
	//----------------------------------------
	nRet |= SendSearchCmd();
	nRet |= SendSearchCmd2();
	if ( !nRet )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::ThreadExecProc()
//	ABSTRACT : Xbh
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread::ThreadExecProc()
{

	int nSize;
	int nRecvLen;
	BYTE byBuffer[1028];				// R}h̍őTCY1024Byte + R}hwb_4Byte
	SOCKADDR_IN	SockAddr;
	LPTSTR lpszAddr;
	DWORD dwHostAddress;
	TCHAR szHostAddress[64];

	nSize = sizeof(SOCKADDR_IN);

	while (1)
	{
		::ZeroMemory( byBuffer, sizeof(byBuffer) );
		::ZeroMemory( &SockAddr , sizeof(SockAddr) );

		nRecvLen = ::recvfrom( m_Socket, (char*)&byBuffer, sizeof(byBuffer), 0, 
								(SOCKADDR FAR*)&SockAddr, &nSize );

		if ( SOCKET_ERROR == nRecvLen )
		{
			return;
		}

		lpszAddr = inet_ntoa(SockAddr.sin_addr);
		dwHostAddress = SockAddr.sin_addr.S_un.S_addr;

		if ( NULL != lpszAddr )
		{
			::lstrcpy( szHostAddress, lpszAddr );
		}
		else
		{
			continue;
		}

		AddPrinterInfo( byBuffer, dwHostAddress, szHostAddress );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::ThreadExitInstance()
//	ABSTRACT : XbhI
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread::ThreadExitInstance()
{
	// Ô߃\PbgN[Y܂
	if ( INVALID_SOCKET != m_Socket )
	{
		::closesocket( m_Socket );
		m_Socket = INVALID_SOCKET;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::ThreadEnd()
//	ABSTRACT : XbhIv
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread::ThreadEnd()
{
	// \PbgN[Y܂
	::closesocket( m_Socket );
	m_Socket = INVALID_SOCKET;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::AddPrinterInfo()
//	ABSTRACT : NPSR}h̉͂sAv^Xgɒǉ
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread::AddPrinterInfo( LPBYTE lpBuffer, DWORD dwHostAddress, TCHAR * szHostAddress )
{
	WORD wIfId;			// C^[tFCXID
	WORD wCmdId;		// R}hID

	if ( FALSE == ReadCmdHdr( lpBuffer, wIfId, wCmdId ) )
	{
		return;
	}

	ULONG id = MAKELONG( wCmdId, wIfId );

	switch ( id )
	{
	case 0x000F0101 :
		AddPrinterInfoOld( lpBuffer, dwHostAddress, szHostAddress );
		break;
	case 0x000F0201 :
		AddPrinterInfoNew( lpBuffer, dwHostAddress, szHostAddress );
		break;
	default :
		break;
	}

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::AddPrinterInfoOld()
//	ABSTRACT : v^̒ǉ(000FH/0101Hp)
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread::AddPrinterInfoOld( LPBYTE lpBuffer, DWORD dwHostAddress, TCHAR * szHostAddress )
{
	T_NpsPrinterInfo tNpsPrinterInfo;
	UINT nPort = 0;
	int Type = NPS_DATATYPE_TAG_NO;
	USHORT TagNo;
	USHORT Length;
	BYTE* pBufAtt;
	unsigned long Counter = 0;

	pBufAtt	= lpBuffer + sizeof( DWORD );
	ZeroMemory( &tNpsPrinterInfo, sizeof( T_NpsPrinterInfo ) );

	// Mf[^ǂݎ
	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			TagNo	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			TagNo	= NkcComApi::ntohs( TagNo );

			if( 0 == TagNo )
			{
				break;
			}

			Type	= NPS_DATATYPE_TAG_LENGTH;
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			Length	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			Length	= NkcComApi::ntohs( Length );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ memcpy( &tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName,		&pBufAtt[ Counter ], Length ); } break;
			case 2:{ memcpy( &tNpsPrinterInfo.Nps000FH_0101H.SerialNumber,			&pBufAtt[ Counter ], Length ); } break;
			case 3:
				{
					for( int i = 0; i < 8; i++ )
					{
						USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ Counter + sizeof( USHORT ) * i ];
						tNpsPrinterInfo.Nps000FH_0101H.SupportResolutions[i]	= NkcComApi::ntohs( *pusTmp );
					}
				}
				break;
			case 4:
				{
					USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ Counter ];
					tNpsPrinterInfo.Nps000FH_0101H.NpsVersion	= NkcComApi::ntohs( *pusTmp );
				}
				break;
			case 5:{ memcpy( &tNpsPrinterInfo.Nps000FH_0101H.MacAddress,			&pBufAtt[ Counter ], Length ); } break;
			case 6:{ memcpy( &tNpsPrinterInfo.Nps000FH_0101H.SoftName,				&pBufAtt[ Counter ], Length ); } break;
			default:break;
			}

			Counter += Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}
	}

#ifdef NPS_OEM_PRINTER								// 2008.10.24 S.Heya

	CString str;
	str.Format(" --%s was found out.", tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName);
	NPS_LOGOUT(str);

	switch ( g_dwConnectMode )
	{
	case 0x00000000:	// NKCî݋AOEM(FUJI)i͋Ȃ
	default:

		// @햼ɂOEMv^[ł邩𒲂ׂ
		if (TRUE == NkcComApi::IsOemPrinterByName(tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName))
		{
			str.Format(" --%s[%s] is OEM Product.", tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName, szHostAddress);
			NPS_LOGOUT(str);
			return;
		}

		// @sȏꍇAv^{OEMR[h𒲂ׂ
		if (FALSE == NkcComApi::IsNoritsuPrinterByName(tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName))
		{
			::memcpy(tNpsPrinterInfo.szIP, szHostAddress, sizeof( TCHAR ) * 16);
			m_pNpsPrinterChecker->AddCheckPrinter(&tNpsPrinterInfo);
			return;
		}

		break;

	case 0x00000001:	// NKCi͋ȂAOEM(FUJI)î݋

		// @햼ɂm[cv^[ł邩𒲂ׂ
		if (TRUE == NkcComApi::IsNoritsuPrinterByName(tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName))
		{
			str.Format(" --%s[%s] is NKC Product.", tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName, szHostAddress);
			NPS_LOGOUT(str);
			return;
		}

		// @sȏꍇAv^{OEMR[h𒲂ׂ
		if (FALSE == NkcComApi::IsOemPrinterByName(tNpsPrinterInfo.Nps000FH_0101H.MachineTypeName))
		{
			::memcpy(tNpsPrinterInfo.szIP, szHostAddress, sizeof( TCHAR ) * 16);
			m_pNpsPrinterChecker->AddCheckPrinter(&tNpsPrinterInfo);
			return;
		}

		break;

	case 0x0FEDCBA0:	// NKCꃂ[h (SĂ)
	case 0x0FEDCBA1:	// FUJIꃂ[h (SĂ)
		break;
	}

#endif // NPS_OEM_PRINTER

	// f[^Vectorɒǉ
	memcpy( tNpsPrinterInfo.szIP, szHostAddress, sizeof( TCHAR ) * 16 );
	m_vPrinterInfo.push_back( tNpsPrinterInfo );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::AddPrinterInfoNew()
//	ABSTRACT : v^̒ǉ(000FH/0201Hp)
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread::AddPrinterInfoNew( LPBYTE lpBuffer, DWORD dwHostAddress, TCHAR * szHostAddress )
{
	T_NpsPrinterInfo tNpsPrinterInfo[4];
	UINT nPort = 0;
	int Type = NPS_DATATYPE_TAG_NO;
	USHORT TagNo;
	USHORT Length;
	BYTE* pBufAtt;
	unsigned long Counter = 0;
	USHORT PrinterNum = 0;

	pBufAtt	= lpBuffer + sizeof( DWORD );
	ZeroMemory( &tNpsPrinterInfo, sizeof( T_NpsPrinterInfo ) );

	// Mf[^ǂݎ
	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			TagNo	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			TagNo	= NkcComApi::ntohs( TagNo );

			if( 0 == TagNo )
			{
				break;
			}

			Type	= NPS_DATATYPE_TAG_LENGTH;
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			Length	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			Length	= NkcComApi::ntohs( Length );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:
				{
					PrinterNum = NkcComApi::ntohs( *(( USHORT* ) &pBufAtt[ Counter ]) );
				}
				break;
			case 2:
				{
					int nArrayPos	= 0;
					int nStrPos		= 0;
					BYTE*	pSrc	= pBufAtt + Counter;

					for( int idx = 0; idx < Length; idx++ )
					{
						tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.MachineTypeName[nStrPos] = pSrc[idx];

						if( 0 == pSrc[idx] )
						{
							nArrayPos++;
							nStrPos	= 0;
						}
						else
						{
							nStrPos++;
						}
					}
				}
				break;
			case 3:
				{
					int nArrayPos	= 0;
					int nStrPos		= 0;
					BYTE*	pSrc	= pBufAtt + Counter;

					for( int idx = 0; idx < Length; idx++ )
					{
						tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.SerialNumber[nStrPos] = pSrc[idx];

						if( 0 == pSrc[idx] )
						{
							nArrayPos++;
							nStrPos	= 0;
						}
						else
						{
							nStrPos++;
						}
					}
				}
				break;
			case 4:
				{
					int pos = Counter;
					for( int nArrayPos = 0; nArrayPos < PrinterNum; nArrayPos++)
					{
						for( int i = 0; i < 8; i++ )
						{
							USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ pos ];
							tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.SupportResolutions[i]	= NkcComApi::ntohs( *pusTmp );
							pos += sizeof( USHORT );
						}
					}
				}
				break;
			case 5:
				{
					int pos = Counter;
					for( int nArrayPos = 0; nArrayPos < PrinterNum; nArrayPos++)
					{
						USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ pos ];
						tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.NpsVersion	= NkcComApi::ntohs( *pusTmp );
						pos += sizeof( USHORT );
					}
				}
				break;
			case 6:
				{
					int pos = Counter;
					for( int nArrayPos = 0; nArrayPos < PrinterNum; nArrayPos++)
					{
						for( int i = 0; i < 6; i++ )
						{
							UCHAR* pucTmp	= ( UCHAR* ) &pBufAtt[ pos ];
							tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.HostMacAddress[i]	= *pucTmp;
							pos += sizeof( UCHAR );
						}
					}
				}
				break;
			case 7:
				{
					int nArrayPos	= 0;
					int nStrPos		= 0;
					BYTE*	pSrc	= pBufAtt + Counter;

					for( int idx = 0; idx < Length; idx++ )
					{
						tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.SoftName[nStrPos] = pSrc[idx];

						if( 0 == pSrc[idx] )
						{
							nArrayPos++;
							nStrPos	= 0;
						}
						else
						{
							nStrPos++;
						}
					}
				}
				break;
			case 8:
				{
					int pos = Counter;
					for( int nArrayPos = 0; nArrayPos < PrinterNum; nArrayPos++)
					{
						USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ pos ];
						tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.NpsPortNo	= NkcComApi::ntohs( *pusTmp );
						pos += sizeof( USHORT );
					}
				}
				break;
			case 9:
				{
					int pos = Counter;
					for( int nArrayPos = 0; nArrayPos < PrinterNum; nArrayPos++)
					{
						USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ pos ];
						tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.ImgPortNo	= NkcComApi::ntohs( *pusTmp );
						pos += sizeof( USHORT );
					}
				}
				break;
			case 10:
				{
					int pos = Counter;
					for( int nArrayPos = 0; nArrayPos < PrinterNum; nArrayPos++)
					{
						ULONG* pusTmp	= ( ULONG* ) &pBufAtt[ pos ];
						tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.PrinterIPAddress	= NkcComApi::ntohl( *pusTmp );
						pos += sizeof( ULONG );
					}
				}
				break;
			case 11:
				{
					int pos = Counter;
					for( int nArrayPos = 0; nArrayPos < PrinterNum; nArrayPos++)
					{
						for( int i = 0; i < 6; i++ )
						{
							UCHAR* pucTmp	= ( UCHAR* ) &pBufAtt[ pos ];
							tNpsPrinterInfo[nArrayPos].Nps000FH_0201H.PrinterMacAddress[i]	= *pucTmp;
							pos += sizeof( UCHAR );
						}
					}
				}
				break;
			default:
				break;
			}

			Counter += Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}
	}

	// f[^Vectorɒǉ
	for( int i = 0; i < PrinterNum; i++ )
	{
		// v^[IPAhXZbgĂȂꍇARIPƂ̊֘AtsĂȂƔf
		if( 0L != tNpsPrinterInfo[i].Nps000FH_0201H.PrinterIPAddress  )
		{
			// MACAhXANPSp|[gԍAv^[IPAhX[IPAhX擾
			DWORD ipAddr = CPseudoIPAddr::GetInstance()->FindByHostIPAddr(
					dwHostAddress,
					tNpsPrinterInfo[i].Nps000FH_0201H.HostMacAddress,
					tNpsPrinterInfo[i].Nps000FH_0201H.NpsPortNo,
					tNpsPrinterInfo[i].Nps000FH_0201H.ImgPortNo,
					tNpsPrinterInfo[i].Nps000FH_0201H.PrinterIPAddress,
					tNpsPrinterInfo[i].Nps000FH_0201H.PrinterMacAddress
					);

			// o^̃v^MACAhXANPSp|[gԍƕRÂPrinterIPAddress[IPAhXƂăXgǉ
			if( 0L == ipAddr )
			{
				ipAddr = CPseudoIPAddr::GetInstance()->Add(
						dwHostAddress,
						tNpsPrinterInfo[i].Nps000FH_0201H.HostMacAddress,
						tNpsPrinterInfo[i].Nps000FH_0201H.NpsPortNo,
						tNpsPrinterInfo[i].Nps000FH_0201H.ImgPortNo,
						tNpsPrinterInfo[i].Nps000FH_0201H.PrinterIPAddress,
						tNpsPrinterInfo[i].Nps000FH_0201H.PrinterMacAddress
						);
			}

			if( 0L != ipAddr )
			{
				struct in_addr addr;
				addr.S_un.S_addr = ipAddr;
				LPTSTR lpszAddr = inet_ntoa(addr);
				TCHAR szAddress[64];
				::lstrcpy( szAddress, lpszAddr );
				memcpy( tNpsPrinterInfo[i].szIP, szAddress, sizeof( TCHAR ) * 16 );
				m_vPrinterInfo.push_back( tNpsPrinterInfo[i] );
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::ReadCmdHdr()
//	ABSTRACT : NPSR}h̃wb_[擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread::ReadCmdHdr( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId )
{
	WORD wId1;
	WORD wId2;

	::memcpy( &wId1, lpBuffer, sizeof(WORD) );
	::memcpy( &wId2, lpBuffer + sizeof(WORD), sizeof(WORD) );

	wInterfaceId = NkcComApi::ntohs( wId1 );
	wCommandId = NkcComApi::ntohs( wId2 );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::GetPrinterCount()
//	ABSTRACT : v^̎擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CNpsBcThread::GetPrinterCount()
{
	return (int)m_vPrinterInfo.size();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::GetPrinterInfo()
//	ABSTRACT : v^̎擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread::GetPrinterInfo( int nIdx, T_NpsPrinterInfo* pPrinterInfo )
{
	int nCount;

	nCount = (int)m_vPrinterInfo.size();
	if (( nIdx >= 0 ) && ( nIdx < nCount ))
	{
		::MoveMemory( pPrinterInfo, &m_vPrinterInfo[nIdx], sizeof(T_NpsPrinterInfo) );
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread::SetMyPCAddr()
//	ABSTRACT : PCIPAhX̐ݒ
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread::SetMyPCAddr( DWORD dwInAddr )
{
	m_dwInAddr = dwInAddr;
}
