// NpsBcThread2.cpp: CNpsBcThread2 NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsBcThread2.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : int WINAPI NpsBcThreadEntry()
//	ABSTRACT : MXbh̃Gg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.05.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
unsigned int WINAPI NpsBcThread2Entry( LPVOID pParam )
{
	CNpsBcThread2* pNpsBcThread2 = (CNpsBcThread2*)pParam;

	NPS_LOGOUT( ">>> Nps Bc Thread2 Start" );
	if ( TRUE == pNpsBcThread2->ThreadInitInstance() )
	{
		pNpsBcThread2->ThreadExecProc();
		pNpsBcThread2->ThreadExitInstance();
	}
	NPS_LOGOUT( "<<< Nps Bc Thread2 End" );

	return 0;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::CNpsBcThread2()
//	ABSTRACT : RXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsBcThread2::CNpsBcThread2()
{
	m_Socket = INVALID_SOCKET;

	m_dwInAddr = NkcComApi::htonl(INADDR_ANY);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::~CNpsBcThread2()
//	ABSTRACT : fXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsBcThread2::~CNpsBcThread2()
{

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::SendSearchCmd()
//	ABSTRACT : v^mR}hM
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread2::SendSearchCmd()
{
	int nResult;
	WORD wPort;
	SOCKADDR_IN ServAddrIn;
	BYTE byBuffer[32];

	if ( INVALID_SOCKET == m_Socket )
	{
		return FALSE;
	}

	// |[gԍ̎擾
	int nSize;
	SOCKADDR SockAddr;

	nSize = sizeof( SockAddr );
	::ZeroMemory( &SockAddr , nSize );
	::getsockname( m_Socket, &SockAddr, &nSize );
	wPort = (WORD)( SockAddr.sa_data[0]<<8 ) + (UCHAR)SockAddr.sa_data[1];

	// T[o[̃Zbg
	ServAddrIn.sin_family		= AF_INET;
	ServAddrIn.sin_addr.s_addr	= NkcComApi::htonl(INADDR_BROADCAST);
	ServAddrIn.sin_port			= NkcComApi::htons(3449);

	// MR}h̍쐬
	::ZeroMemory( byBuffer, 32 );
	*(USHORT*)byBuffer = NkcComApi::htons( 0x0001 );	// R}h(̑0ł悢)

	// M
	nResult = ::sendto( m_Socket, (const char*)byBuffer, 32, 0, (SOCKADDR*)&ServAddrIn, sizeof(SOCKADDR_IN) );

	if ( SOCKET_ERROR == nResult )
	{
		{	// Oo
			NPS_LOGOUT_FATAL( "===NPSBC SENDTO FAIL" );
		}
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::ThreadInitInstance()
//	ABSTRACT : XbhJn
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread2::ThreadInitInstance()
{
	BOOL bBroadcast = TRUE;

	//----------------------------------------
	// M\Pbg̍쐬
	//----------------------------------------

	SOCKADDR_IN AddrIn;
	int nResult;

	AddrIn.sin_family			= AF_INET;
	AddrIn.sin_addr.S_un.S_addr	= m_dwInAddr;
	AddrIn.sin_port				= NkcComApi::htons(0);

	// \Pbg쐬
	m_Socket = ::socket( AF_INET, SOCK_DGRAM, 0 );

	if ( INVALID_SOCKET == m_Socket )
	{
		return FALSE;
	}

	// u[hLXgLɂ
	nResult = ::setsockopt( m_Socket, SOL_SOCKET, SO_BROADCAST, (CHAR*)&bBroadcast, sizeof(BOOL));

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	// \Pbg̃oCh
	nResult = ::bind( m_Socket, (SOCKADDR FAR *)&AddrIn, sizeof(SOCKADDR_IN) );

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	//----------------------------------------
	// mR}hM
	//----------------------------------------
	if ( FALSE == SendSearchCmd() )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::ThreadExecProc()
//	ABSTRACT : Xbh
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread2::ThreadExecProc()
{

	int nSize;
	int nRecvLen;
	BYTE byBuffer[1028];				// R}h̍őTCY1024Byte + R}hwb_4Byte
	SOCKADDR_IN	SockAddr;
	LPTSTR lpszAddr;
	TCHAR szHostAddress[64];

	nSize = sizeof(SOCKADDR_IN);

	while (1)
	{
		::ZeroMemory( byBuffer, sizeof(byBuffer) );
		::ZeroMemory( &SockAddr , sizeof(SockAddr) );

		nRecvLen = ::recvfrom( m_Socket, (char*)&byBuffer, sizeof(byBuffer), 0, 
								(SOCKADDR FAR*)&SockAddr, &nSize );

		if ( SOCKET_ERROR == nRecvLen )
		{
			return;
		}

		lpszAddr = inet_ntoa(SockAddr.sin_addr);
		if ( NULL != lpszAddr )
		{
			::lstrcpy( szHostAddress, lpszAddr );
		}
		else
		{
			continue;
		}

		AddPrinterIFState( byBuffer, nRecvLen, szHostAddress );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::ThreadExitInstance()
//	ABSTRACT : XbhI
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread2::ThreadExitInstance()
{
	// Ô߃\PbgN[Y܂
	if ( INVALID_SOCKET != m_Socket )
	{
		::closesocket( m_Socket );
		m_Socket = INVALID_SOCKET;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::ThreadEnd()
//	ABSTRACT : XbhIv
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread2::ThreadEnd()
{
	// \PbgN[Y܂
	::closesocket( m_Socket );
	m_Socket = INVALID_SOCKET;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::AddPrinterIFState()
//	ABSTRACT : R}h̉͂sAv^I/FԂXgɒǉ
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.01
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread2::AddPrinterIFState( LPBYTE lpBuffer, int nBufferLen, TCHAR * szHostAddress )
{
	if( nBufferLen != ( 2 + 2 + 6 + 22 ) )
	{	// MTCYقȂ
		{	// Oo
			CString str;
			str.Format( "===NPSBC RECEIVE SIZE ERROR ( %d )" );
			NPS_LOGOUT_FATAL( str );
		}
		return;
	}

	T_NpsPrinterIFState		tNpsPrinterIFState;
	UINT					nPort		= 0;
	USHORT					Command;
	USHORT					Status;
	UCHAR					MacAddress[6];
	BYTE*					pBufAtt;
	unsigned long			Counter	= 0;

	pBufAtt	= lpBuffer;
	ZeroMemory( &tNpsPrinterIFState, sizeof( T_NpsPrinterIFState ) );

	// Mf[^ǂݎ
	// R}h
	Command	= *( (USHORT*)&pBufAtt[ Counter ] );
	Counter += sizeof( USHORT );
	Command	= ntohs( Command );

	// Xe[^X
	Status	= *( (USHORT*)&pBufAtt[ Counter ] );
	Counter += sizeof( USHORT );
	Status	= ntohs( Status );

	// MACAhX
	for( int i = 0; i < COUNTOF(MacAddress); i++ )
	{
		MacAddress[i] = ( UCHAR )( pBufAtt[ Counter ] );
		Counter++;
	}

	if( Command == 2 )
	{	// Xe[^X
		// f[^Vectorɒǉ
		memcpy( tNpsPrinterIFState.MacAddress, MacAddress, sizeof(MacAddress) );
		tNpsPrinterIFState.Status = Status;
		m_vPrinterIFState.push_back( tNpsPrinterIFState );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::GetPrinterCount()
//	ABSTRACT : v^I/F̎擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CNpsBcThread2::GetPrinterCount()
{
	return (int)m_vPrinterIFState.size();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::GetPrinterIFState()
//	ABSTRACT : v^I/F̎擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBcThread2::GetPrinterIFState( int nIdx, T_NpsPrinterIFState* pPrinterIFState )
{
	int nCount;

	nCount = (int)m_vPrinterIFState.size();
	if (( nIdx >= 0 ) && ( nIdx < nCount ))
	{
		::MoveMemory( pPrinterIFState, &m_vPrinterIFState[nIdx], sizeof(T_NpsPrinterIFState) );
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBcThread2::SetMyPCAddr()
//	ABSTRACT : PCIPAhX̐ݒ
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsBcThread2::SetMyPCAddr( DWORD dwInAddr )
{
	m_dwInAddr = dwInAddr;
}
