//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallback.h
//	ABSTRACT  : CNpsCallback NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSCALLBACK_H__9894006E_C09F_4AE9_8EC1_290FE5213779__INCLUDED_)
#define AFX_NPSCALLBACK_H__9894006E_C09F_4AE9_8EC1_290FE5213779__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NpsCommand.h"
#include "NkcComApi.h"
#include "NpsCALLBACKDATA.h"
#include "Nps.h"
#include <vector>

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsCallback
//	ABSTRACT : R[obN{NX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsCallback  
{
public:
	CNpsCallback();											// RXgN^
	virtual ~CNpsCallback();								// fXgN^

	BOOL	SetEvent()	{ return ::SetEvent( m_hEvent ); }	// CxgVOiԂ

	BOOL	IsEmpty();										// R[obNo^Xg󂩒ׂ

protected:

	HANDLE	m_hEvent;										// Cxgnh

	std::vector<CNpsCALLBACKDATA*>	m_vectorCALLBACKDATA;		// R[obNo^Xg

	////////////////////////////////////////////////////////////////////////////
	// 㑤̊֐́AAfxBeginThread() ɗ^邽߂ static KvŁAł
	// NXϐɃANZX̂ʓ|Ȃ̂ŁANX֐̉֐Ăяo
	// sĂ܂
	CWinThread*		m_pWinThread;							// Xbhnh
	HANDLE			m_hExitEvent;							// IpCxgnh
	static UINT		CallbackThread( LPVOID pParam );		// Xbh֐
	UINT			Callback();								// CallbackThreadĂяo֐
	void			EndObject();							// IuWFNg̏I

	CNpsCALLBACKDATA* PopCallbackData();					// Xg珈vo

	virtual void	CallCallback( CNpsCALLBACKDATA* pCALLBACKDATA ) = 0;// R[obNďo

	CRITICAL_SECTION	m_CS;								// NeBJZNV
};

#endif // !defined(AFX_NPSCALLBACK_H__9894006E_C09F_4AE9_8EC1_290FE5213779__INCLUDED_)
