//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallbackControl.h
//	ABSTRACT  : CNpsCallbackControl NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSCALLBACKCONTROL_H__1952D74F_6D84_4E45_80CF_136A586E349B__INCLUDED_)
#define AFX_NPSCALLBACKCONTROL_H__1952D74F_6D84_4E45_80CF_136A586E349B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NkcComApi.h"
#include "NpsCallback.h"
#include "NpsCallbackEvent.h"
#include "NpsCallbackCompletion.h"
#include "NpsCallbackUnit.h"
#include <vector>

class CNpsCallbackControl  
{
public:
	CNpsCallbackControl();										// RXgN^
	virtual ~CNpsCallbackControl();								// fXgN^

	BOOL			AddCallback( CNpsCallback * pCallback );	// CNpsCallbackIuWFNgXgɒǉ
	CNpsCallback*	GetCallback( WORD IfId, WORD CmdId );		// CNpsCallbackIuWFNgXg擾iNeBJZNVj

	BOOL			SetBuf( WORD wIfId, WORD wCmdId, BYTE * lpBuff, unsigned long AttSize );// CNpsCallbackIuWFNgփf[^

protected:

	std::vector<CNpsCallback*>	m_vectorCallback;					// CNpsCallbackXg
	CRITICAL_SECTION		m_CS;								// NeBJZNV

	CNpsCallback*	GetCallbackNotCS( WORD IfId, WORD CmdId );	// CNpsCallbackIuWFNgXg擾iNeBJZNVȂj

};

#endif // !defined(AFX_NPSCALLBACKCONTROL_H__1952D74F_6D84_4E45_80CF_136A586E349B__INCLUDED_)
