//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallbackUnit.cpp
//	ABSTRACT  : CNpsCallbackUnit NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsCallbackUnit.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackUnit::CNpsCallbackUnit()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackUnit::CNpsCallbackUnit()
: CNpsCallback()
{
	m_pFunc	= NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackUnit::~CNpsCallbackUnit()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackUnit::~CNpsCallbackUnit()
{
	EndObject();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackUnit::AddNpsCALLBACKDATA()
//	ABSTRACT : CNpsCALLBACKDATA_UnitIuWFNgXgɒǉ
//	FUNCTION : CNpsCALLBACKDATA_UnitIuWFNgXgɒǉ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.21
//	UPDATE   : T.Isogai	2008.7.31	}KWASy[p[̏ԍXVs߂̑Ήis00504j
//									m_pFunc  NULL łĂ bPaperChange bAllPaperChange  TRUE łΏs
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallbackUnit::AddNpsCALLBACKDATA( NPSUNITNOTIFYINFO UnitInfo, BOOL bPaperChange, BOOL bAllPaperChange )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	if( ( NULL == m_pFunc ) && !( bPaperChange || bAllPaperChange ) )
	{
		return;
	}

	CNpsCALLBACKDATA_Unit* pCALLBACKDATA;
	try
	{
		pCALLBACKDATA = new CNpsCALLBACKDATA_Unit;
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [pCALLBACKDATA]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return;
	}
	pCALLBACKDATA->m_UnitInfo			= UnitInfo;
	pCALLBACKDATA->m_bPaperChange		= bPaperChange;
	pCALLBACKDATA->m_bAllPaperChange	= bAllPaperChange;

	m_vectorCALLBACKDATA.push_back( pCALLBACKDATA );
	SetEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackUnit::CallCallback()
//	ABSTRACT : R[obN֐Ăяo
//	FUNCTION : R[obN֐Ăяo
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallbackUnit::CallCallback( CNpsCALLBACKDATA* pCALLBACKDATA )
{
	CNpsCALLBACKDATA_Unit * pData	= ( CNpsCALLBACKDATA_Unit * ) pCALLBACKDATA;

	// y[p[̎擾̂
	if( pData->m_bPaperChange )
	{
		T_Nps6000H_0401H	wNps6000H_0401H;
		m_pNpsCmd->GetPaper( NULL, &wNps6000H_0401H );
		return;
	}

	// Sy[p[̎擾̂
	if( pData->m_bAllPaperChange )
	{
		T_Nps6000H_1301H	wNps6000H_1301H;
		m_pNpsCmd->GetAllPaper( NULL, &wNps6000H_1301H );
		return;
	}

	if( NULL == m_pFunc	)
	{
		return;
	}

	{	// Oo
		CString str;
		in_addr tAddr;
		tAddr.S_un.S_addr = pData->m_UnitInfo.dwIPAddress;
		str.Format( "<Callback> NPSUNITPROC hPrinter=0x%08x, dwIPAddress=%d.%d.%d.%d, wPortNo=%d, lUnitId=0x%08x, iNewStatus=0x%04x, iOldStatus=0x%04x",
			pData->m_UnitInfo.hPrinter,
			tAddr.S_un.S_un_b.s_b1,
			tAddr.S_un.S_un_b.s_b2,
			tAddr.S_un.S_un_b.s_b3,
			tAddr.S_un.S_un_b.s_b4,
			pData->m_UnitInfo.wPortNo,
			pData->m_UnitInfo.lUnitId,
			pData->m_UnitInfo.iNewStatus,
			pData->m_UnitInfo.iOldStatus
			);
		NPS_LOGOUT( str );
	}

	( ( NPSUNITPROC )( m_pFunc ) )( &( pData->m_UnitInfo ) );

	{	// Oo
		//NPS_LOGOUT( "<Callback return> NPSUNITPROC" );
	}
}
