// OrderData.h: COrderData NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORDERDATA_H__84D0766F_27FC_434A_8370_FCE2797AE644__INCLUDED_)
#define AFX_ORDERDATA_H__84D0766F_27FC_434A_8370_FCE2797AE644__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FrameData.h"
#include "FrameDataPrint.h"
#include "FrameDataSort.h"
#include "FrameDataDuplex.h"
#include "FrameDataRetransmission.h"
#include "NpsImg.h"

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : COrderData
//	ABSTRACT : I[_[
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu	2006.9.20
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
class COrderData  
{
public:
	COrderData();
	virtual ~COrderData();

public:

	//----------------------------------------
	// {
	//----------------------------------------
	E_PrintOrderStep	m_eOrderStep;		// vgv̔s

	DWORD		m_dwOrderId;				// I[_[ID
	DWORD		m_dwSortFrame;				// R}̃\[g@\
	USHORT		m_nPossessionNo;			// Lԍ
	USHORT		m_nFirstPossessionNo;		// Lԍi tJnv(6000H-0700)̃I[_[ʎqɎgp j
	void *		m_pCompletionProc;			// vg󋵒ʒmR[obN֐|C^iI[_[j
	BOOL		m_bIsMaintenance;			// eiX[hǂi TRUE:e[hł, FALSE:e[hłȂ j
	USHORT		m_nInterruptMode;			// 荞݃[hi 0:荞݂Ȃ, 1:荞݂ j
	DWORD		m_dwOption;					// ꏈIvV
	DWORD		m_dwLatestIndexNo;			// CfbNXԍ (m_vFrame֓o^f[^SĂɊ蓖Ă郆j[NȔԍ)
	DWORD		m_dwExOptions;				// gIvV(Pvg) 2014.10.28 M.Yamamoto
											// EX_OPTIONS_NONE        : gIvVȂ
											// EX_OPTIONS_SINGLE_LINE : Pvg

	DWORD		GetLatestIndexNo();			// ŐṼCfbNXԍԂ

	//----------------------------------------
	// I[_[Jn
	//----------------------------------------
	USHORT		m_nNpsImgPort;				// 摜Mp̃|[gԍ
	USHORT		m_nSorterNum;				// vg̎divgIvVݒj

	BOOL		m_bReOccupy;				// }ݏI̍ĐLǂ(V^(RD-151)ɂĎgp)		@@@RD-151Ή 2012.05.08 T.Mizushima

	//----------------------------------------
	// I[_[t
	//----------------------------------------
	BOOL		m_bEndOrder;				// EndOrdertς

	//----------------------------------------
	// R}
	//----------------------------------------
	std::vector<CFrameData*>	m_vFrame;	// R}NX̊Ǘ̈

	CFrameData*	GetFrameData( DWORD dwPrintId );			// t[̎擾
	BOOL		DeleteFrameData( DWORD dwPrintId );			// t[̍폜
	CFrameData*	GetFrameDataByReceiptNo( ULONG ReceiptNo );	// t[̎擾itԍwj
	CFrameData*	GetFrameDataByReceiptNo2( ULONG ReceiptNo );// t[̎擾itԍwjtԍ܂Ō

};

#endif // !defined(AFX_ORDERDATA_H__84D0766F_27FC_434A_8370_FCE2797AE644__INCLUDED_)
