// PrintQue.h: CPrintQue NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTQUE_H__482D13C4_BB64_49BC_BD34_1FD445E257E1__INCLUDED_)
#define AFX_PRINTQUE_H__482D13C4_BB64_49BC_BD34_1FD445E257E1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "OrderData.h"
#include "NkcComApi.h"
#include "DataManager.h"
#include "NpsCallbackCompletion.h"
#include "NpsCmd.h"

#include <afxtempl.h>	// CList

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CPrintQue
//	ABSTRACT : vgL[ǗNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu	2006.9.20
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
class CPrintQue  
{
public:
	CPrintQue();
	virtual ~CPrintQue();

	//----------------------------------------
	// {̓o^
	//----------------------------------------
	void	Init(
		DWORD						dwIPAddress,			// v^IPAhX
		USHORT						wNpsPortNo,				// v^NPSp|[gԍ
		HPRINTER					hPrinter,				// v^nh
		CNpsCallbackCompletion*		pCallbackCompletion,	// vg󋵒ʒmNX
		CNpsCmd*					pNpsCmd,				// R}hMNX̃|C^
		CNpsImgManager*				pNpsImgMng,				// \PbgʐMNXǗ(r)NX
		CDataManager*				pDataManager			// v^ǗNX
		);

	//----------------------------------------
	// JE^Ǘ
	//----------------------------------------
	DWORD	GetLatestPrintIdInc();						// CNgvgIDCNgĎ擾

	DWORD	GetOrderIdNormal();							// tOrderId@ʏ 擾
	DWORD	GetOrderIdExpress();						// tOrderId@}(Level1) 擾
	DWORD	GetOrderIdExpressL2();						// tOrderId@}(Level2) 擾
	void	SetOrderIdNormal( DWORD OrderIdNormal );	// tOrderId@ʏ ݒ
	void	SetOrderIdExpress( DWORD OrderIdExpress );	// tOrderId@}(Level1) ݒ
	void	SetOrderIdExpressL2( DWORD OrderIdExpressL2 );// tOrderId@}(Level2) ݒ

	void	ResetOrderStep( const DWORD dwOrderId, const DWORD dwIndexNo = 0 );

	//----------------------------------------
	// I[_[̓o^
	//----------------------------------------

			// StartOrder̓o^
	BOOL	AddStartOrder(
						void *				pCompletionProc,
						BOOL				bOccupyStart,
						USHORT				nPossessionMode,
						USHORT				nInterruptMode,
						DWORD				dwOption,
						USHORT				PossessionNo,
						USHORT				nPort,
						USHORT				nSorterNum,
						DWORD				dwSortFrame,
						DWORD				*pOrderId,
						BOOL				bIsMaintenance,
						DWORD				dwExOptions	// gIvV(Pvg) 2014.10.28 M.Yamamoto
														// EX_OPTIONS_NONE        : gIvVȂ
														// EX_OPTIONS_SINGLE_LINE : Pvg
						);

			// EndOrder̓o^
	BOOL	AddEndOrder(
						DWORD				dwOrderId
						);

			// Print̓o^
	BOOL	AddPrint(
				DWORD				dwOrderId,		// I[_[ID
				DWORD				dwPrintId,		// vgID
				DWORD				dwSourceType,	// 摜f[^[̎󂯓n@
													// 0FLn
													// 1Ft@Cn
				DWORD				dwDataLength,	// 摜f[^̃oCgTCYiPʁFBytej
				DWORD				dwOffset,		// 摜f[^̊i[ĂItZbg
				CString				strName,		// t@C}bsOIuWFNg
				DWORD				dwProcessId,	// vZXID
				BOOL				bBlankPrint,	// 󔒃vgtO
				DWORD				dwClearInk,		// NACN ( 0:Ȃ, 1: )
				void*				pCompletionProc,// vg󋵒ʒmR[obN֐|C^
				NPS_PrintInfo*		pPrnParam,		// vgp[^iNPSpp[^j
				T_ICCSXML*			pIccsXml		// IccsXml
				);

			// Sort̓o^
	BOOL	AddSort( DWORD dwOrderId );

			// ʈ
	BOOL	AddDuplex( DWORD dwOrderId, CFrameDataDuplex::E_DuplexMode eDuplexMode );

			// đJn/I
	BOOL 	AddRetransmission(
				DWORD 						dwOrderId,
				NPS_InterruptOrderInfo*		pInterruptOrderInfo,
				CFrameDataRetransmission::E_RetransmissionMode	eRetransmissionMode
				);
	
	//----------------------------------------
	// I[_[̍XV
	//----------------------------------------

			// vg󋵕ύXʒmM
	void	RecvEventCompletion( ULONG nReceipt, UCHAR nStatus, USHORT nRepeat );

			// vg󋵕ύXiCuŔG[j
	void	InsideProcError( DWORD dwPrintId );


			// vg󋵕ύXiItCɂȂ̏j
	void	OfflineErrorReset();

			// Lԍ̐ݒ
	BOOL	SetPossessionNo( DWORD dwOrderId, USHORT PossessionNo );

			// Lԍ̐ݒ		2006.11.22 T.Mizushima
	USHORT	GetPossessionNo( DWORD dwOrderId );

			// |[gԍ̐ݒ		2006.10.11 T.Mizushima
	BOOL	SetPortNo( DWORD dwOrderId, USHORT PortNo );

			// vgv̔sԂ̍XViORDERj
	BOOL	UpdateOrderStep( DWORD dwOrderId, E_PrintOrderStep eStep );

			// vgv̔sԂ̍XViFRAMEj
	BOOL	UpdateFrameStep( DWORD dwOrderId, DWORD dwIndexNo, E_PrintFrameStep eStep, DWORD dwPrintId = 0 );

			// tԍ̐ݒ
	BOOL	SetReceiptNo( DWORD dwOrderId, DWORD dwPrintId, ULONG ReceiptNo );

			// EndOrder̊
	BOOL	RequestEndOrderEnd( DWORD dwOrderId );

			// vgݒ
	BOOL	CancelProc( DWORD dwOrderId, DWORD dwPrintID, CList<ULONG,ULONG>* pCancelList );

			// }DɕύX\ȃI[_[݂邩mF
	BOOL	IsEnableExpressOrder( DWORD dwOrderId, CList<ULONG,ULONG>* pReceiptNoList );

			// ʏI[_[}I[_[ɕύX
	BOOL	ChangeNormalToExpress( DWORD dwOrderId );

			// FUNCTION : 摜f[^Mp\Pbg̃|[gԍ擾	2007.01.12 T.Mizushima
	USHORT	GetPortNo( DWORD dwOrderId );

			// QSS̎dlsΉ
			// vgv𔭍sȂ悤ɃR}̏ԂDELETEԂɂ
			// QSS̏ꍇ 6000_0700 ŃXv[tԂĂĂtς݂ƂȂ̂
			// vgv~ꍇɂ́A6000_0900(LZv)𔭍s邽
	BOOL	DeleteFrame_6000_0700_13( ULONG ReceiptNo );

	//----------------------------------------
	// I[_[̎擾
	//----------------------------------------

			// ݏI[_[cĂ邩擾
	BOOL	IsOrderRemain();

			// v^LĂ邩擾
	BOOL	IsOccupy( DWORD dwPriority );

			// ɏ擾
	BOOL	GetNextProcData( T_NextCmd* pNextCmd );

			// I[_[JnvɕKvȃf[^擾
	BOOL	GetStartOrderData( T_NextCmd* pNextCmd, T_StartOrderData* pStartOrderData );

			// vgvɕKvȃf[^擾
	BOOL	GetFrameData( T_NextCmd* pNextCmd, T_FrameData* pFrameData );

			// \[gvɕKvȃf[^擾
	BOOL	GetSortData( T_NextCmd* pNextCmd, T_SortData* pSortData );

			// ʈJnvɕKvȃf[^擾
	BOOL	GetStartDuplexData( T_NextCmd* pNextCmd, T_StartDuplexData* pStartDuplexData );

			// ʈIvɕKvȃf[^擾
	BOOL	GetEndDuplexData( T_NextCmd* pNextCmd, T_EndDuplexData* pEndDuplexData );

			// v^LIOɃLZKvȃf[^擾
	BOOL	GetEndOrderDataCancelReceiptNo( ULONG* pReceiptNo );

			// v^LIɕKvȃf[^擾
	BOOL	GetEndOrderData( T_NextCmd* pNextCmd, T_EndOrderData* pEndOrderData );

			// NWbgJnEIɕKvȃf[^擾
	BOOL	GetCreditOrderData( T_NextCmd* pNextCmd, T_CreditOrderData* pCreditOrderData );

			// đJnvɕKvȃf[^擾
	BOOL	GetStartInterruptOrderInfoData( T_NextCmd* pNextCmd, T_InterruptOrderInfoData* pInterruptOrderInfoData );

			// đIvɕKvȃf[^擾
	BOOL	GetEndInterruptOrderInfoData( T_NextCmd* pNextCmd, T_InterruptOrderInfoData* pInterruptOrderInfoData );

			// SDK̖vg擾
	DWORD	GetReserverCount();

			// SDKSĂ̑擾
	DWORD	GetTotalCount();

			// vgԂ̎擾
	DWORD	GetPrintStatus( DWORD dwPrintId );

			// L[ōłVI[_[EndOrdertԎ擾
	BOOL	GetLatestOrderEndOrder( USHORT mode );	// 2006.10.12 T.Mizushima

			// CuɃI[_[邩mF
	BOOL	IsExistOrder( DWORD dwOrderId );

			// I[_[ł邩mF
	BOOL	IsEmptyOrder( DWORD dwOrderId );

			// CuɃR}邩mF
	BOOL	IsExistFrame( DWORD dwPrintId );

			// eiXI[_[mF
	BOOL	IsMaintenance( DWORD dwPrintId );

			// ʈt[hmF
	BOOL	IsDuplexMode( const DWORD dwOrderId, BOOL* pDuplexMode, LPDWORD pDuplexFrameCnt, T_DuplexPaperInfo* pDuplexPaperInfo );

			// ʈI[_[mF
	BOOL	IsDuplexOrder( const DWORD dwOrderId );

			// vgID擾
	DWORD	GetPrintIdByReceiptNo( ULONG ReceiptNo );

	//----------------------------------------
	// I[_[̍폜
	//----------------------------------------

			// I[_[̍폜
	BOOL	RemoveOrder( DWORD dwOrderId );

			// R}̍폜
	BOOL	RemoveFrame( DWORD dwOrderId, DWORD dwPrintId );

private:

	//----------------------------------------
	// I[_[̎擾
	//----------------------------------------

	// ʈ̍ŏIR}ŊmF
	BOOL	IsDuplexLastOdd( const DWORD dwOrderId, const DWORD dwPrintID );

	//----------------------------------------
	// I[_[̍XV
	//----------------------------------------

	// }I[_[ɕύXI[_[f[^
	void	ResetOrderFrameData( COrderData* pOrderData );

private:

	//----------------------------------------
	// vg󋵒ʒmŎgp{
	//----------------------------------------
	DWORD						m_dwIPAddress;				// v^IPAhX
	USHORT						m_wNpsPortNo;				// v^NPSp|[gԍ
	HPRINTER					m_hPrinter;					// v^nh
	CNpsCallbackCompletion*		m_pCallbackCompletion;		// vg󋵒ʒmNX
	CNpsCmd*					m_pNpsCmd;					// R}hMNX̃|C^
	CNpsImgManager*				m_pNpsImgMng;				// \PbgʐMNXǗ(r)NX
	CDataManager*				m_pDataManager;				// v^ǗNX

	//----------------------------------------
	// JE^
	//----------------------------------------
	DWORD	m_dwLatestOrderId;		// CNgI[_[ID
	DWORD	m_dwLatestPrintId;		// CNgvgID

	DWORD	m_dwAcceptNormalOrderId;	// tiʏj̃I[_[ID ( 0:tȂ, 1`:t̃I[_[ID )
	DWORD	m_dwAcceptExpressOrderId;	// ti}Level1j̃I[_[ID ( 0:tȂ, 1`:t̃I[_[ID )
	DWORD	m_dwAcceptExpressL2OrderId;	// ti}Level2j̃I[_[ID ( 0:tȂ, 1`:t̃I[_[ID )

	//----------------------------------------
	// Xg
	//----------------------------------------
	std::vector<COrderData*>	m_vOrderNormal;		// ʏL
	std::vector<COrderData*>	m_vOrderExpress;	// }L(x1)
	std::vector<COrderData*>	m_vOrderExpressL2;	// }L(x2)

	COrderData*	GetOrderData( DWORD dwOrderId );
	COrderData*	GetOrderDataByReceiptNo( ULONG ReceiptNo );
	COrderData*	GetOrderDataByReceiptNo2( ULONG ReceiptNo );
	COrderData*	GetOrderDataByPrintId( DWORD dwPrintId );
	CFrameData*	GetFrameDataByPrintId( DWORD dwPrintId );
	CFrameData*	GetFrameDataByReceiptNo2( ULONG ReceiptNo );
	CFrameData*	GetFrameDataByIndexNo( const DWORD dwOrderId, const DWORD dwIndexNo );
	BOOL		DeleteOrderData( DWORD dwOrderId );

	BOOL GetPriorityModeByReceiptNo( const ULONG ReceiptNo, E_QueModeP& eQueModeP );

	//----------------------------------------
	// L[̍XV
	//----------------------------------------
	void	UpdatePrintStatus( DWORD dwPrintId );
	void	UpdateOrderStatus( DWORD dwOrderId, E_UpdateOrderStatus eMode = UPDATE_NORMAL );

	//----------------------------------------
	// ʒm
	//----------------------------------------
	void	CallbackCompletionPrint( void* pCompletionProc, DWORD dwProcessId, DWORD dwPrintId, DWORD dwStatus, DWORD dwFinishNum );
	void	CallbackCompletionOrder( void* pCompletionProc, DWORD dwOrderId, DWORD dwStatus );

	//----------------------------------------
	// v^ւ̑M̎
	//----------------------------------------
			// }荞݂ɂ郊Zbg
	BOOL	InterruptReset( ULONG ReceiptNumber, USHORT Repeat );
			// v^G[ɂ郊Zbg
	BOOL	PrinterErrorReset( ULONG ReceiptNumber, USHORT Repeat );
			// t[NAɂLZ	2007.01.23 T.Mizushima
	BOOL	FrameMemoryClearCancel( ULONG ReceiptNumber, USHORT Repeat );

	CRITICAL_SECTION	m_CS;	// NeBJZNV


	//----------------------------------------
	// v^Ƃ̐L
	//----------------------------------------
	typedef struct
	{	// v^̃G[ȂǂŁAv^Ƃ̐LƂɎgp
		BOOL				bPossessionRelease;	// Li TRUE:, FALSE:Ȃ j
		T_NextCmd			tNextCmd;			// I[_[
		T_EndOrderData		tEndOrderData;		// GhI[_[
		ULONG				nCancelReceiptNo;	// LOɃLZȂ΂ȂȂtԍ (0700𔭍s0800𔭍sĂȂ)
	} T_PossessionRelease;

	T_PossessionRelease		m_PossessionRelease;

	//----------------------------------------
	// EZ Controller 6x6C` tHgubNΉ
	//----------------------------------------
public:
	void*	m_pCallbackCompletionOrderNG;	// EZ Controller 6x6C` tHgubNΉ
};

#endif // !defined(AFX_PRINTQUE_H__482D13C4_BB64_49BC_BD34_1FD445E257E1__INCLUDED_)
