#pragma once
//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : RecvCmdBuffer.h
//	ABSTRACT  : NPSMR}h̓NX
//	
//	CREATE    : Y.Yoshinobu   2008.6.9
//	UPDATE    : 
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#define	NPS_TYPE_CHAR		1
#define	NPS_TYPE_SHORT		2
#define	NPS_TYPE_LONG		3
#define	NPS_TYPE_FLOAT		4
#define	NPS_TYPE_LONGLONG	5

//////////////////////////////////////////////////////////////////////////////
// }N`
#if !defined(COUNTOF)
	#define COUNTOF(xxxx)	(sizeof(xxxx)/sizeof(xxxx[0]))
#endif

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CAnalysisTag
//	ABSTRACT : TagNX
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CAnalysisTag
{
public:
	CAnalysisTag(void);
	~CAnalysisTag(void);

	// ͂̂߂̏
	WORD	m_wTag;					// ^Oԍ
	WORD	m_wType;				// ^Ǒ^ (NPS_TYPE_*)
	WORD	m_wArrayCntMax;			// z̍ő吔

	// ͌ʂ̏
	WORD	m_wVauleCnt;			// lZbgĂ鐔
	LPBYTE	m_lpVaule;				// li[邽߂̐擪|C^
};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CRecvCmdBuffer
//	ABSTRACT : R}h̉̓NX
//	
//	NOTE     : < RD-123 > 
//             < Note >ygpz
//	                   Tag=1[USHORT,s[g1]̒lnTag1ValueɃZbg
//	                   Tag=2[USHORT,s[g2]̒lnTag2ValueɃZbg
//	
//	            STEP-1 ϐ̒`
//	                   BYTE byBuffer[256] = { /* NPS̃R}hf[^Zbg */ };
//	                   USHORT nTag1Value;
//	                   USHORT nTag2Value[2];
//	                   CRecvCmdBuffer objRecvCmdBuffer;
//	
//	            STEP-2 Tag̓o^
//	                   objRecvCmdBuffer.AddTagList( 1, NPS_TYPE_SHORT, 1 /* ȗ\ */ );
//	                   objRecvCmdBuffer.AddTagList( 2, NPS_TYPE_SHORT, COUNTOF(nTag2Value) /* |C^̏ꍇ͒l̎w肪Kv */ );
//	
//	            STEP-3 ͏
//	                   if ( false == objRecvCmdBuffer.Analysis( &byBuffer, sizeof(byBuffer) /* ȗ\ */ ) )
//	                   {
//	                       /* ͂Ɏsꍇ̏ */
//	                   }
//	
//	            STEP-4 ͌̃f[^擾
//	                   if 1 != objRecvCmdBuffer.GetTagValue( 1, (LPBYTE)&nTag1Value, 1 /* ȗ\ */ ) )
//	                   {
//	                       /* 擾łȂꍇ̏ */
//	                   }
//	                   if ( COUNTOF(nTag2Value) /* |C^̏ꍇ͒l̎w肪Kv */ != objRecvCmdBuffer.GetTagValue( 2, (LPBYTE)&nTag2Value, COUNTOF(nTag2Value) /* |C^̏ꍇ͒l̎w肪Kv */ ) )
//	                   {
//	                       /* 擾łȂꍇ̏ */
//	                   }
//	
//	            STEP-5 ̓^ÕXgɂiCRecvCmdBuffer̃fXgN^łŝSTEP-2,3,4JԂsꍇɎgpj
//	                   objRecvCmdBuffer.EmptyTagList();
//	
//	
//	CREATE	 : Y.Yoshinobu	2008.6.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CRecvCmdBuffer
{
public:
	CRecvCmdBuffer(void);
	~CRecvCmdBuffer(void);

	// ̓^ÕXgJ
	void EmptyTagList(void);

	// ͂^Oo^izpj
	void AddTagList( const WORD wTag, const WORD wType, const WORD wMaxCnt = 1 );

	// w肵obt@͂āAo^^Oԍ̏擾
	bool Analysis( const LPBYTE lpBuffer, const DWORD dwBufferLen = 0xFFFFFFFF );

	// ͌̃C^[tFCXIDƃR}hID擾
	void GetIfIdAndCmdId( LPWORD lpwIfId, LPWORD lpwCmdId );

	// ͌Tag擾
	int GetTagValue( const WORD wTag, LPBYTE lpVariable, const WORD wCnt = 1 );

private:

	// ͌ʂ̒lZbg
	void ResetTagValue(void);


	WORD		m_wIfId;					// ͌C^[tFCXID
	WORD		m_wCmdId;					// ͌R}hID

	std::vector<CAnalysisTag*>	m_vTag;		// ̓^OXgo^Rei
};
