//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : SdkLayout.h
//	ABSTRACT  : CSdkLayout NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2009.11.25	EZ Controller 6x6C` tHgubNΉ
//	UPDATE    : Y.Atoji		2014.02.24	6x6C`tHgubNΉ@QSS-GREEN-IIǉ
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SdkLayout_H__1A65EF86_7CF0_48D1_9B76_E9EFC3C4463F__INCLUDED_)
#define AFX_SdkLayout_H__1A65EF86_7CF0_48D1_9B76_E9EFC3C4463F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Sdk.h"

#define MACHINE_TYPE_NAME_D1005		"D1005"
#define MACHINE_TYPE_NAME_GREEN2	"QSS-GREEN-II"

// 12x12in.
#define REAL_NAME_STRING		"12x12in.(BL+)"
#define REAL_WIDTH				3050
#define REAL_LENGTH				3050
#define REAL_WIDTH_PIX			4380
#define REAL_LENGTH_PIX			4380

// 6x6in.
#define DUMMY_NAME_STRING		"6x6in.(BL+)"
#define DUMMY_WIDTH				1520
#define DUMMY_LENGTH			1520

// 1ʓ\tR}
#define KOMADATA_NUM			4

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CSdkLayout
//	ABSTRACT : v^ʂǗNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CSdkLayout : public CSdk
{
public:
	static BOOL IsUseCSdkLayout();

public:
	CSdkLayout();											// RXgN^
	virtual ~CSdkLayout();								// fXgN^

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevOpen ()
	//	ABSTRACT : v^I[v
	//	FUNCTION : v^𗘗p\ɂ
	virtual long DevOpen (
		DWORD			dwIPAddress,	// v^IPAhX
		HPRINTER*		phPrinter,		// 擾nh̊i[
		NPSEVENTPROC	pEventProc,		// Cxgʒm֐
		NPSUNITPROC		pUnitProc		// jbgԕύXʒm֐
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevClose ()
	//	ABSTRACT : v^N[Y
	//	FUNCTION : v^𗘗p֎~ɂ
	virtual long DevClose (
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevGetPrintNumInfo ()
	//	ABSTRACT : vg擾
	//	FUNCTION : vg̖擾
	virtual long DevGetPrintNumInfo (
		PNPS_PrintNumInfo	pPrintNumInfo	// vg\̂ւ̃AhX
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevStartOrder ()
	//	ABSTRACT : I[_[Jn
	//	FUNCTION : I[_[Jnw
	virtual long DevStartOrder (
		DWORD*				pdwOrderId,	// 擾I[_[IDi[
		NPSCOMPLETIONPROC	pEventProc,	// ʒmpR[obN֐ւ̃AhX
		DWORD				dwPriority,	// Dxw
		DWORD				dwSorterNum,// vg̎d
		DWORD				dwSortFrame,// R}̃\[g@\
		DWORD				dwExOptions	// gIvV(Pvg) 2014.10.28 M.Yamamoto
										// EX_OPTIONS_NONE        : gIvVȂ
										// EX_OPTIONS_SINGLE_LINE : Pvg
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevEndOrder ()
	//	ABSTRACT : I[_[I
	//	FUNCTION : I[_[Iw
	virtual long DevEndOrder (
		DWORD		dwOrderId	// II[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevPrint ()
	//	ABSTRACT : vgv
	//	FUNCTION : vgv󂯕t
	virtual long DevPrint (
		DWORD				dwOrderId,	// vgI[_[IDw肷
		LPDWORD				pPrintID,	// vgʎq
		NPSCOMPLETIONPROC	pEventProc,	// CxgʒmpR[obN֐ւ
										// AhX
		PNPS_PrintInfo		pPrintInfo,	// vgvp[^
		T_ICCSXML*			pIccsXml	// IccsXml
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevSort ()
	//	ABSTRACT : \[gv
	//	FUNCTION : \[gw
	virtual long DevSort (
		DWORD		dwOrderId	// 擾I[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevCancelPrintOrder ()
	//	ABSTRACT : vgI[_[LZ
	//	FUNCTION : 󂯕tĂvg1I[_[LZ
	virtual long DevCancelPrintOrder (
		DWORD		dwOrderId,	// LZI[_[IDw肷
		DWORD		dwPrintID	// vgʎq
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevGetPrintStatus ()
	//	ABSTRACT : vgԎ擾
	//	FUNCTION : vgԂ擾
	virtual long DevGetPrintStatus (
		DWORD		dwPrintID,		// vgʎq
		LPDWORD		pPrintStatus	// vg
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevCloseCheck ()
	//	ABSTRACT : v^N[Y`FbN
	//	FUNCTION : v^̎gp֎~(npsDevClose)\ł邩`FbN
	virtual long DevCloseCheck (
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevGetAllMagInfo ()
	//	ABSTRACT : S}KW擾
	//	FUNCTION : v^ɓo^ĂŎgpłSẴ}KW̏擾
	virtual long DevGetAllMagInfo (
		PNPS_MagDetailInfo	pMagDetailInfo,	// }KWڍ׏󂯎obt@
		DWORD*				pdwSize			// obt@̃TCY
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevGetProfile ()
	//	ABSTRACT : v^vt@C擾
	//	FUNCTION : y[p[Ƀvt@C擾
	virtual long DevGetProfile (
		LPCSTR			lpFileName,	// vt@Cf[^ot@Cw肷
		PNPS_PaperInfo	pPaperInfo	// vt@C擾y[p[̏w肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevStartDuplex ()
	//	ABSTRACT : ʈJn
	//	FUNCTION : ʈ̊Jnw
	virtual long DevStartDuplex(
		DWORD			dwOrderId	// 擾I[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevEndDuplex ()
	//	ABSTRACT : ʈI
	//	FUNCTION : ʈ̏Iw
	virtual long DevEndDuplex(
		DWORD			dwOrderId	// 擾I[_[IDw肷
	);

	//////////////////////////////////////////////////////////////////////////////
	//	MODULE   : CSdkLayout::DevBlankPrint ()
	//	ABSTRACT : 󔒃y[W̃vgv
	//	FUNCTION : 󔒃y[W̃vgw
	virtual long DevBlankPrint(
		DWORD			dwOrderId,				// vgI[_[IDw肷
		LPDWORD			pPrintID,				// vgʎq
		NPSCOMPLETIONPROC pEventProc,			// CxgʒmpR[obN֐ւ̃AhX
		PNPS_BlankPrintInfo	pBlankPrintInfo		// 󔒃vgvp[^
	);

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// EZ Controller 6x6C` tHgubNΉ po
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

public:
	//////////////////////////////////////////////////////////////////////////////
	//	R}\
	//////////////////////////////////////////////////////////////////////////////
	struct KOMADATA
	{
		int					DuplexKomaNo;			// 1`i0͖ݒӖj
		BOOL				bBlankPrint;			// uNvgǂ TRUE:uNvg FALSE:uNvgłȂ
		DWORD				dwOrderId;				// vgI[_[IDw肷
		DWORD				PrintID;				// vgʎq
		NPS_PrintInfo		PrintInfo;				// vgvp[^
		NPS_BlankPrintInfo	BlankPrintInfo;			// 󔒃vgvp[^
		char				FilePath[MAX_PATH];		// vg摜t@CpX
		NPSCOMPLETIONPROC	pEventProc;				// CxgʒmpR[obN֐ւ̃AhX
		T_ICCSXML*			pIccsXml;				// IccsXml
	};

	//////////////////////////////////////////////////////////////////////////////
	//	vg\
	//////////////////////////////////////////////////////////////////////////////

	//  - STATE
	enum E_RealPrintState
	{
		RPS_INIT = 0,			// 
		RPS_PRINT_REQ = 1,		// DevPrintς
		RPS_PRINT_REQ_ERR = 2,	// DevPrints
		RPS_CALLBACK_RECV = 4,	// vg󋵃R[obNMς
	};

	struct REALPRINT
	{
		int					STATE;					// ԃrbgtO E_RealPrintState
		BOOL				bFront;					// TRUE:\ FALSE:
		KOMADATA			KomaData[KOMADATA_NUM];	// \tR}
		DWORD				dwOrderId;				// vgI[_[IDw肷
		DWORD				PrintID;				// vgʎq
		NPS_PrintInfo		PrintInfo;				// vgvp[^
		T_ICCSXML*			pIccsXml;				// IccsXml
		char				FilePath[MAX_PATH];		// vg摜t@CpX
		DWORD				dwStatus;				// NPSPRINTINFO\̂dwStatusϐ̐Ɠ
	};

	//////////////////////////////////////////////////////////////////////////////
	//	R[obNtbN
	//////////////////////////////////////////////////////////////////////////////

	// --- vg ---

	// vgCxgʒmivgjpR[obN֐ X^eBbN
	static void CALLBACK CallbackCompletionPrintDummyStatic(
		DWORD		dwCompletionCode,	// R[h
		PVOID		pCompletionInfo		// Cxg
		);
	
	// vgCxgʒmivgj
	BOOL CompletionPrintProc( NPSPRINTINFO NpsPrintInfo, REALPRINT* pRealPrint );

	// --- I[_[ ---

	// vgCxgʒmiI[_[jpR[obN֐ X^eBbN
	static void CALLBACK CallbackCompletionOrderDummyStatic(
		DWORD		dwCompletionCode,	// R[h
		PVOID		pCompletionInfo		// Cxg
		);

	// vgCxgʒmiI[_[j
	BOOL CompletionOrderProc( NPSORDERINFO NpsOrderInfo, std::vector<KOMADATA>* pvKOMADATA );

protected:

	int					m_DuplexKomaCount;	// ʃvgJE^[iʃvgԁiDevStartDuplex - DevEndDuplexjł̃JE^[j
	T_DuplexPaperInfo	m_DuplexPaperInfo;	// Ov̏ێi`FbNParamChkOfDevPrintDuplexŗpj

	std::vector<KOMADATA>		m_vNotRequestFrame;	// vOt[XgiCSdk::DevPrint()ÕvgvXgj
	std::vector<REALPRINT>		m_vRequestedFrame;	// vσt[XgiCSdk::DevPrint()̂̃Xgj

	// 擪u
	void ReplaceTopOfString( char* str, char* strA, char* strB );

	// ԃOo
	void WriteStatusLog();

	// CAEgo[ϐ
	void Initialize();

	// @햼"D1005"ǂ
	BOOL IsD1005();

	// @햼"QSS-GREEN-II"ǂ
	BOOL IsGreen2();

	// 摜
	void MakeImage( REALPRINT* realprint, KOMADATA* ArrayKomaData );

	// vgv(CSdk::DevPrint())s
	void RequestFrame( REALPRINT* realprint );

	// \  siʂ̃vgv8R}Ƃɍsj
	void ExecDuplexPrint();

	// CAEg`FbNi8R}jƎsi8R}sj
	void CheckForExecDuplexPrint();

	// R[obN TRANSFER LZo^
	void CallbackCancelTransfer( void* pCompletionProc, DWORD dwPrintId );
};

#endif // !defined(AFX_SdkLayout_H__1A65EF86_7CF0_48D1_9B76_E9EFC3C4463F__INCLUDED_)
