//////////////////////////////////////////////////////////////////////////////
//   FILE NAME   : WS2Tcp2.h
//   ABSTRACT    : \PbgʐMNX (WinSock2.0Ή)
//
//                                     (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#if !defined(_WS2TCP2_H_)
#define _WS2TCP2_H_

#include <afxpriv.h>

#include <winsock2.h>		// WinSock 2.0
#include <mswsock.h>		// Microsoft Windows Socket

//////////////////////////////////////////////////////////////////////////////
// e}N`Lq܂
// ڂ̌߂`
#if !defined(COUNTOF)
	#define COUNTOF(xxxx)		(sizeof(xxxx)/sizeof(xxxx[0]))
#endif


class CWS2Tcp2
{
public:
	//////////////////////////////////////////////////////////////////////
	//	@\F	NX̍\zs܂(Server(1)/Client(1))
	//	F	Ȃ
	//	ߒlF	Ȃ
	CWS2Tcp2();

	//////////////////////////////////////////////////////////////////////
	//	@\F	NX̊Js܂
	//	F	Ȃ
	//	ߒlF	Ȃ
	virtual ~CWS2Tcp2();

	//////////////////////////////////////////////////////////////////////
	//	@\F	\Pbg쐬܂(Server(2)/Client(2))
	//	F	int					nAddressFamily		AhX`
	//			int					nSocketType			\Pbg^Cv
	//			int					nProtocol			vgR
	//			LPWSAPROTOCOL_INFO	lpProtocolInfo		쐬
	//	ߒlF	\Pbg쐬 TRUE Ԃ܂
	BOOL Create( int nAddressFamily = AF_INET ,
				 int nSocketType    = SOCK_STREAM ,
				 int nProtocol      = IPPROTO_TCP );
	BOOL Create( LPWSAPROTOCOL_INFO lpProtocolInfo ,
				 int nAddressFamily = FROM_PROTOCOL_INFO ,
				 int nSocketType    = FROM_PROTOCOL_INFO ,
				 int nProtocol      = FROM_PROTOCOL_INFO );

	UINT GetSocketPortNo();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\PbgɖOt܂(Server(3))
	//	F	UINT				nSocketPort			|[gԍ
	//			LPCTSTR				lpszSocketAddress	\Pbg̃AhX
	//			SOCKADDR			lpSockAddr			\Pbg
	//			int					nSockAddrLen	\Pbg̒
	//	ߒlF	Ot̐ TRUE Ԃ܂
	BOOL Bind( UINT nSocketPort , LPCTSTR lpszSocketAddress = NULL );
	BOOL Bind( const SOCKADDR* lpSockAddr, int nSockAddrLen );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	T[o[ɐڑvs܂(Client(3))
	//	F	LPCTSTR				lpszHostAddress		ڑAhX
	//			UINT				nHostPort			ڑ|[g
	//			SOCKADDR*			lpSockAddr			ڑ
	//			int					nSockAddrLen		lpSockAddr ̒(Byte)
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Connect( LPCTSTR lpszHostAddress, UINT nHostPort );
	BOOL Connect( const SOCKADDR* lpSockAddr, int nSockAddrLen );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	f[^̑Ms܂(TCP)
	//	F	void*				lpBuf				Mf[^
	//			int					nBufLen				lpBuf ̒(Byte)
	//			DWORD				dwFlags				MtO
	//			WSABUF*				pBuf				Mf[^
	//			int					nCount				pBuf ̌
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Send( const void* lpBuf, int nBufLen, DWORD dwFlags = 0 );
	BOOL Send( WSABUF* pBuf , int nCount , DWORD dwFlags = 0 );

	////////////////////////////////////////////////////////////////////////////
	//	@\F	MI錾
	//	F	Ȃ
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL SendDisconnect();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	MI錾
	//	F	Ȃ
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL ReceiveDisconnect();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	܂
	//	F	Ȃ
	//	ߒlF	ꍇ TRUE Ԃ܂
	BOOL Close();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	G[擾܂
	//	F	Ȃ
	//	ߒlF	G[R[hԂ܂
	static int GetLastError();

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\Pbg^vꂽƂ̓\Pbgf[^Ԃ܂
	//	F	Ȃ
	//	ߒlF	\Pbg
	operator SOCKET () const { return m_Socket; }

	////////////////////////////////////////////////////////////////////////////
	//	@\F	\PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
	//	F	BOOL				bAutoDelete		= TRUE  : 폜
	//												= FALSE : 폜Ȃ
	//	ߒlF	Ȃ
	void	SetAutoDelete( BOOL bAutoDelete = TRUE );

	BOOL	IsOpenSocket()	{ return ( m_Socket != INVALID_SOCKET ); }

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp2::SetReUsePort
	//   ABSTRACT : |[gԍ̍Ďgpݒ肵܂
	//   FUNCTION : |[gԍ̍Ďgpݒ肵܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	SetReUsePort();

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp2::SetSendBuf
	//   ABSTRACT : f[^Mp̃obt@̃TCYݒ肵܂
	//   FUNCTION : f[^Mp̃obt@̃TCYݒ肵܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	SetSendBuf( const int nSendBufSize );

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp2::GetSendBufSize
	//   ABSTRACT : f[^Mp̃obt@̃TCY擾܂
	//   FUNCTION : f[^Mp̃obt@̃TCY擾܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	GetSendBufSize( int* pSendBufSize );

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp2::SetSendBufSize
	//   ABSTRACT : f[^Mp̃obt@̃TCYݒ肵܂
	//   FUNCTION : f[^Mp̃obt@̃TCYݒ肵܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	SetSendBufSize( const int nSendBufSize );

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp2::GetNoDelay
	//   ABSTRACT : NagleASY̗L擾܂
	//   FUNCTION : NagleASY̗L擾܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	GetNoDelay( BOOL* pEnable );

	//////////////////////////////////////////////////////////////////////////////
	//   MODULE   : CWS2Tcp2::SetNoDelay
	//   ABSTRACT : NagleASY̗Lݒ肵܂
	//   FUNCTION : NagleASY̗Lݒ肵܂
	//////////////////////////////////////////////////////////////////////////////
	BOOL	SetNoDelay( const BOOL bEnable );

private:
	////////////////////////////////////////////////////////////////////////////
	// eCxgs߂̃Xbh𓮍삳邽߂̊֐ł
	// 㑤̊֐́AAfxBeginThread() ɗ^邽߂ static KvŁAł
	// NXϐɃANZX̂ʓ|Ȃ̂ŁANX֐̉֐Ăяo
	// sĂ܂
	static UINT SocketEventThread( LPVOID pParam );
	UINT SocketEvent();

private:
	SOCKET		m_Socket;			// Ǘ\Pbg
	int			m_nAddressFamily;	// AhXt@~[
	BOOL		m_bAutoDelete;		// \PbgN[YɎIɃNX폜?
	BOOL		m_ConnectState;		// ڑ
};

#endif // _CWS2Tcp2_H_
