// DevPrintDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "NpsClient.h"
#include "DevPrintBasicDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevPrintBasicDlg _CAO


CDevPrintBasicDlg::CDevPrintBasicDlg(CWnd* pParent /*=NULL*/)
	: CDevPrintDlg(CDevPrintBasicDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevPrintBasicDlg)
	m_CvpInitialValue1 = 0;
	m_CvpInitialValue2 = 0;
	m_CvpInitialWidth1 = 0;
	m_CvpInitialWidth2 = 0;
	m_CvpLine1 = _T("");
	m_CvpLine2 = _T("");
	m_CvpPoint1 = 0;
	m_CvpPoint2 = 0;
	m_DataLength = 0;
	m_ImgHeight = 0;
	m_ImgWidth = 0;
	m_Offset = 0;
	m_PaperLength = 0;
	m_PaperPresence = 0;
	m_PaperWidth = 0;
	m_Resolution = 0;
	m_Surface = 1;
	m_Name = _T("");
	m_PrintNum = 1;
	m_Espc = 0;
	m_OrderId = 0;
	m_editName = _T("");
	//}}AFX_DATA_INIT
}


void CDevPrintBasicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevPrintBasicDlg)
	DDX_Control(pDX, IDC_COMBO_SOURCE_TYPE, m_ComboSourceType);
	DDX_Control(pDX, IDC_COMBO_NG_RETRY, m_ComboNGRetry);
	DDX_Control(pDX, IDC_COMBO_IMAGE_FORMAT, m_ComboImageFormat);
	DDX_Control(pDX, IDC_COMBO_FEED, m_ComboFeed);
	DDX_Text(pDX, IDC_EDIT_CVP_INITIAL_VALUE1, m_CvpInitialValue1);
	DDV_MinMaxInt(pDX, m_CvpInitialValue1, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_CVP_INITIAL_VALUE2, m_CvpInitialValue2);
	DDV_MinMaxInt(pDX, m_CvpInitialValue2, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_CVP_INITIAL_WIDTH1, m_CvpInitialWidth1);
	DDV_MinMaxInt(pDX, m_CvpInitialWidth1, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_CVP_INITIAL_WIDTH2, m_CvpInitialWidth2);
	DDV_MinMaxInt(pDX, m_CvpInitialWidth2, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_CVP_LINE1, m_CvpLine1);
	DDV_MaxChars(pDX, m_CvpLine1, 1000);
	DDX_Text(pDX, IDC_EDIT_CVP_LINE2, m_CvpLine2);
	DDV_MaxChars(pDX, m_CvpLine2, 1000);
	DDX_Text(pDX, IDC_EDIT_CVP_POINT1, m_CvpPoint1);
	DDV_MinMaxInt(pDX, m_CvpPoint1, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_CVP_POINT2, m_CvpPoint2);
	DDV_MinMaxInt(pDX, m_CvpPoint2, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_DATA_LENGTH, m_DataLength);
	DDV_MinMaxInt(pDX, m_DataLength, 0, 1000000000);
	DDX_Text(pDX, IDC_EDIT_IMG_HEIGHT, m_ImgHeight);
	DDV_MinMaxInt(pDX, m_ImgHeight, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_IMG_WIDTH, m_ImgWidth);
	DDV_MinMaxInt(pDX, m_ImgWidth, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_OFFSET, m_Offset);
	DDV_MinMaxInt(pDX, m_Offset, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_PAPER_LENGTH, m_PaperLength);
	DDV_MinMaxInt(pDX, m_PaperLength, 0, 10000);
	DDX_Text(pDX, IDC_EDIT_PAPER_PRESENSE, m_PaperPresence);
	DDV_MinMaxInt(pDX, m_PaperPresence, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_PAPER_WIDTH, m_PaperWidth);
	DDV_MinMaxInt(pDX, m_PaperWidth, 0, 10000);
	DDX_Text(pDX, IDC_EDIT_RESOLUTION, m_Resolution);
	DDV_MinMaxInt(pDX, m_Resolution, 0, 10000);
	DDX_Text(pDX, IDC_EDIT_SURFACE, m_Surface);
	DDV_MinMaxInt(pDX, m_Surface, 0, 1000);
	DDX_Text(pDX, IDC_STATIC_NAME, m_Name);
	DDV_MaxChars(pDX, m_Name, 1000);
	DDX_Text(pDX, IDC_EDIT_PRINT_NUM, m_PrintNum);
	DDV_MinMaxInt(pDX, m_PrintNum, 1, 10000);
	DDX_Text(pDX, IDC_EDIT_ESPC, m_Espc);
	DDV_MinMaxInt(pDX, m_Espc, -999, 999);
	DDX_Text(pDX, IDC_EDIT_ORDER_ID_, m_OrderId);
	DDV_MinMaxDWord(pDX, m_OrderId, 0, 4294967295);
	DDX_Text(pDX, IDC_EDIT_NAME, m_editName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevPrintBasicDlg, CDialog)
	//{{AFX_MSG_MAP(CDevPrintBasicDlg)
	ON_BN_CLICKED(IDC_BUTTON_FOLDER, OnButtonFolder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

USHORT GetWord( PUCHAR pBuf, PUCHAR pEndOfBuf )
{
	USHORT nResult = (UCHAR)*pBuf << 8;

	if (++pBuf >= pEndOfBuf)
		return 0;

	nResult |= (UCHAR)*pBuf;

	if (++pBuf >= pEndOfBuf)
		return 0;

	return	nResult;
}

BOOL GetImageSizeJPEG( LPVOID pImage, DWORD dwSize, USHORT* pImageXPixels, USHORT* pImageYPixels )
{
	BOOL bResult = FALSE;

	PUCHAR pBuf = (PUCHAR)pImage;
	PUCHAR pEndOfBuf = pBuf + dwSize;
	USHORT nLength = 0;

	for ( ; pBuf < pEndOfBuf; )
	{
		if (*pBuf == (UCHAR)0xff)
		{
			pBuf++;

			if (*pBuf >= (UCHAR)0xe0 && *pBuf <= (UCHAR)0xef) {
				// TlCi[Ă邽߁AAPP}[J[͖܂ 2002.10.29 S.Heya
				pBuf++;
				nLength = GetWord(pBuf, pEndOfBuf);			// t[wb_[(Lf)
				pBuf += nLength;
				continue;
			}

			if (*pBuf == (UCHAR)0xc0)						// {DCTt[(SOF0)
			{
				pBuf++;
				GetWord(pBuf, pEndOfBuf);					// t[wb_[(Lf)

				pBuf += 2;
//				GetWord(pBuf, pEndOfBuf);					// Tv(P)

				pBuf += 1;
				*pImageYPixels = GetWord(pBuf, pEndOfBuf);	// C(Y) 

				pBuf += 2;
				*pImageXPixels = GetWord(pBuf, pEndOfBuf);	// C̃Tv(X)

				bResult = TRUE;
				break;
			}
		}

		pBuf++;
	}

	return bResult;
}

/////////////////////////////////////////////////////////////////////////////
// CDevPrintBasicDlg bZ[W nh
// UPDATE	: J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
/////////////////////////////////////////////////////////////////////////////
void CDevPrintBasicDlg::OnButtonFolder() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );

	CFileDialog	wFileDlg( 
					TRUE,
					NULL,
					NULL, 
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
					"All Files (*.*)|*.*|JPEG (*.jpg)|*.jpg|Bitmap (*.bmp)|*.bmp|RAW (*.raw)|*.raw|", 
					this );

	if( IDOK != wFileDlg.DoModal() )
	{
		return;
	}

	m_editName	= wFileDlg.GetPathName();

	CFile	wFile;
	wFile.Open( m_editName, CFile::modeRead );

	while( 1 )
	{
		// t@CTCY擾
		m_DataLength	= (int)wFile.GetLength();

		// A擾
		char Ext[128];
		m_ImgWidth	= 0;
		m_ImgHeight	= 0;

		_splitpath( m_editName, NULL, NULL, NULL, Ext );

		if( 0 == _stricmp( Ext, ".bmp" ) )
		{	// rbg}bv
			BITMAPFILEHEADER	wFileHeader;
			BITMAPINFOHEADER	wInfoHeader;

			wFile.Read( &wFileHeader, sizeof( BITMAPFILEHEADER ) );
			wFile.Read( &wInfoHeader, sizeof( BITMAPINFOHEADER ) );

			m_ImgWidth	= wInfoHeader.biWidth;
			m_ImgHeight	= wInfoHeader.biHeight;
		}
		else if( 0 == _stricmp( Ext, ".jpg" ) )
		{	// JPEG
			PUCHAR	pImage;

			pImage	= new unsigned char[ m_DataLength ];
			wFile.Read( pImage, m_DataLength );
			USHORT	Width, Height;

			if( GetImageSizeJPEG( pImage, m_DataLength, &Width, &Height ) )
			{
				m_ImgWidth	= Width;
				m_ImgHeight	= Height;
			}

			delete [] pImage;
		}

		break;
	}

	wFile.Close();	

	UpdateData( FALSE );
}

BOOL CDevPrintBasicDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	int nMaintenance;
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char sziniFilePath[MAX_PATH];

	// AvP[V̐΃pX擾i΃pXj
	::GetModuleFileName( NULL, sziniFilePath, MAX_PATH );
	::_splitpath( sziniFilePath, drive, dir, fname, ext );
	::_makepath( sziniFilePath, drive, dir, "NpsClient", "ini" );

	nMaintenance = ::GetPrivateProfileInt( "WITHHELD", "Maintenance", 0, sziniFilePath );
	if ( 1 == nMaintenance )
	{
		m_ComboImageFormat.AddString( "15 : 0x64 (100)" );
		m_ComboImageFormat.AddString( "16 : 0x65 (101)" );
	}

	m_ComboImageFormat.SetCurSel( m_pNpsPrintInfo->PrintInfo.dwImageFormat );
	m_ComboSourceType.SetCurSel( m_pNpsPrintInfo->PrintInfo.dwSourceType );
	m_ComboFeed.SetCurSel( m_pNpsPrintInfo->PrintInfo.dwFeed );
	m_ComboNGRetry.SetCurSel( 0 );

	// DATAݒ
	m_CvpInitialValue1	= m_pNpsPrintInfo->PrintInfo.dwCvpInitialValue1;
	m_CvpInitialValue2	= m_pNpsPrintInfo->PrintInfo.dwCvpInitialValue2;
	m_CvpInitialWidth1	= m_pNpsPrintInfo->PrintInfo.dwCvpInitialWidth1;
	m_CvpInitialWidth2	= m_pNpsPrintInfo->PrintInfo.dwCvpInitialWidth2;
	m_CvpLine1			= m_pNpsPrintInfo->PrintInfo.szCvpLine1;
	m_CvpLine2			= m_pNpsPrintInfo->PrintInfo.szCvpLine2;
	m_CvpPoint1			= m_pNpsPrintInfo->PrintInfo.dwCvpPoint1;
	m_CvpPoint2			= m_pNpsPrintInfo->PrintInfo.dwCvpPoint2;
	m_DataLength		= m_pNpsPrintInfo->PrintInfo.dwDataLength;
	m_ImgHeight			= m_pNpsPrintInfo->PrintInfo.dwImgHeight;
	m_ImgWidth			= m_pNpsPrintInfo->PrintInfo.dwImgWidth;
	m_Offset			= m_pNpsPrintInfo->PrintInfo.dwOffset;
	m_PaperLength		= m_pNpsPrintInfo->PrintInfo.dwPaperLength;
	m_PaperPresence		= m_pNpsPrintInfo->PrintInfo.dwPaperPresence;
	m_PaperWidth		= m_pNpsPrintInfo->PrintInfo.dwPaperWidth;
	m_Resolution		= m_pNpsPrintInfo->PrintInfo.dwResolution;
	m_Surface			= m_pNpsPrintInfo->PrintInfo.dwSurface;
	//m_editName		= m_pNpsPrintInfo->PrintInfo.pName;
	m_editName			= m_pNpsPrintInfo->FilePath;
	m_PrintNum			= m_pNpsPrintInfo->PrintInfo.dwPrintNum;
	m_OrderId			= m_pNpsPrintInfo->dwOrderId;
	m_Espc				= m_pNpsPrintInfo->PrintInfo.nEspc;

	UpdateData( FALSE );
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDevPrintBasicDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	UpdateMemberData();
	
	CDialog::OnOK();
}

void CDevPrintBasicDlg::UpdateMemberData() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	UpdateData();

	m_pNpsPrintInfo->PrintInfo.dwImageFormat	= m_ComboImageFormat.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.dwSourceType		= m_ComboSourceType.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.dwFeed			= m_ComboFeed.GetCurSel();				

	// DATAݒ
	m_pNpsPrintInfo->PrintInfo.dwCvpInitialValue1	= m_CvpInitialValue1;
	m_pNpsPrintInfo->PrintInfo.dwCvpInitialValue2	= m_CvpInitialValue2;
	m_pNpsPrintInfo->PrintInfo.dwCvpInitialWidth1	= m_CvpInitialWidth1;
	m_pNpsPrintInfo->PrintInfo.dwCvpInitialWidth2	= m_CvpInitialWidth2;
	strcpy( m_pNpsPrintInfo->PrintInfo.szCvpLine1, m_CvpLine1 );
	strcpy( m_pNpsPrintInfo->PrintInfo.szCvpLine2, m_CvpLine2 );
	m_pNpsPrintInfo->PrintInfo.dwCvpPoint1			= m_CvpPoint1;
	m_pNpsPrintInfo->PrintInfo.dwCvpPoint2			= m_CvpPoint2;
	m_pNpsPrintInfo->PrintInfo.dwDataLength			= m_DataLength;
	m_pNpsPrintInfo->PrintInfo.dwImgHeight			= m_ImgHeight;
	m_pNpsPrintInfo->PrintInfo.dwImgWidth			= m_ImgWidth;
	m_pNpsPrintInfo->PrintInfo.dwOffset				= m_Offset;
	m_pNpsPrintInfo->PrintInfo.dwPaperLength		= m_PaperLength;
	m_pNpsPrintInfo->PrintInfo.dwPaperPresence		= m_PaperPresence;
	m_pNpsPrintInfo->PrintInfo.dwPaperWidth			= m_PaperWidth;
	m_pNpsPrintInfo->PrintInfo.dwResolution			= m_Resolution;
	m_pNpsPrintInfo->PrintInfo.dwSurface			= m_Surface;
	//m_pNpsPrintInfo->PrintInfo.pName				= m_editName;
	strcpy( m_pNpsPrintInfo->FilePath, m_editName );
	m_pNpsPrintInfo->PrintInfo.dwPrintNum			= m_PrintNum;
	m_pNpsPrintInfo->dwOrderId						= m_OrderId;
	m_pNpsPrintInfo->PrintInfo.nEspc				= m_Espc;
}
