// DevStartOrderDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "NpsClient.h"
#include "DevStartOrderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevStartOrderDlg _CAO


CDevStartOrderDlg::CDevStartOrderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDevStartOrderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevStartOrderDlg)
	m_SorterNum = 0;
	//}}AFX_DATA_INIT

	m_Priority = 0;
	m_SortFrame = 0;
	m_dwExOptions	= EX_OPTIONS_NONE;
}


void CDevStartOrderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevStartOrderDlg)
	DDX_Control(pDX, IDC_COMBO_SORT_FRAME, m_ComboSortFrame);
	DDX_Control(pDX, IDC_COMBO_PRIORITY, m_ComboPriority);
	DDX_Control(pDX, IDC_EX_OPTIONS_SINGLE_LINE_PRINT_CHECK, m_ExOptionsSingleLinePrintCheck);
	DDX_Text(pDX, IDC_EDIT_SORTER_NUM, m_SorterNum);
	DDV_MinMaxInt(pDX, m_SorterNum, 0, 1000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevStartOrderDlg, CDialog)
	//{{AFX_MSG_MAP(CDevStartOrderDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevStartOrderDlg bZ[W nh

BOOL CDevStartOrderDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	int nMaintenance;
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char sziniFilePath[MAX_PATH];

	// AvP[V̐΃pX擾i΃pXj
	::GetModuleFileName( NULL, sziniFilePath, MAX_PATH );
	::_splitpath( sziniFilePath, drive, dir, fname, ext );
	::_makepath( sziniFilePath, drive, dir, "NpsClient", "ini" );

	nMaintenance = ::GetPrivateProfileInt( "WITHHELD", "Maintenance", 0, sziniFilePath );

	if ( 1 == nMaintenance )
	{
		m_ComboPriority.AddString( "2:EXPRESS (M0)" );
		m_ComboPriority.AddString( "3:EXPRESS (M1)" );
		m_ComboPriority.AddString( "4:EXPRESS (M2)" );
		m_ComboPriority.AddString( "5:CREDIT" );
		m_ComboPriority.AddString( "6:SETTING" );
	}

	m_ComboPriority.SetCurSel( m_Priority );
	m_ComboSortFrame.SetCurSel( m_SortFrame );
	m_ExOptionsSingleLinePrintCheck.SetCheck(0);
	m_dwExOptions = EX_OPTIONS_NONE;

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDevStartOrderDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	m_Priority	= m_ComboPriority.GetCurSel();
	m_SortFrame	= m_ComboSortFrame.GetCurSel();

	// m_dwExOptions bit or B
	// 2014.10.29onłbita EX_OPTIONS_SINGLE_LINE 
	m_dwExOptions = EX_OPTIONS_NONE;
	if (m_ExOptionsSingleLinePrintCheck.GetCheck()) {
		m_dwExOptions |= EX_OPTIONS_SINGLE_LINE;
	}
	
	CDialog::OnOK();
}
