// LogDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "NpsClient.h"
#include "LogDlg.h"
#include "Winsock2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogDlg _CAO


CLogDlg::CLogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLogDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	m_pOutputLog = NULL;

	m_bInit	= FALSE;
}


void CLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogDlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLogDlg, CDialog)
	//{{AFX_MSG_MAP(CLogDlg)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLogDlg bZ[W nh

void CLogDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if( m_bInit )
	{
		CRect	wClientRect;

		GetClientRect( wClientRect );
		
		m_List.MoveWindow( wClientRect );
	}	
}

BOOL CLogDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_pOutputLog = new COutputLog( "NpsClient", "NpsClient", 5242880, 65535 );
	{	// Oo
		DWORD dwFileVersionMS;
		DWORD dwFileVersionLS;
		ReadMyVersion( &dwFileVersionMS, &dwFileVersionLS );
		CString str;
		str.Format( "===== NpsClient Start Version %d.%d.%d.%d =====",
						(WORD)(dwFileVersionMS>>16), (WORD)(dwFileVersionMS&0xFFFF),
						(WORD)(dwFileVersionLS>>16), (WORD)(dwFileVersionLS&0xFFFF));
		m_pOutputLog->LogToMemory( LOG_INFO, __FILE__, __LINE__, str );
	}

	m_bInit	= TRUE;

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CLogDlg::AddText( CString strText )
{
	m_pOutputLog->LogToMemory( LOG_INFO, __FILE__, __LINE__, strText );
	if ( 1000 < m_List.GetCount() )
	{
		m_List.DeleteString( 0 );
	}
	m_List.AddString( strText );
	m_List.SetCurSel( m_List.GetCount() - 1 );

	// ---------------------------------------------
	// Xg{bNX̐XN[o[̒
	// ---------------------------------------------

	// Xg{bNX̃foCXReLXg擾
	CDC *pDC = m_List.GetDC();

	// foCXReLXgɃXg{bNX̃tHgݒ
	CFont* pOldFont = pDC->SelectObject( m_List.GetFont() );

	// Xg{bNX̍ő啶񕝎擾
	int nIdx;
	int nMax = 0;
	int nSize;
	CString strListText;
	for ( nIdx=0 ; m_List.GetCount() > nIdx ; nIdx++ )
	{
		m_List.GetText( nIdx, strListText );
		nSize = pDC->GetTextExtent( strListText ).cx;
		if ( nMax < nSize )
		{
			nMax = nSize;
		}
	}

	// XN[o[ݒ
	m_List.SetHorizontalExtent( nMax + 5 );

	// foCXReLXg̃tHgɖ߂
	pDC->SelectObject( pOldFont );

    // foCXReLXg̊J
	ReleaseDC( pDC );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CLogDlg::ReadMyVersion()
//	ABSTRACT : o[W擾
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL CLogDlg::ReadMyVersion( DWORD* pdwFileVersionMS, DWORD* pdwFileVersionLS )
{
	HMODULE	hModule;
	HRSRC	hRsrc;
	HGLOBAL	hGlobal;
	struct VS_VERSIONINFO { 
		WORD  wLength;			// ̍\̂̃TCY(2oCg)
		WORD  wValueLength;		// ValuẽTCY(2oCg)
		WORD  wType;			// oCieLXg(2oCg)
		WCHAR szKey[16];		// "VS_VERSION_INFO\0"16(32oCg)
		WORD  Padding1[1];		// 2oCgčv40oCg
		VS_FIXEDFILEINFO Value;	// Ƀo[Wԍ
//		WORD  Padding2[];		// ϒ̂C̍\̂ł͕\s
//		WORD  Children[];		// ܂Ӗ̂Ȃf[^
	} *pData;

	*pdwFileVersionMS = 0;
	*pdwFileVersionLS = 0;

	// \[Xǂ
	hModule = GetModuleHandle(NULL);
	if ( NULL != (hRsrc=FindResource( hModule,(LPCTSTR)VS_VERSION_INFO,RT_VERSION)) )
	{
		if ( NULL != (hGlobal=LoadResource(hModule,hRsrc)) )
		{
			// \[XbNĂgp
			pData = (VS_VERSIONINFO*)LockResource(hGlobal);
			*pdwFileVersionMS = pData->Value.dwFileVersionMS;
			*pdwFileVersionLS = pData->Value.dwFileVersionLS;
			return TRUE;
		}
	}

	return FALSE;
}

void CLogDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if ( NULL != m_pOutputLog )
	{
		delete m_pOutputLog;
		m_pOutputLog = NULL;
	}
}

void CLogDlg::LogOut( LPCTSTR lpFunc, LPCTSTR lpStatus, LPCTSTR lpFormat, ... )
{
	va_list pArg;
	TCHAR szLog[1024] = { 0 };
	CString strLog;
	SYSTEMTIME stTime;

	::GetLocalTime( &stTime );

	try
	{
		va_start( pArg, lpFormat );
		vsprintf( szLog, lpFormat, pArg );
		va_end(pArg);
	}
	catch (...)
	{
		strcpy( szLog, "CNpsClientDlg::LogOut() BUFFER FULL ERROR" );
	}

	strLog.Format( "%02d:%02d:%02d'%03d [%-3s] [%s] %s",
					stTime.wHour, stTime.wMinute, stTime.wSecond, stTime.wMilliseconds,
					lpStatus, lpFunc,
					szLog );

	AddText( strLog );
}

///////////////////////////////////////////////////////////////////////////////
CString	CLogDlg::rvi2a( long nValue )
{
	CString strValue;

	switch ( nValue )
	{
	case 1:		strValue = "NPSERR_NORMAL";			break;
	case 4:		strValue = "NPSERR_REJECT2";		break;
	case 5:		strValue = "NPSERR_BADPARAM";		break;
	case 6:		strValue = "NPSERR_SYSERR";			break;
	case 7:		strValue = "NPSERR_PRNERR";			break;
	case 10:	strValue = "NPSERR_REJECT3";		break;
	case 15:	strValue = "NPSERR_REMAINING_DATA";	break;
	case 16:	strValue = "NPSERR_TIMEOUT";		break;
	default:	strValue.Format( "UNKNOWN(%d)", nValue );	break;
	}

	return strValue;
}
CString CLogDlg::ip2a( DWORD dwIPAddress )
{
	in_addr stIpAddress;
	CString strIPAddress;

	stIpAddress.S_un.S_addr = dwIPAddress;

	strIPAddress.Format( "%d,%d,%d,%d", stIpAddress.S_un.S_un_b.s_b1,
										stIpAddress.S_un.S_un_b.s_b2,
										stIpAddress.S_un.S_un_b.s_b3,
										stIpAddress.S_un.S_un_b.s_b4 );

	return strIPAddress;
}
CString CLogDlg::status2a( DWORD dwStatus )
{
	CString strStatus;

	switch ( dwStatus )
	{
	case RESULT_OK:				strStatus.Format( "RESULT_OK(%u)", dwStatus );			break;
	case RESULT_NG:				strStatus.Format( "RESULT_NG(%u)", dwStatus );			break;
	case RESULT_USER_CANCEL:	strStatus.Format( "RESULT_USER_CANCEL(%u)", dwStatus );	break;
	case RESULT_TRANSFER:		strStatus.Format( "RESULT_TRANSFER(%u)", dwStatus );	break;
	case RESULT_PRINT:			strStatus.Format( "RESULT_PRINT(%u)", dwStatus );		break;
	case RESULT_OK_REPEAT:		strStatus.Format( "RESULT_OK_REPEAT(%u)", dwStatus );	break;
	case RESULT_PRINT_REPEAT:	strStatus.Format( "RESULT_PRINT_REPEAT(%u)", dwStatus );break;
	default:					strStatus.Format( "UNKNOWN(%u)", dwStatus );			break;
	}

	return strStatus;
}
CString CLogDlg::unitid2a( long nUnitId )
{
	CString strUnitId;

	switch ( nUnitId )
	{
	case INFO_PRINTER:			strUnitId.Format( "INFO_PRINTER(0x%08X)", nUnitId );			break;
	case INFO_ADVANCE:			strUnitId.Format( "INFO_ADVANCE(0x%08X)", nUnitId );			break;
	case INFO_LASER:			strUnitId.Format( "INFO_LASER(0x%08X)", nUnitId );				break;
	case INFO_DEVELOPMENT:		strUnitId.Format( "INFO_DEVELOPMENT(0x%08X)", nUnitId );		break;
	case INFO_PROCESSOR:		strUnitId.Format( "INFO_PROCESSOR(0x%08X)", nUnitId );			break;
	case INFO_REPLENISHER:		strUnitId.Format( "INFO_REPLENISHER(0x%08X)", nUnitId );		break;
	case INFO_REPLACECARTRIDGE:	strUnitId.Format( "INFO_REPLACECARTRIDGE(0x%08X)", nUnitId );	break;
	case INFO_ACCEPT:			strUnitId.Format( "INFO_ACCEPT(0x%08X)", nUnitId );				break;
	case INFO_POSSESSION:		strUnitId.Format( "INFO_POSSESSION(0x%08X)", nUnitId );			break;
	case INFO_INSTMAG:			strUnitId.Format( "INFO_INSTMAG(0x%08X)", nUnitId );			break;
	case INFO_INFOMAG:			strUnitId.Format( "INFO_INFOMAG(0x%08X)", nUnitId );			break;
	case INFO_STARTCHECK:		strUnitId.Format( "INFO_STARTCHECK(0x%08X)", nUnitId );			break;
	case INFO_REFILLWATER:		strUnitId.Format( "INFO_REFILLWATER(0x%08X)", nUnitId );		break;
	case INFO_DAILYSETUP:		strUnitId.Format( "INFO_DAILYSETUP(0x%08X)", nUnitId );			break;
	case INFO_CNTRSTRP:			strUnitId.Format( "INFO_CNTRSTRP(0x%08X)", nUnitId );			break;
	case INFO_MNTNNC:			strUnitId.Format( "INFO_MNTNNC(0x%08X)", nUnitId );				break;
	case INFO_FAD:				strUnitId.Format( "INFO_FAD(0x%08X)", nUnitId );				break;
	default:					strUnitId.Format( "UNKNOWN(0x%08X)", nUnitId );					break;
	}

	return strUnitId;
}
///////////////////////////////////////////////////////////////////////////////
// NPSCũOo
///////////////////////////////////////////////////////////////////////////////
long CLogDlg::npsLibOpen( LPCSTR lpLogFileName )
{
	int nResult;

	AddText( "--------------------------------------------------------------------------------" );
	LogOut( "npsLibOpen", "<==", "lpLogFileName=\"%s\"", lpLogFileName );
	nResult = ::npsLibOpen( lpLogFileName );
	LogOut( "npsLibOpen", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsLibClose()
{
	int nResult;

	LogOut( "npsLibClose", "<==", "" );
	nResult = ::npsLibClose();
	LogOut( "npsLibClose", "==>", "return=%s", rvi2a(nResult) );
	AddText( "--------------------------------------------------------------------------------" );

	return nResult;
}
long CLogDlg::npsGetNpsVersion( LPWORD pNpsVersion )
{
	int nResult;

	LogOut( "npsGetNpsVersion", "<==", "pNpsVersion=%u", pNpsVersion );
	nResult = ::npsGetNpsVersion( pNpsVersion );
	LogOut( "npsGetNpsVersion", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsSearchPrinter( LPWORD pPrinterNum, DWORD dwWaitTime )
{
	int nResult;

	LogOut( "npsSearchPrinter", "<==", "pPrinterNum=0x%08X, dwWaitTime=%u", pPrinterNum, dwWaitTime );
	nResult = ::npsSearchPrinter( pPrinterNum, dwWaitTime );
	LogOut( "npsSearchPrinter", "==>", "return=%s, *pPrinterNum=%u", rvi2a(nResult), *pPrinterNum );

	return nResult;
}
long CLogDlg::npsGetPrinter( WORD wBufferNum, PNPS_PRINTER_ENUM pPrinterInfo )
{
	int nIdx;
	int nResult;

	LogOut( "npsGetPrinter", "<==", "wBufferNum=%u, pPrinterInfo=0x%08X", wBufferNum, pPrinterInfo );
	nResult = ::npsGetPrinter( wBufferNum, pPrinterInfo );
	for ( nIdx=0 ; wBufferNum > nIdx ; nIdx++ )
	{
		LogOut( "npsGetPrinter", "===", "pPrinterInfo[%d]={ dwIPAddress=%s, szMachineTypeName=\"%s\", szSoftName=\"%s\", szSerialNumber=\"%s\", wSupportResolutions={ %u,%u,%u,%u,%u,%u,%u,%u }, wNpsVersion=0x%04X, MacAddress=%02X-%02X-%02X-%02X-%02X-%02X }",
				nIdx+1, ip2a((pPrinterInfo+nIdx)->dwIPAddress), (pPrinterInfo+nIdx)->szMachineTypeName, (pPrinterInfo+nIdx)->szSoftName, (pPrinterInfo+nIdx)->szSerialNumber,
				(pPrinterInfo+nIdx)->wSupportResolutions[0], (pPrinterInfo+nIdx)->wSupportResolutions[1], (pPrinterInfo+nIdx)->wSupportResolutions[2], (pPrinterInfo+nIdx)->wSupportResolutions[3],
				(pPrinterInfo+nIdx)->wSupportResolutions[4], (pPrinterInfo+nIdx)->wSupportResolutions[5], (pPrinterInfo+nIdx)->wSupportResolutions[6], (pPrinterInfo+nIdx)->wSupportResolutions[7],
				(pPrinterInfo+nIdx)->wNpsVersion,
				(pPrinterInfo+nIdx)->MacAddress[0], (pPrinterInfo+nIdx)->MacAddress[1], (pPrinterInfo+nIdx)->MacAddress[2], (pPrinterInfo+nIdx)->MacAddress[3], (pPrinterInfo+nIdx)->MacAddress[4], (pPrinterInfo+nIdx)->MacAddress[5] );
	}
	LogOut( "npsGetPrinter", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevOpen( DWORD dwIPAddress, HPRINTER* phPrinter, NPSEVENTPROC pEventProc, NPSUNITPROC pUnitProc )
{
	int nResult;

	AddText( "----------------------------------------" );
	LogOut( "npsDevOpen", "<==", "dwIPAddress=%s, phPrinter=0x%08X, pEventProc=0x%08X, pUnitProc=0x%08X", ip2a(dwIPAddress), phPrinter, pEventProc, pUnitProc );
	nResult = ::npsDevOpen( dwIPAddress, phPrinter, pEventProc, pUnitProc );
	LogOut( "npsDevOpen", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevClose( HPRINTER hPrinter )
{
	int nResult;

	LogOut( "npsDevClose", "<==", "hPrinter=0x%08X", hPrinter );
	nResult = ::npsDevClose( hPrinter );
	LogOut( "npsDevClose", "==>", "return=%s", rvi2a(nResult) );
	AddText( "----------------------------------------" );

	return nResult;
}
long CLogDlg::npsDevGetUnitInfo( HPRINTER hPrinter, PNPS_UnitInfo pUnitInfo )
{
	int nResult;

	LogOut( "npsDevGetUnitInfo", "<==", "hPrinter=0x%08X, pUnitInfo=0x%08X", hPrinter, pUnitInfo );
	nResult = ::npsDevGetUnitInfo( hPrinter, pUnitInfo );
	LogOut( "npsDevGetUnitInfo", "===", "pUnitInfo{ dwPrinterStatus=%u, dwAcceptStatus=%u, dwPrinterPossession=%u, dwAdvanceStatus=%u, dwLaserStatus=%u, dwDevelopmentStatus=%u, dwProcessorStatus=%u, dwReplenisherStatus=%u, dwReplaceCartridgeStatus=%u, dwStartUpChecksStatus=%u, dwRefillWaterStatus=%u, dwDailySetupStatus=%u, dwControlStripStatus=%u, dwMaintenanceStatus=%u, dwFadStatus=%u }",
			pUnitInfo->dwPrinterStatus, pUnitInfo->dwAcceptStatus, pUnitInfo->dwPrinterPossession, pUnitInfo->dwAdvanceStatus,
			pUnitInfo->dwLaserStatus, pUnitInfo->dwDevelopmentStatus, pUnitInfo->dwProcessorStatus, pUnitInfo->dwReplenisherStatus,
			pUnitInfo->dwReplaceCartridgeStatus, pUnitInfo->dwStartUpChecksStatus, pUnitInfo->dwRefillWaterStatus, pUnitInfo->dwDailySetupStatus,
			pUnitInfo->dwControlStripStatus, pUnitInfo->dwMaintenanceStatus, pUnitInfo->dwFadStatus );
	LogOut( "npsDevGetUnitInfo", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevGetMagInfo( HPRINTER hPrinter, PNPS_MagInfo pMagInfo, DWORD* pdwSize )
{
	int nIdx;
	int nCnt;
	int nResult;

	LogOut( "npsDevGetMagInfo", "<==", "hPrinter=0x%08X, pMagInfo(size:%d)=0x%08X, *pdwSize=%u", hPrinter, sizeof(NPS_MagInfo), pMagInfo, *pdwSize );
	nResult = ::npsDevGetMagInfo( hPrinter, pMagInfo, pdwSize );
	nCnt = *pdwSize / sizeof(NPS_MagInfo);
	for ( nIdx=0 ; nCnt > nIdx ; nIdx++ )
	{
		LogOut( "npsDevGetMagInfo", "===", "pMagInfo[%d]={ dwWidth=%u, dwSurface=%u, dwRemain=%u, dwFeed=%u, dwPresence=%u, szName=\"%s\" }",
				nIdx+1, (pMagInfo+nIdx)->dwWidth, (pMagInfo+nIdx)->dwSurface, (pMagInfo+nIdx)->dwRemain, (pMagInfo+nIdx)->dwFeed, (pMagInfo+nIdx)->dwPresence, (pMagInfo+nIdx)->szName );
	}
	LogOut( "npsDevGetMagInfo", "==>", "return=%s, *pdwSize=%u(%d)", rvi2a(nResult), *pdwSize, nCnt );

	return nResult;
}
long CLogDlg::npsDevGetSetUpInfo( HPRINTER hPrinter, PNPS_SetUpInfo pSetUpInfo )
{
	int nResult;

	LogOut( "npsDevGetSetUpInfo", "<==", "hPrinter=0x%08X, pSetUpInfo=0x%08X", hPrinter, pSetUpInfo );
	nResult = ::npsDevGetSetUpInfo( hPrinter, pSetUpInfo );
	LogOut( "npsDevGetSetUpInfo", "===", "pSetUpInfo[1/7]{ szMachineTypeName=\"%s\", szSoftName=\"%s\", szSerialNumber=\"%s\" }",
			pSetUpInfo->szMachineTypeName, pSetUpInfo->szSoftName, pSetUpInfo->szSerialNumber );
	LogOut( "npsDevGetSetUpInfo", "===", "pSetUpInfo[2/7]{ wSupportResolutions={%u,%u,%u,%u,%u,%u,%u,%u}, wNpsVersion=0x%04X, wMachineTypeID=%u, dwTotalMemory=%u }",
			pSetUpInfo->wSupportResolutions[0], pSetUpInfo->wSupportResolutions[1], pSetUpInfo->wSupportResolutions[2], pSetUpInfo->wSupportResolutions[3],
			pSetUpInfo->wSupportResolutions[4], pSetUpInfo->wSupportResolutions[5], pSetUpInfo->wSupportResolutions[6], pSetUpInfo->wSupportResolutions[7],
			pSetUpInfo->wNpsVersion, pSetUpInfo->wMachineTypeID, pSetUpInfo->dwTotalMemory );
	LogOut( "npsDevGetSetUpInfo", "===", "pSetUpInfo[3/7]{ dwImageSizeMinWidth=%u, dwImageSizeMinHeight=%u, dwImageSizeMaxWidth=%u, dwImageSizeMaxHeight=%u, dwNumberOfMagazine=%u }",
			pSetUpInfo->dwImageSizeMinWidth, pSetUpInfo->dwImageSizeMinHeight, pSetUpInfo->dwImageSizeMaxWidth, pSetUpInfo->dwImageSizeMaxHeight, pSetUpInfo->dwNumberOfMagazine );
	LogOut( "npsDevGetSetUpInfo", "===", "pSetUpInfo[4/7]{ PrinterTime=%04u/%02u/%02u %02u:%02u:%02u, dwRepeatCountMax=%u, SupportImageFormat={ %d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d } }",
			pSetUpInfo->PrinterTime.tDate.dwYear, pSetUpInfo->PrinterTime.tDate.dwMonth, pSetUpInfo->PrinterTime.tDate.dwDay,
			pSetUpInfo->PrinterTime.tTime.dwHour, pSetUpInfo->PrinterTime.tTime.dwMinute, pSetUpInfo->PrinterTime.tTime.dwSecond, pSetUpInfo->dwRepeatCountMax,
			pSetUpInfo->SupportImageFormat[0], pSetUpInfo->SupportImageFormat[1], pSetUpInfo->SupportImageFormat[2], pSetUpInfo->SupportImageFormat[3],
			pSetUpInfo->SupportImageFormat[4], pSetUpInfo->SupportImageFormat[5], pSetUpInfo->SupportImageFormat[6], pSetUpInfo->SupportImageFormat[7],
			pSetUpInfo->SupportImageFormat[8], pSetUpInfo->SupportImageFormat[9], pSetUpInfo->SupportImageFormat[10],pSetUpInfo->SupportImageFormat[11],
			pSetUpInfo->SupportImageFormat[12],pSetUpInfo->SupportImageFormat[13],pSetUpInfo->SupportImageFormat[14],pSetUpInfo->SupportImageFormat[15] );
	LogOut( "npsDevGetSetUpInfo", "===", "pSetUpInfo[5/7]{ wLaminatorUnitAttach=%u, InstallationDate=%04u/%02u/%02u, OperationStartDate=%04u/%02u/%02u, wProcessorType=%u, wEmulsionNumber=%u }",
			pSetUpInfo->wLaminatorUnitAttach,
			pSetUpInfo->InstallationDate.dwYear, pSetUpInfo->InstallationDate.dwMonth, pSetUpInfo->InstallationDate.dwDay,
			pSetUpInfo->OperationStartDate.dwYear, pSetUpInfo->OperationStartDate.dwMonth, pSetUpInfo->OperationStartDate.dwDay,
			pSetUpInfo->wProcessorType, pSetUpInfo->wEmulsionNumber );
	LogOut( "npsDevGetSetUpInfo", "===", "pSetUpInfo[6/7]{ szPrinterNickname=\"%s\", wSupportAngle=%u, wSupportIntoPrinter=%u, wSorterStatus=%u, wCvpStatus=%u, wSupportPaperFitting=%u }",
			pSetUpInfo->szPrinterNickname, pSetUpInfo->wSupportAngle, pSetUpInfo->wSupportIntoPrinter, pSetUpInfo->wSorterStatus, pSetUpInfo->wCvpStatus, pSetUpInfo->wSupportPaperFitting );
	LogOut( "npsDevGetSetUpInfo", "===", "pSetUpInfo[7/7]{ wSupportEdgeEnhancement=%u, wSupportWithBorder=%u, wMachinTypeForProfile=%u, wPaperTypeCode={ %u,%u,%u,%u,%u,%u }, wSupportCMS=%u, wSetupAlgorithm=%u, wSupportDuplex=%u, dwFadAttachNo=%u }",
			pSetUpInfo->wSupportEdgeEnhancement, pSetUpInfo->wSupportWithBorder, pSetUpInfo->wMachinTypeForProfile,
			pSetUpInfo->wPaperTypeCode[0],pSetUpInfo->wPaperTypeCode[1], pSetUpInfo->wPaperTypeCode[2], pSetUpInfo->wPaperTypeCode[3], pSetUpInfo->wPaperTypeCode[4], pSetUpInfo->wPaperTypeCode[5],
			pSetUpInfo->wSupportCMS, pSetUpInfo->wSetupAlgorithm, pSetUpInfo->wSupportDuplex, pSetUpInfo->dwFadAttachNo );
	LogOut( "npsDevGetSetUpInfo", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevGetPrintNumInfo( HPRINTER hPrinter, PNPS_PrintNumInfo pPrintNumInfo )
{
	int nResult;

	LogOut( "npsDevGetPrintNumInfo", "<==", "hPrinter=0x%08X, pPrintNumInfo=0x%08X" );
	nResult = ::npsDevGetPrintNumInfo( hPrinter, pPrintNumInfo );
	LogOut( "npsDevGetPrintNumInfo", "===", "pPrintNumInfo={ dwSdkReserver=%u, dwFrmRatio=%u, dwReserver=%u, dwPrtNumber=%u, dwProNumber=%u, dwTotalCount=%u }",
			pPrintNumInfo->dwSdkReserver, pPrintNumInfo->dwFrmRatio, pPrintNumInfo->dwReserver, pPrintNumInfo->dwPrtNumber, pPrintNumInfo->dwProNumber, pPrintNumInfo->dwTotalCount );
	LogOut( "npsDevGetPrintNumInfo", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevResetEvent( HPRINTER hPrinter, DWORD dwErrHandle, DWORD dwActionId )
{
	int nResult;

	LogOut( "npsDevResetEvent", "<==", "hPrinter=0x%08X, dwErrHandle=%u, dwActionId=%u", hPrinter, dwErrHandle, dwActionId );
	nResult = ::npsDevResetEvent( hPrinter, dwErrHandle, dwActionId );
	LogOut( "npsDevResetEvent", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevIsReady( HPRINTER hPrinter )
{
	int nResult;

	LogOut( "npsDevIsReady", "<==", "hPrinter=0x%08X", hPrinter );
	nResult = ::npsDevIsReady( hPrinter );
	LogOut( "npsDevIsReady", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevStartOrderEx( HPRINTER hPrinter, DWORD* pdwOrderId, NPSCOMPLETIONPROC pEventProc, DWORD dwPriority, DWORD dwSorterNum, DWORD dwSortFrame, DWORD dwExOptions )
{
	int nResult;

	LogOut( "npsDevStartOrderEx", "<==", "hPrinter=0x%08X, pdwOrderId=0x%08X, pEventProc=0x%08X, dwPriority=%u, dwSorterNum=%u, dwSortFrame=%u, dwExOptions=%u", hPrinter, pdwOrderId, pEventProc, dwPriority, dwSorterNum, dwSortFrame, dwExOptions );
	nResult = ::npsDevStartOrderEx( hPrinter, pdwOrderId, pEventProc, dwPriority, dwSorterNum, dwSortFrame, dwExOptions );
	LogOut( "npsDevStartOrderEx", "==>", "return=%s, *pdwOrderId=0x%08X", rvi2a(nResult), *pdwOrderId );

	return nResult;
}
long CLogDlg::npsDevEndOrder( HPRINTER hPrinter, DWORD dwOrderId )
{
	int nResult;

	LogOut( "npsDevEndOrder", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X", hPrinter, dwOrderId );
	nResult = ::npsDevEndOrder( hPrinter, dwOrderId );
	LogOut( "npsDevEndOrder", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevPrint( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, PNPS_PrintInfo pPrintInfo )
{
	int nResult;

	LogOut( "npsDevPrint", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X, pPrintID=0x%08X, pEventProc=0x%08X, pPrintInfo=0x%08X", hPrinter, dwOrderId, pPrintID, pEventProc, pPrintInfo );
	LogOut( "npsDevPrint", "===", "pPrintInfo[1/8]={ dwImageFormat=%u, dwColorSpace=%u, dwSourceType=%u, dwDataLength=%u, pName=\"%s\", dwOffset=%u }",
			pPrintInfo->dwImageFormat, pPrintInfo->dwColorSpace, pPrintInfo->dwSourceType, pPrintInfo->dwDataLength, pPrintInfo->pName, pPrintInfo->dwOffset );
	LogOut( "npsDevPrint", "===", "pPrintInfo[2/8]={ dwImgWidth=%u, dwImgHeight=%u, dwResolution=%u, dwPaperWidth=%u, dwPaperLength=%u, dwCvpPrintSize=%u }",
			pPrintInfo->dwImgWidth, pPrintInfo->dwImgHeight, pPrintInfo->dwResolution, pPrintInfo->dwPaperWidth, pPrintInfo->dwPaperLength, pPrintInfo->dwCvpPrintSize );
	LogOut( "npsDevPrint", "===", "pPrintInfo[3/8]={ dwCvpInitialValue1=%u, dwCvpPoint1=%u, dwCvpInitialWidth1=%u, szCvpLine1=\"%s\" }",
			pPrintInfo->dwCvpInitialValue1, pPrintInfo->dwCvpPoint1, pPrintInfo->dwCvpInitialWidth1, pPrintInfo->szCvpLine1 );
	LogOut( "npsDevPrint", "===", "pPrintInfo[4/8]={ dwCvpInitialValue2=%u, dwCvpPoint2=%u, dwCvpInitialWidth2=%u, szCvpLine2=\"%s\" }",
			pPrintInfo->dwCvpInitialValue2, pPrintInfo->dwCvpPoint2, pPrintInfo->dwCvpInitialWidth2, pPrintInfo->szCvpLine2 );
	LogOut( "npsDevPrint", "===", "pPrintInfo[5/8]={ dwPrintNum=%u, dwFeed=%u, dwSurface=%u, dwPaperPresence=%u, nEspc=%d, wCMS=%u, wAngle=%u }",
			pPrintInfo->dwPrintNum, pPrintInfo->dwFeed, pPrintInfo->dwSurface, pPrintInfo->dwPaperPresence, pPrintInfo->nEspc, pPrintInfo->wCMS, pPrintInfo->wAngle );
	LogOut( "npsDevPrint", "===", "pPrintInfo[6/8]={ wPaperFitting=%u, wEdgeEnhancement=%u, wWithBorderTop=%u, wWithBorderBottom=%u, wWithBorderLeft=%u, wWithBorderRight=%u }",
			pPrintInfo->wPaperFitting, pPrintInfo->wEdgeEnhancement, pPrintInfo->wWithBorderTop, pPrintInfo->wWithBorderBottom, pPrintInfo->wWithBorderLeft, pPrintInfo->wWithBorderRight );
	LogOut( "npsDevPrint", "===", "pPrintInfo[7/8]={ byWithBorderColor={ %d,%d,%d }, szPaperName=\"%s\", nPcfms=%d, wPrintQuality=%u, byImageEnlargeType=%u }",
			pPrintInfo->byWithBorderColor[0], pPrintInfo->byWithBorderColor[1], pPrintInfo->byWithBorderColor[2], pPrintInfo->szPaperName, pPrintInfo->nPcfms, pPrintInfo->wPrintQuality, pPrintInfo->byImageEnlargeType );
	LogOut( "npsDevPrint", "===", "pPrintInfo[8/8]={ wLoadingCount=%u, wPrintedCount=%u, dwEventId=%u, wEventCodeMain=%u }",
			pPrintInfo->wLoadingCount, pPrintInfo->wPrintedCount, pPrintInfo->dwEventId, pPrintInfo->wEventCodeMain );
	nResult = ::npsDevPrint( hPrinter, dwOrderId, pPrintID, pEventProc, pPrintInfo );
	LogOut( "npsDevPrint", "==>", "return=%s, *pPrintID=%u", rvi2a(nResult), *pPrintID );

	return nResult;
}
long CLogDlg::npsDevSort( HPRINTER hPrinter, DWORD dwOrderId )
{
	int nResult;

	LogOut( "npsDevSort", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X", hPrinter, dwOrderId );
	nResult = ::npsDevSort( hPrinter, dwOrderId );
	LogOut( "npsDevSort", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevCancelPrintOrder( HPRINTER hPrinter, DWORD dwOrderId, DWORD dwPrintID )
{
	int nResult;

	LogOut( "npsDevCancelPrintOrder", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X, dwPrintID=%u", hPrinter, dwOrderId, dwPrintID );
	nResult = ::npsDevCancelPrintOrder( hPrinter, dwOrderId, dwPrintID );
	LogOut( "npsDevCancelPrintOrder", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevGetPrintStatus( HPRINTER hPrinter, DWORD dwPrintID, LPDWORD pPrintStatus )
{
	int nResult;

	LogOut( "npsDevGetPrintStatus", "<==", "hPrinter=0x%08X, dwPrintID=%u, pPrintStatus=0x%08X", hPrinter, dwPrintID, pPrintStatus );
	nResult = ::npsDevGetPrintStatus( hPrinter, dwPrintID, pPrintStatus );
	LogOut( "npsDevGetPrintStatus", "==>", "return=%s, *pPrintStatus=%u", rvi2a(nResult), *pPrintStatus );

	return nResult;
}
long CLogDlg::npsDevSetTime( HPRINTER hPrinter, PNPS_DateTime pTime )
{
	int nResult;

	LogOut( "npsDevSetTime", "<==", "hPrinter=0x%08X, pTime=%04u/%02u/%02u %02u:%02u:%02u", hPrinter,
			pTime->tDate.dwYear, pTime->tDate.dwMonth, pTime->tDate.dwDay, pTime->tTime.dwHour, pTime->tTime.dwMinute, pTime->tTime.dwSecond );
	nResult = ::npsDevSetTime( hPrinter, pTime );
	LogOut( "npsDevSetTime", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevGetTime( HPRINTER hPrinter, PNPS_DateTime pTime )
{
	int nResult;

	LogOut( "npsDevGetTime", "<==", "hPrinter=0x%08X, pTime=0x%08X", hPrinter, pTime );
	nResult = ::npsDevGetTime( hPrinter, pTime );
	LogOut( "npsDevGetTime", "==>", "return=%s, *pTime=%04u/%02u/%02u %02u:%02u:%02u", rvi2a(nResult),
			pTime->tDate.dwYear, pTime->tDate.dwMonth, pTime->tDate.dwDay, pTime->tTime.dwHour, pTime->tTime.dwMinute, pTime->tTime.dwSecond );

	return nResult;
}
long CLogDlg::npsDevCloseCheck( HPRINTER hPrinter )
{
	int nResult;

	LogOut( "npsDevCloseCheck", "<==", "hPrinter=0x%08X", hPrinter );
	nResult = ::npsDevCloseCheck( hPrinter );
	LogOut( "npsDevCloseCheck", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevGetAllMagInfo( HPRINTER hPrinter, PNPS_MagDetailInfo pMagDetailInfo, DWORD* pdwSize )
{
	int nCnt;
	int nIdx;
	int nResult;

	LogOut( "npsDevGetAllMagInfo", "<==", "hPrinter=0x%08X, pMagDetailInfo(size:%d)=0x%08X, *pdwSize=%u", hPrinter, sizeof(NPS_MagDetailInfo), pMagDetailInfo, *pdwSize );
	nResult = ::npsDevGetAllMagInfo( hPrinter, pMagDetailInfo, pdwSize );
	nCnt = *pdwSize / sizeof(NPS_MagDetailInfo);
	for ( nIdx=0 ; nCnt > nIdx ; nIdx++ )
	{
		LogOut( "npsDevGetAllMagInfo", "===", "pMagDetailInfo[%d]={ dwWidth=%u, dwLength={ %u - %u }, dwSurface=%u, dwResolution={ %u,%u,%u,%u,%u,%u,%u,%u }, nAllocation={ %d,%d,%d,%d }, dwSetupStatus=%u, dwFeed=%u, nWBAdjust={ %d,%d }, szPaperName=\"%s\", wPaperTypeCode=%u, wDirection=%u, wPrintQuality=%u, PaperTypeValid=%u, PaperType=%u }",
				nIdx+1, (pMagDetailInfo+nIdx)->dwWidth, (pMagDetailInfo+nIdx)->dwLengthMin, (pMagDetailInfo+nIdx)->dwLengthMax, (pMagDetailInfo+nIdx)->dwSurface,
				(pMagDetailInfo+nIdx)->dwResolution[0], (pMagDetailInfo+nIdx)->dwResolution[1], (pMagDetailInfo+nIdx)->dwResolution[2], (pMagDetailInfo+nIdx)->dwResolution[3],
				(pMagDetailInfo+nIdx)->dwResolution[4], (pMagDetailInfo+nIdx)->dwResolution[5], (pMagDetailInfo+nIdx)->dwResolution[6], (pMagDetailInfo+nIdx)->dwResolution[7],
				(pMagDetailInfo+nIdx)->nAllocationTop, (pMagDetailInfo+nIdx)->nAllocationBottom, (pMagDetailInfo+nIdx)->nAllocationLeft, (pMagDetailInfo+nIdx)->nAllocationRight,
				(pMagDetailInfo+nIdx)->dwSetupStatus, (pMagDetailInfo+nIdx)->dwFeed, (pMagDetailInfo+nIdx)->nWBAdjustLeft, (pMagDetailInfo+nIdx)->nWBAdjustRight,
				(pMagDetailInfo+nIdx)->szPaperName, (pMagDetailInfo+nIdx)->wPaperTypeCode, (pMagDetailInfo+nIdx)->wDirection, (pMagDetailInfo+nIdx)->wPrintQuality,
				(pMagDetailInfo+nIdx)->PaperTypeValid, (pMagDetailInfo+nIdx)->PaperType );
	}
	LogOut( "npsDevGetAllMagInfo", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevCtrlPrint( HPRINTER hPrinter, DWORD dwCtrl )
{
	int nResult;

	LogOut( "npsDevCtrlPrint", "<==", "hPrinter=0x%08X, dwCtrl=%u", hPrinter, dwCtrl );
	nResult = ::npsDevCtrlPrint( hPrinter, dwCtrl );
	LogOut( "npsDevCtrlPrint", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevExpressOrder( HPRINTER hPrinter, DWORD dwOrderId )
{
	int nResult;

	LogOut( "npsDevExpressOrder", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X", hPrinter, dwOrderId );
	nResult = ::npsDevExpressOrder( hPrinter, dwOrderId );
	LogOut( "npsDevExpressOrder", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevGetProfile( HPRINTER hPrinter, LPCSTR lpFileName, PNPS_PaperInfo pPaperInfo )
{
	int nResult;

	LogOut( "npsDevGetProfile", "<==", "hPrinter=0x%08X, lpFileName=\"%s\", pPaperInfo{ dwWidth=, dwSurface=, dwFeed=, szPaperName=\"%s\" }",
			hPrinter, lpFileName, pPaperInfo->dwWidth, pPaperInfo->dwSurface, pPaperInfo->dwFeed, pPaperInfo->szPaperName );
	nResult = ::npsDevGetProfile( hPrinter, lpFileName, pPaperInfo );
	LogOut( "npsDevGetProfile", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsSetCompletionProcMode( DWORD dwMode )
{
	int nResult;

	LogOut( "npsSetCompletionProcMode", "<==", "dwMode=0x%08X", dwMode );
	nResult = ::npsSetCompletionProcMode( dwMode );
	LogOut( "npsSetCompletionProcMode", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevStartDuplex( HPRINTER hPrinter, DWORD dwOrderId )
{
	int nResult;

	LogOut( "npsDevStartDuplex", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X", hPrinter, dwOrderId );
	nResult = ::npsDevStartDuplex( hPrinter, dwOrderId );
	LogOut( "npsDevStartDuplex", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevEndDuplex( HPRINTER hPrinter, DWORD dwOrderId )
{
	int nResult;

	LogOut( "npsDevEndDuplex", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X", hPrinter, dwOrderId );
	nResult = ::npsDevEndDuplex( hPrinter, dwOrderId );
	LogOut( "npsDevEndDuplex", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevBlankPrint( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, PNPS_BlankPrintInfo pBlankPrintInfo )
{
	int nResult;

	LogOut( "npsDevBlankPrint", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X, pPrintID=0x%08X, pEventProc=0x%08X, pBlankPrintInfo=0x%08X", hPrinter, dwOrderId, pPrintID, pEventProc, pBlankPrintInfo );
	LogOut( "npsDevBlankPrint", "===", "pBlankPrintInfo[1/2]={ dwResolution=%u, dwPaperWidth=%u, dwPaperLength=%u, dwPrintNum=%u, dwFeed=%u, dwSurface=%u, dwPaperPresence=%u }",
			 pBlankPrintInfo->dwResolution, pBlankPrintInfo->dwPaperWidth, pBlankPrintInfo->dwPaperLength, pBlankPrintInfo->dwPrintNum, pBlankPrintInfo->dwFeed, pBlankPrintInfo->dwSurface, pBlankPrintInfo->dwPaperPresence );
	LogOut( "npsDevBlankPrint", "===", "pBlankPrintInfo[2/2]={ szPaperName=\"%s\", dwClearInk=%u, wPrintQuality=%u }",
			 pBlankPrintInfo->szPaperName, pBlankPrintInfo->dwClearInk, pBlankPrintInfo->wPrintQuality );
	nResult = ::npsDevBlankPrint( hPrinter, dwOrderId, pPrintID, pEventProc, pBlankPrintInfo );
	LogOut( "npsDevBlankPrint", "==>", "return=%s, *pPrintID=%u", rvi2a(nResult), *pPrintID );

	return nResult;
}
long CLogDlg::npsSearchPrinter2( LPWORD pPrinterNum, DWORD dwWaitTime )
{
	int nResult;

	LogOut( "npsSearchPrinter2", "<==", "pPrinterNum=0x%08X, dwWaitTime=%u", pPrinterNum, dwWaitTime );
	nResult = ::npsSearchPrinter2( pPrinterNum, dwWaitTime );
	LogOut( "npsSearchPrinter2", "==>", "return=%s, *pPrinterNum=%u", rvi2a(nResult), *pPrinterNum );

	return nResult;
}
long CLogDlg::npsDevNpsCommand1( HPRINTER hPrinter, WORD wIfId, WORD wSendCmdId, WORD wSendBufLen, LPVOID lpSendBuf, WORD wRecvCmdId, LPWORD pwRecvBufLen, LPVOID lpRecvBuf, DWORD dwTimeOut )
{
	int nResult;

	LogOut( "npsDevNpsCommand1", "<==", "hPrinter=0x%08X, wIfId=0x%04X, wSendCmdId=0x%04X, wSendBufLen=%u, lpSendBuf=0x%08X, wRecvCmdId=0x%04X, pwRecvBufLen=0x%08X, lpRecvBuf=0x%08X, dwTimeOut=%u",
			hPrinter, wIfId, wSendCmdId, wSendBufLen, lpSendBuf, wRecvCmdId, pwRecvBufLen, lpRecvBuf, dwTimeOut );
	nResult = ::npsDevNpsCommand1( hPrinter, wIfId, wSendCmdId, wSendBufLen, lpSendBuf, wRecvCmdId, pwRecvBufLen, lpRecvBuf, dwTimeOut );
	LogOut( "npsDevNpsCommand1", "==>", "return=%s, *pwRecvBufLen=%u", rvi2a(nResult), *pwRecvBufLen );

	return nResult;
}
long CLogDlg::npsDevNpsCommand2( HPRINTER hPrinter, WORD wIfId, WORD wSendCmdId, WORD wSendBufLen, LPVOID lpSendBuf, WORD wRecvCmdId, LPWORD pwRecvBufLen, RECVPROC pRecvProc, DWORD dwTimeOut )
{
	int nResult;

	LogOut( "npsDevNpsCommand2", "<==", "hPrinter=0x%08X, wIfId=0x%04X, wSendCmdId=0x%04X, wSendBufLen=5u, lpSendBuf=0x%08X, wRecvCmdId=0x%04X, pwRecvBufLen=0x%08X, pRecvProc=0x%08X, dwTimeOut=%u",
			hPrinter, wIfId, wSendCmdId, wSendBufLen, lpSendBuf, wRecvCmdId, pwRecvBufLen, pRecvProc, dwTimeOut );
	nResult = ::npsDevNpsCommand2( hPrinter, wIfId, wSendCmdId, wSendBufLen, lpSendBuf, wRecvCmdId, pwRecvBufLen, pRecvProc, dwTimeOut );
	LogOut( "npsDevNpsCommand2", "==>", "return=%s, *pwRecvBufLen=%u", rvi2a(nResult), *pwRecvBufLen );

	return nResult;
}
long CLogDlg::npsDevNpsNotice( HPRINTER hPrinter, WORD wIfId, WORD wCmdId, NOTICEPROC pNoticeProc )
{
	int nResult;

	LogOut( "npsDevNpsNotice", "<==", "hPrinter=0x%08X, wIfId=0x%04X, wCmdId=0x%04X, pNoticeProc=0x%08X", hPrinter, wIfId, wCmdId, pNoticeProc );
	nResult = ::npsDevNpsNotice( hPrinter, wIfId, wCmdId, pNoticeProc );
	LogOut( "npsDevNpsNotice", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevCancelPrintAll( HPRINTER hPrinter )
{
	int nResult;

	LogOut( "npsDevCancelPrintAll", "<==", "hPrinter=0x%08X", hPrinter );
	nResult = ::npsDevCancelPrintAll( hPrinter );
	LogOut( "npsDevCancelPrintAll", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevOccupyCheck( HPRINTER hPrinter )
{
	int nResult;

	LogOut( "npsDevOccupyCheck", "<==", "hPrinter=0x%08X", hPrinter );
	nResult = ::npsDevOccupyCheck( hPrinter );
	LogOut( "npsDevOccupyCheck", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsSetLanguage( LPCSTR lpLangName )
{
	int nResult;

	LogOut( "npsSetLanguage", "<==", "lpLangName=\"%s\"", lpLangName );
	nResult = ::npsSetLanguage( lpLangName );
	LogOut( "npsSetLanguage", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsSetCustomMode( DWORD dwMode )
{
	int nResult;

	LogOut( "npsSetCustomMode", "<==", "dwMode=0x%08X", dwMode );
	nResult = ::npsSetCustomMode( dwMode );
	LogOut( "npsSetCustomMode", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsSetConnectMode( DWORD dwMode )
{
	int nResult;

	LogOut( "npsSetConnectMode", "<==", "dwMode=0x%08X", dwMode );
	nResult = ::npsSetConnectMode( dwMode );
	LogOut( "npsSetConnectMode", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevGetTransmitTime( HPRINTER hPrinter, LPDWORD pOrderId, LPDWORD pPrintID, LPDWORD pTime )
{
	int nResult;

	LogOut( "npsDevGetTransmitTime", "<==", "hPrinter=0x%08X, pOrderId=0x%08X, pPrintID=0x%08X, pTime=0x%08X", hPrinter, pOrderId, pPrintID, pTime );
	nResult = ::npsDevGetTransmitTime( hPrinter, pOrderId, pPrintID, pTime );
	LogOut( "npsDevGetTransmitTime", "==>", "return=%s, *pPrintID=%u, *pTime=%u", rvi2a(nResult), *pPrintID, *pTime );

	return nResult;
}
long CLogDlg::npsSetTempFolder( LPCSTR lpFolderName )
{
	int nResult;

	LogOut( "npsSetTempFolder", "<==", "lpFolderName=\"%s\"", lpFolderName );
	nResult = ::npsSetTempFolder( lpFolderName );
	LogOut( "npsSetTempFolder", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevPrintIccsXml( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, short priority, PNPS_PrintInfoIccsXml pPrintInfo )
{
	int nResult;

	LogOut( "npsDevPrintIccsXml", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X, pPrintID=0x%08X, pEventProc=0x%08X, pPrintInfo=0x%08X", hPrinter, dwOrderId, pPrintID, pEventProc, pPrintInfo );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[1/8]={ dwImageFormat=%u, dwColorSpace=%u, dwSourceType=%u, dwDataLength=%u, pName=\"%s\", dwOffset=%u }",
			pPrintInfo->printInfo.dwImageFormat, pPrintInfo->printInfo.dwColorSpace, pPrintInfo->printInfo.dwSourceType, pPrintInfo->printInfo.dwDataLength, pPrintInfo->printInfo.pName, pPrintInfo->printInfo.dwOffset );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[2/8]={ dwImgWidth=%u, dwImgHeight=%u, dwResolution=%u, dwPaperWidth=%u, dwPaperLength=%u, dwCvpPrintSize=%u }",
			pPrintInfo->printInfo.dwImgWidth, pPrintInfo->printInfo.dwImgHeight, pPrintInfo->printInfo.dwResolution, pPrintInfo->printInfo.dwPaperWidth, pPrintInfo->printInfo.dwPaperLength, pPrintInfo->printInfo.dwCvpPrintSize );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[3/8]={ dwCvpInitialValue1=%u, dwCvpPoint1=%u, dwCvpInitialWidth1=%u, szCvpLine1=\"%s\" }",
			pPrintInfo->printInfo.dwCvpInitialValue1, pPrintInfo->printInfo.dwCvpPoint1, pPrintInfo->printInfo.dwCvpInitialWidth1, pPrintInfo->printInfo.szCvpLine1 );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[4/8]={ dwCvpInitialValue2=%u, dwCvpPoint2=%u, dwCvpInitialWidth2=%u, szCvpLine2=\"%s\" }",
			pPrintInfo->printInfo.dwCvpInitialValue2, pPrintInfo->printInfo.dwCvpPoint2, pPrintInfo->printInfo.dwCvpInitialWidth2, pPrintInfo->printInfo.szCvpLine2 );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[5/8]={ dwPrintNum=%u, dwFeed=%u, dwSurface=%u, dwPaperPresence=%u, nEspc=%d, wCMS=%u, wAngle=%u }",
			pPrintInfo->printInfo.dwPrintNum, pPrintInfo->printInfo.dwFeed, pPrintInfo->printInfo.dwSurface, pPrintInfo->printInfo.dwPaperPresence, pPrintInfo->printInfo.nEspc, pPrintInfo->printInfo.wCMS, pPrintInfo->printInfo.wAngle );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[6/8]={ wPaperFitting=%u, wEdgeEnhancement=%u, wWithBorderTop=%u, wWithBorderBottom=%u, wWithBorderLeft=%u, wWithBorderRight=%u }",
			pPrintInfo->printInfo.wPaperFitting, pPrintInfo->printInfo.wEdgeEnhancement, pPrintInfo->printInfo.wWithBorderTop, pPrintInfo->printInfo.wWithBorderBottom, pPrintInfo->printInfo.wWithBorderLeft, pPrintInfo->printInfo.wWithBorderRight );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[7/8]={ byWithBorderColor={ %d,%d,%d }, szPaperName=\"%s\", nPcfms=%d, wPrintQuality=%u, byImageEnlargeType=%u }",
			pPrintInfo->printInfo.byWithBorderColor[0], pPrintInfo->printInfo.byWithBorderColor[1], pPrintInfo->printInfo.byWithBorderColor[2], pPrintInfo->printInfo.szPaperName, pPrintInfo->printInfo.nPcfms, pPrintInfo->printInfo.wPrintQuality, pPrintInfo->printInfo.byImageEnlargeType );
	LogOut( "npsDevPrintIccsXml", "===", "pPrintInfo[7/8]={ pIccsCmdFilePath=\"%s\" }",
			pPrintInfo->pIccsCmdFilePath );
	nResult = ::npsDevPrintIccsXml( hPrinter, dwOrderId, pPrintID, pEventProc, priority, pPrintInfo );
	LogOut( "npsDevPrintIccsXml", "==>", "return=%s, *pPrintID=%u", rvi2a(nResult), *pPrintID );

	return nResult;
}
long CLogDlg::npsDevStartFAD( HPRINTER hPrinter, DWORD dwOrderId, LPCSTR lpOrderKey, LPDWORD lpdwResult, WORD wFadOut, LPCSTR lpFadFileName )
{
	int nResult;

	LogOut( "npsDevStartFAD", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X, lpOrderKey=\"%s\", lpdwResult=0x%08X, wFadOut=%u, lpFadFileName=\"%s\"", hPrinter, dwOrderId, lpOrderKey, lpdwResult, wFadOut, lpFadFileName );
	nResult = ::npsDevStartFAD( hPrinter, dwOrderId, lpOrderKey, lpdwResult, wFadOut, lpFadFileName );
	LogOut( "npsDevStartFAD", "==>", "return=%s, *lpdwResult=0x%08X", rvi2a(nResult), *lpdwResult );

	return nResult;
}
long CLogDlg::npsDevAdjustForPrint( HPRINTER hPrinter )
{
	int nResult;

	LogOut( "npsDevAdjustForPrint", "<==", "hPrinter=0x%08X", hPrinter );
	nResult = ::npsDevAdjustForPrint( hPrinter );
	LogOut( "npsDevAdjustForPrint", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevStartRetransmission( HPRINTER hPrinter, DWORD dwOrderId, PNPS_InterruptOrderInfo pInterruptOrderInfo )
{
	int nResult;

	LogOut( "npsDevStartRetransmission", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X, pInterruptOrderInfo=0x%08X", hPrinter, dwOrderId, pInterruptOrderInfo );
	LogOut( "npsDevStartRetransmission", "===", "pInterruptOrderInfo[1/1]={ wOrderState=%u, wMainSideState=%u, wBackSideState=%u, wPrintSide=%u }",
			pInterruptOrderInfo->wOrderState, pInterruptOrderInfo->wMainSideState, pInterruptOrderInfo->wBackSideState, pInterruptOrderInfo->wPrintSide );
	nResult = ::npsDevStartRetransmission( hPrinter, dwOrderId, pInterruptOrderInfo );
	LogOut( "npsDevStartRetransmission", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevEndRetransmission( HPRINTER hPrinter, DWORD dwOrderId )
{
	int nResult;

	LogOut( "npsDevEndRetransmission", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X", hPrinter, dwOrderId );
	nResult = ::npsDevEndRetransmission( hPrinter, dwOrderId );
	LogOut( "npsDevEndRetransmission", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevInterruptPrintOrder( HPRINTER hPrinter, DWORD dwOrderId, PNPS_InterruptOrderInfo pInterruptOrderInfo )
{
	int nResult;

	LogOut( "npsDevInterruptPrintOrder", "<==", "hPrinter=0x%08X, dwOrderId=0x%08X, pInterruptOrderInfo=0x%08X", hPrinter, dwOrderId, pInterruptOrderInfo );
	nResult = ::npsDevInterruptPrintOrder( hPrinter, dwOrderId, pInterruptOrderInfo );
	LogOut( "npsDevInterruptPrintOrder", "===", "pInterruptOrderInfo[1/1]={ wOrderState=%u, wMainSideState=%u, wBackSideState=%u, wPrintSide=%u }",
			pInterruptOrderInfo->wOrderState, pInterruptOrderInfo->wMainSideState, pInterruptOrderInfo->wBackSideState, pInterruptOrderInfo->wPrintSide );
	LogOut( "npsDevInterruptPrintOrder", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
long CLogDlg::npsDevNpsNoticeEventProcEx( HPRINTER hPrinter, NPSEVENTPROCEX pEventProcEx )
{
	int nResult;

	LogOut( "npsDevNpsNoticeEventProcEx", "<==", "hPrinter=0x%08X, pEventProcEx=0x%08X", hPrinter, pEventProcEx );
	nResult = ::npsDevNpsNoticeEventProcEx( hPrinter, pEventProcEx );
	LogOut( "npsDevNpsNoticeEventProcEx", "==>", "return=%s", rvi2a(nResult) );

	return nResult;
}
void CLogDlg::CALLBACK_NPSEVENTPROC( PNPSEVENTINFO pEventInfo )
{
	LogOut( "PNPSEVENTINFO", ">>>", "hPrinter=0x%08X, dwIPAddress=\"%s\", dwErrHandle=0x%08X, sysTime=%04d/%02d/%02d %02d:%02d:%02d, dwErrCode=%u, dwOnOff=%u, alParams={ %d,%d,%d,%d }, szStrings={ \"%s\",\"%s\",\"%s\",\"%s\" }",
		pEventInfo->hPrinter, ip2a(pEventInfo->dwIPAddress), pEventInfo->dwErrHandle,
		pEventInfo->sysTime.wYear, pEventInfo->sysTime.wMonth, pEventInfo->sysTime.wDay,
		pEventInfo->sysTime.wHour, pEventInfo->sysTime.wMinute, pEventInfo->sysTime.wSecond,
		pEventInfo->dwErrCode, pEventInfo->dwOnOff,
		pEventInfo->alParams[0], pEventInfo->alParams[1], pEventInfo->alParams[2], pEventInfo->alParams[3],
		pEventInfo->szStrings[0], pEventInfo->szStrings[1], pEventInfo->szStrings[2], pEventInfo->szStrings[3] );
}
void CLogDlg::CALLBACK_NPSUNITPROC( PNPSUNITNOTIFYINFO pUnitInfo )
{
	LogOut( "NPSUNITPROC", ">>>", "hPrinter=0x%08X, dwIPAddress=%s, wPortNo=%d, lUnitId=%s, Status={ %d -> %d }",
		pUnitInfo->hPrinter, ip2a(pUnitInfo->dwIPAddress), pUnitInfo->wPortNo, unitid2a(pUnitInfo->lUnitId), pUnitInfo->iOldStatus, pUnitInfo->iNewStatus );
}
void CLogDlg::CALLBACK_NPSCOMPLETIONPROC( DWORD dwCompletionCode, PVOID pCompletionInfo )
{
	PNPSPRINTINFO pNpsPrintInfo = NULL;
	PNPSORDERINFO pNpsOrderInfo = NULL;

	switch ( dwCompletionCode )
	{
	case COMPLETION_PRINT:
		pNpsPrintInfo = (PNPSPRINTINFO)pCompletionInfo;
		LogOut( "NPSCOMPLETIONPROC", ">>>", "dwCompletionCode=COMPLETION_PRINT(0), pCompletionInfo={ hPrinter=0x%08X, dwIPAddress=%s, sysTime=%04d/%02d/%02d %02d:%02d:%02d, dwPrintId=%u, dwStatus=%s, dwFinishNum=%u }",
				pNpsPrintInfo->hPrinter, ip2a(pNpsPrintInfo->dwIPAddress),
				pNpsPrintInfo->sysTime.wYear, pNpsPrintInfo->sysTime.wMonth, pNpsPrintInfo->sysTime.wDay,
				pNpsPrintInfo->sysTime.wHour, pNpsPrintInfo->sysTime.wMinute, pNpsPrintInfo->sysTime.wSecond,
				pNpsPrintInfo->dwPrintId, status2a(pNpsPrintInfo->dwStatus), pNpsPrintInfo->dwFinishNum );
		break;
	case COMPLETION_ORDER:
		pNpsOrderInfo = (PNPSORDERINFO)pCompletionInfo;
		LogOut( "NPSCOMPLETIONPROC", ">>>", "dwCompletionCode=COMPLETION_ORDER(3), pCompletionInfo={ hPrinter=0x%08X, dwIPAddress=%s, sysTime=%04d/%02d/%02d %02d:%02d:%02d, dwOrderId=%u, dwStatus=%s }",
				pNpsOrderInfo->hPrinter, ip2a(pNpsOrderInfo->dwIPAddress),
				pNpsOrderInfo->sysTime.wYear, pNpsOrderInfo->sysTime.wMonth, pNpsOrderInfo->sysTime.wDay,
				pNpsOrderInfo->sysTime.wHour, pNpsOrderInfo->sysTime.wMinute, pNpsOrderInfo->sysTime.wSecond,
				pNpsOrderInfo->dwOrderId, status2a(pNpsOrderInfo->dwStatus) );
		break;
	default:
		LogOut( "NPSCOMPLETIONPROC", ">>>", "dwCompletionCode=%d, pCompletionInfo=0x%08X", dwCompletionCode, pCompletionInfo );
		break;
	}
}
void CLogDlg::CALLBACK_NPSEVENTPROCEX( PNPSEVENTINFOEX pEventInfoEx )
{
	LogOut( "NPSEVENTPROCEX", ">>>", "dwPrintId=%u, dwEventId=%u, wEventCodeMain=%u",
		 pEventInfoEx->dwPrintId, pEventInfoEx->dwEventId, pEventInfoEx->wEventCodeMain );
}
