// NpsClientDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "NpsClient.h"
#include "NpsClientDlg.h"
#include "DevResetEventDlg.h"
#include "DevPrintDlg.h"
#include "DevPrintTabDlg.h"
#include "DevPrintExtendDlg.h"
#include "DevEndOrderDlg.h"
#include "DevSortDlg.h"
#include "DevCancelPrintOrderDlg.h"
#include "DevGetPrintStatusDlg.h"
#include "DevSetTimeDlg.h"
#include "DevCtrlPrintDlg.h"
#include "DevOpenDlg.h"
#include "DevStartOrderDlg.h"
#include "GetPrinterDlg.h"
#include "DevGetMagInfoDlg.h"
#include "DevGetRegMagInfoDlg.h"
#include "DevExpressOrderDlg.h"
#include "LibOpenDlg.h"
#include "DevGetProfileDlg.h"
#include "SetCompletionProcMode.h"
#include "DevStartDuplexDlg.h"
#include "DevEndDuplexDlg.h"
#include "DevBlankPrintDlg.h"
#include "DevStartFadDlg.h"
#include "DevStartRetransmissionDlg.h"
#include "DevPrintResendDlg.h"
#include "DevEndRetransmissionDlg.h"
#include "DevInterruptPrintOrderDlg.h"

#include <winsock2.h>		// WinSock 2.0
#include <mswsock.h>		// Microsoft Windows Socket
#pragma comment( lib , "Ws2_32.lib"  )			// WinSock 2.0 gp
#pragma comment( lib , "Mswsock.lib" )

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNpsClientDlg _CAO

CNpsClientDlg *	gpNpsClientDlg	= NULL;

CNpsClientDlg::CNpsClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNpsClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNpsClientDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_PrinterNum		= 0;
	m_LatestOrderId		= 0;
	m_MMFNO				= 0;

	InitializeCriticalSection( &m_CS );
}

void CNpsClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNpsClientDlg)
	DDX_Control(pDX, IDC_COMBO_HPRINTER, m_Combo_hPrinter);
	DDX_Control(pDX, IDC_LIST_CALLBACK, m_ListCallback);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNpsClientDlg, CDialog)
	//{{AFX_MSG_MAP(CNpsClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LIB_OPEN, OnButtonLibOpen)
	ON_BN_CLICKED(IDC_BUTTON_LIB_CLOSE, OnButtonLibClose)
	ON_BN_CLICKED(IDC_BUTTON_SEARCH_PRINT, OnButtonSearchPrint)
	ON_BN_CLICKED(IDC_BUTTON_SEARCH_PRINT2, OnButtonSearchPrint2)
	ON_BN_CLICKED(IDC_BUTTON_GET_PRINTER, OnButtonGetPrinter)
	ON_BN_CLICKED(IDC_BUTTON_DEV_OPEN, OnButtonDevOpen)
	ON_BN_CLICKED(IDC_BUTTON_DEV_GET_PRINTER_VERSION, OnButtonDevGetPrinterVersion)
	ON_BN_CLICKED(IDC_BUTTON_GET_UNIT_INFO, OnButtonGetUnitInfo)
	ON_BN_CLICKED(IDC_BUTTON_DEV_GET_MAG_INFO, OnButtonDevGetMagInfo)
	ON_BN_CLICKED(IDC_BUTTON_GET_SET_UP_INFO, OnButtonGetSetUpInfo)
	ON_BN_CLICKED(IDC_BUTTON_GET_PRINT_NUM_INFO, OnButtonGetPrintNumInfo)
	ON_BN_CLICKED(IDC_BUTTON_DEV_RESET_EVENT, OnButtonDevResetEvent)
	ON_BN_CLICKED(IDC_BUTTON_DEV_CONVERT_PICTURE_SIZE, OnButtonDevConvertPictureSize)
	ON_BN_CLICKED(IDC_BUTTON_DEV_IS_READY, OnButtonDevIsReady)
	ON_BN_CLICKED(IDC_BUTTON_DEV_START_ORDER, OnButtonDevStartOrder)
	ON_BN_CLICKED(IDC_BUTTON_DEV_END_ORDER, OnButtonDevEndOrder)
	ON_BN_CLICKED(IDC_BUTTON_DEV_PRINT, OnButtonDevPrint)
	ON_BN_CLICKED(IDC_BUTTON_DEV_SORT, OnButtonDevSort)
	ON_BN_CLICKED(IDC_BUTTON_DEV_CANCEL_PRINT_ORDER, OnButtonDevCancelPrintOrder)
	ON_BN_CLICKED(IDC_BUTTON_DEV_GET_PRINT_STATE, OnButtonDevGetPrintState)
	ON_BN_CLICKED(IDC_BUTTON_DEV_SET_TIME, OnButtonDevSetTime)
	ON_BN_CLICKED(IDC_BUTTON_DEV_GET_TIME, OnButtonDevGetTime)
	ON_BN_CLICKED(IDC_BUTTON_DEV_CLOSE_CHECK, OnButtonDevCloseCheck)
	ON_BN_CLICKED(IDC_BUTTON_DEV_GET_REG_MAG_INFO, OnButtonDevGetRegMagInfo)
	ON_BN_CLICKED(IDC_BUTTON_DEV_CTRL_PRINT, OnButtonDevCtrlPrint)
	ON_BN_CLICKED(IDC_BUTTON_DEV_NPS_COMMAND1, OnButtonDevNpsCommand1)
	ON_BN_CLICKED(IDC_BUTTON_DEV_NPS_COMMAND2, OnButtonDevNpsCommand2)
	ON_BN_CLICKED(IDC_BUTTON_DEV_CLOSE, OnButtonDevClose)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_DEV_EXPRESS_ORDER, OnButtonDevExpressOrder)
	ON_BN_CLICKED(IDC_BUTTON_DEV_NPS_NOTICE, OnButtonDevNpsNotice)
	ON_BN_CLICKED(IDC_BUTTON_DEV_CANCEL_PRINT_ALL, OnButtonDevCancelPrintAll)
	ON_BN_CLICKED(IDC_BUTTON_GET_NPS_VERSION, OnButtonGetNpsVersion)
	ON_BN_CLICKED(IDC_BUTTON_DEV_OCCUPY_CHECK, OnButtonDevOccupyCheck)
	ON_BN_CLICKED(IDC_BUTTON_DEV_GET_PROFILE, OnButtonDevGetProfile)
	ON_BN_CLICKED(IDC_BUTTON_DEV_GET_TRANSMIT_TIME, OnButtonDevGetTransmitTime)
	ON_BN_CLICKED(IDC_BUTTON_SET_COMPLETION_PROC_MODE, OnButtonSetCompletionProcMode)
	ON_BN_CLICKED(IDC_BUTTON_DEV_START_DUPLEX, OnButtonDevStartDuplex)
	ON_BN_CLICKED(IDC_BUTTON_DEV_END_DUPLEX, OnButtonDevEndDuplex)
	ON_BN_CLICKED(IDC_BUTTON_DEV_BLANK_PRINT, OnButtonDevBlankPrint)
	ON_BN_CLICKED(IDC_BUTTON_DEV_PRINT_ICCSXML, OnButtonDevPrintIccsxml)
	ON_BN_CLICKED(IDC_BUTTON_DEV_START_FAD, OnButtonDevStartFad)
	ON_BN_CLICKED(IDC_BUTTON_DEV_ADJUST_FOR_PRINT, OnButtonDevAdjustForPrint)
	ON_BN_CLICKED(IDC_BUTTON_DEV_START_RETRANSMISSION, OnButtonDevStartRetransmission)
	ON_BN_CLICKED(IDC_BUTTON_DEV_END_RETRANSMISSION, OnButtonDevEndRetransmission)
	ON_BN_CLICKED(IDC_BUTTON_DEV_INTERRUPT_PRINT_ORDER, OnButtonDevInterruptPrintOrder)
	ON_BN_CLICKED(IDC_BUTTON_DEV_PRINT_RESEND, OnButtonDevPrintResend)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE( UM_NKC_NPSCLIENT_UNIT, OnUmNkcNpsclientUnit )
	ON_REGISTERED_MESSAGE( UM_NKC_NPSCLIENT_EVENT, OnUmNkcNpsclientEvent )
	ON_REGISTERED_MESSAGE( UM_NKC_NPSCLIENT_COMPLETION, OnUmNkcNpsclientCompletion )
	ON_REGISTERED_MESSAGE( UM_NKC_NPSCLIENT_EVENT_EX, OnUmNkcNpsclientEventEx )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MMFǗ
// UPDATE	: J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
HANDLE CNpsClientDlg::CreateMapFromFile( CString strFileName, CString strMapName )
{
	// t@Cf[^[h
	int	nDataBytes;
	
	CFile	wFile;
	wFile.Open( strFileName, CFile::modeRead );
	
	nDataBytes	= (int)wFile.GetLength();
	BYTE* pImgData	= new BYTE[nDataBytes];
	wFile.Read( pImgData, nDataBytes );
	wFile.Close();

	// MMF쐬
	HANDLE hMemory =
	::CreateFileMapping(
		 INVALID_HANDLE_VALUE,
		 NULL,
		 PAGE_READWRITE,
		 0,
		 nDataBytes,
		 strMapName
	);

	if( hMemory == NULL )
	{
		delete [] pImgData;
		return NULL;
	}

	BYTE* pMemory = (BYTE*)
	::MapViewOfFile(
		hMemory,
		FILE_MAP_ALL_ACCESS,
		0,
		0,
		nDataBytes
	);

	if( pMemory == NULL )
	{
		delete [] pImgData;
		::CloseHandle(hMemory);
		return NULL;
	}

	// f[^Rs[
	::CopyMemory( (VOID*)pMemory, pImgData, nDataBytes );

	BOOL bRet =
	::UnmapViewOfFile(
		pMemory
	);

	if( bRet != TRUE )
	{
		delete [] pImgData;
		::CloseHandle(hMemory);
		return NULL;
	}

	delete [] pImgData;
	return hMemory;
}

/////////////////////////////////////////////////////////////////////////////
// v^nhǗ
void CNpsClientDlg::AddPrinterHandle( HPRINTER hPrinter )
{
	CString	str;
	str.Format( "%08X", (USHORT)hPrinter );
	m_Combo_hPrinter.AddString( str );
	m_Combo_hPrinter.SetItemData( m_Combo_hPrinter.GetCount() - 1, ( DWORD )hPrinter );
	m_Combo_hPrinter.SetCurSel( m_Combo_hPrinter.GetCount() - 1 );
}

HPRINTER CNpsClientDlg::GetPrinterHandle()
{
	HPRINTER	hPrinter	= NULL;
	hPrinter	= ( void* ) m_Combo_hPrinter.GetItemData( m_Combo_hPrinter.GetCurSel() );

	return hPrinter;
}

void CNpsClientDlg::DeletePrinterHandle( HPRINTER hPrinter )
{
	CString	str;
	str.Format( "%08X", (USHORT)hPrinter );

	int	idx	= m_Combo_hPrinter.FindString( 0, str );

	if( CB_ERR == idx )
	{
		return;
	}

	m_Combo_hPrinter.DeleteString( idx );
	m_Combo_hPrinter.SetCurSel( m_Combo_hPrinter.GetCount() - 1 );
}

/////////////////////////////////////////////////////////////////////////////
// R[obN

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackEvent()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.31
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackEventStatic(
		PNPSEVENTINFO	pEventInfo	// Cxg
		)
{
	NPSEVENTINFO* pInfo;
	pInfo = new NPSEVENTINFO;
	memcpy( pInfo, pEventInfo, sizeof(NPSEVENTINFO) );
	::PostMessage( gpNpsClientDlg->GetSafeHwnd(), UM_NKC_NPSCLIENT_EVENT, (WPARAM)pInfo, (LPARAM)NULL );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnUmNkcNpsclientEvent()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.1
//	UPDATE   : Y.Yoshinobu 2007.7.5	R[obNĂяoWMɕύX
//////////////////////////////////////////////////////////////////////////////
LRESULT CNpsClientDlg::OnUmNkcNpsclientEvent( WPARAM wParam, LPARAM lParam )
{
	PNPSEVENTINFO pEventInfo = (PNPSEVENTINFO)wParam;

	CCSScopeLock	CSScopeLock( &m_CS );

	m_objNpsLib.CALLBACK_NPSEVENTPROC( pEventInfo );

	if( EVENT_ON == pEventInfo->dwOnOff )	// EVENT_ONȂ烊Xgɒǉ
	{
		NPSEVENTINFO * pEventInfoTmp	= new NPSEVENTINFO;

		memcpy( pEventInfoTmp, pEventInfo, sizeof( NPSEVENTINFO ) );

		CString	str;

		str.Format( "hPrinter( 0x%08X ) dwErrCode( %d ) alParams( %d, %d, %d, %d )", 
			pEventInfo->hPrinter, pEventInfo->dwErrCode,
			pEventInfo->alParams[0], pEventInfo->alParams[1], pEventInfo->alParams[2], pEventInfo->alParams[3] );

		AddCallbackData( str, pEventInfoTmp );
	}
	else if( EVENT_OFF == pEventInfo->dwOnOff )	// EVENT_OFFȂ烊Xg폜
	{
		// v^nhErrHandlev̂폜
		DeleteCallbackData( pEventInfo->hPrinter, pEventInfo->dwErrHandle );
	}

	delete pEventInfo;

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackUnit()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.31
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackUnitStatic(
		PNPSUNITNOTIFYINFO	pUnitInfo	// jbgԕω
		)
{
	NPSUNITNOTIFYINFO* pInfo;
	pInfo = new NPSUNITNOTIFYINFO;
	memcpy( pInfo, pUnitInfo, sizeof(NPSUNITNOTIFYINFO) );
	::PostMessage( gpNpsClientDlg->GetSafeHwnd(), UM_NKC_NPSCLIENT_UNIT, (WPARAM)pInfo, (LPARAM)NULL );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnUmNkcNpsclientUnit()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.1
//	UPDATE   : Y.Yoshinobu 2007.7.5	R[obNĂяoWMɕύX
//////////////////////////////////////////////////////////////////////////////
LRESULT CNpsClientDlg::OnUmNkcNpsclientUnit( WPARAM wParam, LPARAM lParam )
{
	PNPSUNITNOTIFYINFO pUnitInfo = (PNPSUNITNOTIFYINFO)wParam;

	CCSScopeLock	CSScopeLock( &m_CS );

	m_objNpsLib.CALLBACK_NPSUNITPROC( pUnitInfo );

	delete pUnitInfo;

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackCompletion()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.31
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackCompletionStatic(
		DWORD		dwCompletionCode,	// R[h
		PVOID		pCompletionInfo		// Cxg
		)
{
	if( COMPLETION_PRINT == dwCompletionCode )
	{
		NPSPRINTINFO* pInfo;
		pInfo = new NPSPRINTINFO;
		memcpy( pInfo, pCompletionInfo, sizeof(NPSPRINTINFO) );
		::PostMessage( gpNpsClientDlg->GetSafeHwnd(), UM_NKC_NPSCLIENT_COMPLETION, (WPARAM)dwCompletionCode, (LPARAM)pInfo );
	}
	if (COMPLETION_ORDER == dwCompletionCode)
	{
		NPSORDERINFO* pInfo;
		pInfo = new NPSORDERINFO;
		memcpy( pInfo, pCompletionInfo, sizeof(NPSORDERINFO) );
		::PostMessage( gpNpsClientDlg->GetSafeHwnd(), UM_NKC_NPSCLIENT_COMPLETION, (WPARAM)dwCompletionCode, (LPARAM)pInfo );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackCompletion()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
LRESULT CNpsClientDlg::OnUmNkcNpsclientCompletion( WPARAM wParam, LPARAM lParam )
{
	DWORD dwCompletionCode = (DWORD)wParam;
	PVOID pCompletionInfo = (PVOID)lParam;

	CCSScopeLock	CSScopeLock( &m_CS );

	m_objNpsLib.CALLBACK_NPSCOMPLETIONPROC( dwCompletionCode, pCompletionInfo );

	// COMPLETION_PRINT
	if( COMPLETION_PRINT == dwCompletionCode )
	{
		NPSPRINTINFO * pInfo	= ( NPSPRINTINFO * ) pCompletionInfo;

		// t[XV
		OrderManager::UpdateFrame( pInfo );

		delete pInfo;
	}

	// COMPLETION_ORDER
	if( COMPLETION_ORDER == dwCompletionCode )
	{
		NPSORDERINFO * pInfo	= ( NPSORDERINFO * ) pCompletionInfo;

		// I[_[XV
		OrderManager::UpdateOrder( pInfo );

		delete pInfo;
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackRecvprocStatic()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.29
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackRecvprocStatic(
	WORD		wIfId,		// C^[tFCXID
	WORD		wRecvCmdId,	// p̃R}hID
	LPVOID		lpRecvBuf,	// p̃R}h̃obt@
	WORD		RecvBufLen,	// p̃R}h̃obt@TCY
	long		Result		// 
	)
{
	gpNpsClientDlg->CallbackRecvproc(
									wIfId,		// C^[tFCXID
									wRecvCmdId,	// p̃R}hID
									lpRecvBuf,	// p̃R}h̃obt@
									RecvBufLen,	// p̃R}h̃obt@TCY
									Result		// 
									);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackRecvproc()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.29
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackRecvproc(
	WORD		wIfId,		// C^[tFCXID
	WORD		wRecvCmdId,	// p̃R}hID
	LPVOID		lpRecvBuf,	// p̃R}h̃obt@
	WORD		RecvBufLen,	// p̃R}h̃obt@TCY
	long		Result		// 
	)
{
	CCSScopeLock	CSScopeLock( &m_CS );

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackNoticeprocStatic()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackNoticeprocStatic(
	HPRINTER	hPrinter,		// v^̃nh
	DWORD		dwIPAddress,	// v^IPAhX
	WORD		wIfId,			// C^[tFCXID
	WORD		wCmdId,			// R}hID
	LPVOID		lpBuf,			// R}h̃obt@
	WORD		wBufLen			// R}h̃obt@TCY
	)
{
	gpNpsClientDlg->CallbackNoticeproc(
								hPrinter,		// v^̃nh
								dwIPAddress,	// v^IPAhX
								wIfId,			// C^[tFCXID
								wCmdId,			// R}hID
								lpBuf,			// R}h̃obt@
								wBufLen			// R}h̃obt@TCY
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackNoticeproc()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackNoticeproc(
	HPRINTER	hPrinter,		// v^̃nh
	DWORD		dwIPAddress,	// v^IPAhX
	WORD		wIfId,			// C^[tFCXID
	WORD		wCmdId,			// R}hID
	LPVOID		lpBuf,			// R}h̃obt@
	WORD		wBufLen			// R}h̃obt@TCY
	)
{
	CCSScopeLock	CSScopeLock( &m_CS );

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CALLBACK CNpsClientDlg::CallbackEventExStatic()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsClientDlg::CallbackEventExStatic(
		PNPSEVENTINFOEX	pEventInfoEx	// Cxgg
		)
{
	PNPSEVENTINFOEX pInfo;
	pInfo = new NPSEVENTINFOEX;
	memcpy( pInfo, pEventInfoEx, sizeof(NPSEVENTINFOEX) );
	::PostMessage( gpNpsClientDlg->GetSafeHwnd(), UM_NKC_NPSCLIENT_EVENT_EX, (WPARAM)pInfo, (LPARAM)NULL );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnUmNkcNpsclientEventEx()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
LRESULT CNpsClientDlg::OnUmNkcNpsclientEventEx( WPARAM wParam, LPARAM lParam )
{
	PNPSEVENTINFOEX pEventInfoEx = (PNPSEVENTINFOEX)wParam;

	CCSScopeLock	CSScopeLock( &m_CS );

	m_objNpsLib.CALLBACK_NPSEVENTPROCEX( pEventInfoEx );

	// YR}XV
	OrderManager::UpdateFrame( pEventInfoEx );

	delete pEventInfoEx;

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::AddCallbackData()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::AddCallbackData( CString str, NPSEVENTINFO * pNpsEventInfo )
{
	m_ListCallback.AddString( str );
	int idx	= m_ListCallback.GetCount() - 1;
	m_ListCallback.SetItemDataPtr( idx, pNpsEventInfo );
	m_ListCallback.SetCurSel( idx );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::DeleteCallbackData()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::DeleteCallbackData( HANDLE hPrinter, DWORD dwErrHandle )
{
	for( int i = 0; i < m_ListCallback.GetCount(); i++ )
	{
		NPSEVENTINFO* pNpsEventInfo	= ( NPSEVENTINFO* ) m_ListCallback.GetItemDataPtr( i );

		if( ( hPrinter == pNpsEventInfo->hPrinter ) && ( dwErrHandle == pNpsEventInfo->dwErrHandle ) )
		{
			m_ListCallback.DeleteString( i );
			delete pNpsEventInfo;
			break;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CNpsClientDlg bZ[W nh
#define INI_APP_SETTING	"Setting"
void CNpsClientDlg::SaveSetting( CString strKey, int nData )
{
	CString str;
	str.Format( "%d", nData );
	WritePrivateProfileString( INI_APP_SETTING, strKey, str, m_strSettingFilePath );
}

int CNpsClientDlg::LoadSetting( CString strKey, int nDefault )
{
	return GetPrivateProfileInt( INI_APP_SETTING, strKey, nDefault, m_strSettingFilePath );
}

void CNpsClientDlg::SaveSettingStr( CString strKey, CString strData )
{
	WritePrivateProfileString( INI_APP_SETTING, strKey, strData, m_strSettingFilePath );
}

CString CNpsClientDlg::LoadSettingStr( CString strKey, CString strDefault )
{
	char ctmp[256];
	GetPrivateProfileString( INI_APP_SETTING, strKey, strDefault, ctmp, 256, m_strSettingFilePath );

	return ctmp;
}

BOOL CNpsClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	gpNpsClientDlg	= this;

	m_objNpsLib.Create( IDD_DIALOG_LOG, this );
	m_objNpsLib.ShowWindow( SW_SHOW );

	m_Combo_hPrinter.AddString( "<none>" );
	m_Combo_hPrinter.SetItemData( 0, 0 );
	m_Combo_hPrinter.SetCurSel( 0 );

	// INIt@Cɂ鏉ݒ
	char szFilePath[512];

	HINSTANCE	hInstance;

	hInstance	= AfxGetApp()->m_hInstance;

	int npsDevNpsCommand1			=0;
	int npsDevNpsCommand2			=0;
	int npsDevNpsNotice				=0;
	int npsDevCancelPrintAll		=0;
	int npsDevOccupyCheck			=0;
	int npsDevGetTransmitTime		=0;
	int npsDevStartFAD				=0;
	int npsDevStartRetransmission	=0;
	int npsDevEndRetransmission		=0;
	int npsDevInterruptPrintOrder	=0;

	if( 0 == GetModuleFileName( hInstance, szFilePath, 512 ) )
	{
	}
	else
	{
		char szIniFilePath[512];
		char szDir[512];
		_splitpath( szFilePath, szIniFilePath, szDir, NULL, NULL );
		strcat( szIniFilePath, szDir );
		strcat( szIniFilePath, "NpsClient.ini" );

		m_strSettingFilePath	= szIniFilePath;

		npsDevNpsCommand1			= GetPrivateProfileInt( "WITHHELD", "npsDevNpsCommand1", 0, szIniFilePath );
		npsDevNpsCommand2			= GetPrivateProfileInt( "WITHHELD", "npsDevNpsCommand2", 0, szIniFilePath );
		npsDevNpsNotice				= GetPrivateProfileInt( "WITHHELD", "npsDevNpsNotice", 0, szIniFilePath );
		npsDevCancelPrintAll		= GetPrivateProfileInt( "WITHHELD", "npsDevCancelPrintAll", 0, szIniFilePath );
		npsDevOccupyCheck			= GetPrivateProfileInt( "WITHHELD", "npsDevOccupyCheck", 0, szIniFilePath );
		npsDevGetTransmitTime		= GetPrivateProfileInt( "WITHHELD", "npsDevGetTransmitTime", 0, szIniFilePath );
		npsDevStartFAD				= GetPrivateProfileInt( "WITHHELD", "npsDevStartFAD", 0, szIniFilePath );
		npsDevStartRetransmission	= GetPrivateProfileInt( "WITHHELD", "npsDevStartRetransmission", 0, szIniFilePath );
		npsDevEndRetransmission		= GetPrivateProfileInt( "WITHHELD", "npsDevEndRetransmission", 0, szIniFilePath );
		npsDevInterruptPrintOrder	= GetPrivateProfileInt( "WITHHELD", "npsDevInterruptPrintOrder", 0, szIniFilePath );
	}

	if( 0 == npsDevNpsCommand1 )
	{
		GetDlgItem( IDC_BUTTON_DEV_NPS_COMMAND1 )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_NPS_COMMAND1 )->EnableWindow( FALSE );
	}

	if( 0 == npsDevNpsCommand2 )
	{
		GetDlgItem( IDC_BUTTON_DEV_NPS_COMMAND2 )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_NPS_COMMAND2 )->EnableWindow( FALSE );
	}

	if( 0 == npsDevNpsNotice )
	{
		GetDlgItem( IDC_BUTTON_DEV_NPS_NOTICE )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_NPS_NOTICE )->EnableWindow( FALSE );
	}

	if( 0 == npsDevCancelPrintAll )
	{
		GetDlgItem( IDC_BUTTON_DEV_CANCEL_PRINT_ALL )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_CANCEL_PRINT_ALL )->EnableWindow( FALSE );
	}

	if( 0 == npsDevOccupyCheck )
	{
		GetDlgItem( IDC_BUTTON_DEV_OCCUPY_CHECK )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_OCCUPY_CHECK )->EnableWindow( FALSE );
	}

	if( 0 == npsDevStartFAD )
	{
		GetDlgItem( IDC_BUTTON_DEV_START_FAD )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_START_FAD )->EnableWindow( FALSE );
	}

	if( 0 == npsDevStartRetransmission )
	{
		GetDlgItem( IDC_BUTTON_DEV_START_RETRANSMISSION )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_START_RETRANSMISSION )->EnableWindow( FALSE );
	}

	if( 0 == npsDevEndRetransmission )
	{
		GetDlgItem( IDC_BUTTON_DEV_END_RETRANSMISSION )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_END_RETRANSMISSION )->EnableWindow( FALSE );
	}

	if( 0 == npsDevInterruptPrintOrder )
	{
		GetDlgItem( IDC_BUTTON_DEV_INTERRUPT_PRINT_ORDER )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_BUTTON_DEV_INTERRUPT_PRINT_ORDER )->EnableWindow( FALSE );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CNpsClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CNpsClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CNpsClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonLibOpen()
//	ABSTRACT : CũI[v
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonLibOpen() 
{
	CCSScopeLock	CSScopeLock( &m_CS );

	// _CAOɂݒ
	CLibOpenDlg	wLibOpenDlg;

	if( IDOK != wLibOpenDlg.DoModal() )
	{
		return;
	}

	long Ret;

	if ( TRUE == wLibOpenDlg.m_bExistConfigFile )
	{
		Ret = m_objNpsLib.npsLibOpen( wLibOpenDlg.m_strConfigFile );
	}
	else
	{
		Ret = m_objNpsLib.npsLibOpen( NULL );
	}

	if ( NPSERR_NORMAL == Ret )
	{
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		char fname[_MAX_FNAME];
		char ext[_MAX_EXT];
		char szModuleFilePath[MAX_PATH];
		char sziniFilePath[MAX_PATH];
		char szTempFolder[MAX_PATH];
		DWORD dwMode;

		::GetModuleFileName( NULL, szModuleFilePath, MAX_PATH );
		::_splitpath( szModuleFilePath, drive, dir, fname, ext );
		::_makepath( szTempFolder, drive, dir, NULL, NULL );
		::_makepath( sziniFilePath, drive, dir, "NpsClient", "ini" );

		npsSetCustomMode( NPSCTM_CMSTBLMAKE_ON | NPSCTM_PAPERCHK_OFF );
		npsSetTempFolder( szTempFolder );

		dwMode = ::GetPrivateProfileInt( "WITHHELD", "npsSetConnectMode", 0, sziniFilePath );
		switch ( dwMode )
		{
		case 0x00000000:	// OEM(FUJI)i͋ȂANKCî݋
			break;
		default:
			npsSetConnectMode( dwMode );
			break;
		}

		// s[gPʂ̃vgAroʒm󂯎
		npsSetCompletionProcMode(	NPS_PRINT_DETAIL_NOTIFY_ENABLE |
									NPS_OUTPUT_DETAIL_NOTIFY_ENABLE |
									NPS_LOADING_DETAIL_NOTIFY_ENABLE );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonLibClose()
//	ABSTRACT : CũN[Y
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonLibClose() 
{
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsLibClose();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonSearchPrint()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonSearchPrint() 
{
	CCSScopeLock	CSScopeLock( &m_CS );

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	WORD		PrinterNum = 0;		// v^̑䐔
	DWORD		dwWaitTime = 6000;	// ҋ@(~b)

	long Ret = m_objNpsLib.npsSearchPrinter (
								&PrinterNum,		// v^̑䐔
								dwWaitTime			// ҋ@(~b)
								);

	if( NPSERR_NORMAL == Ret )
	{
		m_PrinterNum	= PrinterNum;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonSearchPrint2()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.10.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonSearchPrint2() 
{
	CCSScopeLock	CSScopeLock( &m_CS );

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	WORD		PrinterNum = 0;		// v^̑䐔
	DWORD		dwWaitTime = 6000;	// ҋ@(~b)

	long Ret = m_objNpsLib.npsSearchPrinter2 (
								&PrinterNum,		// v^̑䐔
								dwWaitTime			// ҋ@(~b)
								);

	if( NPSERR_NORMAL == Ret )
	{
		m_PrinterNum	= PrinterNum;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonGetPrinter()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonGetPrinter() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	WORD				wBufferNum	= 1;		// pPrinterInfõobt@
	NPS_PRINTER_ENUM*	pPrinterInfo;			// v^

	pPrinterInfo	= NULL;

	// _CAOɂݒ
	CGetPrinterDlg	wGetPrinterDlg;

	wGetPrinterDlg.m_BufferNum	= m_PrinterNum;

	if( IDOK != wGetPrinterDlg.DoModal() )
	{
		return;
	}

	wBufferNum	= wGetPrinterDlg.m_BufferNum;

	if( wBufferNum > 0 )
	{
		pPrinterInfo	= new NPS_PRINTER_ENUM[ wBufferNum ];
		ZeroMemory( pPrinterInfo, sizeof( NPS_PRINTER_ENUM ) * wBufferNum );
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsGetPrinter (
								wBufferNum,		// pPrinterInfõobt@
								pPrinterInfo	// v^
								);

	if( pPrinterInfo )
	{
		delete [] pPrinterInfo;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevOpen()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
#define KEY_IPADDRESS1	"IPAddress1"
#define KEY_IPADDRESS2	"IPAddress2"
#define KEY_IPADDRESS3	"IPAddress3"
#define KEY_IPADDRESS4	"IPAddress4"
void CNpsClientDlg::OnButtonDevOpen() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	DWORD			dwIPAddress;	// v^IPAhX
	HPRINTER		hPrinter;		// 擾nh̊i[
	NPSEVENTPROC	pEventProc;		// Cxgʒm֐
	NPSUNITPROC		pUnitProc;		// jbgԕύXʒm֐

	// _CAOɂݒ
	CDevOpenDlg	wDevOpenDlg;

	LPHOSTENT	lpHostEnt;
	LPHOSTENT	lpHostEnt2;

	lpHostEnt	= gethostbyname( "localhost" );
	lpHostEnt2	= gethostbyname( lpHostEnt->h_name );

	UCHAR* pIpAddr = (UCHAR*)(lpHostEnt2->h_addr_list[0]);

	// IP AhX擾
	unsigned char * pCharDevOpenDlg = ( unsigned char * ) &wDevOpenDlg.m_dwIPAddress;

	pCharDevOpenDlg[3] = LoadSetting( KEY_IPADDRESS1, pIpAddr[0] );
	pCharDevOpenDlg[2] = LoadSetting( KEY_IPADDRESS2, pIpAddr[1] );
	pCharDevOpenDlg[1] = LoadSetting( KEY_IPADDRESS3, pIpAddr[2] );
	pCharDevOpenDlg[0] = LoadSetting( KEY_IPADDRESS4, pIpAddr[3] );

	if( IDOK != wDevOpenDlg.DoModal() )
	{
		return;
	}

	unsigned char * pChar	= ( unsigned char * ) &dwIPAddress;

	pChar[0]	= pCharDevOpenDlg[3];
	pChar[1]	= pCharDevOpenDlg[2];
	pChar[2]	= pCharDevOpenDlg[1];
	pChar[3]	= pCharDevOpenDlg[0];

	SaveSetting( KEY_IPADDRESS1, pChar[0] );
	SaveSetting( KEY_IPADDRESS2, pChar[1] );
	SaveSetting( KEY_IPADDRESS3, pChar[2] );
	SaveSetting( KEY_IPADDRESS4, pChar[3] );

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	pEventProc	= CallbackEventStatic;
	pUnitProc	= CallbackUnitStatic;

	long Ret = m_objNpsLib.npsDevOpen (
							dwIPAddress,	// v^IPAhX
							&hPrinter,		// 擾nh̊i[
							pEventProc,		// Cxgʒm֐
							pUnitProc		// jbgԕύXʒm֐
							);

	if( Ret == NPSERR_NORMAL )
	{
		AddPrinterHandle( hPrinter );

		// Cxggʒmo^
		NPSEVENTPROCEX	pEventProcEx = CallbackEventExStatic;
		Ret = m_objNpsLib.npsDevNpsNoticeEventProcEx( hPrinter, pEventProcEx );

		// I[_[
		OrderManager::Initialize();
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevClose()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevClose() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷

	hPrinter	= GetPrinterHandle();

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevClose (
						hPrinter	// v^̃nhw肷
						);

	if( NPSERR_NORMAL == Ret )
	{
		// I[_[
		OrderManager::Initialize();

		DeletePrinterHandle( hPrinter );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevGetPrinterVersion()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevGetPrinterVersion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonGetUnitInfo()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonGetUnitInfo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;	// v^̃nhw肷
	NPS_UnitInfo	UnitInfo;	// jbgԍ\̂ւ̃AhX

	hPrinter	= GetPrinterHandle();

	ZeroMemory( &UnitInfo, sizeof( NPS_UnitInfo ) );

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetUnitInfo (
							hPrinter,	// v^̃nhw肷
							&UnitInfo	// jbgԍ\̂ւ̃AhX
							);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevGetMagInfo()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevGetMagInfo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;	// v^̃nhw肷
	NPS_MagInfo*	pMagInfo;	// }KW󂯎obt@
	DWORD			dwSize;		// obt@̃TCY

	hPrinter	= GetPrinterHandle();

	DWORD	InfoNum	= 1;
	pMagInfo	= NULL;

	// _CAOɂݒ
	CDevGetMagInfoDlg	wDevGetMagInfoDlg;

	wDevGetMagInfoDlg.m_Size	= InfoNum;

	if( IDOK != wDevGetMagInfoDlg.DoModal() )
	{
		return;
	}

	InfoNum	= wDevGetMagInfoDlg.m_Size;
	dwSize	= InfoNum * sizeof( NPS_MagInfo );

	if( dwSize > 0 )
	{
		pMagInfo	= new NPS_MagInfo[ InfoNum ];
		ZeroMemory( pMagInfo, dwSize );
	}
	else
	{
		pMagInfo	= NULL;
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetMagInfo (
								hPrinter,	// v^̃nhw肷
								pMagInfo,	// }KW󂯎obt@
								&dwSize		// obt@̃TCY
								);

	if( NULL == pMagInfo )
	{
		return;
	}

	delete [] pMagInfo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonGetSetUpInfo()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonGetSetUpInfo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;	// v^̃nhw肷
	NPS_SetUpInfo	SetUpInfo;	// ݒu\̂ւ̃AhX

	hPrinter	= GetPrinterHandle();

	ZeroMemory( &SetUpInfo, sizeof( NPS_SetUpInfo ) );

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetSetUpInfo (
									hPrinter,	// v^̃nhw肷
									&SetUpInfo	// ݒu\̂ւ̃AhX
									);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonGetPrintNumInfo()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonGetPrintNumInfo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER			hPrinter;		// v^̃nhw肷
	NPS_PrintNumInfo	PrintNumInfo;	// vg\̂ւ̃AhX

	hPrinter	= GetPrinterHandle();

	ZeroMemory( &PrintNumInfo, sizeof( NPS_PrintNumInfo ) );

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetPrintNumInfo (
										hPrinter,		// v^̃nhw肷
										&PrintNumInfo	// vg\̂ւ̃AhX
										);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevResetEvent()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevResetEvent() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;		// v^̃nhw肷
	DWORD		dwErrHandle;	// NACxgnh
	DWORD		dwActionId;		// Cxg̃ANVw肷

	hPrinter	= GetPrinterHandle();

	int idx;
	idx	= m_ListCallback.GetCurSel();

	if( idx < 0 )
	{
		return;
	}

	NPSEVENTINFO * pEventInfo	 = ( NPSEVENTINFO * ) m_ListCallback.GetItemDataPtr( idx );

	if( 0 == pEventInfo->dwErrHandle )
	{
		return;
	}

	// _CAOɂݒ
	CDevResetEventDlg	wDevResetEventDlg;

	wDevResetEventDlg.m_Message.Format(
		"hPrinter( 0x%08X ) dwErrHandle( 0x%08X )\nsysTime( %d/%d/%d %02d:%02d:%02d.%03d )\ndwErrCode( %d ) dwOnOff( %d ) alParams( %d, %d, %d, %d )",
		pEventInfo->hPrinter, pEventInfo->dwErrHandle,
		pEventInfo->sysTime.wYear, pEventInfo->sysTime.wMonth, pEventInfo->sysTime.wDay, pEventInfo->sysTime.wHour, pEventInfo->sysTime.wMinute, pEventInfo->sysTime.wSecond, pEventInfo->sysTime.wMilliseconds,
		pEventInfo->dwErrCode, pEventInfo->dwOnOff, pEventInfo->alParams[0], pEventInfo->alParams[1], pEventInfo->alParams[2], pEventInfo->alParams[3] );

	if( IDOK != wDevResetEventDlg.DoModal() )
	{
		return;
	}

	dwErrHandle	= pEventInfo->dwErrHandle;
	dwActionId	= wDevResetEventDlg.m_ButtonNo;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevResetEvent (
									hPrinter,		// v^̃nhw肷
									dwErrHandle,	// NACxgnh
									dwActionId		// Cxg̃ANVw肷
									);

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevConvertPictureSize()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevConvertPictureSize() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevIsReady()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevIsReady() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷

	hPrinter	= GetPrinterHandle();

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevIsReady (
								hPrinter	// v^̃nhw肷
								);

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevStartOrder()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevStartOrder() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER			hPrinter;	// v^̃nhw肷
	DWORD				dwOrderId;	// 擾I[_[IDi[
	NPSCOMPLETIONPROC	pEventProc;	// ʒmpR[obN֐ւ̃AhX
	DWORD				dwPriority;	// Dxw
	DWORD				dwSorterNum;// vg̎d
	DWORD				dwSortFrame;// R}̃\[g@\
	DWORD				dwExOptions;// gIvViPvgj

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevStartOrderDlg	wDevStartOrderDlg;

	wDevStartOrderDlg.m_Priority	= 0;
	wDevStartOrderDlg.m_SorterNum	= 0;
	//wDevStartOrderDlg.m_ExOptionsSingleLinePrintCheck.SetCheck(FALSE);

	if( IDOK != wDevStartOrderDlg.DoModal() )
	{
		return;
	}

	dwPriority	= wDevStartOrderDlg.m_Priority;
	dwSorterNum	= wDevStartOrderDlg.m_SorterNum;
	dwSortFrame	= wDevStartOrderDlg.m_SortFrame;
	dwExOptions	= wDevStartOrderDlg.m_dwExOptions;
	pEventProc	= CallbackCompletionStatic;

	switch ( dwPriority )
	{
	case 2:	dwPriority = 0xFFFFFFFC;	break;	// 2:EXPRESS (M0)
	case 3:	dwPriority = 0xFFFFFFFF;	break;	// 3:EXPRESS (M1)
	case 4:	dwPriority = 0xFFFFFFFE;	break;	// 4:EXPRESS (M2)
	case 5:	dwPriority = 0xB0000001;	break;	// 5:CREDIT
	case 6:	dwPriority = 0xA0000001;	break;	// 6:SETTING
	}

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevStartOrderEx (
									hPrinter,	// v^̃nhw肷
									&dwOrderId,	// 擾I[_[IDi[
									pEventProc,	// ʒmpR[obN֐ւ̃AhX
									dwPriority,	// Dxw
									dwSorterNum,// vg̎d
									dwSortFrame,
									dwExOptions
									);

	if( NPSERR_NORMAL == Ret )
	{
		m_LatestOrderId	= dwOrderId;

		// I[_[ǉ
		OrderManager::COrder	tempOrder(
									dwOrderId,
									dwPriority,
									dwSorterNum,
									dwSortFrame,
									dwExOptions);

		OrderManager::AppendOrder( &tempOrder );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevEndOrder()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevEndOrder() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// II[_[IDw肷

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevEndOrderDlg	wDevEndOrderDlg;

	wDevEndOrderDlg.m_OrderId	= m_LatestOrderId;

	if( IDOK != wDevEndOrderDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevEndOrderDlg.m_OrderId;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevEndOrder (
								hPrinter,	// v^̃nhw肷
								dwOrderId	// II[_[IDw肷
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::DevPrint()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
#define KEY_IMAGEFORMAT		"ImageFormat"
#define KEY_SOURCETYPE		"SourceType"
#define KEY_DATALENGTH		"DataLength"
#define KEY_NAME			"Name"
#define KEY_OFFSET			"Offset"
#define KEY_IMGWIDTH		"ImgWidth"
#define KEY_IMGHEIGHT		"ImgHeight"
#define KEY_RESOLUTION		"Resolution"
#define KEY_PAPERWIDTH		"PaperWidth"
#define KEY_PAPERLENGTH		"PaperLength"
#define KEY_SURFACE			"Surface"
#define	KEY_CMS				"Cms"
#define	KEY_ANGLE			"Angle"
#define	KEY_FITTING			"Fitting"
#define	KEY_EDGE			"Edge"
#define	KEY_WBTOP			"WbTop"
#define	KEY_WBBOTTOM		"WbBottom"
#define	KEY_WBLEFT			"WbLeft"
#define	KEY_WBRIGHT			"WbRight"
#define	KEY_CSPACE			"ColorSpace"
#define	KEY_PRIORITY		"Priority"
#define	KEY_ICCSCMDFILEPATH	"IccsCmdFilePath"
#define	KEY_FEED			"Feed"
#define	KEY_PAPERNAME		"PaperName"
#define	KEY_PRINTQUALITY	"PrintQuality"

/////////////////////////////////////////////////////////////////////////////
// CNpsClientDlg _CAO
// UPDATE: J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
/////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::DevPrint( int eType )
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER			hPrinter;	// v^̃nhw肷
	DWORD				dwOrderId;	// vgI[_[IDw肷
	NPSCOMPLETIONPROC	pEventProc;	// CxgʒmpR[obN֐ւ̃AhX
	//NPS_PrintInfo		PrintInfo;	// vgvp[^
	char				szName[512];// pNamẽobt@

	hPrinter	= GetPrinterHandle();

	//----------------------------------
	// f[^̐ݒ
	//----------------------------------
	NPS_PRINTINFO	wPrintInfo;
	CDevPrintTabDlg	wDevPrintDlg;

	switch( eType )
	{
	case eDevPrint: wDevPrintDlg.SetType( CDevPrintTabDlg::eDevPrint ); break;
	case eDevPrintIccsXml: wDevPrintDlg.SetType( CDevPrintTabDlg::eDevPrintIccsXml ); break;
	};

	ZeroMemory( &wPrintInfo, sizeof( NPS_PRINTINFO ) );

	wDevPrintDlg.m_CallTimes		= 1;

	// BASIC
	wPrintInfo.dwOrderId					= m_LatestOrderId;

	wPrintInfo.PrintInfo.dwImageFormat		= LoadSetting( KEY_IMAGEFORMAT, 0 );	// 摜tH[}bg
	wPrintInfo.PrintInfo.dwSourceType		= LoadSetting( KEY_SOURCETYPE, 1 );		// 摜f[^[̎󂯓n@
	wPrintInfo.PrintInfo.dwDataLength		= LoadSetting( KEY_DATALENGTH, 0 );		// 摜f[^̃oCgTCYiPʁFBytej

	strcpy( wPrintInfo.FilePath, LoadSettingStr( KEY_NAME, "" ) );					// t@C}bsOIuWFNg̓t@C
	//wPrintInfo.PrintInfo.pName													// t@C}bsOIuWFNg̓t@C
	wPrintInfo.PrintInfo.dwOffset			= LoadSetting( KEY_OFFSET, 0 );			// 摜f[^̊i[ĂItZbg
	wPrintInfo.PrintInfo.dwImgWidth			= LoadSetting( KEY_IMGWIDTH, 0 );		// 摜̕iPʁFPixelj
	wPrintInfo.PrintInfo.dwImgHeight		= LoadSetting( KEY_IMGHEIGHT, 0 );		// 摜̍iPʁFPixelj
	wPrintInfo.PrintInfo.dwResolution		= LoadSetting( KEY_RESOLUTION, 3000 );	// 𑜓xiPʁF0.1dpij
	wPrintInfo.PrintInfo.dwPaperWidth		= LoadSetting( KEY_PAPERWIDTH, 1270 );	// y[p[iPʁF0.1mmj
	wPrintInfo.PrintInfo.dwPaperLength		= LoadSetting( KEY_PAPERLENGTH, 890 );	// y[p[蒷iPʁF0.1mmj
	wPrintInfo.PrintInfo.dwCvpInitialValue1	= 0;		// CVP1sڂ̒ʂԍ̏l
	wPrintInfo.PrintInfo.dwCvpPoint1		= 0;		// CVP1sڂ̒ʂԍ}ʒu
	wPrintInfo.PrintInfo.dwCvpInitialWidth1	= 0;		// CVP1sڂ̒ʂԍ󎚂錅
	strcpy( wPrintInfo.PrintInfo.szCvpLine1, "" );		// CVP1sڂ̕f[^
	wPrintInfo.PrintInfo.dwCvpInitialValue2	= 0;		// CVP2sڂ̒ʂԍ̏l
	wPrintInfo.PrintInfo.dwCvpPoint2		= 0;		// CVP2sڂ̒ʂԍ}ʒu
	wPrintInfo.PrintInfo.dwCvpInitialWidth2	= 0;		// CVP2sڂ̒ʂԍ󎚂錅
	strcpy( wPrintInfo.PrintInfo.szCvpLine2, "" );		// CVP2sڂ̕f[^
	wPrintInfo.PrintInfo.dwPrintNum			= 1;		// vg
	wPrintInfo.PrintInfo.dwFeed				= LoadSetting( KEY_FEED, 0 );			// @
	wPrintInfo.PrintInfo.dwSurface			= LoadSetting( KEY_SURFACE, 1 );		// y[p[̖ʎ
	wPrintInfo.PrintInfo.dwPaperPresence	= 0;		// }KWwi}KWԍj
	wPrintInfo.PrintInfo.nEspc				= 0;		// Exposure start position correction (Unit: 0.1 mm) 

	// EXTEND
	wPrintInfo.PrintInfo.dwCvpPrintSize		= 0;
	wPrintInfo.PrintInfo.wCMS				= LoadSetting( KEY_CMS, 0 );			// CMS
	wPrintInfo.PrintInfo.wAngle				= LoadSetting( KEY_ANGLE, 0 );
	wPrintInfo.PrintInfo.wPaperFitting		= LoadSetting( KEY_FITTING, 0 );
	wPrintInfo.PrintInfo.wEdgeEnhancement	= LoadSetting( KEY_EDGE, 0 );
	wPrintInfo.PrintInfo.wWithBorderTop		= LoadSetting( KEY_WBTOP, 0 );
	wPrintInfo.PrintInfo.wWithBorderBottom	= LoadSetting( KEY_WBBOTTOM, 0 );
	wPrintInfo.PrintInfo.wWithBorderLeft	= LoadSetting( KEY_WBLEFT, 0 );
	wPrintInfo.PrintInfo.wWithBorderRight	= LoadSetting( KEY_WBRIGHT, 0 );
	wPrintInfo.PrintInfo.byWithBorderColor[0]	= 255;
	wPrintInfo.PrintInfo.byWithBorderColor[1]	= 255;
	wPrintInfo.PrintInfo.byWithBorderColor[2]	= 255;
	strcpy( wPrintInfo.PrintInfo.szPaperName, LoadSettingStr( KEY_PAPERNAME, "" ) );
	wPrintInfo.PrintInfo.nPcfms				= 0;
	wPrintInfo.PrintInfo.dwColorSpace		= LoadSetting( KEY_CSPACE, 0 );
	wPrintInfo.PrintInfo.wPrintQuality		= LoadSetting( KEY_PRINTQUALITY, 0 );
	wPrintInfo.PrintInfo.byImageEnlargeType	= 0;	// Image enlarge algorithm

	// ICCSXML
	if( eType == CDevPrintTabDlg::eDevPrintIccsXml )
	{
		wPrintInfo.priority					= LoadSetting( KEY_PRIORITY, 0 );
		strcpy( wPrintInfo.IccsCmdFilePath, LoadSettingStr( KEY_ICCSCMDFILEPATH, "" ) );
	}

	//----------------------------------
	// f[^̐ݒ
	//----------------------------------
	wDevPrintDlg.SetDataPointer( &wPrintInfo );

	//----------------------------------
	// f[^̐ݒ
	//----------------------------------
	if( IDOK != wDevPrintDlg.DoModal() )
	{
		return;
	}

	// BASIC
	dwOrderId	= wPrintInfo.dwOrderId;

	SaveSetting( KEY_IMAGEFORMAT,	wPrintInfo.PrintInfo.dwImageFormat );
	SaveSetting( KEY_SOURCETYPE,	wPrintInfo.PrintInfo.dwSourceType );
	SaveSetting( KEY_DATALENGTH,	wPrintInfo.PrintInfo.dwDataLength );
	SaveSettingStr( KEY_NAME,		wPrintInfo.FilePath );
	SaveSetting( KEY_OFFSET,		wPrintInfo.PrintInfo.dwOffset );
	SaveSetting( KEY_IMGWIDTH,		wPrintInfo.PrintInfo.dwImgWidth );
	SaveSetting( KEY_IMGHEIGHT,		wPrintInfo.PrintInfo.dwImgHeight );
	SaveSetting( KEY_RESOLUTION,	wPrintInfo.PrintInfo.dwResolution );
	SaveSetting( KEY_PAPERWIDTH,	wPrintInfo.PrintInfo.dwPaperWidth );
	SaveSetting( KEY_PAPERLENGTH,	wPrintInfo.PrintInfo.dwPaperLength );
	SaveSetting( KEY_FEED,			wPrintInfo.PrintInfo.dwFeed );
	SaveSetting( KEY_SURFACE,		wPrintInfo.PrintInfo.dwSurface );
	SaveSetting( KEY_CMS,			wPrintInfo.PrintInfo.wCMS );
	SaveSetting( KEY_ANGLE,			wPrintInfo.PrintInfo.wAngle );
	SaveSetting( KEY_FITTING,		wPrintInfo.PrintInfo.wPaperFitting );
	SaveSetting( KEY_EDGE,			wPrintInfo.PrintInfo.wEdgeEnhancement );
	SaveSetting( KEY_WBTOP,			wPrintInfo.PrintInfo.wWithBorderTop );
	SaveSetting( KEY_WBBOTTOM,		wPrintInfo.PrintInfo.wWithBorderBottom );
	SaveSetting( KEY_WBLEFT,		wPrintInfo.PrintInfo.wWithBorderLeft );
	SaveSetting( KEY_WBRIGHT,		wPrintInfo.PrintInfo.wWithBorderRight );
	SaveSetting( KEY_CSPACE,		wPrintInfo.PrintInfo.dwColorSpace );

	// EXTEND
	SaveSetting( KEY_CMS,			wPrintInfo.PrintInfo.wCMS				 );
	SaveSetting( KEY_ANGLE,			wPrintInfo.PrintInfo.wAngle				 );
	SaveSetting( KEY_FITTING,		wPrintInfo.PrintInfo.wPaperFitting		 );
	SaveSetting( KEY_EDGE,			wPrintInfo.PrintInfo.wEdgeEnhancement	 );
	SaveSetting( KEY_WBTOP,			wPrintInfo.PrintInfo.wWithBorderTop		 );
	SaveSetting( KEY_WBBOTTOM,		wPrintInfo.PrintInfo.wWithBorderBottom	 );
	SaveSetting( KEY_WBLEFT,		wPrintInfo.PrintInfo.wWithBorderLeft	 );
	SaveSetting( KEY_WBRIGHT,		wPrintInfo.PrintInfo.wWithBorderRight	 );
	SaveSettingStr( KEY_PAPERNAME,	wPrintInfo.PrintInfo.szPaperName		 );
	SaveSetting( KEY_CSPACE,		wPrintInfo.PrintInfo.dwColorSpace		 );
	SaveSetting( KEY_PRINTQUALITY,	wPrintInfo.PrintInfo.wPrintQuality		 );

	// ICCSXML
	if( eType == CDevPrintTabDlg::eDevPrintIccsXml )
	{
		LoadSetting( KEY_PRIORITY, wPrintInfo.priority );
		SaveSettingStr( KEY_ICCSCMDFILEPATH, wPrintInfo.IccsCmdFilePath );
	}

	switch ( wPrintInfo.PrintInfo.dwImageFormat ) // 摜tH[}bg
	{
	case 15: wPrintInfo.PrintInfo.dwImageFormat = 0x00000064; break;	// ʐMx摜
	case 16: wPrintInfo.PrintInfo.dwImageFormat = 0x00000065; break;	// lbg[NȐff摜(CRC`FbNp)
	default: break;
	}

	pEventProc	= CallbackCompletionStatic;

	CCSScopeLock	CSScopeLock( &m_CS );

	DWORD dwIdx;

	for( dwIdx=0 ; dwIdx < wDevPrintDlg.m_CallTimes; dwIdx++ )
	{

		// 摜f[^̎󂯓n@
		if( 0 == wPrintInfo.PrintInfo.dwSourceType )
		{	// Ln
			// }bsOIuWFNg̖O NPSCLIENT_MAPPING_[ԍ]
			m_MMFNO++;
			CString	strMapName;
			strMapName.Format( "NPSCLIENT_MAPPING_%03d", m_MMFNO );
			CreateMapFromFile( wPrintInfo.FilePath, strMapName );
			strcpy( szName, strMapName );
		}
		else
		{	// t@Cn
			strcpy( szName, wPrintInfo.FilePath );
		}

		wPrintInfo.PrintInfo.pName	= szName;

		// t[쐬
		OrderManager::CFrame	tempFrame(
									dwOrderId,
									&wPrintInfo.PrintInfo,
									eType,
									wPrintInfo.priority,
									wPrintInfo.IccsCmdFilePath );

		// tJn𔭍s
		long Ret = DevPrintRequest(
									hPrinter,
									pEventProc,
									&tempFrame );

		if( NPSERR_NORMAL == Ret )
		{
			// t[ǉ
			OrderManager::COrder*	pOrder = OrderManager::FindOrder( dwOrderId );
			if( pOrder )
			{
				pOrder->AppendFrame( &tempFrame );
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::DevPrintRequest()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsClientDlg::DevPrintRequest(
		HPRINTER				hPrinter,
		NPSCOMPLETIONPROC		pEventProc,
		OrderManager::CFrame*	pFrame )
{
	long Ret;

	//-----------------------------
	// npsDevPrint
	//-----------------------------
	if( pFrame->m_eType == eDevPrint )
	{
		Ret = m_objNpsLib.npsDevPrint (
							hPrinter,					// v^̃nhw肷
							pFrame->m_dwOrderId,		// vgI[_[IDw肷
							&pFrame->m_dwPrintId,		// vgʎq
							pEventProc,					// CxgʒmpR[obN֐ւ̃AhX
							&pFrame->m_tPrintInfo		// vgvp[^
							);
	}
	//-----------------------------
	// npsDevPrintIccsXml
	//-----------------------------
	else if( pFrame->m_eType == eDevPrintIccsXml )
	{
		#ifdef NPSCLIENT_NPSDEVPRINTICCSXML
		NPS_PrintInfoIccsXml	wPrintInfoIccsXml;

		ZeroMemory( &wPrintInfoIccsXml, sizeof( NPS_PrintInfoIccsXml ) );

		memcpy( &(wPrintInfoIccsXml.printInfo), &pFrame->m_tPrintInfo, sizeof( NPS_PrintInfo ) );
		wPrintInfoIccsXml.pIccsCmdFilePath	= &pFrame->m_cIccsCmdFilePath;

		Ret = m_objNpsLib.npsDevPrintIccsXml (
								hPrinter,				// v^̃nhw肷
								pFrame->m_dwOrderId,	// vgI[_[IDw肷
								&pFrame->m_dwPrintId,	// vgʎq
								pEventProc,				// CxgʒmpR[obN֐ւ̃AhX
								pFrame->m_nPriority,	// 摜␳Xbh̗Dx
								&wPrintInfoIccsXml		// vgvp[^
								);
		#endif
	}

	return Ret;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevPrint()
//	ABSTRACT : API DevPrint
void CNpsClientDlg::OnButtonDevPrint()
{
	DevPrint();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevPrintIccsxml()
//	ABSTRACT : 
void CNpsClientDlg::OnButtonDevPrintIccsxml() 
{
	#ifdef NPSCLIENT_NPSDEVPRINTICCSXML
	DevPrint( eDEVPRITNTTYPE::eDevPrintIccsXml );
	#endif
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevSort()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevSort() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// 擾I[_[IDw肷

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevSortDlg	wDevSortDlg;

	wDevSortDlg.m_OrderId	= m_LatestOrderId;

	if( IDOK != wDevSortDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevSortDlg.m_OrderId;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevSort (
							hPrinter,	// v^̃nhw肷
							dwOrderId	// 擾I[_[IDw肷
							);

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevCancelPrintOrder()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevCancelPrintOrder() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// LZI[_[IDw肷
	DWORD		dwPrintID;	// vgʎq
	OrderManager::COrder*	pOrder	= NULL;

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevCancelPrintOrderDlg	wDevCancelPrintOrderDlg;
	if( IDOK != wDevCancelPrintOrderDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevCancelPrintOrderDlg.m_OrderId;
	dwPrintID	= wDevCancelPrintOrderDlg.m_PrintId;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevCancelPrintOrder (
										hPrinter,	// v^̃nhw肷
										dwOrderId,	// LZI[_[IDw肷
										dwPrintID	// vgʎq
										);

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevGetPrintState()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevGetPrintState() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;		// v^̃nhw肷
	DWORD		dwPrintID;		// vgʎq
	DWORD		PrintStatus;	// vg

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevGetPrintStatusDlg	wDevGetPrintStatusDlg;

	wDevGetPrintStatusDlg.m_PrintId	= 1;

	if( IDOK != wDevGetPrintStatusDlg.DoModal() )
	{
		return;
	}

	dwPrintID	= wDevGetPrintStatusDlg.m_PrintId;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetPrintStatus (
									hPrinter,		// v^̃nhw肷
									dwPrintID,		// vgʎq
									&PrintStatus	// vg
									);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevSetTime()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevSetTime() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;	// v^̃nhw肷
	NPS_DateTime	Time;		// ݒ肷

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevSetTimeDlg	wDevSetTimeDlg;

	CTime	wTime;

	wTime	= wTime.GetCurrentTime();

	wDevSetTimeDlg.m_Year		= wTime.GetYear();
	wDevSetTimeDlg.m_Month		= wTime.GetMonth();
	wDevSetTimeDlg.m_Day		= wTime.GetDay();
	wDevSetTimeDlg.m_Dayofweek	= wTime.GetDayOfWeek() - 1;
	wDevSetTimeDlg.m_Hour		= wTime.GetHour();
	wDevSetTimeDlg.m_Minute		= wTime.GetMinute();
	wDevSetTimeDlg.m_Second		= wTime.GetSecond();

	if( IDOK != wDevSetTimeDlg.DoModal() )
	{
		return;
	}

	Time.tDate.dwYear		= wDevSetTimeDlg.m_Year;
	Time.tDate.dwMonth		= wDevSetTimeDlg.m_Month;
	Time.tDate.dwDay		= wDevSetTimeDlg.m_Day;
	Time.tDate.dwDayofweek	= wDevSetTimeDlg.m_Dayofweek;
	Time.tTime.dwHour		= wDevSetTimeDlg.m_Hour;
	Time.tTime.dwMinute		= wDevSetTimeDlg.m_Minute;
	Time.tTime.dwSecond		= wDevSetTimeDlg.m_Second;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevSetTime (
								hPrinter,	// v^̃nhw肷
								&Time		// ݒ肷
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevGetTime()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevGetTime() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;	// v^̃nhw肷
	NPS_DateTime	Time;		// 擾̊i[

	hPrinter	= GetPrinterHandle();

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetTime (
								hPrinter,	// v^̃nhw肷
								&Time		// 擾̊i[
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevCloseCheck()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevCloseCheck() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷

	hPrinter	= GetPrinterHandle();

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevCloseCheck (
		hPrinter	// v^̃nhw肷
	);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevGetRegMagInfo()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevGetRegMagInfo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER			hPrinter;	// v^̃nhw肷
	NPS_MagDetailInfo*	pMagInfo;	// o^}KW󂯎obt@
	DWORD				dwSize;		// obt@̃TCY

	hPrinter	= GetPrinterHandle();

	DWORD	InfoNum	= 1;
	pMagInfo	= NULL;

	// _CAOɂݒ
	CDevGetMagInfoDlg	wDevGetMagInfoDlg;

	wDevGetMagInfoDlg.m_Size	= InfoNum;

	if( IDOK != wDevGetMagInfoDlg.DoModal() )
	{
		return;
	}

	InfoNum	= wDevGetMagInfoDlg.m_Size;
	dwSize	= InfoNum * sizeof( NPS_MagDetailInfo );

	if( dwSize > 0 )
	{
		pMagInfo	= new NPS_MagDetailInfo[ InfoNum ];
		ZeroMemory( pMagInfo, dwSize );
	}
	else
	{
		pMagInfo	= NULL;
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetAllMagInfo (
								hPrinter,	// v^̃nhw肷
								pMagInfo,	// }KW󂯎obt@
								&dwSize		// obt@̃TCY
								);

	if( NULL == pMagInfo )
	{
		return;
	}

	delete [] pMagInfo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevCtrlPrint()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevCtrlPrint() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwCtrl;		// ew肷

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevCtrlPrintDlg	wDevCtrlPrintDlg;

	wDevCtrlPrintDlg.m_Ctrl	= 0;

	if( IDOK != wDevCtrlPrintDlg.DoModal() )
	{
		return;
	}

	dwCtrl	= wDevCtrlPrintDlg.m_Ctrl;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevCtrlPrint (
								hPrinter,	// v^̃nhw肷
								dwCtrl		// ew肷
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevExpressOrder()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevExpressOrder() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// Dx}wɂI[_[IDw肷

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevExpressOrderDlg	wDevExpressOrderDlg;

	wDevExpressOrderDlg.m_OrderId	= m_LatestOrderId;

	if( IDOK != wDevExpressOrderDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevExpressOrderDlg.m_OrderId;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevExpressOrder (
					hPrinter,	// v^̃nhw肷
					dwOrderId	// Dx}wɂI[_[IDw肷
					);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevNpsCommand1()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevNpsCommand1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;		// v^̃nhw肷
	WORD		wIfId;			// C^[tFCXID
	WORD		wSendCmdId;		// vp̃R}hID
	WORD		wSendBufLen;	// vp̃R}h̃obt@TCY
	LPVOID		lpSendBuf;		// vp̃R}h̃obt@
	WORD		wRecvCmdId;		// p̃R}hID
	WORD		wRecvBufLen;	// p̃R}h̃obt@TCY
	LPVOID		lpRecvBuf;		// p̃R}h̃obt@
	DWORD		dwTimeOut;		// ^CAEg(~b)

	hPrinter	= GetPrinterHandle();

	wIfId		= 0x6000;

	wSendCmdId	= 0x0100;
	wSendBufLen	= sizeof( USHORT ) * 2;
	BYTE	SendBuffer[ sizeof( USHORT ) * 2 ];
	ZeroMemory( SendBuffer, wSendBufLen );
	lpSendBuf	= SendBuffer;

	wRecvCmdId	= 0x0101;
	wRecvBufLen	= 65535;
	BYTE RecvBuffer[65535];
	lpRecvBuf	= RecvBuffer;
	dwTimeOut	= 30000;

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevNpsCommand1 (
									hPrinter,		// v^̃nhw肷
									wIfId,			// C^[tFCXID
									wSendCmdId,		// vp̃R}hID
									wSendBufLen,	// vp̃R}h̃obt@TCY
									lpSendBuf,		// vp̃R}h̃obt@
									wRecvCmdId,		// p̃R}hID
									&wRecvBufLen,	// p̃R}h̃obt@TCY
									lpRecvBuf,		// p̃R}h̃obt@
									dwTimeOut		// ^CAEg(~b)
									);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevNpsCommand2()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevNpsCommand2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;		// v^̃nhw肷
	WORD		wIfId;			// C^[tFCXID
	WORD		wSendCmdId;		// vp̃R}hID
	WORD		wSendBufLen;	// vp̃R}h̃obt@TCY
	LPVOID		lpSendBuf;		// vp̃R}h̃obt@
	WORD		wRecvCmdId;		// p̃R}hID
	WORD		wRecvBufLen;	// p̃R}h̃obt@TCY
	RECVPROC	pRecvProc;		// ɌĂяo֐
	DWORD		dwTimeOut;		// ^CAEg(~b)

	hPrinter	= GetPrinterHandle();

	pRecvProc	= CallbackRecvprocStatic;

	wIfId		= 0x6000;

	wSendCmdId	= 0x0100;
	wSendBufLen	= sizeof( USHORT ) * 2;
	BYTE	SendBuffer[ sizeof( USHORT ) * 2 ];
	ZeroMemory( SendBuffer, wSendBufLen );
	lpSendBuf	= SendBuffer;

	wRecvCmdId	= 0x0101;
	wRecvBufLen	= 65535;
	dwTimeOut	= 30000;

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevNpsCommand2 (
									hPrinter,		// v^̃nhw肷
									wIfId,			// C^[tFCXID
									wSendCmdId,		// vp̃R}hID
									wSendBufLen,	// vp̃R}h̃obt@TCY
									lpSendBuf,		// vp̃R}h̃obt@
									wRecvCmdId,		// p̃R}hID
									&wRecvBufLen,	// p̃R}h̃obt@TCY
									pRecvProc,		// ɌĂяo֐
									dwTimeOut		// ^CAEg(~b)
									);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnDestroy()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_objNpsLib.DestroyWindow();

	for( int i = 0; i < m_ListCallback.GetCount(); i++ )
	{
		NPSEVENTINFO * pEventInfo	 = ( NPSEVENTINFO * ) m_ListCallback.GetItemDataPtr( i );
		delete pEventInfo;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevNpsNotice()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevNpsNotice() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;		// v^̃nhw肷
	WORD			wIfId;			// C^[tFCXID
	WORD			wCmdId;			// R}hID
	NOTICEPROC		pNoticeProc;	// ɌĂяo֐	

	hPrinter	= GetPrinterHandle();

	pNoticeProc	= CallbackNoticeprocStatic;

	wIfId	= 0x6000;
	wCmdId	= 0xF102;

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevNpsNotice (
								hPrinter,		// v^̃nhw肷
								wIfId,			// C^[tFCXID
								wCmdId,			// R}hID
								pNoticeProc		// ɌĂяo֐
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevCancelPrintAll()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevCancelPrintAll() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;		// v^̃nhw肷

	hPrinter	= GetPrinterHandle();

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevCancelPrintAll (
								hPrinter	// v^̃nhw肷
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonGetNpsVersion()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonGetNpsVersion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	WORD	NpsVersion;	// NPS I/F ̃o[W

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsGetNpsVersion (
								&NpsVersion	// NPS I/F ̃o[W
								);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevOccupyCheck()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.02.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevOccupyCheck() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷

	hPrinter	= GetPrinterHandle();

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevOccupyCheck (
		hPrinter	// v^̃nhw肷
	);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevGetProfile()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.4.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
#define KEY_PROF_FEED			"ProfFeed"
#define KEY_PROF_PAPERWIDTH		"ProfPaperWidth"
#define KEY_PROF_SURFACE		"ProfSurface"
#define KEY_PROF_NAME			"ProfName"
#define KEY_PROF_PATH			"ProfPath"
void CNpsClientDlg::OnButtonDevGetProfile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	CString strFilePath;
	NPS_PaperInfo stPaperInfo;

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevGetProfileDlg cDevGetProfileDlg;

	::ZeroMemory( &stPaperInfo, sizeof(NPS_PaperInfo) );

	cDevGetProfileDlg.m_Feed		= LoadSetting( KEY_PROF_FEED, 0 );
	cDevGetProfileDlg.m_PaperWidth	= LoadSetting( KEY_PROF_PAPERWIDTH, 1270 );
	cDevGetProfileDlg.m_Surface		= LoadSetting( KEY_PROF_SURFACE, 1 );
	cDevGetProfileDlg.m_strName		= LoadSettingStr( KEY_PROF_NAME, "" );
	cDevGetProfileDlg.m_strFilePath	= LoadSettingStr( KEY_PROF_PATH, "" );

	if( IDOK != cDevGetProfileDlg.DoModal() )
	{
		return;
	}

	SaveSetting( KEY_PROF_FEED, cDevGetProfileDlg.m_Feed );
	SaveSetting( KEY_PROF_PAPERWIDTH, cDevGetProfileDlg.m_PaperWidth );
	SaveSetting( KEY_PROF_SURFACE, cDevGetProfileDlg.m_Surface );
	SaveSettingStr( KEY_PROF_NAME, cDevGetProfileDlg.m_strName );
	SaveSettingStr( KEY_PROF_PATH, cDevGetProfileDlg.m_strFilePath );

	stPaperInfo.dwFeed		= cDevGetProfileDlg.m_Feed;
	stPaperInfo.dwWidth		= cDevGetProfileDlg.m_PaperWidth;
	stPaperInfo.dwSurface	= cDevGetProfileDlg.m_Surface;
	::strncpy( stPaperInfo.szPaperName, cDevGetProfileDlg.m_strName.GetBuffer( cDevGetProfileDlg.m_strName.GetLength() ), sizeof(stPaperInfo.szPaperName) );
	strFilePath				= cDevGetProfileDlg.m_strFilePath;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetProfile (
					hPrinter,
					strFilePath.GetBuffer( strFilePath.GetLength() ),
					&stPaperInfo
					);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsClientDlg::OnButtonDevGetProfile()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.10.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevGetTransmitTime() 
{
	HPRINTER		hPrinter;	// v^̃nhw肷
	DWORD			dwOrderId;	// I[_[ID
	DWORD			dwPrintID;	// vgʎq
	DWORD			dwTime;		// 摜M

	hPrinter	= GetPrinterHandle();

	dwOrderId	= 0;
	dwPrintID	= 0;
	dwTime		= 0;

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevGetTransmitTime (
							hPrinter,	// v^̃nhw肷
							&dwOrderId,	// I[_[ID
							&dwPrintID,	// vgʎq
							&dwTime		// 摜M
							);
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonSetCompletionProcMode
//  ABSTRACT : [npsSetCompletionProcMode]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : N.Nakashima		2007.11.13
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonSetCompletionProcMode() 
{
	DWORD dwMode;

	// _CAOɂݒ
	CSetCompletionProcMode cSetCompletionProcMode;

	if( IDOK != cSetCompletionProcMode.DoModal() )
	{
		return;
	}

	dwMode = cSetCompletionProcMode.m_dwMode;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsSetCompletionProcMode( dwMode );
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevStartDuplex
//  ABSTRACT : [npsDevStartDuplex]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : Y.Yoshinobu		2008.5.14
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevStartDuplex() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// 擾I[_[IDw肷

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevStartDuplexDlg	wDevStartDuplexDlg;

	wDevStartDuplexDlg.m_OrderId	= m_LatestOrderId;

	if( IDOK != wDevStartDuplexDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevStartDuplexDlg.m_OrderId;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevStartDuplex (
							hPrinter,	// v^̃nhw肷
							dwOrderId	// 擾I[_[IDw肷
							);
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevEndDuplex
//  ABSTRACT : [npsEndDuplex]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : Y.Yoshinobu		2008.5.14
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevEndDuplex() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// 擾I[_[IDw肷

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevEndDuplexDlg	wDevEndDuplexDlg;

	wDevEndDuplexDlg.m_OrderId	= m_LatestOrderId;

	if( IDOK != wDevEndDuplexDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevEndDuplexDlg.m_OrderId;

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevEndDuplex (
							hPrinter,	// v^̃nhw肷
							dwOrderId	// 擾I[_[IDw肷
							);
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevBlankPrint
//  ABSTRACT : [npsDevBlankPrint]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : Y.Yoshinobu		2008.5.14
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
#define	KEY_CLEARINK		"ClearInk"

void CNpsClientDlg::OnButtonDevBlankPrint() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER			hPrinter;	// v^̃nhw肷
	DWORD				dwOrderId;	// vgI[_[IDw肷
	DWORD				PrintID;	// vgʎq
	NPSCOMPLETIONPROC	pEventProc;	// CxgʒmpR[obN֐ւ̃AhX
	NPS_BlankPrintInfo	PrintInfo;	// vgvp[^

	hPrinter	= GetPrinterHandle();

	ZeroMemory( &PrintInfo, sizeof( NPS_BlankPrintInfo ) );

	// _CAOɂݒ
	CDevBlankPrintDlg	wDevBlankPrintDlg;

	// BASIC
	wDevBlankPrintDlg.m_OrderId	= m_LatestOrderId;

	wDevBlankPrintDlg.m_Resolution		= LoadSetting( KEY_RESOLUTION, 3000 );	// 𑜓xiPʁF0.1dpij
	wDevBlankPrintDlg.m_PaperWidth		= LoadSetting( KEY_PAPERWIDTH, 1270 );	// y[p[iPʁF0.1mmj
	wDevBlankPrintDlg.m_PaperLength		= LoadSetting( KEY_PAPERLENGTH, 890 );	// y[p[蒷iPʁF0.1mmj
	wDevBlankPrintDlg.m_PaperName		= LoadSettingStr( KEY_PAPERNAME, "" );	// y[p[
	wDevBlankPrintDlg.m_PrintNum		= 1;		// vg
	wDevBlankPrintDlg.m_Feed			= LoadSetting( KEY_FEED, 0 );			// @
	wDevBlankPrintDlg.m_Surface			= LoadSetting( KEY_SURFACE, 1 );		// y[p[̖ʎ
	wDevBlankPrintDlg.m_PaperPresence	= 0;		// }KWwi}KWԍj
	wDevBlankPrintDlg.m_ClearInk		= LoadSetting( KEY_CLEARINK, 0 );		// NACN
	wDevBlankPrintDlg.m_PrintQuality	= LoadSetting( KEY_PRINTQUALITY, 0 );	// @

	if( IDOK != wDevBlankPrintDlg.DoModal() )
	{
		return;
	}

	// BASIC
	dwOrderId	= wDevBlankPrintDlg.m_OrderId;

	SaveSetting( KEY_RESOLUTION, wDevBlankPrintDlg.m_Resolution );
	SaveSetting( KEY_PAPERWIDTH, wDevBlankPrintDlg.m_PaperWidth );
	SaveSetting( KEY_PAPERLENGTH, wDevBlankPrintDlg.m_PaperLength );
	SaveSettingStr( KEY_PAPERNAME, wDevBlankPrintDlg.m_PaperName );
	SaveSetting( KEY_FEED, wDevBlankPrintDlg.m_Feed );
	SaveSetting( KEY_SURFACE, wDevBlankPrintDlg.m_Surface );
	SaveSetting( KEY_CLEARINK, wDevBlankPrintDlg.m_ClearInk );
	SaveSetting( KEY_PRINTQUALITY, wDevBlankPrintDlg.m_PrintQuality );

	PrintInfo.dwResolution			= wDevBlankPrintDlg.m_Resolution;		// 𑜓xiPʁF0.1dpij
	PrintInfo.dwPaperWidth			= wDevBlankPrintDlg.m_PaperWidth;		// y[p[iPʁF0.1mmj
	PrintInfo.dwPaperLength			= wDevBlankPrintDlg.m_PaperLength;		// y[p[蒷iPʁF0.1mmj
	PrintInfo.dwPrintNum			= wDevBlankPrintDlg.m_PrintNum;			// vg
	PrintInfo.dwFeed				= wDevBlankPrintDlg.m_Feed;				// @
	PrintInfo.dwSurface				= wDevBlankPrintDlg.m_Surface;			// y[p[̖ʎ
	PrintInfo.dwPaperPresence		= wDevBlankPrintDlg.m_PaperPresence;	// }KWwi}KWԍj
	PrintInfo.dwClearInk			= wDevBlankPrintDlg.m_ClearInk;			// NACN
	PrintInfo.wPrintQuality			= wDevBlankPrintDlg.m_PrintQuality;		// @
	strcpy( PrintInfo.szPaperName, wDevBlankPrintDlg.m_PaperName );

	pEventProc	= CallbackCompletionStatic;

	CCSScopeLock	CSScopeLock( &m_CS );

	// APIĂяo

	long Ret = m_objNpsLib.npsDevBlankPrint (
							hPrinter,	// v^̃nhw肷
							dwOrderId,	// vgI[_[IDw肷
							&PrintID,	// vgʎq
							pEventProc,	// CxgʒmpR[obN֐ւ̃AhX
							&PrintInfo	// vgvp[^
							);
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevStartFad
//  ABSTRACT : [npsDevStartFad]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : Y.Yoshinobu		2008.12.23
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevStartFad() 
{
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwResult=0;

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevStartFadDlg	wDevStartFadDlg;

	wDevStartFadDlg.m_OrderId = m_LatestOrderId;
	wDevStartFadDlg.m_strOrderKey.Format( "FAD%d", m_LatestOrderId );
	wDevStartFadDlg.m_FadOut = 0;
	wDevStartFadDlg.m_strFadFileName.Empty();

	if( IDOK != wDevStartFadDlg.DoModal() )
	{
		return;
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevStartFAD (
							hPrinter,
							wDevStartFadDlg.m_OrderId,
							wDevStartFadDlg.m_strOrderKey.GetBuffer( wDevStartFadDlg.m_strOrderKey.GetLength() ),
							&dwResult,
							wDevStartFadDlg.m_FadOut,
							wDevStartFadDlg.m_strFadFileName.GetBuffer( wDevStartFadDlg.m_strFadFileName.GetLength() )
							);
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevStartFad
//  ABSTRACT : [npsDevAdjustForPrint]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : Y.Yoshinobu		2009.03.23
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevAdjustForPrint() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER		hPrinter;	// v^̃nhw肷

	hPrinter	= GetPrinterHandle();

	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevAdjustForPrint (
							hPrinter	// v^̃nhw肷
							);
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevStartRetransmission
//  ABSTRACT : [npsDevStartRetransmission]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : H.Kamiya		2011.11.10
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevStartRetransmission()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	HPRINTER	hPrinter;			// v^̃nhw肷
	DWORD		dwSuspendOrderId;	// 擾fI[_[IDw肷
	DWORD		dwResumeOrderId;	// 擾đI[_[IDw肷
	OrderManager::COrder*	pSuspendOrder	= NULL;
	OrderManager::COrder*	pResumeOrder	= NULL;

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevStartRetransmissionDlg	wDevStartRetransmissionDlg;
	wDevStartRetransmissionDlg.m_ResumeOrderId	= m_LatestOrderId;
	if( IDOK != wDevStartRetransmissionDlg.DoModal() )
	{
		return;
	}

	dwSuspendOrderId	= wDevStartRetransmissionDlg.m_SuspendOrderId;
	dwResumeOrderId		= wDevStartRetransmissionDlg.m_ResumeOrderId;

	// fI[_[ƍđI[_[擾
	pSuspendOrder	= OrderManager::FindOrder( dwSuspendOrderId );
	pResumeOrder	= OrderManager::FindOrder( dwResumeOrderId );
	if( !pSuspendOrder || !pResumeOrder )
	{
		return;
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevStartRetransmission (
							hPrinter,						// v^̃nhw肷
							dwResumeOrderId,				// 擾I[_[IDw肷
							&pSuspendOrder->m_tOrderInfo );	// fI[_[Zbg

	if( NPSERR_NORMAL == Ret )
	{
		while( 0 < pSuspendOrder->GetFrameSize() )
		{
			OrderManager::CFrame*	pFrame = pSuspendOrder->GetFrame( 0 );
			OrderManager::CFrame	tempFrame( pFrame );

			// R}̃I[_[ID
			tempFrame.m_dwOrderId = dwResumeOrderId;

			// đI[_[ɃR}ǉ
			pResumeOrder->AppendFrame( &tempFrame );

			// fI[_[̃R}폜
			pSuspendOrder->RemoveFrame( pFrame );
		}

		// fI[_[폜
		OrderManager::RemoveOrder( pSuspendOrder );
	}
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevEndRetransmission
//  ABSTRACT : [npsDevEndRetransmission]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : H.Kamiya		2011.11.10
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevEndRetransmission()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// 擾I[_[IDw肷
	OrderManager::COrder*	pOrder	= NULL;

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevEndRetransmissionDlg	wDevEndRetransmissionDlg;

	wDevEndRetransmissionDlg.m_OrderId	= m_LatestOrderId;

	if( IDOK != wDevEndRetransmissionDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevEndRetransmissionDlg.m_OrderId;

	// đȊΏۃI[_[擾
	pOrder		= OrderManager::FindOrder( dwOrderId );
	if( !pOrder )
	{
		return;
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevEndRetransmission (
							hPrinter,	// v^̃nhw肷
							dwOrderId	// 擾I[_[IDw肷
							);

	for( int ii = 0; ii < pOrder->GetFrameSize(); ii++ )
	{
		OrderManager::CFrame*	pFrame = pOrder->GetFrame( ii );

		// ]̃R}đ
		if( !pFrame->m_bTransfered )
		{
			long Ret = DevPrintRequest(
									GetPrinterHandle(),
									CallbackCompletionStatic,
									pFrame );
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevInterruptPrintOrder
//  ABSTRACT : [npsDevInterruptPrintOrder]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : H.Kamiya		2011.11.10
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevInterruptPrintOrder()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	HPRINTER	hPrinter;	// v^̃nhw肷
	DWORD		dwOrderId;	// 擾I[_[IDw肷
	NPS_InterruptOrderInfo	tOrderInfo = { 0 };
	OrderManager::COrder*	pOrder	= NULL;

	hPrinter	= GetPrinterHandle();

	// _CAOɂݒ
	CDevInterruptPrintOrderDlg	wDevInterruptPrintOrderDlg;
	if( IDOK != wDevInterruptPrintOrderDlg.DoModal() )
	{
		return;
	}

	dwOrderId	= wDevInterruptPrintOrderDlg.m_OrderId;

	// fLZ̑ΏۃI[_[擾
	pOrder		= OrderManager::FindOrder( dwOrderId );
	if( !pOrder )
	{
		return;
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	long Ret = m_objNpsLib.npsDevInterruptPrintOrder (
							hPrinter,		// v^̃nhw肷
							dwOrderId,		// 擾I[_[IDw肷
							&tOrderInfo );	// fI[_[擾

	// fI[_[ɂ
	if( NPSERR_NORMAL == Ret )
	{
		pOrder->m_bInterrupted = TRUE;
		pOrder->m_tOrderInfo = tOrderInfo;
	}
}

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : OnButtonDevPrintResend
//  ABSTRACT : [npsDevPrintResend]{^ꂽƂ
//  FUNCTION : 
//  NOTE     : 
//  RETURN   : 
//
//  CREATE   : H.Kamiya		2011.11.10
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsClientDlg::OnButtonDevPrintResend() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	HPRINTER	hPrinter;			// v^̃nhw肷
	DWORD		dwOrderId;			// 擾đI[_[IDw肷
	OrderManager::COrder*	pOrder	= NULL;

	hPrinter	= GetPrinterHandle();
	dwOrderId	= m_LatestOrderId;

	// _CAOɂmF
	CDevPrintResendDlg	wDevPrintResendDlg;
	wDevPrintResendDlg.m_OrderId	= dwOrderId;
	if( IDOK != wDevPrintResendDlg.DoModal() )
	{
		return;
	}

	// đI[_[擾
	pOrder	= OrderManager::FindOrder( dwOrderId );
	if( !pOrder )
	{
		return;
	}

	// APIĂяo
	CCSScopeLock	CSScopeLock( &m_CS );

	for( int ii = 0; ii < pOrder->GetFrameSize(); ii++ )
	{
		OrderManager::CFrame*	pFrame = pOrder->GetFrame( ii );

		// ]ς݂̃R}đ
		if( pFrame->m_bTransfered )
		{
			long Ret = DevPrintRequest(
									GetPrinterHandle(),
									CallbackCompletionStatic,
									pFrame );
		}
	}

}
