// Frame.h: CFrame NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FRAME_H__0996E866_9CB7_4958_B282_B203773FCDA8__INCLUDED_)
#define AFX_FRAME_H__0996E866_9CB7_4958_B282_B203773FCDA8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CFrame  
{
public:

	enum STATUS
	{	// 
		WAITING=0,			// t҂
		RECEIVING,			// t
		RECEIVED,			// t
	};

	enum IMG_FORMAT
	{
		JPEG=0,
		BMP=1,
		RGB24=2,
		RGB48_H12_LSB,
		RGB48_L12_LSB,
		BGR48_H12_LSB,
		BGR48_L12_LSB,
		RGB48_H12_MSB,
		RGB48_L12_MSB,
		BGR48_H12_MSB,
		BGR48_L12_MSB,
		BMP_PATH=14,
	};

	enum PRIORITY
	{	// D揇
		NORMAL=0,			// ʏ
		EXPRESS_L1,			// }[x1]
		EXPRESS_L2			// }[x2]
	};

	CFrame();
	virtual ~CFrame();

	// ----------------------------------------
	// tJnvp[^
	// ----------------------------------------

	// tԍ̍̔
	void	NumberingReceiptNo();

	// Lԍ
	void	SetPossessionNo( USHORT nPossessionNo );
	USHORT	GetPossessionNo();

	// 摜e iPʁFBytej
	void	SetImageCapacity( ULONG nImageCapacity );
	ULONG	GetImageCapacity();

	// 摜tH[}bg
	void	SetImageFormat( UCHAR nImageFormat );
	UCHAR	GetImageFormat();

	// 摜̕ iPʁFPixelj
	void	SetImageWidth( USHORT nImageWidth );
	USHORT	GetImageWidth();

	// 摜̍ iPʁFPixelj
	void	SetImageHeight( USHORT nImageHeight );
	USHORT	GetImageHeight();

	// ͉𑜓x iPʁF0.1dpij
	void	SetPaperResolution( USHORT	nPaperResolution );
	USHORT	GetPaperResolution();

	// y[p[̕ iPʁF0.1mmj
	void	SetPaperWidth( USHORT nPaperWidth );
	USHORT	GetPaperWidth();

	// y[p[̑蒷 iPʁF0.1mmj
	void	SetPaperLength( USHORT	nPaperLength );
	USHORT	GetPaperLength();

	// y[p[ID
	void	SetPaperID( USHORT	nPaperID );
	USHORT	GetPaperID();

	// s[g
	void	SetRepeat( USHORT nRepeat );
	USHORT	GetRepeat();

	// @
	void	SetPaperFeed( USHORT nPaperFeed );
	USHORT	GetPaperFeed();

	// ~l[g
	void	SetLaminator( USHORT nLaminator );
	USHORT	GetLaminator();

	// CVP1sڂ̒ʂԍ̏l
	void	SetCvpInitialValue1( USHORT nCvpInitialValue1 );
	USHORT	GetCvpInitialValue1();

	// CVP1sڂ̒ʂԍ}ʒu
	void	SetCvpPoint1( USHORT nCvpPoint1 );
	USHORT	GetCvpPoint1();

	// CVP1sڂ̒ʂԍ󎚂錅
	void	SetCvpInitialWidth1( USHORT nCvpInitialWidth1 );
	USHORT	GetCvpInitialWidth1();

	// CVP2sڂ̒ʂԍ̏l
	void	SetCvpInitialValue2( USHORT nCvpInitialValue2 );
	USHORT	GetCvpInitialValue2();

	// CVP2sڂ̒ʂԍ}ʒu
	void	SetCvpPoint2( USHORT nCvpPoint2 );
	USHORT	GetCvpPoint2();

	// CVP2sڂ̒ʂԍ󎚂錅
	void	SetCvpInitialWidth2( USHORT nCvpInitialWidth2 );
	USHORT	GetCvpInitialWidth2();

	// CVP1s
	void	SetCvpLine1( LPCTSTR lpString );
	CString	GetCvpLine1();
	int		GetCvpLine1( LPTSTR lpString, int nStringSize );

	// CVP2s
	void	SetCvpLine2( LPCTSTR lpString );
	CString	GetCvpLine2();
	int		GetCvpLine2( LPTSTR lpString, int nStringSize );

	// ]px
	void	SetAngle( USHORT nAngle );
	USHORT	GetAngle();

	// Uy[p[w
	void	SetPaperPresence( UCHAR nPaperPresence );
	UCHAR	GetPaperPresence();

	// IJnʒu␳ iPʁF0.1mmj
	void	SetEspc( SHORT nEspc );
	SHORT	GetEspc();

	// MgC
	void	SetRetry( SHORT nRetry );
	SHORT	GetRetry();

	// I[_[ʔԍ
	void	SetOrderId( ULONG nOrderId );
	ULONG	GetOrderId();

	// y[p[tBbeBO
	void	SetPaperFitting( USHORT	nPaperFitting );
	USHORT	GetPaperFitting();

	// GbW
	void	SetEdgeEnhancement( USHORT nEdgeEnhancement );
	USHORT	GetEdgeEnhancement();

	// CMS
	void	SetCMS( USHORT nCMS );
	USHORT	GetCMS();

	// 㕔
	void	SetWithBorderTop( USHORT nWithBorderTop );
	USHORT	GetWithBorderTop();

	// 
	void	SetWithBorderBottom( USHORT	nWithBorderBottom );
	USHORT	GetWithBorderBottom();

	// 
	void	SetWithBorderLeft( USHORT nWithBorderLeft );
	USHORT	GetWithBorderLeft();

	// E
	void	SetWithBorderRight( USHORT nWithBorderRight );
	USHORT	GetWithBorderRight();

	// ̐F
	void	SetWithBorderColor( UCHAR* pWithBorderColor );
	void	GetWithBorderColor( UCHAR* pWithBorderColor );

	// y[p[
	void	SetPaperName( LPCTSTR lpString );
	CString GetPaperName();
	int		GetPaperName( LPTSTR lpString, int nStringSize );

	// 呖vgZ^[ʒuItZbgl
	void	SetPrintCenterOffset( SHORT	nPrintCenterOffset );
	SHORT	GetPrintCenterOffset();

	// CVP󎚕TCY
	void	SetCvpPrintSize( USHORT nCvpPrintSize );
	USHORT	GetCvpPrintSize();

	// @
	void	SetPrintQuality( USHORT nPrintQuality );
	USHORT	GetPrintQuality();

	// 摜gASY
	void	SetImageEnLargeType( UCHAR nImageEnLargeType );
	UCHAR	GetImageEnLargeType();
	
	// NACN
	void	SetClearInk( USHORT nClearInk );
	USHORT	GetClearInk();

	// ʈ̏
	void	SetDuplexSeqNo( ULONG nDuplexSeqNo );
	ULONG	GetDuplexSeqNo();

	// [fBOJn
	void SetLoadingCount( USHORT nLoadingCount );
	USHORT GetLoadingCount();

	// ro
	void SetPrintedCount( USHORT nPrintedCount );
	USHORT GetPrintedCount();

	// Cxgʎq
	void SetEventId( ULONG nEventId );
	ULONG GetEventId();

	// CxgR[hiԁj
	void SetEventCodeMain( USHORT nEventCodeMain );
	USHORT GetEventCodeMain();

	// ----------------------------------------
	// tJnp[^
	// ----------------------------------------

	// tԍ
	void	SetReceiptNo( ULONG nReceiptNo );
	ULONG	GetReceiptNo();

	// ----------------------------------------
	// t@C
	// ----------------------------------------

	// ----------------------------------------
	// vg󋵒ʒm
	// ----------------------------------------

	// 
	void SetStatus( STATUS eStatus );
	STATUS GetStatus();

	// [1FvgJn]ʒm鎞
	void	SetNotify1( time_t nNotify1 );
	time_t	GetNotify1();

	// [2Fvg]ʒm鎞
	void	SetNotify2( time_t nNotify2 );
	time_t	GetNotify2();

	// [3Fvgro]ʒm鎞
	void	Setm_nNotify3( time_t nNotify3 );
	time_t	GetNotify3();

	// vgJn
	void	IncrementPrintCount();
	USHORT	GetPrintCount();
	USHORT	GetNonPrintCount();
	BOOL	IsPrintEnd();

	// ----------------------------------------
	// M
	// ----------------------------------------

	// M̃\Pbg|C^
	void	SetSock( LPVOID pSock );
	LPVOID	GetSock();

	// 2006.10.25 T.Mizushima	wE51
	BOOL	ChkExpressPrint()
	{
		return ( EXPRESS_L1 == m_eExpress ) ? TRUE : FALSE ;			// }w̃vgǂ
	}
	BOOL	ChkExpressPrint2()
	{
		return ( EXPRESS_L2 == m_eExpress ) ? TRUE : FALSE ;			// }w̃vgǂ
	}
	void	SetExpressPrint( PRIORITY ePriority )
	{
		m_eExpress = ePriority;			// }w̃vgǂ
	}

	// 
	const CFrame& operator=(const CFrame& src);

private:

	// ----------------------------------------
	// tJnvp[^
	// ----------------------------------------

	USHORT	m_nPossessionNo;		// Lԍ
	ULONG	m_nImageCapacity;		// 摜e iPʁFBytej
	UCHAR	m_nImageFormat;			// 摜tH[}bg
	USHORT	m_nImageWidth;			// 摜̕ iPʁFPixelj
	USHORT	m_nImageHeight;			// 摜̍ iPʁFPixelj
	USHORT	m_nPaperResolution;		// ͉𑜓x iPʁF0.1dpij
	USHORT	m_nPaperWidth;			// y[p[̕ iPʁF0.1mmj
	USHORT	m_nPaperLength;			// y[p[̑蒷 iPʁF0.1mmj
	USHORT	m_nPaperID;				// y[p[ID
	USHORT	m_nRepeat;				// s[g
	USHORT	m_nPaperFeed;			// @
	USHORT	m_nLaminator;			// ~l[g
	USHORT	m_nCvpInitialValue1;	// CVP1sڂ̒ʂԍ̏l
	USHORT	m_nCvpPoint1;			// CVP1sڂ̒ʂԍ}ʒu
	USHORT	m_nCvpInitialWidth1;	// CVP1sڂ̒ʂԍ󎚂錅
	USHORT	m_nCvpInitialValue2;	// CVP2sڂ̒ʂԍ̏l
	USHORT	m_nCvpPoint2;			// CVP2sڂ̒ʂԍ}ʒu
	USHORT	m_nCvpInitialWidth2;	// CVP2sڂ̒ʂԍ󎚂錅
	CString	m_strCvpLine1;			// CVP1s
	CString	m_strCvpLine2;			// CVP2s
	USHORT	m_nAngle;				// ]px
	UCHAR	m_nPaperPresence;		// Uy[p[w
	SHORT	m_nEspc;				// IJnʒu␳ iPʁF0.1mmj
	SHORT	m_nRetry;				// MgC
	ULONG	m_nOrderId;				// I[_[ʔԍ
	USHORT	m_nPaperFitting;		// y[p[tBbeBO
	USHORT	m_nEdgeEnhancement;		// GbW
	USHORT	m_nCMS;					// CMS
	USHORT	m_nWithBorderTop;		// 㕔
	USHORT	m_nWithBorderBottom;	// 
	USHORT	m_nWithBorderLeft;		// 
	USHORT	m_nWithBorderRight;		// E
	UCHAR	m_nWithBorderColor[3];	// ̐F
	CString	m_strPaperName;			// y[p[
	SHORT	m_nPrintCenterOffset;	// 呖vgZ^[ʒuItZbgl
	USHORT	m_nCvpPrintSize;		// CVP󎚕TCY
	USHORT	m_nPrintQuality;		// @
	UCHAR	m_nImageEnLargeType;	// 摜gASY
	USHORT	m_nClearInk;			// NACN
	ULONG	m_nDuplexSeqNo;			// ʈ̏
	USHORT	m_nLoadingCount;		// [fBOJn			2011.11.1 A.Nagamatsu (D703/WG)
	USHORT	m_nPrintedCount;		// ro					2011.11.1 A.Nagamatsu (D703/WG)
	ULONG	m_nEventId;				// Cxgʎq				2011.11.1 A.Nagamatsu (D703/WG)
	USHORT	m_nEventCodeMain;		// CxgR[h ()		2011.11.1 A.Nagamatsu (D703/WG)

	// ----------------------------------------
	// tJnp[^
	// ----------------------------------------

	ULONG	m_nReceiptNo;			// tԍ

	// ----------------------------------------
	// t@C
	// ----------------------------------------

	// ----------------------------------------
	// vg
	// ----------------------------------------

	STATUS	m_eStatus;				// 

	USHORT	m_nPrintCount;			// vgJn

	// ----------------------------------------
	// M
	// ----------------------------------------
	LPVOID	m_pSock;				// M̃\Pbg|C^

	// 2006.10.25 T.Mizushima	wE51
	PRIORITY	m_eExpress;				// }w̃vgǂ
};

#endif // !defined(AFX_FRAME_H__0996E866_9CB7_4958_B282_B203773FCDA8__INCLUDED_)
