// PaperInfo.h: CPaperInfo NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PAPERINFO_H__28EDD33C_5CA4_4D5B_97D9_A394C2ECB44E__INCLUDED_)
#define AFX_PAPERINFO_H__28EDD33C_5CA4_4D5B_97D9_A394C2ECB44E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct
{
	USHORT	nPaperWidth;				// y[p[̕ iPʁF0.1mmj
	USHORT	nPaperId;					// y[p[ID iʎj í͈jF1`4
	ULONG	nPaperRemaind;				// y[p[c iPʁF0.1mmj
	UCHAR	nPaperFeed;					// @	( 0F[, 1FV[g )
	UCHAR	nPaperPresence;				// U
	CHAR	szPaperName[32];			// y[p[
} T_MagInstInfo;

typedef struct
{
	USHORT	nPaperWidth;				// y[p[̕ iPʁF0.1mmj
	USHORT	nPaperLengthMin;			// y[p[̑蒷̍ŏl iPʁF0.1mmj
	USHORT	nPaperLengthMax;			// y[p[̑蒷̍ől iPʁF0.1mmj
	USHORT	nPaperId;					// y[p[ID iʎj í͈jF1`4
	USHORT	nPaperResolution[8];		// ͉𑜓x iPʁF0.1dpij
	SHORT	nPaperAllocationTop;		// t㕔 iPʁFPixelj
	SHORT	nPaperAllocationBottom;		// t iPʁFPixelj
	SHORT	nPaperAllocationLeft;		// t iPʁFPixelj
	SHORT	nPaperAllocationRight;		// tE iPʁFPixelj
	USHORT	nSetupStatus;				// ZbgAbv
	UCHAR	nPaperFeed;					// @	( 0F[, 1FV[g )
	USHORT	nPaperTypeCode;				// y[p[^CvR[h
	UCHAR	nPaperKind;					// y[p[ʎ
	UCHAR	nMagazineID;				// }KWID
	SHORT	nWBAdjustLeft;				// WB␳l iPʁF0.1mmj
	SHORT	nWBAdjustRight;				// WB␳lE iPʁF0.1mmj
	CHAR	szPaperName[32];			// y[p[
	UCHAR	nPaperType;					// y[p[^Cvi܎j
	UCHAR	nDirection;					// fBNViBERGpj
	UCHAR	nPrintQuality;				// iiBERGpj
	USHORT	nDoubleSidedPaper;			// ʃy[p[iFUJIpj
	USHORT	nPaperInfo;					// y[p[iFUJIpj
} T_MagAllInfo;

class CPaperInfo  
{
public:
	CPaperInfo();
	virtual ~CPaperInfo();

	// gp\ȃy[p[̕ƃy[p[ID擾
//	BOOL GetPaperWidthAndId( const int nIndex, USHORT* pPaperWidth, USHORT* pPaperId, UCHAR* pMagazineID );

	// gp\ȃy[p[擾@// Added by H.Yoshida	2007.02.22
	BOOL GetPaperInfo( const int nIndex, USHORT* pPaperWidth, USHORT* pPaperId, UCHAR* pMagazineID, UCHAR* pPaperFeed, LPTSTR lpPaperName, int nStringSize );

	// w肳ꂽ}KW̑S擾
	BOOL GetMagAllInfo( const int nIndex, T_MagAllInfo* pMagInfo );

	// U}KW̑S擾
	BOOL GetMagInstInfo( const int nIndex, T_MagInstInfo* pMagInfo );

	// U}KW
	void SetPaper( int nIndex, USHORT  nPaperWidth, USHORT  nPaperId, UCHAR  nPaperFeed, LPCTSTR lpPaperName, int nStringSize );
	void GetPaper( int nIndex, USHORT* pPaperWidth, USHORT* pPaperId, UCHAR* pPaperFeed, LPTSTR  lpPaperName, int nStringSize );

	// o^}KWe[uOt@Cǂݍ
	// 2006.09.20 T.Mizushima
	BOOL LoadRegMagTbl();

	// init@Cǂݍ(y[p[)
	// Added by H.Yoshida	2007.02.22
	void LoadPaperInfo();

private:

	//////////////////////////////
	// oϐ
	//////////////////////////////

	// U}KW
	USHORT	m_nPaperWidth[5];
	USHORT	m_nPaperId[5];
	UCHAR	m_nPaperFeed[5];			// @	( 0F[, 1FV[g )
	CHAR	m_szPaperName[5][32];		// y[p[

	int		m_RegMagCnt;	// o^}KW	2006.09.20 T.Mizushima
};

#endif // !defined(AFX_PAPERINFO_H__28EDD33C_5CA4_4D5B_97D9_A394C2ECB44E__INCLUDED_)
