// PrintQue.h: CPrintQue NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTQUE_H__3AB83A05_2DAC_4A06_B111_1D02F5706334__INCLUDED_)
#define AFX_PRINTQUE_H__3AB83A05_2DAC_4A06_B111_1D02F5706334__INCLUDED_

#include "Frame.h"	// ClassView ɂĒǉ܂B
#include "Photo.h"	// ClassView ɂĒǉ܂B
#include <afxtempl.h>		// MFC ̃ev[gT|[g

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPrintQue  
{
public:
	CPrintQue();
	virtual ~CPrintQue();

	// M̃R}
	BOOL	ReciveStartFrame( CFrame* pFrame );		// MJn
	CFrame::STATUS GetReceivingFrameStatus();		// M
	void	SetReceivingFrameStatus( CFrame::STATUS eStatus );
	ULONG	GetReceivingFrameReceiptNo();			// tԍ擾
	UCHAR	GetReceivingFrameImageFormat();			// 摜`擾
	ULONG	GetReceivingFrameImageCapacity();		// 摜eʎ擾
	ULONG	GetReceivingFrameImageReceivSize();		// 摜擾eʎ擾
	void	SetReceivingFrameImageReceivSize( ULONG nRemainSize );// 摜擾eʐݒ
	USHORT	GetReceivingFrameImageWidth();			// 摜̕擾
	USHORT	GetReceivingFrameImageHeight();			// 摜̍擾
	BOOL	ReciveEndFrame( ULONG nReceiptNo );		// MIiR}̒ǉj
	BOOL	ReciveCancelFrame( ULONG nReceiptNo );	// M
	BOOL	ReciveCancelFrame();					// Mij

	// R}̊J
	void	RemoveFrame( ULONG nReceiptNo );

	// Ăяo
	void	OnTime100ms();

	// L[CÕvg擾
	ULONG	GetQueueingCount();

	// L[CỎ摜eʎ擾
	ULONG	GetQueueingImageCapacity();

	// vg̃vg擾
	ULONG	GetPrintingCount();

	// ̃vg擾
	ULONG	GetAdvancingCount();

	// vgꎞ~
	int		PrintStopCountIncrement();
	int		PrintStopCountDecrement();
	int		GetPrintStopCount();

	// tԍ̑݊mF
	BOOL	IsExistReceiptNo( ULONG nReceiptNo );

	// vgv
	BOOL	CancelRequest( ULONG nReceiptNo );
	BOOL	CancelOrderRequest( USHORT nPossessionNo );
	void	CancelAll();

	// }荞݂ɂAvgL[̊J
	void	PossessionStop();
	void	PossessionStop2();
	void	SavePrintQue( WORD wPossessionMode );	// @@@RD-151Ή	2012.02.15	T.Mizushima
	void	RecoveryPrintQue();						// @@@RD-151Ή	2012.02.15	T.Mizushima

	// G[ɂSvgf
	// 2006.09.25 T.Mizushima
	void	ErrorPrintAbort();

	// ʈ
	void	EnableDuplex();
	void	DisableDuplex();
	BOOL	IsEnableDuplex();
	DWORD	GetDuplexSeqNo();
	void	IncrementDuplexSeqNo();

private:
	// v^[̃`FbN
	// Added by H.Yoshida	2007.12.05
	void	CheckPrinterMemory();

private:

	// M̃R}
	CFrame*	m_pReceivingFrame;				// M̃R}NX
	ULONG m_nImageReceivSize;
	CRITICAL_SECTION	m_pFrameLock;

	// vg҂̃R}
	CArray<CFrame*,CFrame*>	m_apFrame;		// R}NX̊Ǘ̈
	CRITICAL_SECTION	m_apFrameLock;

	// vg̃tHg
	CArray<CPhoto*,CPhoto*>	m_apPhoto1;		// vgNX̊Ǘ̈
	CRITICAL_SECTION	m_apPhoto1Lock;

	// ̃tHg
	CArray<CPhoto*,CPhoto*>	m_apPhoto2;		// vgNX̊Ǘ̈
	CRITICAL_SECTION	m_apPhoto2Lock;

	// vgJn^C~O
	time_t	m_nLatestPrintTime;				// OvgsԁivgJnԊu̒Ɏgpj

	// vgꎞ~
	int m_nPrintStopCount;					// vg~v̐i 0:vgꎞ~vȂ, 1`:vgꎞ~v j
	CRITICAL_SECTION	m_pPrintStopLock;

	// ʈ
	BOOL	m_bDuplexEnable;				// ʈ ( TRUE:, FALSE: )
	DWORD	m_dwDuplexSeqNo;				// ʈ̎t ( :\, : )
	CRITICAL_SECTION	m_bDuplexEnableLock;

	// ޔ𒆂̃R}		@@@RD-151Ή	2012.02.15	T.Mizushima
	CArray<CFrame*,CFrame*>	m_svFrame;		// }荞݂󂯂đޔR}NX̊Ǘ̈(ʏ탌x)
	CArray<CFrame*,CFrame*>	m_svExpFrame;	// }荞݂󂯂đޔR}NX̊Ǘ̈(}x)
	CFrame*	m_psvReceivingFrame;			// M̃R}NX
};

#endif // !defined(AFX_PRINTQUE_H__3AB83A05_2DAC_4A06_B111_1D02F5706334__INCLUDED_)
