// PrinterConfig.cpp: CPrinterConfig NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "PrinterConfig.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CPrinterConfig::CPrinterConfig()
{
#if 0	// v^[ݒuOinit@C擾Ή	2006.09.20 T.Mizushima
	int nIndex;

	// v^̃e (PʁFMByte)
	m_nTotalMemory = 256*1024*1024;

	// t摜̍̕ŏTCY iPʁFPixelj
	m_nImageSizeMinWidth = 32;

	// t摜̍̍ŏTCY iPʁFPixelj
	m_nImageSizeMinHeight = 32;

	// t摜̍̕őTCY iPʁFPixelj
	m_nImageSizeMaxWidth = 13000;

	// t摜̍̍őTCY iPʁFPixelj
	m_nImageSizeMaxHeight = 13000;

	// U\ȃ}KW
	m_nNumberOfMagazine = 4;

	// ő僊s[g
	m_nRepeatCountMax = 9999;

	//T|[g摜
	for ( nIndex=0 ; 32 > nIndex ; nIndex++ )
	{
		m_SupportImageFormat[nIndex] = 0;
	}
	m_SupportImageFormat[0] = 1;		// JPEG
	m_SupportImageFormat[1] = 0;		// Bitmap
	m_SupportImageFormat[2] = 1;		// RGB24
	m_SupportImageFormat[3]	= 0;		// RGB48rbg J[_(12rbgL,LSB) 
	m_SupportImageFormat[4]	= 0;		// RGB48rbg J[_(12rbgL,LSB)
	m_SupportImageFormat[5]	= 0;		// BGR48rbg J[_(12rbgL,LSB)
	m_SupportImageFormat[6]	= 0;		// BGR48rbg J[_(12rbgL,LSB)
	m_SupportImageFormat[7]	= 0;		// RGB48rbg J[_(12rbgL,MSB)
	m_SupportImageFormat[8]	= 0;		// RGB48rbg J[_(12rbgL,MSB)
	m_SupportImageFormat[9]	= 0;		// BGR48rbg J[_(12rbgL,MSB)
	m_SupportImageFormat[10]= 0;		// BGR48rbg J[_(12rbgL,MSB)

	// ~l[^[jbg̑
	m_nLaminatorUnitAttach = 0;

	// ݒu
	m_InstallationDate[0] = 2006;
	m_InstallationDate[1] = 8;
	m_InstallationDate[2] = 11;

	// ғJn
	m_OperationStartDate[0] = 2006;
	m_OperationStartDate[1] = 8;
	m_OperationStartDate[2] = 19;

	// vZT[ ivZT[ʁj
	m_nProcessorType = 12;

	// [ ij
	m_nEmulsionNumber = 54;

	// [U[`̃v^
	m_strPrinterNickname.Format( "QSS-Simu" );

	// T|[g]px
	m_nSupportAngle = 0;				// 0F90x]Ή

	// L
	m_nSupportIntoPrinter = 1;			// 1F}ݑΉ

	// ڃvgΉ
	m_nSupportLongPaper = 1;			// 1FΉς

	// \[^[̃gC̐
	m_nSorterStatus = 10;

	// CVP󎚍s
	m_nCvpStatus = 2;

	// T|[gy[p[tBbeBO
	m_nSupportPaperFitting = 0;			// 0FtBbeBOΉ

	// T|[gGbW
	m_nSupportEdgeEnhancement = 0;		// 0FGbWΉ

	// T|[gCMS
	m_nSupportCMS = 0;					// 0FCMSΉ

	// T|[g
	m_nSupportWithBorder = 0;			// 0FΉ

	// vt@Cp̋@R[h
	m_nMachinTypeForProfile = 23;		// 

	// vt@Co[W
	m_strMachinProfileVersion.Format( "N b006" );	// SHR[hĖႤKv聚

	// y[p[^CvR[h
	m_PaperTypeCode[0] = 152;			// SHR[hĖႤKv聚
	m_PaperTypeCode[1] = 133;			// SHR[hĖႤKv聚
	m_PaperTypeCode[2] = 0;				// SHR[hĖႤKv聚
	m_PaperTypeCode[3] = 0;				// SHR[hĖႤKv聚
	m_PaperTypeCode[4] = 0;				// SHR[hĖႤKv聚
	m_PaperTypeCode[5] = 0;				// SHR[hĖႤKv聚

	// OEMR[h
	m_nOemCode = 0;						// 0FNKCdl

	// ZbgAbṽASYo[W
	m_nSetupAlgorithm = 0;

	// T|[gʈ
	m_nSupportDoubleSided = 0;

	// ʈi (0:, 1:蓮)
	m_nMethodDoubleSided = 0;

	// FADڑԍ (0:ڑ, 1`:FADڑԍ)
	m_nFadAttachNo = 0;

	// f
	m_nSupportInterrupt = 0;

#else
	// init@Cǂݍ
	LoadSetupInfo();
#endif	// v^[ݒuOinit@C擾Ή	2006.09.20 T.Mizushima
}

CPrinterConfig::~CPrinterConfig()
{

}

// v^̃e
void CPrinterConfig::SetTotalMemory( ULONG nMemory )
{
	m_nTotalMemory = nMemory;
}

ULONG CPrinterConfig::GetTotalMemory()
{
	return m_nTotalMemory;
}

// t摜̍̕ŏTCY
void CPrinterConfig::SetImageSizeMinWidth( ULONG nWidth )
{
	m_nImageSizeMinWidth = nWidth;
}

ULONG CPrinterConfig::GetImageSizeMinWidth()
{
	return m_nImageSizeMinWidth;
}

// t摜̍̍ŏTCY
void CPrinterConfig::SetImageSizeMinHeight( ULONG nHeight )
{
	m_nImageSizeMinHeight = nHeight;
}

ULONG CPrinterConfig::GetImageSizeMinHeight()
{
	return m_nImageSizeMinHeight;
}

// t摜̍̕őTCY
void CPrinterConfig::SetImageSizeMaxWidth( ULONG nWidth )
{
	m_nImageSizeMaxWidth = nWidth;
}

ULONG CPrinterConfig::GetImageSizeMaxWidth()
{
	return m_nImageSizeMaxWidth;
}

// t摜̍̍őTCY
void CPrinterConfig::SetImageSizeMaxHeight( ULONG nHeight )
{
	m_nImageSizeMaxHeight = nHeight;
}

ULONG CPrinterConfig::GetImageSizeMaxHeight()
{
	return m_nImageSizeMaxHeight;
}

// U\ȃ}KW
void CPrinterConfig::SetNumberOfMagazine( USHORT nNumber )
{
	m_nNumberOfMagazine = nNumber;
}

USHORT CPrinterConfig::GetNumberOfMagazine()
{
	return m_nNumberOfMagazine;
}

// v^̓
void CPrinterConfig::GetPrinterTime( USHORT* pTime )
{
	SYSTEMTIME	sysTime;

	::GetLocalTime( &sysTime );

	pTime[0] = sysTime.wYear;
	pTime[1] = sysTime.wMonth;
	pTime[2] = sysTime.wDay;
	pTime[3] = sysTime.wHour;
	pTime[4] = sysTime.wMinute;
	pTime[5] = sysTime.wSecond;
	pTime[6] = sysTime.wMilliseconds;
	pTime[7] = sysTime.wDayOfWeek;
}

// ő僊s[g
void CPrinterConfig::SetRepeatCountMax( ULONG nCount)
{
	m_nRepeatCountMax = nCount;
}

ULONG CPrinterConfig::GetRepeatCountMax()
{
	return m_nRepeatCountMax;
}

//T|[g摜
void CPrinterConfig::SetSupportImageFormat( UCHAR* pSupport )
{
	int nIndex;

	for ( nIndex=0 ; 32 > nIndex ; nIndex++ )
	{
		m_SupportImageFormat[nIndex] = pSupport[nIndex];
	}
}

void CPrinterConfig::GetSupportImageFormat( UCHAR* pSupport )
{
	int nIndex;

	for ( nIndex=0 ; 32 > nIndex ; nIndex++ )
	{
		pSupport[nIndex] = m_SupportImageFormat[nIndex];
	}
}

// ~l[^[jbg̑
void CPrinterConfig::SetLaminatorUnitAttach( UCHAR nAttach )
{
	m_nLaminatorUnitAttach = nAttach;
}

UCHAR CPrinterConfig::GetLaminatorUnitAttach()
{
	return m_nLaminatorUnitAttach;
}

// ݒu
void CPrinterConfig::SetInstallationDate( USHORT* pDate )
{
	int nIndex;

	for ( nIndex=0 ; 3 > nIndex ; nIndex++ )
	{
		m_InstallationDate[nIndex] = pDate[nIndex];
	}
}

void CPrinterConfig::GetInstallationDate( USHORT* pDate )
{
	int nIndex;

	for ( nIndex=0 ; 3 > nIndex ; nIndex++ )
	{
		pDate[nIndex] = m_InstallationDate[nIndex];
	}
}

// ғJn
void CPrinterConfig::SetOperationStartDate( USHORT* pDate )
{
	int nIndex;

	for ( nIndex=0 ; 3 > nIndex ; nIndex++ )
	{
		m_OperationStartDate[nIndex] = pDate[nIndex];
	}
}

void CPrinterConfig::GetOperationStartDate( USHORT* pDate )
{
	int nIndex;

	for ( nIndex=0 ; 3 > nIndex ; nIndex++ )
	{
		pDate[nIndex] = m_OperationStartDate[nIndex];
	}
}

// vZT[ ivZT[ʁj
void CPrinterConfig::SetProcessorType( USHORT nType )
{
	m_nProcessorType = nType;
}

USHORT CPrinterConfig::GetProcessorType()
{
	return m_nProcessorType;
}

// [ ij
void CPrinterConfig::SetEmulsionNumber( USHORT nNumber )
{
	m_nEmulsionNumber = nNumber;
}

USHORT CPrinterConfig::GetEmulsionNumber()
{
	return m_nEmulsionNumber;
}

// [U[`̃v^
void CPrinterConfig::SetPrinterNickname( LPCTSTR lpString )
{
	m_strPrinterNickname = lpString;
}

int CPrinterConfig::GetPrinterNickname( LPTSTR lpString, int nStringSize )
{
	int nRetSize = 0;

	if ( m_strPrinterNickname.GetLength() < nStringSize ) {
		lstrcpy( lpString, m_strPrinterNickname.GetBuffer(1) );
		nRetSize = lstrlen( lpString ) + 1;
	} else {
		lstrcpyn( lpString, m_strPrinterNickname.GetBuffer(1), nStringSize - 1 );
		nRetSize = nStringSize - 1;
	}

	return nRetSize;
}

// T|[g]px
void CPrinterConfig::SetSupportAngle( USHORT nAngle )
{
	m_nSupportAngle = nAngle;
}

USHORT CPrinterConfig::GetSupportAngle()
{
	return m_nSupportAngle;
}

// L
void CPrinterConfig::SetSupportIntoPrinter( USHORT nIntoPrinter )
{
	m_nSupportIntoPrinter = nIntoPrinter;
}

USHORT CPrinterConfig::GetSupportIntoPrinter()
{
	return m_nSupportIntoPrinter;
}

// ڃvgΉ
void CPrinterConfig::SetSupportLongPaper( USHORT nSupportLongPaper )
{
	m_nSupportLongPaper = nSupportLongPaper;
}

USHORT CPrinterConfig::GetSupportLongPaper()
{
	return m_nSupportLongPaper;
}

// \[^[̃gC̐
void CPrinterConfig::SetSorterStatus( UCHAR nSorterStatus )
{
	m_nSorterStatus = nSorterStatus;
}

UCHAR CPrinterConfig::GetSorterStatus()
{
	return m_nSorterStatus;
}

// CVP󎚍s
void CPrinterConfig::SetCvpStatus( UCHAR nCvpStatus )
{
	m_nCvpStatus = nCvpStatus;
}

UCHAR CPrinterConfig::GetCvpStatus()
{
	return m_nCvpStatus;
}

// T|[gy[p[tBbeBO
void CPrinterConfig::SetSupportPaperFitting( USHORT nSupportPaperFitting )
{
	m_nSupportPaperFitting = nSupportPaperFitting;
}

USHORT CPrinterConfig::GetSupportPaperFitting()
{
	return m_nSupportPaperFitting;
}

// T|[gGbW
void CPrinterConfig::SetSupportEdgeEnhancement( USHORT nSupportEdgeEnhancement )
{
	m_nSupportEdgeEnhancement = nSupportEdgeEnhancement;
}

USHORT CPrinterConfig::GetSupportEdgeEnhancement()
{
	return m_nSupportEdgeEnhancement;
}

// T|[gCMS
void CPrinterConfig::SetSupportCMS( USHORT nSupportCMS )
{
	m_nSupportCMS = nSupportCMS;
}

USHORT CPrinterConfig::GetSupportCMS()
{
	return m_nSupportCMS;
}

// T|[g
void CPrinterConfig::SetSupportWithBorder( USHORT nSupportWithBorder )
{
	m_nSupportWithBorder = nSupportWithBorder;
}

USHORT CPrinterConfig::GetSupportWithBorder()
{
	return m_nSupportWithBorder;
}

// vt@Cp̋@R[h
void CPrinterConfig::SetMachinTypeForProfile( USHORT nMachinTypeForProfile )
{
	m_nMachinTypeForProfile = nMachinTypeForProfile;
}

USHORT CPrinterConfig::GetMachinTypeForProfile()
{
	return m_nMachinTypeForProfile;
}

// vt@Co[W
void CPrinterConfig::SetMachinProfileVersion( LPCTSTR lpString )
{
	m_strMachinProfileVersion = lpString;
}

int CPrinterConfig::GetMachinProfileVersion( LPTSTR lpString, int nStringSize )
{
	int nRetSize = 0;

	if ( m_strMachinProfileVersion.GetLength() < nStringSize ) {
		lstrcpy( lpString, m_strMachinProfileVersion.GetBuffer(1) );
		nRetSize = lstrlen( lpString ) + 1;
	} else {
		lstrcpyn( lpString, m_strMachinProfileVersion.GetBuffer(1), nStringSize - 1 );
		nRetSize = nStringSize - 1;
	}

	return nRetSize;
}

// y[p[^CvR[h
void CPrinterConfig::SetPaperTypeCode( USHORT* pPaperTypeCode )
{
	int nIndex;

	for ( nIndex=0 ; 6 > nIndex ; nIndex++ )
	{
		m_PaperTypeCode[nIndex] = pPaperTypeCode[nIndex];
	}
}

void CPrinterConfig::GetPaperTypeCode( USHORT* pPaperTypeCode )
{
	int nIndex;

	for ( nIndex=0 ; 6 > nIndex ; nIndex++ )
	{
		pPaperTypeCode[nIndex] = m_PaperTypeCode[nIndex];
	}
}

// OEMR[h
void CPrinterConfig::SetOemCode( UCHAR nOemCode )
{
	m_nOemCode = nOemCode;
}
UCHAR CPrinterConfig::GetOemCode()
{
	return m_nOemCode;
}

// ZbgAbṽASYo[W
void CPrinterConfig::SetSetupAlgorithm( USHORT nSetupAlgorithm )
{
	m_nSetupAlgorithm = nSetupAlgorithm;
}

USHORT CPrinterConfig::GetSetupAlgorithm()
{
	return m_nSetupAlgorithm;
}

// T|[gʈ
void CPrinterConfig::SetSupportDoubleSided( USHORT nSupportDoubleSided )
{
	m_nSupportDoubleSided = nSupportDoubleSided;
}

USHORT CPrinterConfig::GetSupportDoubleSided()
{
	return m_nSupportDoubleSided;
}

// FADڑԍ (0:ڑ, 1`:FADڑԍ)
void CPrinterConfig::SetFadAttachNo( ULONG nFadAttachNo )
{
	m_nFadAttachNo = nFadAttachNo;
}

ULONG CPrinterConfig::GetFadAttachNo()
{
	return m_nFadAttachNo;
}

// f
void CPrinterConfig::SetSupportInterrupt( USHORT nSupportInterrupt )
{
	m_nSupportInterrupt = nSupportInterrupt;
}

USHORT CPrinterConfig::GetSupportInterrupt()
{
	return m_nSupportInterrupt;
}

// init@Cǂݍ(v^ݒu)(fpsDevGetSetUpInfo()p)
// 2006.09.20 T.Mizushima
void CPrinterConfig::LoadSetupInfo()
{
	CString	strInfoFile;
	strInfoFile = NkcComApi::MakeFullPath("PrnSetupInfo.ini");

	// vZT[ ivZT[ʁj
	m_nProcessorType = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													"ProcessorType",
													12,
													(LPCTSTR)strInfoFile
													);

	// [ ij
	m_nEmulsionNumber = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													 "CpType",
													 54,
													 (LPCTSTR)strInfoFile
													 );

	// \[^[̃gC̐i\[^[EpbJ[ʁj
	m_nSorterStatus = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
												  "SorterType",
												  10,
												  (LPCTSTR)strInfoFile
												  );

	// ғJn
	m_OperationStartDate[0] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														   "OperationStartYear",
														   2006,
														   (LPCTSTR)strInfoFile
														   );
	m_OperationStartDate[1] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														   "OperationStartMonth",
														   9,
														   (LPCTSTR)strInfoFile
														   );
	m_OperationStartDate[2] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														   "OperationStartDay",
														   20,
														   (LPCTSTR)strInfoFile
														   );

	// ݒu
	m_InstallationDate[0] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														 "SetupYear",
														 2006,
														 (LPCTSTR)strInfoFile
														 );
	m_InstallationDate[1] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														 "SetupMonth",
														 9,
														 (LPCTSTR)strInfoFile
														 );
	m_InstallationDate[2] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														 "SetupDay",
														 10,
														 (LPCTSTR)strInfoFile
														 );

	// U\ȃ}KW
	m_nNumberOfMagazine = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													   "MagNumCap",
													   4,
													   (LPCTSTR)strInfoFile
													   );

	// v^̃e (PʁFByte)
	m_nTotalMemory = (ULONG)GetPrivateProfileInt("PrinterSetupInfo",
												 "MemCap",
												 268435456,
												 (LPCTSTR)strInfoFile
												 );

/////////////////////////////////////////////////////////////////////////////////////////

	// t摜̍̕ŏTCY iPʁFPixelj
	m_nImageSizeMinWidth = (ULONG)GetPrivateProfileInt("PrinterSetupInfo",
													   "ImageSizeMinWidth",
													   32,
													   (LPCTSTR)strInfoFile
													   );

	// t摜̍̍ŏTCY iPʁFPixelj
	m_nImageSizeMinHeight = (ULONG)GetPrivateProfileInt("PrinterSetupInfo",
														"ImageSizeMinHeight",
														32,
														(LPCTSTR)strInfoFile
														);

	// t摜̍̕őTCY iPʁFPixelj
	m_nImageSizeMaxWidth = (ULONG)GetPrivateProfileInt("PrinterSetupInfo",
													   "ImageSizeMaxWidth",
													   13000,
													   (LPCTSTR)strInfoFile
													   );

	// t摜̍̍őTCY iPʁFPixelj
	m_nImageSizeMaxHeight = (ULONG)GetPrivateProfileInt("PrinterSetupInfo",
														"ImageSizeMaxHeight",
														13000,
														(LPCTSTR)strInfoFile
														);

	// ő僊s[g
	m_nRepeatCountMax = (ULONG)GetPrivateProfileInt("PrinterSetupInfo",
													"RepeatCountMax",
													9999,
													(LPCTSTR)strInfoFile
													);

	//T|[g摜
	CString	str;
	for(int i = 0; i < COUNTOF(m_SupportImageFormat); i++)
	{
		str.Format("SupportImageFormat%d", i + 1);

		if (( 3 > i ) && ( 1 != i ))
		{
			m_SupportImageFormat[i] = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
																  (LPCTSTR)str,
																  1,
																  (LPCTSTR)strInfoFile
																  );
		}
		else
		{
			m_SupportImageFormat[i] = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
																  (LPCTSTR)str,
																  0,
																  (LPCTSTR)strInfoFile
																  );
		}
	}

	// ~l[^[jbg̑
	m_nLaminatorUnitAttach = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
														 "LaminatorUnitAttach",
														 0,
														 (LPCTSTR)strInfoFile
														 );

	// [U[`̃v^
	m_strPrinterNickname.Empty();
	GetPrivateProfileString("PrinterSetupInfo",
							"PrinterNickname",
							"QSS-Simu",
							m_strPrinterNickname.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);
	m_strPrinterNickname.ReleaseBuffer();
	m_strPrinterNickname.FreeExtra();

	// T|[g]px
	m_nSupportAngle = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
												   "SupportAngle",
												   0,
												   (LPCTSTR)strInfoFile
												   );

	// L
	m_nSupportIntoPrinter = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														 "SupportIntoPrinter",
														 1,
														 (LPCTSTR)strInfoFile
														 );

	// ڃvgΉ
	m_nSupportLongPaper = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													   "SupportLongPaper",
													   1,
													   (LPCTSTR)strInfoFile
													   );

	// CVP󎚍s
	m_nCvpStatus = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
											   "CvpStatus",
											   2,
											   (LPCTSTR)strInfoFile
											   );

	// T|[gy[p[tBbeBO
	m_nSupportPaperFitting = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
											   "SupportPaperFitting",
											   0,
											   (LPCTSTR)strInfoFile
											   );

	// T|[gGbW
	m_nSupportEdgeEnhancement = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
											   "SupportEdgeEnhancement",
											   0,
											   (LPCTSTR)strInfoFile
											   );

	// T|[gCMS
	m_nSupportCMS = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
											   "SupportCMS",
											   0,
											   (LPCTSTR)strInfoFile
											   );

	// T|[g
	m_nSupportWithBorder = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
											   "SupportWithBorder",
											   0,
											   (LPCTSTR)strInfoFile
											   );

	// vt@Cp̋@R[h
	m_nMachinTypeForProfile = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
											   "MachinTypeForProfile",
											   23,
											   (LPCTSTR)strInfoFile
											   );
	// vt@Co[W
	m_strMachinProfileVersion.Empty();
	GetPrivateProfileString("PrinterSetupInfo",
							"MachinProfileVersion",
							"N b006",
							m_strMachinProfileVersion.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);

	// y[p[^CvR[h
	m_PaperTypeCode[0] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														"PaperTypeCode1",
														152,
														(LPCTSTR)strInfoFile
														);
	m_PaperTypeCode[1] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														"PaperTypeCode2",
														133,
														(LPCTSTR)strInfoFile
														);
	m_PaperTypeCode[2] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														"PaperTypeCode3",
														0,
														(LPCTSTR)strInfoFile
														);
	m_PaperTypeCode[3] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														"PaperTypeCode4",
														0,
														(LPCTSTR)strInfoFile
														);
	m_PaperTypeCode[4] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														"PaperTypeCode5",
														0,
														(LPCTSTR)strInfoFile
														);
	m_PaperTypeCode[5] = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
														"PaperTypeCode6",
														0,
														(LPCTSTR)strInfoFile
														);

	// OEMR[h
	m_nOemCode = (UCHAR)GetPrivateProfileInt("PrinterSetupInfo",
														"OemCode",
														0,
														(LPCTSTR)strInfoFile
														);

	// ZbgAbṽASYo[W
	m_nSetupAlgorithm = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													   "SetupAlgorithm",
													   0,
													   (LPCTSTR)strInfoFile
													   );

	// T|[gʈ
	m_nSupportDoubleSided = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													   "SupportDoubleSided",
													   0,
													   (LPCTSTR)strInfoFile
													   );

	// ʈi (0:, 1:蓮)
	m_nMethodDoubleSided = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													   "MethodDoubleSided",
													   0,
													   (LPCTSTR)strInfoFile
													   );

	// FADڑԍ (0:ڑ, 1`:FADڑԍ)
	m_nFadAttachNo = (ULONG)GetPrivateProfileInt("PrinterSetupInfo",
													   "FadAttachNo",
													   0,
													   (LPCTSTR)strInfoFile
													   );

	// f
	m_nSupportInterrupt = (USHORT)GetPrivateProfileInt("PrinterSetupInfo",
													   "SupportInterrupt",
													   0,
													   (LPCTSTR)strInfoFile
													   );
}
