// PrinterConfig.h: CPrinterConfig NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTERCONFIG_H__6752453D_9EA1_4934_8455_9B70635BE89E__INCLUDED_)
#define AFX_PRINTERCONFIG_H__6752453D_9EA1_4934_8455_9B70635BE89E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPrinterConfig  
{
public:
	CPrinterConfig();
	virtual ~CPrinterConfig();

	//////////////////////////////
	// o֐
	//////////////////////////////

	// v^̃e
	void	SetTotalMemory( ULONG nMemory );
	ULONG	GetTotalMemory();

	// t摜̍̕ŏTCY
	void	SetImageSizeMinWidth( ULONG nWidth );
	ULONG	GetImageSizeMinWidth();

	// t摜̍̍ŏTCY
	void	SetImageSizeMinHeight( ULONG nHeight );
	ULONG	GetImageSizeMinHeight();

	// t摜̍̕őTCY
	void	SetImageSizeMaxWidth( ULONG nWidth );
	ULONG	GetImageSizeMaxWidth();

	// t摜̍̍őTCY
	void	SetImageSizeMaxHeight( ULONG nHeight );
	ULONG	GetImageSizeMaxHeight();

	// U\ȃ}KW
	void	SetNumberOfMagazine( USHORT nNumber );
	USHORT	GetNumberOfMagazine();

	// v^̓
	void	GetPrinterTime( USHORT* pTime );

	// ő僊s[g
	void	SetRepeatCountMax( ULONG nCount);
	ULONG	GetRepeatCountMax();

	// T|[g摜
	void	SetSupportImageFormat( UCHAR* pSupport );
	void	GetSupportImageFormat( UCHAR* pSupport );

	// ~l[^[jbg̑
	void	SetLaminatorUnitAttach( UCHAR nAttach );
	UCHAR	GetLaminatorUnitAttach();

	// ݒu
	void	SetInstallationDate( USHORT* pDate );
	void	GetInstallationDate( USHORT* pDate );

	// ғJn
	void	SetOperationStartDate( USHORT* pDate );
	void	GetOperationStartDate( USHORT* pDate );

	// vZT[ ivZT[ʁj
	void	SetProcessorType( USHORT nType );
	USHORT	GetProcessorType();

	// [ ij
	void	SetEmulsionNumber( USHORT nNumber );
	USHORT	GetEmulsionNumber();

	// [U[`̃v^
	void	SetPrinterNickname( LPCTSTR lpString );
	int		GetPrinterNickname( LPTSTR lpString, int nStringSize );

	// T|[g]px
	void	SetSupportAngle( USHORT nAngle );
	USHORT	GetSupportAngle();

	// L
	void	SetSupportIntoPrinter( USHORT nIntoPrinter );
	USHORT	GetSupportIntoPrinter();

	// ڃvgΉ
	void	SetSupportLongPaper( USHORT nSupportLongPaper );
	USHORT	GetSupportLongPaper();

	// \[^[̃gC̐
	void	SetSorterStatus( UCHAR nSorterStatus );
	UCHAR	GetSorterStatus();

	// CVP󎚍s
	void	SetCvpStatus( UCHAR nCvpStatus );
	UCHAR	GetCvpStatus();

	// T|[gy[p[tBbeBO
	void	SetSupportPaperFitting( USHORT nSupportPaperFitting );
	USHORT	GetSupportPaperFitting();

	// T|[gGbW
	void	SetSupportEdgeEnhancement( USHORT nSupportEdgeEnhancement );
	USHORT	GetSupportEdgeEnhancement();

	// T|[gCMS
	void	SetSupportCMS( USHORT nSupportCMS );
	USHORT	GetSupportCMS();

	// T|[g
	void	SetSupportWithBorder( USHORT nSupportWithBorder );
	USHORT	GetSupportWithBorder();

	// vt@Cp̋@R[h
	void	SetMachinTypeForProfile( USHORT	nMachinTypeForProfile );
	USHORT	GetMachinTypeForProfile();

	// vt@Co[W
	void	SetMachinProfileVersion( LPCTSTR lpString );
	int		GetMachinProfileVersion( LPTSTR lpString, int nStringSize );

	// y[p[^CvR[h
	void	SetPaperTypeCode( USHORT* pPaperTypeCode );
	void	GetPaperTypeCode( USHORT* pPaperTypeCode );

	// OEMR[h
	void	SetOemCode( UCHAR nOemCode );
	UCHAR	GetOemCode();

	// ZbgAbṽASYo[W
	void	SetSetupAlgorithm( USHORT nSetupAlgorithm );
	USHORT	GetSetupAlgorithm();

	// T|[gʈ
	void	SetSupportDoubleSided( USHORT nSupportDoubleSided );
	USHORT	GetSupportDoubleSided();

	// FADڑԍ (0:ڑ, 1`:FADڑԍ)
	void	SetFadAttachNo( ULONG nFadAttachNo );
	ULONG	GetFadAttachNo();

	// f
	void	SetSupportInterrupt( USHORT nSupportInterrupt );
	USHORT	GetSupportInterrupt();

	// init@Cǂݍ(v^ݒu)(fpsDevGetSetUpInfo()p)
	void	LoadSetupInfo();

private:

	//////////////////////////////
	// oϐ
	//////////////////////////////

	ULONG	m_nTotalMemory;				// v^̃e (PʁFMByte)
	ULONG	m_nImageSizeMinWidth;		// t摜̍̕ŏTCY iPʁFPixelj
	ULONG	m_nImageSizeMinHeight;		// t摜̍̍ŏTCY iPʁFPixelj
	ULONG	m_nImageSizeMaxWidth;		// t摜̍̕őTCY iPʁFPixelj
	ULONG	m_nImageSizeMaxHeight;		// t摜̍̍őTCY iPʁFPixelj
	USHORT	m_nNumberOfMagazine;		// U\ȃ}KW
	//USHORT	m_PrinterTime[7];			// v^̓
	ULONG	m_nRepeatCountMax;			// ő僊s[g
	UCHAR	m_SupportImageFormat[32];	//T|[g摜
	UCHAR	m_nLaminatorUnitAttach;		// ~l[^[jbg̑
	USHORT	m_InstallationDate[3];		// ݒu
	USHORT	m_OperationStartDate[3];	// ғJn
	USHORT	m_nProcessorType;			// vZT[ ivZT[ʁj
	USHORT	m_nEmulsionNumber;			// [ ij
	CString	m_strPrinterNickname;		// [U[`̃v^
	USHORT	m_nSupportAngle;			// T|[g]px iPʁF0.1pxj
	USHORT	m_nSupportIntoPrinter;		// L
	USHORT	m_nSupportLongPaper;		// ڃvgΉ
	UCHAR	m_nSorterStatus;			// \[^[̃gC̐
	UCHAR	m_nCvpStatus;				// CVP󎚍s
	USHORT	m_nSupportPaperFitting;		// T|[gy[p[tBbeBO
	USHORT	m_nSupportEdgeEnhancement;	// T|[gGbW
	USHORT	m_nSupportCMS;				// T|[gCMS
	USHORT	m_nSupportWithBorder;		// T|[g
	USHORT	m_nMachinTypeForProfile;	// vt@Cp̋@R[h
	CString	m_strMachinProfileVersion;	// vt@Co[W
	USHORT	m_PaperTypeCode[6];			// y[p[^CvR[h
	UCHAR	m_nOemCode;					// OEMR[h ( 0:NKCdl, 1:FFdl )
	USHORT	m_nSetupAlgorithm;			// ZbgAbṽASYo[W
	USHORT	m_nSupportDoubleSided;		// T|[gʈ
	USHORT	m_nMethodDoubleSided;		// ʈi (0:, 1:蓮) gp
	ULONG	m_nFadAttachNo;				// FADڑԍ (0:ڑ, 1`:FADڑԍ)
	USHORT	m_nSupportInterrupt;		// f
};

#endif // !defined(AFX_PRINTERCONFIG_H__6752453D_9EA1_4934_8455_9B70635BE89E__INCLUDED_)
