//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrinterInfo.cpp
//	ABSTRACT  : v^{ǗNX
//	
//	CREATE    : Y.Yoshinobu	2006.7.30
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
// PrinterInfo.cpp: CPrinterInfo NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "PrinterInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CPrinterInfo::CPrinterInfo()
{
#if 0
	// @햼
	m_strMachineTypeName		= _T( "QSS-3501 PLUS" );

	// VAԍ
	m_strSerialNumber			= _T( "25300001" );

	// 𑜓x iPʁF0.1 dpij
	m_nSupportResolutions[0]	= 3000;
	m_nSupportResolutions[1]	= 0;
	m_nSupportResolutions[2]	= 0;
	m_nSupportResolutions[3]	= 0;
	m_nSupportResolutions[4]	= 0;
	m_nSupportResolutions[5]	= 0;
	m_nSupportResolutions[6]	= 0;
	m_nSupportResolutions[7]	= 0;

	// NPS I/F ̃o[W
	m_nNpsVersion				= 0x0100;

	// MacAhX
	::ZeroMemory( m_szMacAddress, sizeof(m_szMacAddress) );

	// @敪i 0F≖I^Cv(Laser), 1FCNWFbg^Cv, 2F≖I^Cv(iBeam) j
	m_nMachineTypeID = 0;

	// \tgEFA		2006.10.18 T.Mizushima
	m_strSoftName				= _T( "QSS-Printer" );

	// vgJnԊu		2007.02.08 Y.Yoshinobu
	m_nStartInterval			= 3;

	// Printing			2007.02.08 Y.Yoshinobu
	m_nPrintInterval			= 3;

	// Advancing		2007.02.08 Y.Yoshinobu
	m_nAdvanceInterval			= 10;

#else
	// init@Cǂݍ
	LoadPrinterInfo();
#endif	// v^{Oinit@C擾Ή	2006.10.20 M.Hasegawa
}

CPrinterInfo::~CPrinterInfo()
{

}

// @햼
void CPrinterInfo::SetMachineTypeName( LPCTSTR lpString )
{
	m_strMachineTypeName = lpString;
}

CString	CPrinterInfo::GetMachineTypeName()
{
	return m_strMachineTypeName;
}

int CPrinterInfo::GetMachineTypeName( LPTSTR lpString, int nStringSize )
{
	int nRetSize = 0;

	if ( m_strMachineTypeName.GetLength() < nStringSize ) {
		lstrcpy( lpString, m_strMachineTypeName.GetBuffer(1) );
		nRetSize = lstrlen( lpString ) + 1;
	} else {
		lstrcpyn( lpString, m_strMachineTypeName.GetBuffer(1), nStringSize - 1 );
		nRetSize = nStringSize - 1;
	}

	return nRetSize;
}

// VAԍ
void CPrinterInfo::SetSerialNumber( LPCTSTR lpString )
{
	m_strSerialNumber = lpString;
}

int CPrinterInfo::GetSerialNumber( LPTSTR lpString, int nStringSize )
{
	int nRetSize = 0;

	if ( m_strSerialNumber.GetLength() < nStringSize ) {
		lstrcpy( lpString, m_strSerialNumber.GetBuffer(1) );
		nRetSize = lstrlen( lpString ) + 1;
	} else {
		lstrcpyn( lpString, m_strSerialNumber.GetBuffer(1), nStringSize - 1 );
		nRetSize = nStringSize - 1;
	}

	return nRetSize;
}

// 𑜓x iPʁF0.1 dpij
void CPrinterInfo::SetSupportResolutions( USHORT* pResolutions )
{
	int nIndex;

	for ( nIndex=0 ; 8 > nIndex ; nIndex++ )
	{
		m_nSupportResolutions[nIndex] = pResolutions[nIndex];
	}
}

void CPrinterInfo::GetSupportResolutions( USHORT* pResolutions )
{
	int nIndex;

	for ( nIndex=0 ; 8 > nIndex ; nIndex++ )
	{
		pResolutions[nIndex] = m_nSupportResolutions[nIndex];
	}
}

// NPS I/F ̃o[W
void CPrinterInfo::SetNpsVersion( USHORT nVersion )
{
	m_nNpsVersion = nVersion;
}

USHORT CPrinterInfo::GetNpsVersion()
{
	return m_nNpsVersion;
}

// MacAhX
void CPrinterInfo::SetMacAddress( UCHAR* pMacAddress )
{
	memcpy( m_szMacAddress, pMacAddress, 6 );
}

void CPrinterInfo::GetMacAddress( UCHAR* pMacAddress )
{
	memcpy( pMacAddress, m_szMacAddress, 6 );
}

// @敪i 0F≖I^Cv, 1FCNWFbg^Cv j
void CPrinterInfo::SetMachineTypeID( USHORT nTypeID )
{
	m_nMachineTypeID = nTypeID;
}

USHORT CPrinterInfo::GetMachineTypeID()
{
	return m_nMachineTypeID;
}

// \tgEFA		2006.10.18 T.Mizushima
void CPrinterInfo::SetSoftName( LPCTSTR lpString )
{
	m_strSoftName = lpString;
}

int CPrinterInfo::GetSoftName( LPTSTR lpString, int nStringSize )
{
	int nRetSize = 0;

	if ( m_strSoftName.GetLength() < nStringSize ) {
		lstrcpy( lpString, m_strSoftName.GetBuffer(1) );
		nRetSize = lstrlen( lpString ) + 1;
	} else {
		lstrcpyn( lpString, m_strSoftName.GetBuffer(1), nStringSize - 1 );
		nRetSize = nStringSize - 1;
	}

	return nRetSize;
}

// vgJnԊu
void CPrinterInfo::SetStartInterval( ULONG nStartInterval )
{
	m_nStartInterval = nStartInterval;
}

ULONG CPrinterInfo::GetStartInterval()
{
	return m_nStartInterval;
}

// Printing
void CPrinterInfo::SetPrintInterval( ULONG nPrintInterval )
{
	m_nPrintInterval = nPrintInterval;
}

ULONG CPrinterInfo::GetPrintInterval()
{
	return m_nPrintInterval;
}

// Advancing
void CPrinterInfo::SetAdvanceInterval( ULONG nAdvanceInterval )
{
	m_nAdvanceInterval = nAdvanceInterval;
}

ULONG CPrinterInfo::GetAdvanceInterval()
{
	return m_nAdvanceInterval;
}

// Xv[t@C̍쐬
void CPrinterInfo::SetCreateSpoolFile( ULONG nCreateSpoolFile )
{
	m_nCreateSpoolFile = nCreateSpoolFile;
}

ULONG CPrinterInfo::GetCreateSpoolFile()
{
	return m_nCreateSpoolFile;
}

void CPrinterInfo::LoadPrinterInfo()
{
	CString	strInfoFile;
	strInfoFile = NkcComApi::MakeFullPath("PrnSetupInfo.ini");

	// @햼
	GetPrivateProfileString("PrinterInfo",
							"MachineTypeName",
							"QSS-3501 PLUS",
							m_strMachineTypeName.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);
	m_strMachineTypeName.ReleaseBuffer();
	m_strMachineTypeName.FreeExtra();

	// VAԍ
	GetPrivateProfileString("PrinterInfo",
							"SerialNumber",
							"25300001",
							m_strSerialNumber.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);
	m_strSerialNumber.ReleaseBuffer();
	m_strSerialNumber.FreeExtra();

	// 𑜓x iPʁF0.1 dpij
	m_nSupportResolutions[0]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution0",
				3000,
				(LPCTSTR)strInfoFile);
	m_nSupportResolutions[1]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution1",
				0,
				(LPCTSTR)strInfoFile);
	m_nSupportResolutions[2]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution2",
				0,
				(LPCTSTR)strInfoFile);
	m_nSupportResolutions[3]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution3",
				0,
				(LPCTSTR)strInfoFile);
	m_nSupportResolutions[4]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution4",
				0,
				(LPCTSTR)strInfoFile);
	m_nSupportResolutions[5]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution5",
				0,
				(LPCTSTR)strInfoFile);
	m_nSupportResolutions[6]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution6",
				0,
				(LPCTSTR)strInfoFile);
	m_nSupportResolutions[7]	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"SupportResolution7",
				0,
				(LPCTSTR)strInfoFile);

	// NPS I/F ̃o[W
	m_nNpsVersion				= 0x0100;

	// MacAhX
	::ZeroMemory( m_szMacAddress, sizeof(m_szMacAddress) );

	// @敪i 0F≖I^Cv(Laser), 1FCNWFbg^Cv, 2F≖I^Cv(iBeam) j
	m_nMachineTypeID	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"MachineTypeID",
				0,
				(LPCTSTR)strInfoFile);

	// \tgEFA		2006.10.18 T.Mizushima
	GetPrivateProfileString("PrinterInfo",
							"SoftName",
							"QSS-Printer",
							m_strSoftName.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);

	// vgJnԊu		2007.02.08 Y.Yoshinobu
	m_nStartInterval	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"StartInterval",
				3,
				(LPCTSTR)strInfoFile);

	// Printing			2007.02.08 Y.Yoshinobu
	m_nPrintInterval	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"PrintInterval",
				3,
				(LPCTSTR)strInfoFile);

	// Advancing		2007.02.08 Y.Yoshinobu
	m_nAdvanceInterval	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"AdvanceInterval",
				10,
				(LPCTSTR)strInfoFile);

	// Xv[t@C̍쐬
	m_nCreateSpoolFile	=
		(USHORT)GetPrivateProfileInt("PrinterInfo",
				"CreateSpoolFile",
				0,
				(LPCTSTR)strInfoFile);
}
