//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrinterInfo.h
//	ABSTRACT  : v^{ǗNX
//	
//	CREATE    : Y.Yoshinobu	2006.7.30
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
// PrinterInfo.h: CPrinterInfo NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTERINFO_H__9E7CFF9E_4FF0_4A30_9076_B2FCEBCAC7FF__INCLUDED_)
#define AFX_PRINTERINFO_H__9E7CFF9E_4FF0_4A30_9076_B2FCEBCAC7FF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPrinterInfo  
{
public:
	CPrinterInfo();
	virtual ~CPrinterInfo();

	//////////////////////////////
	// o֐
	//////////////////////////////

	// @햼
	void	SetMachineTypeName( LPCTSTR lpString );
	CString	GetMachineTypeName();
	int		GetMachineTypeName( LPTSTR lpString, int nStringSize );

	// VAԍ
	void	SetSerialNumber( LPCTSTR lpString );
	int		GetSerialNumber( LPTSTR lpString, int nStringSize );

	// 𑜓x iPʁF0.1 dpij
	void	SetSupportResolutions( USHORT* pResolutions );
	void	GetSupportResolutions( USHORT* pResolutions );

	// NPS I/F ̃o[W
	void	SetNpsVersion( USHORT nVersion );
	USHORT	GetNpsVersion();

	// MacAhX
	void	SetMacAddress( UCHAR* pMacAddress );
	void	GetMacAddress( UCHAR* pMacAddress );

	// @敪i 0F≖I^Cv, 1FCNWFbg^Cv j
	void	SetMachineTypeID( USHORT nTypeID );
	USHORT	GetMachineTypeID();

	// \tgEFA		2006.10.18 T.Mizushima
	void	SetSoftName( LPCTSTR lpString );
	int		GetSoftName( LPTSTR lpString, int nStringSize );

	// vgJnԊu
	void	SetStartInterval( ULONG nStartInterval );
	ULONG	GetStartInterval();

	// Printing
	void	SetPrintInterval( ULONG nPrintInterval );
	ULONG	GetPrintInterval();

	// Advancing
	void	SetAdvanceInterval( ULONG nAdvanceInterval );
	ULONG	GetAdvanceInterval();

	// Xv[t@C̍쐬
	void	SetCreateSpoolFile( ULONG nCreateSpoolFile );
	ULONG	GetCreateSpoolFile();

	// init@Cǂݍ(v^{p)
	void	LoadPrinterInfo();

public:

	//////////////////////////////
	// oϐ
	//////////////////////////////

	CString	m_strMachineTypeName;			// @햼
	CString	m_strSerialNumber;				// VAԍ
	USHORT	m_nSupportResolutions[8];		// 𑜓x iPʁF0.1 dpij
	USHORT	m_nNpsVersion;					// NPS I/F ̃o[W
	UCHAR	m_szMacAddress[6];				// MacAhX
	USHORT	m_nMachineTypeID;				// @敪i 0F≖I^Cv, 1FCNWFbg^Cv j
	CString	m_strSoftName;					// \tgEFA		2006.10.18 T.Mizushima

	// vgԂ̒l
	ULONG	m_nStartInterval;				// vgJnԊu
	ULONG	m_nPrintInterval;				// Printing
	ULONG	m_nAdvanceInterval;				// Advancing

	// Xv[֌W
	ULONG	m_nCreateSpoolFile;				// Xv[t@C̍쐬 ( 0:쐬, 1:쐬Ȃ )
};

#endif // !defined(AFX_PRINTERINFO_H__9E7CFF9E_4FF0_4A30_9076_B2FCEBCAC7FF__INCLUDED_)
