// VirtualPrinter.h: CVirtualPrinter NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIRTUALPRINTER_H__827C959E_890A_4F12_9926_E5412D0DD4AD__INCLUDED_)
#define AFX_VIRTUALPRINTER_H__827C959E_890A_4F12_9926_E5412D0DD4AD__INCLUDED_

#include "PrinterInfo.h"	// ClassView ɂĒǉ܂B
#include "PrinterConfig.h"	// ClassView ɂĒǉ܂B
#include "PrinterState.h"	// ClassView ɂĒǉ܂B
#include "PaperInfo.h"		// ClassView ɂĒǉ܂B
#include "PrintQue.h"		// ClassView ɂĒǉ܂B
#include "ErrorInfo.h"		// ClassView ɂĒǉ܂B

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define	WAIT_RELEASE_TIME	5	// ʏor}(Level1)̍ĊJ҂鎞 (P:b)

// 2006.09.21 T.Mizushima
enum
{
	STATE_PRN_STATE = 0,	// v^Ŝ̏
	STATE_PRN_ACCEPT,		// t
	STATE_PRN_ADVANCE,		// v^Ŝ̏ԁinŚj
	STATE_PRN_LASER,		// w[U[̏
	STATE_PRN_DEV,			// vZT[Ŝ̏ԁinŚj
	STATE_PRN_PROC,			// ̏
	STATE_PRN_REPL,			// [Ŝ̏
	STATE_PRN_CART,			// [J[gbW̌̉
};

class CVirtualPrinter  
{
public:

	enum POSSESSION
	{	// L
		NONE = 0,			// L
		NORMAL,				// ʏL
		NORMAL_WAIT,		// LiʏĊJ҂j
		EXPRESS1,			// }[x1]L
		EXPRESS1_WAIT,		// Li}[x1]ĊJ҂j
		EXPRESS2,			// }[x2]L
	};

	CVirtualPrinter();
	virtual ~CVirtualPrinter();

	void SetNpsServerDlg(CWnd* pWnd);
	CWnd* GetNpsServerDlg();

	DWORD GetIncrementEventId();
	DWORD GetIncrementReciveNo();

	// --------------------
	// L֌W
	// --------------------
	BOOL SetPossessionState( WORD wPossessionMode, WORD wInterruptMode, WORD wPort, LPWORD pPossessionNo, LPVOID pPossessionSock, UCHAR IsMaintenance);
	void ResetPossession();
	LPVOID GetPossessionSock();
	WORD GetPossessionNo();
	BOOL IsWarikomiPossessionNo( WORD wPossessionNo );
	void DeleteWarikomiPossessionNo( WORD wPossessionNo );	// @@@RD-151Ή	2012.02.15	T.Mizushima
	// 摜M|[g
	WORD GetPort();
	// LiĊJ҂j=> L
	void RestartWaitCheck();
	UCHAR GetIsMaintenance()	{	return m_IsMaintenance;	}

	// --------------------
	// Xv[֌W
	// --------------------
	inline CString GetSpoolFolder() { return m_strSpoolFolder; };

	// v^ԂύX
	// 2006.09.21 T.Mizushima
	void SetPrinterStateExt(UINT ChgSts, UCHAR value, BOOL post);
	// 󂯕tsȃG[ǂ`FbN
	// 2006.09.22 T.Mizushima
	BOOL ChkNotAcceptError();

	// 2006.09.25 T.Mizushima
	POSSESSION	GetPossessionState()	{	return m_ePossessionState;	}

	// ݒ肳ꂽ擾
	CString		GetDateTimeStr()		{	return m_strDateTime;		}
	// ݒ肳ꂽ̕\˗
	void		RequestDspDateTime(CString strDateTime);

public:
	CPrinterInfo m_cPrinterInfo;	// v^{ǗNX
	CPrinterConfig m_cPrinterConfig;// v^ݒǗNX
	CPrinterState m_cPrinterState;	// v^ԏǗNX
	CPaperInfo m_cPaperInfo;		// y[p[ǗNX
	CPrintQue m_cPrintQue;			// vgL[ǗNX
	CErrorInfo m_cErrorInfo;		// G[ǗNX

	
private:

	CWnd* m_pNpsServerDlg;			// O[oɃANZX邽߂ɁAŃZbgB

	DWORD m_dwEventId;				// Cxgʎq̊Ǘ
	DWORD m_dwReciveNo;				// vgvtԍ̊Ǘ


	// --------------------
	// L֌W
	// --------------------
	WORD		m_wPossessionNo;	// Lԍ(̔ԗp)
	WORD		m_wPossessionNoActive;// Lԍ(L̐Lԍ)
	POSSESSION	m_ePossessionState;	// L
	LPVOID		m_pPossessionSock;	// L̃\Pbg
	UCHAR		m_IsMaintenance;	// eiX

	CWordArray	m_awPossessionNo;	// 荞݂ɂ蒆fꂽLԍ~ς

	// 摜M֌W
	WORD		m_wPort;			// 摜M|[g
	// LiĊJ҂j=> L
	time_t		m_nReleaseTime;		// LiĊJ҂j̊J

	CRITICAL_SECTION	m_csPossessionLock;

	
	

	// --------------------
	// Xv[֌W
	// --------------------
	CString		m_strSpoolFolder;	// Xv[tH_


	// ݒ肳ꂽԕ\
	CString		m_strDateTime;		// ݒ肳ꂽ

};

#endif // !defined(AFX_VIRTUALPRINTER_H__827C959E_890A_4F12_9926_E5412D0DD4AD__INCLUDED_)
