// WS2TcpListenImg.cpp: CWS2TcpListenImg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "WS2TcpListenImg.h"
#include "ServerTcpImg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenImg::CWS2TcpListenImg
//   ABSTRACT : RXgN^
//   FUNCTION : T[o[\PbgNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CWS2TcpListenImg::CWS2TcpListenImg( pfnSockCreate pfnSockCreateFunc )
{
	TRACE( "[%08X] CWS2TcpListenImg::CWS2TcpListenImg()\n", GetCurrentThreadId() );

	m_pfnSockCreate = pfnSockCreateFunc;		// \Pbg쐬֐|C^[
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenImg::~CWS2TcpListenImg
//   ABSTRACT : fXgN^
//   FUNCTION : T[o[\PbgNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CWS2TcpListenImg::~CWS2TcpListenImg()
{
	TRACE( "[%08X] CWS2TcpListenImg::~CWS2TcpListenImg()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenImg::Create
//   ABSTRACT : T[o[\Pbg쐬܂
//   FUNCTION : T[o[\Pbg쐬܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2TcpListenImg::Create( UINT nSocketPort , LPCTSTR lpszSocketAddress )
{
	TRACE( "[%08X] CWS2TcpListenImg::Create()\n", GetCurrentThreadId() );

	// \Pbg̍쐬
	if( !CWS2Tcp::Create() )
		return FALSE;
	// \PbgɖOt܂
	if( !Bind( nSocketPort , lpszSocketAddress ) )
		return FALSE;
	if( !Listen( LISTEN_IMG_NUM ) )
		return FALSE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenImg::OnAccept
//   ABSTRACT : ڑvM
//   FUNCTION : ڑvM
//////////////////////////////////////////////////////////////////////////////
void CWS2TcpListenImg::OnAccept( int nErrorCode )
{
	TRACE( "[%08X] CWS2TcpListenImg::OnAccept()\n", GetCurrentThreadId() );

	// \Pbg̍쐬
	CWS2Tcp*	pSock = OnAcceptSockCreate();
	if( pSock == NULL )
		return;			// \PbgNXԂĂ炦Ȃ
	
	// \Pbǧ
	SOCKADDR_IN sa;
	int nAddrLen = sizeof(sa);
	if( !Accept( *pSock, (LPSOCKADDR)&sa, &nAddrLen ) )
		delete pSock;		// \Pbǧs

	TRACE( "[%08X] CWS2TcpListenImg::OnAccept() PORT = %d\n", GetCurrentThreadId(), NkcComApi::ntohs( sa.sin_port ) );

	{	// Oo
		CString str;
		str.Format( "Connect [IMG] PORT = %d", NkcComApi::ntohs( sa.sin_port ) );
		NPS_LOGOUT( str );
	}

	// Ǘ̈ɊǗNXǉ
	::GetServerTcpImg()->AddServerSock( pSock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpListenImg::OnAcceptSockCreate
//   ABSTRACT : ڑvM
//   FUNCTION : ڑvM
//////////////////////////////////////////////////////////////////////////////
CWS2Tcp* CWS2TcpListenImg::OnAcceptSockCreate()
{
	TRACE( "[%08X] CWS2TcpListenImg::OnAcceptSockCreate()\n", GetCurrentThreadId() );

	if( m_pfnSockCreate )
		return (*m_pfnSockCreate)();
	ASSERT(0);		// {̃NXł͐łȂ̂ ASSERT() s
	CWS2Tcp*	pSock = new CWS2Tcp;	// Ƃ肠삷悤Ƀ\Pbg쐬
	pSock->SetAutoDelete( TRUE );		// Close 폜
	return pSock;
}
