// PrintQue.h: CPrintQue NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTQUE_H__BA34D611_8162_4D5B_9336_A2CF9D412A64__INCLUDED_)
#define AFX_PRINTQUE_H__BA34D611_8162_4D5B_9336_A2CF9D412A64__INCLUDED_

#include <vector>
#include "Order.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPrintQue  
{
public:
	CPrintQue();
	virtual ~CPrintQue();

	// L[
	void Empty();															// vgL[ɂ
	BOOL OrderStart( DWORD* pdwOrderId, T_ORDER_PARAM* ptOrderParam );		// I[_[̓o^Jn
	BOOL OrderEnd( const DWORD dwOrderId );									// I[_[̓o^I
	BOOL DuplexStart( const DWORD dwOrderId );								// ʂJn
	BOOL DuplexEnd( const DWORD dwOrderId );								// ʂI
	BOOL AddFrame( const DWORD dwOrderId, LPDWORD pPrintID, T_FRAME_PARAM* ptFrameParam );	// R}ǉ
	BOOL AddSort( const DWORD dwOrderId );									// \[gǉ
	BOOL DelOrder( const DWORD dwOrderId );									// I[_[폜
	BOOL DelFrame( const DWORD dwOrderId, DWORD dwPrintID );				// R}폜
	void UpdateOrderStatus( NPSORDERINFO* ptOrderInfo );					// I[_[ԂXV
	void UpdateFrameStatus( NPSPRINTINFO* ptPrintInfo );					// R}ԂXV
	BOOL IsCanCancel( CTreeCtrl* pobjTreeCtrl );							// IĂI[_[̓R}LZł邩mF
	void Cancel( CTreeCtrl* pobjTreeCtrl );									// I[_[̓R}LZ

	// ʕ\
	void DrawInitial( CTreeCtrl* pobjTreeCtrl );
	void DrawUpdate( CTreeCtrl* pobjTreeCtrl );

private:

	CRITICAL_SECTION		m_csMemberData;

	std::vector<COrder*>	m_vOrder;
};

void CreatePrintQue();
void DropPrintQue();
CPrintQue* GetPrintQue();

#endif // !defined(AFX_PRINTQUE_H__BA34D611_8162_4D5B_9336_A2CF9D412A64__INCLUDED_)
