// StatusInfo.h: CStatusInfo NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATUSINFO_H__12B99A4A_2197_42C4_B6B9_8834B3D11879__INCLUDED_)
#define AFX_STATUSINFO_H__12B99A4A_2197_42C4_B6B9_8834B3D11879__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
class CTreeInfo
{
	public:	CTreeInfo( HTREEITEM hItem, ENUM_VARIABLE_TYPE eType )
				{ m_hItem=hItem; m_eType=eType; };
	public:	virtual ~CTreeInfo()
				{};

	public:	HTREEITEM m_hItem;
	public:	ENUM_VARIABLE_TYPE m_eType;
};

//////////////////////////////////////////////////////////////////////
class CStatusInfo  
{
public:
	CStatusInfo();
	virtual ~CStatusInfo();

	void DataUpdate( CTreeCtrl* pobjTreeCtrl );

	// ʕ\
	void DrawInitial( CTreeCtrl* pobjTreeCtrl );
	void DrawUpdate( CTreeCtrl* pobjTreeCtrl );

private:

	CRITICAL_SECTION		m_csMemberData;

	std::vector<CTreeInfo>	m_vTreeInfo;

	HTREEITEM				m_hItem_npsDevGetUnitInfo;
	HTREEITEM				m_hItem_npsDevGetSetUpInfo;
	HTREEITEM				m_hItem_npsDevGetMagInfo;
	HTREEITEM				m_hItem_npsDevGetTime;
	HTREEITEM				m_hItem_npsDevGetPrintNumInfo;
};

void CreateStatusInfo();
void DropStatusInfo();
CStatusInfo* GetStatusInfo();

#endif // !defined(AFX_STATUSINFO_H__12B99A4A_2197_42C4_B6B9_8834B3D11879__INCLUDED_)
