// version 2.0.0.2
// nkcLogCommon.h : NKCLOGCOMMON AvP[ṼC wb_[ t@CłB
//

#if !defined(AFX_NKCLOGCOMMON_H__B7A7727D_08C3_4E40_B95B_69A2DA492BBE__INCLUDED_)
#define AFX_NKCLOGCOMMON_H__B7A7727D_08C3_4E40_B95B_69A2DA492BBE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// C V{

/////////////////////////////////////////////////////////////////////////////
// CNkcLogCommonApp
// ̃NX̓̒`ɊւĂ nkcLogCommon.cpp t@CQƂĂB
//

class CNkcLogCommonApp : public CWinApp
{
public:
	CNkcLogCommonApp();

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CNkcLogCommonApp)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CNkcLogCommonApp)
		//  -  ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
		//         ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

// import/export
#ifdef	CNKCLOGCOMMON_EXPORTS
#define CNKCLOGCOMMON_API __declspec(dllexport)
#else
#define CNKCLOGCOMMON_API __declspec(dllimport)

#if	_MSC_VER >= 1400				//VS2005
#pragma comment(lib,"nkcLogCommon80.lib")
#else								//VS2005ȊO
#pragma comment(lib,"nkcLogCommon.lib")
#endif

#endif

//ADD
#include <afxmt.h>
#include <afxtempl.h>
#include <shlwapi.h>
#pragma comment(lib, "Shlwapi.lib")

#define LOG_MAXLINE_LOW		100
#define LOG_MAXLINE_HIGH	3000
#define LOG_MAXLINE_DEFAUT	1000

#define LOG_FATAL			0
#define LOG_WARN			1
#define LOG_INFO			2
#define LOG_DEBUG			3

#define LOGLEVEL_OUT		0
#define LOGLEVEL_NOT_OUT	1	

#define MAX_INI_PARAM		1024		
#define LOG_BLOCK_SIZE		344

#define ERR					_T("err")

#define MEM_NAME_STARTUP			_T("StartUpLogInfo")
#define MEM_SIZE_STARTUP			( 1 + (260 * 50))
#define MAX_STARTUP_MEM_LINE		50
#define STARTUP_LOG_BLOCK_SIZE		260
#define STARTUP_MUTEX_NAME			_T("nkcCommonlog_StartUpLogInfo_mutex")

//Ver.2 DEFINE
#define LOG2_NAME_LOGCOUNT			_T("NkcLogCount")
#define LOG2_NAME_LOGCOUNT_MUT		_T("Mutex_NkcLogCount")
#define LOG2_NAME_LOGFILE			_T("NkcLogFile_")
#define LOG2_NAME_LOGFILE_MUT		_T("Mutex_NkcLogFile_")

#define LOG2_SIZE_LOGCOUNT			4
#define LOG2_SIZE_LOGLENGTH			4
#define LOG2_SIZE_WRITEPOINT		4
#define LOG2_SIZE_INIFPATH			260
#define LOG2_SIZE_FILEPATH			260
#define LOG2_SIZE_LOGFILE_MIN		256000
#define LOG2_SIZE_LOGFILE_MAX		512000

#define LOG2_POINT_LOGLENGTH		0
#define LOG2_POINT_WRITEPOINT		4
#define LOG2_POINT_INIFPATH			4+4
#define LOG2_POINT_FILEPATH			4+4+260
#define LOG2_POINT_LOGMEMORY		4+4+260+260

#define LOG2_LOGCOUNT_MAX			9999


// }N
#define LOG_MEMORY_OUT( clog, level, mes )(clog.LogToMemory(level, __FILE__, __LINE__, mes) )		// o


class CNKCLOGCOMMON_API CNkcLogCommon  
{
public:
	CNkcLogCommon();
	virtual ~CNkcLogCommon();

	CNkcLogCommon( LPCSTR configFile, LPCSTR localPath = NULL );

	void LogToFile( int level, LPCSTR filename, int linenumber, LPCSTR mes );
	void LogToMemory( int level, LPCSTR filename, int linenumber, LPCSTR mes );
	void FileOut( void );
	void FileOut( LPCSTR dirPath );//o͐w
	void EndLog();

private:
	HANDLE m_hFile;
	HANDLE m_hMapping;
	void *m_pMappingView;
	UINT shareMemorySize;

	CString m_strMapName;
	CString m_strMutexName;	
	CMutex *m_pMutex;
	CMutex *m_pStatrUpMutex;
	char inifilename[MAX_PATH];//init@Cۑp

	CMap <int, int, CString, CString> m_LevelMap;

	// t@C
	void WriteLogFile( LPCSTR mes );
	int  ReadLogFile();
	CString makeFileOutLogStr( int linePos );
	CString GetLevel( int level );
	CString GetFileName( LPCSTR filename );

	int m_WritePos;

	/*----------NoritsuHelperΉ----------*/
	HANDLE m_hStartUpMapping;
	void *m_pStartUpMappingView;

	void CreateStartUpLogInfo( LPCSTR configFile );
	/*-------------------------------------*/

	void GetFullFilePath( char* filename, LPCSTR  localpath = NULL );

private:
	struct TLogIniInfo
	{
		LPCSTR	logger;
		INT		maxline;
		LPCSTR	filename;
		BOOL	levelfatal;
		BOOL	levelwarn;
		BOOL	levelinfo;
		BOOL	leveldebug;
	} iniInfo;

};

class CNKCLOGCOMMON_API CNkcLogCommon2
{
public:
	CNkcLogCommon2( LPCSTR configFile, LPCSTR localPath = NULL );
	virtual ~CNkcLogCommon2();

	void LogToMemory( int level, LPCSTR filename, int linenumber, LPCSTR mes );
	void FileOut( void );
	void FileOut( LPCSTR dirPath );//o͐w
	void EndLog();

private:
	//INIt@C
	char m_strIniFileName[LOG2_SIZE_INIFPATH];	//init@Cۑp

	//OS`FbN  0:2k,XP  1:Vista
	BOOL m_bOsType;

	// OǗ
	CMutex *m_pLogCountMutex;
	HANDLE  m_hLogCountMapping;
	void   *m_pLogCountMappingView;

	//OL^
	CMutex *m_pLogFileMutex;
	HANDLE  m_hLogFileMapping;
	void   *m_pLogFileMappingView;
	//OL^̈
	DWORD m_dRecodeMemorySize;//TCY
	//t̃tO
	BOOL m_bMemSizeFlow;
	//̔ԍ
	DWORD m_dLogCount;

	// t@C
	bool GetLogMemoryHandle( DWORD dLogCount ,char* pstrConfigFileName, DWORD *dEmptyMemoryNum );
	void WriteLogFile( HANDLE hFile );
	int  ReadLogFile();

	// ̑
	bool GetInifileState( char* pIniFilePath, char* pLocalPath );		//INIt@C̏擾
	void GetLevel( int level,char *pstrLevel );							//x擾
	void CreateLogFileName( char c = NULL );							//Ot@Cւ̓t^
	void GetFullFilePath( char* filename, LPCSTR  localpath = NULL );	//tpX쐬

	// INIt@C\
	struct TLogIniInfo2
	{
		CHAR	logger[40];
		INT		maxline;
		CHAR	filename[LOG2_SIZE_INIFPATH];
		BOOL	levelfatal;
		BOOL	levelwarn;
		BOOL	levelinfo;
		BOOL	leveldebug;
		INT		memorysize;
	} iniInfo2;

};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_NKCLOGCOMMON_H__B7A7727D_08C3_4E40_B95B_69A2DA492BBE__INCLUDED_)
