#ifndef __CorrectWrapDllCom_h__
#define __CorrectWrapDllCom_h__

#pragma once

#ifdef CORRECT_WRAPDLL_EXPORTS
#define CORRECT_WRAPDLL_API __declspec(dllexport)
#else
#define CORRECT_WRAPDLL_API __declspec(dllimport)
#endif

#ifndef CORRECT_WRAPDLL_EXPORTS
	#pragma comment(lib, "ImgCorrectWrapDllComIF.lib")
#endif

//**********************************************************************************************
//e`
//**********************************************************************************************
enum GPRO_IMGPROC_ERRCODE{//G[R[h
	GPRO_IMGPROC_NOERR,			//I
	GPRO_IMGPROC_MODULEERR,		//OW[G[
	GPRO_IMGPROC_FILEACCESSERR,	//t@CANZXZ[
	GPRO_IMGPROC_MMFACCESSERR,	//MMFANZXZ[
	GPRO_IMGPROC_MALLOCERR,		//ԉ摜pmۃG[
	GPRO_IMGPROC_EXCEPTION,		//O
	GPRO_IMGPROC_ERR,			//̑̃G[
};

enum WRAPDLL_CASH_TYPE{//LbVL/w
	WRAPDLL_CASH_DISABLE,//LbV펞
	WRAPDLL_CASH_ENABLE,//LbV펞L
	WRAPDLL_CASH_AUTO//̎gp󋵂Ďf
};

//**********************************************************************************************
//e\̒`
//**********************************************************************************************
typedef struct {	//摜p[^
	DWORD	dwInOffset;		// ͉摜f[^̊i[ĂItZbg
	SIZE	sizeInImage;	// ͉摜̃TCY iP:Pixelj
	SIZE	sizeZoomImage;	// gk摜̃TCY iP:Pixelj
	SIZE	sizeOutImage;	// o͉摜̃TCY iP:Pixelj
	BOOL	bWBEnable;		// ] i FALSE:Ȃ, TRUE: j
	DWORD	BlankLeft;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
	DWORD	BlankTop;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
	DWORD	BlankRight;		// E]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
	DWORD	BlankBottom;	// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
	DWORD	dwAngle;		// ] ( 0:]Ȃ, 1:90x], 2:180x], 3:270x] )
	LPVOID	pCmsProFile;	// CMS̃vt@Cf[^ ( NULL̏ꍇCMSsȂ )
	SHORT	Edge_r;			// NxNtB^[x
	BYTE	EdgeMaskSize;	// NxNtB^[TCY
} T_CorrectWrapDll_ImgProcParam;

typedef struct {	//摜p[^
	int				ImgType;	//o͉摜`(0:t@C)
	char			*pSrcImg;	//͉摜t@C
	char			*pDstImg;	//o͉摜t@C
								//	o͉摜̓wb_tBMP`̂
								//@t@Ĉ́Agq(.BMP)ttpX(ő260)
	int				DstCh;		//o͉摜`l(3:3ch@4:4ch)
} T_CorrectWrapDll_ImgInf;

typedef struct {	//摜ڍ׃p[^
	SIZE			DstSize;	// o͉摜TCY(P:Pixel)
	BOOL			BlkSW;		// ](FALSE:Ȃ@TRUE:)
	unsigned long	BlkLeft;	// ]TCY(P:Pixel)@ BlkSW=TRUȄꍇɎgp
	unsigned long	BlkTop;		// ]TCY(@@V@@)@@@@@@@V
	unsigned long	BlkRight;	// E]TCY(@@V@@)@@@@@@@V
	unsigned long	BlkBottom;	// ]TCY(@@V@@)@@@@@@@V
	unsigned long	Angle;		// ](0`360)
} T_CorrectWrapDll_ImgDtl;

typedef struct {	//CMSp[^
	unsigned short	*pCMS;		//CMS|C^(NULL̏ꍇACMS{)
								//	CMŚAL`̏ݒ肷
								//	@wb_:4Byte
								//	@f[^:3F~729_(9~9~93)~2Byte
								//	@@v:4Byte{4374Byte=4378Byte
} T_CorrectWrapDll_CmsInf;

typedef struct {	//NxNFilterp[^
	long			EgInt;		//NxNtB^[x(-2048`2047)
	int				MskSiz;		//NxNtB^[TCY(3/5/7)
} T_CorrectWrapDll_NxNInf;

//**********************************************************************************************
//evg^Cv錾
//**********************************************************************************************
/**
 *
 * GPro摜Jn
 *
 * @return 
 * @retval NULL s
 * @retval nh 
 *
 * @author Y.Wada
 * @date 2006/12/16
 * @note VK쐬
 * @attention ɂȂ
 *
 */
extern "C" CORRECT_WRAPDLL_API
LPVOID WINAPI	NkcICorr_GProImgProc_Start();

/**
 *
 * GPro摜I
 *
 * @author Y.Wada
 * @date 2006/12/16
 * @note VK쐬
 * @attention ɂȂ
 *
 */
extern "C" CORRECT_WRAPDLL_API
VOID WINAPI	NkcICorr_GProImgProc_End(LPVOID handle);

/**
 *
 * GPro摜
 *
 * @return GPRO_IMGPROC_ERRCODE
 * @retval GPRO_IMGPROC_ERRCODE enum`Q
 *
 * @param[in] handle	nh
 * @param[in] priority	CMS摜Dx	(-2 to 2)
 *								-2=lowest
 *								-1=below normal
 *								 0=normal
 *								 1=above normal
 *								 2=highest
 * @param[in]   dwSourceType	o͉摜`(0:MMFIuWFNg 1:t@C)
 * @param[in]   lpInName		͉摜IuWFNg/t@C
 * @param[out]  lpOutName		o͉摜IuWFNg/t@C
 * @param[in]   lpTempFolder	e|tH_
 * @param[in]   *pParam			摜p[^(T_CorrectWrapDll_ImgProcParam`Q)
 * @param[out]  *ErrCode		ڍ׃G[R[h
 * @param[in] CacheType	LbVL/w
 *
 * @author K.Kishi
 * @date 2006/12/16
 * @note VK쐬
 * @attention 
 *	NkcICorr_GProImgProc:RAWC^[tFCXALbVw薳
 *	NkcICorr_GProImgProcEx:RAWC^[tFCXALbVw肠
 *	NkcICorr_GProImgBmpProc:BMPC^[tFCXALbVw薳
 *	NkcICorr_GProImgBmpProcEx:BMPC^[tFCXALbVw肠
 *	
 */
extern "C" CORRECT_WRAPDLL_API
long WINAPI NkcICorr_GProImgProc(
	VOID			*handle,
	short			priority,
	DWORD			dwSourceType,				//o͉摜`(0:L 1:t@C)
	LPCSTR			lpInName,					//͉摜L or t@C
	LPCSTR			lpOutName,					//o͉摜@@@V@@@ or @@@V
	LPCSTR			lpTempFolder,				//ꎞƗptH_
	T_CorrectWrapDll_ImgProcParam	*pParam,	//摜p[^
	long			*ErrCode					//ڍ׃G[e
);
extern "C" CORRECT_WRAPDLL_API
long WINAPI NkcICorr_GProImgProcEx(
	VOID					*handle,
	short					priority,
	DWORD					dwSourceType,		//o͉摜`(0:L 1:t@C)
	LPCSTR					lpInName,			//͉摜L or t@C
	LPCSTR					lpOutName,			//o͉摜@@@V@@@ or @@@V
	LPCSTR					lpTempFolder,		//ꎞƗptH_
	T_CorrectWrapDll_ImgProcParam	*pParam,	//摜p[^
	long					*ErrCode,			//ڍ׃G[e
	WRAPDLL_CASH_TYPE		CacheType			//LbVL/w
);
extern "C" CORRECT_WRAPDLL_API
long WINAPI NkcICorr_GProImgBmpProc(
	VOID			*handle,
	short			priority,
	LPCSTR			lpInName,					//͉摜t@C
	LPCSTR			lpOutName,					//o͉摜 @@@V
	LPCSTR			lpTempFolder,				//ꎞƗptH_
	T_CorrectWrapDll_ImgProcParam	*pParam,	//摜p[^
	long			*ErrCode					//ڍ׃G[e
);
extern "C" CORRECT_WRAPDLL_API
long WINAPI NkcICorr_GProImgBmpProcEx(
	VOID					*handle,
	short					priority,
	LPCSTR					lpInName,			//͉摜t@C
	LPCSTR					lpOutName,			//o͉摜 @@@V
	LPCSTR					lpTempFolder,		//ꎞƗptH_
	T_CorrectWrapDll_ImgProcParam	*pParam,	//摜p[^
	long					*ErrCode,			//ڍ׃G[e
	WRAPDLL_CASH_TYPE		CacheType			//LbVL/w
);
/**
 *
 * CMS摜Jn
 *
 * @return nh
 * @retval 0 s
 * @retval Not 0 
 *
 * @author Y.Wada
 * @date 2006/12/16
 * @note VK쐬
 * @attention ɂȂ
 *
 */
extern "C" CORRECT_WRAPDLL_API
LPVOID WINAPI	NkcICorr_CMS_Start();

/**
 *
 * CMS摜I
 *
 * @return 
 * @retval 0 s
 * @retval Not 0 
 *
 * @author Y.Wada
 * @date 2006/12/16
 * @note VK쐬
 * @attention ɂȂ
 *
 */
extern "C" CORRECT_WRAPDLL_API
VOID WINAPI	NkcICorr_CMS_End(LPVOID handle);

/**
 *
 * CMS摜֐
 *
 * @param[in] handle	nh
 * @param[in] priority	CMS摜Dx	(-2 to 2)
 *								-2=lowest
 *								-1=below normal
 *								 0=normal
 *								 1=above normal
 *								 2=highest
 * @param[in] *pImgInf	摜p[^
 * @param[in] *pCMSInf	CMSp[^
 * @param[out] *PrcFlg	ڍ׃G[R[h
 * @param[in] CacheType	LbVL/w
 *
 *
 *
 *
 * @return 
 * @retval 0 s
 * @retval Not 0 
 *
 * @author 
 * @date 2006/12/15
 * @note VK쐬
 * @attention 
 *	NkcICorr_CMS:LbVwȂ
 *	NkcICorr_CMSEx:bVw肠
 *
 */
extern "C" CORRECT_WRAPDLL_API
BOOL WINAPI	NkcICorr_CMS(
	LPVOID					handle,		//nh
	short					priority,	//Dx -2 to 2 (-2=lowest, 1=below norrmal, 0=normat, 1=above normal, 2=highest)
	T_CorrectWrapDll_ImgInf	*pImgInf,	//摜p[^
	T_CorrectWrapDll_CmsInf	*pCMSInf,	//CMSp[^
	HRESULT					*pErrCode	//ڍ׃G[R[h
);
extern "C" CORRECT_WRAPDLL_API
BOOL WINAPI	NkcICorr_CMSEx(
	LPVOID					handle,		//nh
	short					priority,	//Dx -2 to 2 (-2=lowest, 1=below norrmal, 0=normat, 1=above normal, 2=highest)
	T_CorrectWrapDll_ImgInf	*pImgInf,	//摜p[^
	T_CorrectWrapDll_CmsInf	*pCMSInf,	//CMSp[^
	HRESULT					*pErrCode,	//ڍ׃G[R[h
	WRAPDLL_CASH_TYPE		CacheType	//LbVL/w
);

/**
 *
 * NxNFilter摜Jn
 *
 * @return nh
 * @retval 0 s
 * @retval Not 0 
 *
 * @author Y.Wada
 * @date 2006/12/16
 * @note VK쐬
 * @attention ɂȂ
 *
 */
extern "C" CORRECT_WRAPDLL_API
LPVOID WINAPI	NkcICorr_NxNFilter_Start();

/**
 *
 * NxNFilter摜I
 *
 * @return 
 * @retval 0 s
 * @retval Not 0 
 *
 * @author Y.Wada
 * @date 2006/12/16
 * @note VK쐬
 * @attention ɂȂ
 *
 */
extern "C" CORRECT_WRAPDLL_API
VOID WINAPI	NkcICorr_NxNFilter_End(LPVOID handle);

/**
 *
 * NxNFilter摜֐
 *
 * @param[in] handle	nh
 * @param[in] priority	CMS摜Dx	(-2 to 2)
 *								-2=lowest
 *								-1=below normal
 *								 0=normal
 *								 1=above normal
 *								 2=highest
 * @param[in] *pImgInf	摜p[^
 * @param[in] *pNxNInf	NxNFilterp[^
 * @param[out] *PrcFlg	ڍ׃G[R[h
 * @param[in] CacheType	LbVL/w
 *
 *
 *
 *
 *
 * @return 
 * @retval 0 s
 * @retval Not 0 
 *
 * @author 
 * @date 2006/12/15
 * @note VK쐬
 * @attention 
 *	NkcICorr_NxNFilter:LbVwȂ
 *	NkcICorr_NxNFilterEx:bVw肠
 *
 */
extern "C" CORRECT_WRAPDLL_API
BOOL WINAPI	NkcICorr_NxNFilter(
	LPVOID					handle,		//nh
	short					priority,	//Dx -2 to 2 (-2=lowest, 1=below norrmal, 0=normat, 1=above normal, 2=highest)
	T_CorrectWrapDll_ImgInf	*pImgInf,	//摜p[^
	T_CorrectWrapDll_NxNInf	*pNxNInf,	//NxNFilterp[^
	HRESULT					*pErrCode	//ڍ׃G[R[h
);
extern "C" CORRECT_WRAPDLL_API
BOOL WINAPI	NkcICorr_NxNFilterEx(
	LPVOID					handle,		//nh
	short					priority,	//Dx -2 to 2 (-2=lowest, 1=below norrmal, 0=normat, 1=above normal, 2=highest)
	T_CorrectWrapDll_ImgInf	*pImgInf,	//摜p[^
	T_CorrectWrapDll_NxNInf	*pNxNInf,	//NxNFilterp[^
	HRESULT					*pErrCode,	//ڍ׃G[R[h
	WRAPDLL_CASH_TYPE		CacheType	//LbVL/w
);

#endif	//#ifndef __CorrectWrapDllCom_h__

//End of file
