//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : DrawObjNumber.h
//	ABSTRACT  : CDrawObjNumber NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2009.11.25	EZ Controller 6x6C` tHgubNΉ
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DrawObjNumber_H__A1DF3C43_14DB_45BF_8EF8_7E5AC36D7D9B__INCLUDED_)
#define AFX_DrawObjNumber_H__A1DF3C43_14DB_45BF_8EF8_7E5AC36D7D9B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DrawObj.h"
#include <vector>

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CDrawObjNumber
//	ABSTRACT : `IuWFNg [`]
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CDrawObjNumber : public CDrawObj  
{
public:

	// RXgN^
	CDrawObjNumber();

	// fXgN^
	virtual ~CDrawObjNumber();

	// 񕶎擾
	virtual CString GetInformation()
	{
		CString str;
		str.Format("DrawObjNumber : Offset (%d, %d)", m_Offset.x, m_Offset.y);
		return str;
	}

	// I
	virtual void End();

	// `揈
	virtual ECODE Draw(unsigned char* pData, RECT rect);

public:

	BOOL	m_bTransparent;					// wi߂ǂ TRUE: FALSE:s
	POINT	m_Offset;						// ItZbgʒuiP:1sNZj
	int		m_nDegree;						// ]px (0, 90,180, 270 ̂ݗLj

	COLORREF m_BkColor;						// wiF
	COLORREF m_TxColor;						// F

	// ԍ̐ݒ
	void	SetNumber(int Number);

private:

	std::vector<unsigned char> m_Number;	// ԍi1̈ʂ1l̃Xgj
	RECT	m_Rect;							// `̈iP:1sNZj
	
	// NUMMAPiԍ`}bvjmF
	BOOL	CheckNumberMap(int x, int y);
};

#endif // !defined(AFX_DrawObjNumber_H__A1DF3C43_14DB_45BF_8EF8_7E5AC36D7D9B__INCLUDED_)

