//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : MakeCompositeImage.h
//	ABSTRACT  : CMakeCompositeImage NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2009.11.25	EZ Controller 6x6C` tHgubNΉ
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAKECOMPOSITEIMAGE_H__B129C929_F62D_4832_BBDA_9164DBA88BEB__INCLUDED_)
#define AFX_MAKECOMPOSITEIMAGE_H__B129C929_F62D_4832_BBDA_9164DBA88BEB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DrawObj.h"
#include "DrawObjImage.h"
#include "DrawObjLine.h"
#include "DrawObjRect.h"
#include "DrawObjNumber.h"
#include <vector>

#define MAKE_COMPOSITE_IMAGE_LINE 150

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CMakeCompositeImage
//	ABSTRACT : 摜쐬NX
//
//				g
//				@Initialize()ŏi{l̐ݒj
//				A`施ߊ֐ŕ`施߂ݒij
//				BMakeCompositeImage()Ŏۂ̉摜쐬
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CMakeCompositeImage
{
public:

	// G[R[h
	enum ECODE
	{
		SUCCESS = 0,
		ERR_HEADER_WRITE,
		ERR_MEMORY,
		ERR_DRAWOBJ,
		ERR_DATA_WRITE,
	};

	CString m_strLastError;				// G[

	// RXgN^
	CMakeCompositeImage();

	// fXgN^
	virtual ~CMakeCompositeImage();

private:

	int m_nLineNum;						// obt@C
	int m_nWidth;						// iP:1sNZj
	int m_nHeight;						// iP:1sNZj
	CString m_strFilePath;				// o̓rbg}bv摜t@CpX

	std::vector<CDrawObj*> m_vDrawObj;	// `施߃Xg

public:

	// 
	void Initialize(int nWidth, int nHeight, CString strFilePath);

	// 摜쐬
	ECODE MakeCompositeImage();

	// G[̂߂Ƀwb_[݂̂̉摜t@C쐬
	ECODE MakeDummyFileForError();

	// `施߃Zbg
	void Reset();

	// `施 摜t@C
	void DrawImage(RECT Trim1, RECT Trim2, CString strFilePath);

	// `施 
	void DrawLine(int X1, int Y1, int X2, int Y2, COLORREF Color);

	// `施 `
	void DrawRect(int left, int top, int right, int bottom, COLORREF Color);

	// `施 
	void DrawNumber(int x, int y, int Number, COLORREF color, int nDegree);
};

#endif // !defined(AFX_MAKECOMPOSITEIMAGE_H__B129C929_F62D_4832_BBDA_9164DBA88BEB__INCLUDED_)
