//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsBc.cpp
//	ABSTRACT  : CNpsBc NX̃Cve[V
//	
//	CREATE    : Y.Yoshinobu	2007.05.20
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsBc.h"
#include "NpsPrinterChecker.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBc::CNpsBc()
//	ABSTRACT : RXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsBc::CNpsBc()
{
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBc::~CNpsBc()
//	ABSTRACT : fXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsBc::~CNpsBc()
{
	m_vInAddr.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBc::SearchPrinter()
//	ABSTRACT : v^ms
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.17
//	UPDATE   : T.Isogai		2008.9.17 RD-129 HUBXΉ
//	UPDATE   : Y.Yoshinobu	2008.10.24 HubXΉ̎dlύXΉ (SĕԂ悤ɑΉ)
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBc::SearchPrinter( BOOL bEnableLoopBack, std::vector<T_NpsPrinterInfo*>*	pvPrinterInfo, DWORD dwWaitTime )
{
	//----------------------------------------
	// NIC𒲂ׂ
	//----------------------------------------

	SearchNic();

	DWORD dwInAddr;

	if ( TRUE == bEnableLoopBack )
	{
		// [vobNAhXIɓo^B
		dwInAddr = NkcComApi::htonl( INADDR_LOOPBACK );
		m_vInAddr.push_back( dwInAddr );
	}

#if 0	// Ń[obNAhX֒ʒm悤ɎdlύXƂȂ̂ŃRgɂ
	//----------------------------------------
	// jLXgׂׂ
	//----------------------------------------
	// T.Isogai 2008.9.17 RD-129 HUBXΉ
	BOOL	bUnicast = FALSE;

	if( 1 == m_vInAddr.size() )
	{
		if( NkcComApi::htonl( INADDR_LOOPBACK ) == m_vInAddr[0] )
		{
			bUnicast = TRUE;
		}
	}
#endif

	//----------------------------------------
	// v^̎擾
	//----------------------------------------
	std::vector<T_NpsPrinterInfo*> vLocalPrinterInfo;
	std::vector<CNpsBcThread*> vpNpsBcThread;
	std::vector<CWinThread*> vpWinThread;
	std::vector<DWORD>::iterator itInAddr;
	std::vector<CNpsBcThread*>::iterator itNpsBcThread;
	std::vector<CWinThread*>::iterator itWinThread;
	CNpsBcThread* pNpsBcThread;
	CWinThread* pWinThread;

#ifdef NPS_OEM_PRINTER								// 2008.10.24 S.Heya
	// v^[ƍNX
	CNpsPrinterChecker NpsPrinterChecker;
	NpsPrinterChecker.StartupThread();
#endif // NPS_OEM_PRINTER

	// XbhN
	for ( itInAddr=m_vInAddr.begin() ; itInAddr != m_vInAddr.end() ; itInAddr++ )
	{
#ifdef NPS_OEM_PRINTER								// 2008.10.24 S.Heya
		pNpsBcThread = new CNpsBcThread(&NpsPrinterChecker);
#else
		pNpsBcThread = new CNpsBcThread();
#endif

		//----------------------------------------
		// jLXgݒ
		//----------------------------------------
		if( NkcComApi::htonl( INADDR_LOOPBACK ) == (*itInAddr) )
		{
			// [obNAhX́AjLXgőM
			pNpsBcThread->SetUnicast();
		}
		
		pNpsBcThread->SetMyPCAddr( (*itInAddr) );

		pWinThread = ::AfxBeginThread( (AFX_THREADPROC)NpsBcThreadEntry, pNpsBcThread, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED, NULL );

		pWinThread->m_bAutoDelete = FALSE;
		pWinThread->ResumeThread();

		vpNpsBcThread.push_back( pNpsBcThread );
		vpWinThread.push_back( pWinThread );
	}

	// w莞ԑҋ@
	::Sleep( dwWaitTime );

	// XbhI
	for ( itNpsBcThread=vpNpsBcThread.begin() ; itNpsBcThread != vpNpsBcThread.end() ; itNpsBcThread++ )
	{
		pNpsBcThread = *itNpsBcThread;
		pNpsBcThread->ThreadEnd();
	}

	// XbhI܂őҋ@
	for ( itWinThread=vpWinThread.begin() ; itWinThread != vpWinThread.end() ; itWinThread++ )
	{
		pWinThread = *itWinThread;
		::WaitForSingleObject( pWinThread->m_hThread, INFINITE );
		delete pWinThread;
	}
	vpWinThread.clear();

	//----------------------------------------
	// v^̎擾
	//----------------------------------------

	int nCount;
	int nIdx;
	T_NpsPrinterInfo tPrinterInfo;
	T_NpsPrinterInfo* pPrinterInfo;
	std::vector<T_NpsPrinterInfo*>::iterator itPrinterInfo;

	for ( itNpsBcThread=vpNpsBcThread.begin() ; itNpsBcThread != vpNpsBcThread.end() ; itNpsBcThread++ )
	{
		pNpsBcThread = *itNpsBcThread;
		nCount = pNpsBcThread->GetPrinterCount();
		for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
		{
			if ( TRUE == pNpsBcThread->GetPrinterInfo( nIdx, &tPrinterInfo ) )
			{
				// Xgɒǉ
				pPrinterInfo = new T_NpsPrinterInfo;
				::MoveMemory( pPrinterInfo, &tPrinterInfo, sizeof(T_NpsPrinterInfo) );
				vLocalPrinterInfo.push_back( pPrinterInfo );
			}
		}
		delete pNpsBcThread;
	}
	vpNpsBcThread.clear();

#ifdef NPS_OEM_PRINTER								// 2008.10.24 S.Heya

	// XbhI܂őҋ@
	NpsPrinterChecker.WaitEndThread();

	for (int nIndex = 0; nIndex < NpsPrinterChecker.GetPrinterCount(); nIndex++)
	{
		// v^[擾
		if (FALSE == NpsPrinterChecker.GetPrinterInfo(nIndex, &tPrinterInfo))
			break;

		// XgɃv^[ǉ
		pPrinterInfo = new T_NpsPrinterInfo;
		::MoveMemory( pPrinterInfo, &tPrinterInfo, sizeof(T_NpsPrinterInfo) );
		vLocalPrinterInfo.push_back( pPrinterInfo );
	}

#endif

	//----------------------------------------
	// Xg̐
	//----------------------------------------

	std::vector<T_NpsPrinterInfo*>::iterator itLocalPrinterInfo;

	for ( itLocalPrinterInfo=vLocalPrinterInfo.begin() ; itLocalPrinterInfo != vLocalPrinterInfo.end() ; itLocalPrinterInfo++ )
	{
		for ( itPrinterInfo=pvPrinterInfo->begin() ; pvPrinterInfo->end() != itPrinterInfo ; itPrinterInfo++ )
		{
			// ݂̏Ǝ擾̂ǂ炩̏ꍇ́AIPAhX̏dȂ
			if( (*itPrinterInfo)->wType == 0 ||
				(*itLocalPrinterInfo)->wType == 0 )
			{
				if ( 0 == ::lstrcmpi( (*itPrinterInfo)->szIP, (*itLocalPrinterInfo)->szIP ) )
				{
					break;
				}
			}
			// ݂̏Ǝ擾̗V̏ꍇ́AIPAhX|[gԍ̏dȂ
			else
			{
				if ( 0 == ::lstrcmpi( (*itPrinterInfo)->szIP, (*itLocalPrinterInfo)->szIP ) &&
					(*itPrinterInfo)->Nps000FH_0201H.NpsPortNo == (*itLocalPrinterInfo)->Nps000FH_0201H.NpsPortNo)
				{
					break;
				}
			}
		}
		if ( pvPrinterInfo->end() != itPrinterInfo )
		{
			// dIPAhXȂ̂ŃXgɒǉȂ
			delete (*itLocalPrinterInfo);
			continue;
		}

		// [vobNAhXœ̋@̏ꍇ́AXgɒǉȂ
		if ( NkcComApi::htonl( INADDR_LOOPBACK ) == inet_addr( (*itLocalPrinterInfo)->szIP ) )
		{
			if ((*itLocalPrinterInfo)->wType == 0)
			{
				if ( TRUE == NkcComApi::IsNotSupportHublessByName( (*itLocalPrinterInfo)->Nps000FH_0101H.MachineTypeName ) )
				{
					// [vobNAhXԂĂ͂Ȃ@Ȃ̂ŃXgɒǉȂ
					delete (*itLocalPrinterInfo);
					continue;
				}
			}
		}

		// Xgɒǉ
		pvPrinterInfo->push_back( (*itLocalPrinterInfo) );
	}
	vLocalPrinterInfo.clear();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBc::PrinterStateCheck()
//	ABSTRACT : v^I/FԂ̃`FbNs
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsBc::PrinterStateCheck( std::vector<T_NpsPrinterIFState*>* pvPrinterIFState, DWORD dwWaitTime )
{
	//----------------------------------------
	// NIC𒲂ׂ
	//----------------------------------------

	SearchNic();

	//----------------------------------------
	// v^̎擾
	//----------------------------------------
	std::vector<CNpsBcThread2*> vpNpsBcThread2;
	std::vector<CWinThread*> vpWinThread;
	std::vector<DWORD>::iterator itInAddr;
	std::vector<CNpsBcThread2*>::iterator itNpsBcThread2;
	std::vector<CWinThread*>::iterator itWinThread;
	CNpsBcThread2* pNpsBcThread2;
	CWinThread* pWinThread;

	// XbhN
	for ( itInAddr=m_vInAddr.begin() ; itInAddr != m_vInAddr.end() ; itInAddr++ )
	{
		pNpsBcThread2 = new CNpsBcThread2;

		pNpsBcThread2->SetMyPCAddr( (*itInAddr) );

		pWinThread = ::AfxBeginThread( (AFX_THREADPROC)NpsBcThread2Entry, pNpsBcThread2, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED, NULL );

		pWinThread->m_bAutoDelete = FALSE;
		pWinThread->ResumeThread();

		vpNpsBcThread2.push_back( pNpsBcThread2 );
		vpWinThread.push_back( pWinThread );
	}

	// w莞ԑҋ@
	::Sleep( dwWaitTime );

	// XbhI
	for ( itNpsBcThread2=vpNpsBcThread2.begin() ; itNpsBcThread2 != vpNpsBcThread2.end() ; itNpsBcThread2++ )
	{
		pNpsBcThread2 = *itNpsBcThread2;
		pNpsBcThread2->ThreadEnd();
	}

	// XbhI܂őҋ@
	for ( itWinThread=vpWinThread.begin() ; itWinThread != vpWinThread.end() ; itWinThread++ )
	{
		pWinThread = *itWinThread;
		::WaitForSingleObject( pWinThread->m_hThread, INFINITE );
		delete pWinThread;
	}
	vpWinThread.clear();

	//----------------------------------------
	// v^̎擾
	//----------------------------------------

	int nCount;
	int nIdx;
	T_NpsPrinterIFState tPrinterIFState;
	T_NpsPrinterIFState* pPrinterIFState;

	for ( itNpsBcThread2=vpNpsBcThread2.begin() ; itNpsBcThread2 != vpNpsBcThread2.end() ; itNpsBcThread2++ )
	{
		pNpsBcThread2 = *itNpsBcThread2;
		nCount = pNpsBcThread2->GetPrinterCount();
		for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
		{
			if ( TRUE == pNpsBcThread2->GetPrinterIFState( nIdx, &tPrinterIFState ) )
			{
				// Xgɒǉ
				pPrinterIFState = new T_NpsPrinterIFState;
				::MoveMemory( pPrinterIFState, &tPrinterIFState, sizeof(T_NpsPrinterIFState) );
				pvPrinterIFState->push_back( pPrinterIFState );
			}
		}
		delete pNpsBcThread2;
	}
	vpNpsBcThread2.clear();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsBc::SearchNic()
//	ABSTRACT : NIC𒲂ׂ
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.5.20
//	UPDATE   : Y.Yoshinobu	2008.10.24 [vobNAhXNICɓo^悤ɕύX
//	UPDATE   : Y.Yoshinobu	2008.10.28 [vobNAhXNICɓo^Ȃ悤ɕύX
//////////////////////////////////////////////////////////////////////////////
void CNpsBc::SearchNic()
{
	int nNicCount;
	TCHAR szHostName[MAX_PATH];
	LPHOSTENT lpHostEnt;
	DWORD dwInAddr;

	m_vInAddr.clear();

	::ZeroMemory( szHostName, sizeof(szHostName) );

	if ( SOCKET_ERROR != ::gethostname( szHostName, sizeof(szHostName) ) )
	{
		lpHostEnt = ::gethostbyname( szHostName );
		if ( NULL != lpHostEnt )
		{
			for ( nNicCount=0 ; NULL != lpHostEnt->h_addr_list[nNicCount] ; nNicCount++ )
			{
				dwInAddr = (*((in_addr *)lpHostEnt->h_addr_list[nNicCount])).S_un.S_addr;

				if ( NkcComApi::htonl( INADDR_LOOPBACK ) == dwInAddr )
				{
					continue;
				}

				m_vInAddr.push_back( dwInAddr );
			}
		}
		else
		{
			CString str;
			str.Format( "   fail gethostbyname ( %d )", ::WSAGetLastError() );
			TRACE( "%s\n", str );
		}
	}
	else
	{
		CString str;
		str.Format( "   fail gethostname ( %d )", ::WSAGetLastError() );
		TRACE( "%s\n", str );
	}
}
