//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallbackCompletion.cpp
//	ABSTRACT  : CNpsCallbackCompletion NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsCallbackCompletion.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackCompletion::CNpsCallbackCompletion()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackCompletion::CNpsCallbackCompletion()
: CNpsCallback()
{

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackCompletion::~CNpsCallbackCompletion()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackCompletion::~CNpsCallbackCompletion()
{
	EndObject();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackCompletion::AddNpsCALLBACKDATA()
//	ABSTRACT : CNpsCALLBACKDATA_CompletionIuWFNgXgɒǉ
//	FUNCTION : CNpsCALLBACKDATA_CompletionIuWFNgXgɒǉ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallbackCompletion::AddNpsCALLBACKDATA( void*			pFunc, 
												DWORD			dwCompletionCode,
												NPSPRINTINFO	PrintInfo,
												NPSORDERINFO	OrderInfo )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	CNpsCALLBACKDATA_Completion* pCALLBACKDATA;
	try
	{
		pCALLBACKDATA = new CNpsCALLBACKDATA_Completion;
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CNpsCALLBACKDATA_Completion]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return;
	}

	pCALLBACKDATA->m_wCallCallback		= NPS_CALLBACKCOMPLETION;	// ʒm		2011.11.18 A.Nagamatsu

	pCALLBACKDATA->m_pFunc				= pFunc;
	pCALLBACKDATA->m_dwCompletionCode	= dwCompletionCode;
	pCALLBACKDATA->m_PrintInfo			= PrintInfo;
	pCALLBACKDATA->m_OrderInfo			= OrderInfo;

	m_vectorCALLBACKDATA.push_back( pCALLBACKDATA );
	SetEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackCompletion::AddNpsCALLBACKDATA()
//	ABSTRACT : CNpsCALLBACKDATA_CompletionIuWFNgXgɒǉ
//	FUNCTION : CNpsCALLBACKDATA_CompletionIuWFNgXgɒǉ
//
//	NOTE     : < RD-111 > 
//             < Note > 
//				v^CxggʒmƏʒm̒ʒmۏ؂邽߂ɁA
//				v^CxggʒmʒmƓXbhɂ
//				s悤ɂ܂B
//
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu		2011.11.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallbackCompletion::AddNpsCALLBACKDATA( void*			pFunc, 
												NPSEVENTINFOEX	EventInfoEx )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	CNpsCALLBACKDATA_Completion* pCALLBACKDATA;
	try
	{
		pCALLBACKDATA = new CNpsCALLBACKDATA_Completion;
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CNpsCALLBACKDATA_Completion]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return;
	}

	pCALLBACKDATA->m_wCallCallback	= NPS_CALLBACKEVENTPROCEX;	// v^Cxggʒm

	pCALLBACKDATA->m_pFunc			= pFunc;
	pCALLBACKDATA->m_EventInfoEx	= EventInfoEx;

	m_vectorCALLBACKDATA.push_back( pCALLBACKDATA );
	SetEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackCompletion::CallCallback()
//	ABSTRACT : R[obN֐Ăяo
//	FUNCTION : R[obN֐Ăяo
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : A.Nagamatsu	2011.11.18		v^CxggʒmɑΉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallbackCompletion::CallCallback( CNpsCALLBACKDATA* pCALLBACKDATA )
{
	CNpsCALLBACKDATA_Completion * pData	= ( CNpsCALLBACKDATA_Completion * ) pCALLBACKDATA;

	////////////////////////////////////////////////////////
	// v^Cxggʒm
	if( NPS_CALLBACKEVENTPROCEX == pData->m_wCallCallback )
	{
		{	// Oo
			CString str;
			str.Format( "<Callback> NPSEVENTPROCEX PrintId=%d, EventId=%d, EventCodeMain=%d",
				pData->m_EventInfoEx.dwPrintId,			// Print ID 
				pData->m_EventInfoEx.dwEventId,			// Event Id 
				pData->m_EventInfoEx.wEventCodeMain );	// Event code (main) 
					
			NPS_LOGOUT( str );
		}

		( ( NPSEVENTPROCEX )( pData->m_pFunc ) )(
			&( pData->m_EventInfoEx )
			);
	}

	////////////////////////////////////////////////////////
	// ʒm
	else if( NPS_CALLBACKCOMPLETION == pData->m_wCallCallback )
	{
		if( COMPLETION_PRINT == pData->m_dwCompletionCode )
		{
			{	// Oo
				CString str;
				CString strStatus;
				in_addr tAddr;
				tAddr.S_un.S_addr = pData->m_PrintInfo.dwIPAddress;
				switch ( pData->m_PrintInfo.dwStatus )
				{
				case RESULT_OK:				strStatus = _T( "OUTPUT  " );	break;	// ɔro
				case RESULT_TRANSFER:		strStatus = _T( "TRANSFER" );	break;	// ]
				case RESULT_PRINT:			strStatus = _T( "PRINT   " );	break;	// vg

				// >>>>> 2011.11.30 A.Nagamatsu
				case RESULT_OK_REPEAT:			strStatus = _T( "OUTPUTRP" );	break;	// 	ɔro(s[gP)
				case RESULT_PRINT_REPEAT:		strStatus = _T( "PRNINTRP" );	break;	// 	vg(s[gP)
				case RESULT_LOADING:			strStatus = _T( "LOADING " );	break;	// 	[fBOJn
				case RESULT_LOADING_REPEAT:		strStatus = _T( "LOADINGR" );	break;	// 	[fBOJn(s[gP)
				case RESULT_OK_RETRANSMISSION:	strStatus = _T( "RETRANS " );	break;	// ɔro(đǗp̔ro)
				// <<<<<
				}
				str.Format( "<Callback> NPSCOMPLETIONPROC [PRINT] hPrinter=0x%08X, IPAddress=%d.%d.%d.%d, PortNo=%d, PrintId=%d, Status=%s, FinishNum=%d",
					pData->m_PrintInfo.hPrinter,
					tAddr.S_un.S_un_b.s_b1,
					tAddr.S_un.S_un_b.s_b2,
					tAddr.S_un.S_un_b.s_b3,
					tAddr.S_un.S_un_b.s_b4,
					pData->m_PrintInfo.wPortNo,
					pData->m_PrintInfo.dwPrintId,
					strStatus,
					pData->m_PrintInfo.dwFinishNum);
				NPS_LOGOUT( str );
			}

			( ( NPSCOMPLETIONPROC )( pData->m_pFunc ) )(
				pData->m_dwCompletionCode,
				&( pData->m_PrintInfo )
				);

			{	// Oo
				// NPS_LOGOUT( "<Callback return> NPSCOMPLETIONPROC [PRINT]" );
			}
		}
		else if ( COMPLETION_ORDER == pData->m_dwCompletionCode )
		{
			{	// Oo
				CString str;
				CString strStatus;
				in_addr tAddr;
				tAddr.S_un.S_addr = pData->m_OrderInfo.dwIPAddress;
				switch ( pData->m_OrderInfo.dwStatus )
				{
				case RESULT_OK:				strStatus = _T( "SUCCESS" );	break;	// I[_[̑SẴvgɔro
				case RESULT_NG:				strStatus = _T( "ERROR  " );	break;	// ُI
				case RESULT_USER_CANCEL:	strStatus = _T( "CANCEL " );	break;	// [U[ɂLZ
				}
				str.Format( "<Callback> NPSCOMPLETIONPROC [ORDER] hPrinter=0x%08X, IPAddress=%d.%d.%d.%d, PortNo=%d, OrderId=%d, Status=%s",
					pData->m_OrderInfo.hPrinter,
					tAddr.S_un.S_un_b.s_b1,
					tAddr.S_un.S_un_b.s_b2,
					tAddr.S_un.S_un_b.s_b3,
					tAddr.S_un.S_un_b.s_b4,
					pData->m_OrderInfo.wPortNo,
					pData->m_OrderInfo.dwOrderId,
					strStatus);
				NPS_LOGOUT( str );
			}

			( ( NPSCOMPLETIONPROC )( pData->m_pFunc ) )(
				pData->m_dwCompletionCode,
				&( pData->m_OrderInfo )
				);

			{	// Oo
				//NPS_LOGOUT( "<Callback return> NPSCOMPLETIONPROC [ORDER]" );
			}
		}
	}
}
