//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallbackUnit.h
//	ABSTRACT  : CNpsCallbackUnit NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSCALLBACKUNIT_H__8A62ADAF_9B0A_4E50_A9D8_F7C0FD95EFD9__INCLUDED_)
#define AFX_NPSCALLBACKUNIT_H__8A62ADAF_9B0A_4E50_A9D8_F7C0FD95EFD9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NpsCallback.h"
#include "NpsCmd.h"

class CNpsCmd;

//////////////////////////////////////////////////////////////////////////////
class CNpsCALLBACKDATA_Unit : public CNpsCALLBACKDATA
{
public:
	CNpsCALLBACKDATA_Unit()
	{
		m_bPaperChange		= FALSE;
		m_bAllPaperChange	= FALSE;
	}

	~CNpsCALLBACKDATA_Unit()
	{
	}

	NPSUNITNOTIFYINFO	m_UnitInfo;
	BOOL				m_bPaperChange;
	BOOL				m_bAllPaperChange;
};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsCallbackUnit
//	ABSTRACT : R[obNv^ԕύXʒmNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsCallbackUnit : public CNpsCallback  
{
public:
	CNpsCallbackUnit();				// RXgN^
	virtual ~CNpsCallbackUnit();	// fXgN^
	void	Initialize( void * pFunc, CNpsCmd * pNpsCmd )
	{
		m_pFunc		= pFunc;
		m_pNpsCmd	= pNpsCmd;
	}

	void	AddNpsCALLBACKDATA( NPSUNITNOTIFYINFO UnitInfo, BOOL bPaperChange = FALSE, BOOL bAllPaperChange = FALSE );

protected:
	
	void*			m_pFunc;
	CNpsCmd*		m_pNpsCmd;
	virtual void	CallCallback( CNpsCALLBACKDATA* );// R[obNďo
};


#endif // !defined(AFX_NPSCALLBACKUNIT_H__8A62ADAF_9B0A_4E50_A9D8_F7C0FD95EFD9__INCLUDED_)
