//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCommand.h
//	ABSTRACT  : NpsCommand\̒`
//	
//	CREATE    : T.Isogai	2006.7.5
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#ifndef __NPSCOMMAND_H__
#define __NPSCOMMAND_H__

//typedef char				CHAR;
//typedef unsigned char		UCHAR;
//typedef short				SHORT;
//typedef unsigned short	USHORT;
//typedef long				LONG;
//typedef unsigned long		USHORT;

enum NpsType
{
	NPS_CHAR	= 0,	// CHAR^
	NPS_UCHAR,			// UCHAR^
	NPS_SHORT,			// SHORT^
	NPS_USHORT,			// USHORT^
	NPS_LONG,			// LONG^
	NPS_ULONG,			// ULONG^
	NPS_INT64,			// int64^
	NPS_FLOAT,			// float^
};

enum NpsDataType
{
	NPS_DATATYPE_IFID = 0,
	NPS_DATATYPE_CMDID,
	NPS_DATATYPE_TAG_NO,
	NPS_DATATYPE_TAG_LENGTH,
	NPS_DATATYPE_TAG_VALUE,
	NPS_DATATYPE_TAG_NO_END,
	NPS_DATATYPE_TAG_LENGTH_END,
};

#define NPS_UDP_SERVER_PORT					30580
#define NPS_TCP_SERVER_PORT					30582
#define NPS_TCP_SERVER_IMAGESEND_PORT		30583

#define NPS_UDP_SERVER_PORT_2				31580		// v^m2R}hŎgp

#define NPS_DEFAULT_TIMEOUT					60000	// ftHg^CAEgi~bj

// I[_[̓ꏈIvViIɂ́AŃe[hwł悤ɂj
#define	OPTION_BERG_CREDIT					0x00000001		// NWbgR}h̑Mi ON:M, OFF:MȂ j
#define	OPTION_SETTING_PRN					0x00000002		// [hύXR}h([h)̑Mi ON:M, OFF:MȂ j

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_NpsPaperInfo
//   Contents	 : y[p[
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT			PaperWidth;				// y[p[̕ iPʁF0.1mmj
	USHORT			PaperId;				// y[p[ID iʎj
	USHORT			PaperResolution[8];		// ͉𑜓x iPʁF0.1dpij
	ULONG			PaperRemaind;			// y[p[c iPʁF0.1mmj
	UCHAR			PaperFeed;				// @
	UCHAR			PaperPresence;			// U
	CHAR			PaperName[32];			// y[p[

} T_NpsMagInfo;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_NpsRegPaperInfo
//   Contents	 : o^y[p[
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PaperWidth;				// y[p[̕ iPʁF0.1mmj
	USHORT	PaperLengthMin;			// y[p[̑蒷̍ŏl iPʁF0.1mmj
	USHORT	PaperLengthMax;			// y[p[̑蒷̍ől iPʁF0.1mmj
	USHORT	PaperId;				// y[p[ID iʎj í͈jF1`4
	USHORT	PaperResolution[8];		// ͉𑜓x iPʁF0.1dpij
	SHORT	PaperAllocationTop;		// t㕔 iPʁF0.1mmj
	SHORT	PaperAllocationBottom;	// t iPʁF0.1mmj
	SHORT	PaperAllocationLeft;	// t iPʁF0.1mmj
	SHORT	PaperAllocationRight;	// tE iPʁF0.1mmj
	USHORT	SetupStatus;			// ZbgAbv
	UCHAR	PaperFeed;				// @
	USHORT	PaperTypeCode;			// y[p[^Cv
	UCHAR	PaperKind;				// y[p[ʎ
	UCHAR	MagazineID;				// }KWID
	SHORT	WBAdjustLeft;			// WB␳l iPʁF0.1mmj
	SHORT	WBAdjustRight;			// WB␳lE iPʁF0.1mmj
	CHAR	PaperName[32];			// y[p[
	UCHAR	PaperType;				// y[p[^Cvi܎j
	UCHAR	Direction;				// fBNV
	UCHAR	PrintQuality;			// i
	UCHAR	PaperTypeValid;			// y[p[^CvuL/v	(2011.8.4 A.Nagamatsu)

} T_NpsRegMagInfo;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps000FH_0100H
//   Contents	 : v^mv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps000FH_0100H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps000FH_0101H
//   Contents	 : v^m
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	CHAR	MachineTypeName[20];	// @햼
	CHAR	SerialNumber[20];		// VAԍ
	USHORT	SupportResolutions[8];	// 𑜓x iPʁF0.1 dpij
									// ̉𑜓xĂꍇ́A𑜓x珇ɃZbg܂
	USHORT	NpsVersion;				// NPS I/F ̃o[W
									// 1Byte W[ԍ
									// 1Byte }Ci[ԍ
	UCHAR	MacAddress[6];			// MacAhX
									// v^NICMACAhXZbgB
	CHAR	SoftName[20];			// \tgEFA
} T_Nps000FH_0101H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps000FH_0200H
//   Contents	 : v^mv2
//   Inheritance : 
//   Author/Date : H.Kamiya	2015.12.03
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps000FH_0200H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps000FH_0201H
//   Contents	 : v^m2
//   Inheritance : 
//   Author/Date : H.Kamiya	2015.12.03
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	CHAR	MachineTypeName[20];	// @햼
	CHAR	SerialNumber[20];		// VAԍ
	USHORT	SupportResolutions[8];	// 𑜓x iPʁF0.1 dpij
									// ̉𑜓xĂꍇ́A𑜓x珇ɃZbg܂
	USHORT	NpsVersion;				// NPS I/F ̃o[W
									// 1Byte W[ԍ
									// 1Byte }Ci[ԍ
	UCHAR	HostMacAddress[6];		// MacAhX
									// HostMACAhXZbgB
	CHAR	SoftName[20];			// \tgEFA
	USHORT	NpsPortNo;				// NPSp|[gԍ
	USHORT	ImgPortNo;				// NPS(摜f[^]p)|[gԍ
	ULONG	PrinterIPAddress;		// v^[IPAhX
	UCHAR	PrinterMacAddress[6];	// v^[MacAhX
} T_Nps000FH_0201H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0100H
//   Contents	 : v^{̎擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_0100H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0101H
//   Contents	 : v^{̎擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;					// 
									// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	CHAR	MachineTypeName[20];	// @햼
	CHAR	SerialNumber[20];		// VAԍ
	USHORT	SupportResolutions[8];	// 𑜓x iPʁF0.1 dpij
									// ̉𑜓xĂꍇ́A𑜓x珇ɃZbg܂
	USHORT	MachineTypeID;			// @敪
									// 0:≖I^Cv(Laser)
									// 1:CNWFbg^Cv
									// 2:≖I^Cv(iBeam)
	CHAR	SoftName[20];			// \tgEFA
} T_Nps6000H_0101H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0200H
//   Contents	 : v^ݒ̎擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_0200H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0201H
//   Contents	 : v^ݒ̎擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;					// 
									// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	ULONG	TotalMemory;			// v^̃e (PʁFByte)
	ULONG	ImageSizeMinWidth;		// t摜̍̕ŏTCY iPʁFPixelj
	ULONG	ImageSizeMinHeight;		// t摜̍̍ŏTCY iPʁFPixelj
	ULONG	ImageSizeMaxWidth;		// t摜̍̕őTCY iPʁFPixelj
	ULONG	ImageSizeMaxHeight;		// t摜̍̍őTCY iPʁFPixelj
	USHORT	NumberOfMagazine;		// U\ȃ}KW
	USHORT	PrinterTime[8];			// v^̓
									// z[0] N
									// z[1] 
									// z[2] 
									// z[3] 
									// z[4] 
									// z[5] b
									// z[6] ~b
									// z[7] j
	ULONG	RepeatCountMax;			// ő僊s[g
	UCHAR	SupportImageFormat[32];	//T|[g摜
									// z[0] JPEG
									// z[1] Bitmap
									// z[2] RGB24rbg J[_
									// z[3-32] gp
	UCHAR	LaminatorUnitAttach;	// ~l[^[jbg̑
	USHORT	InstallationDate[3];	// ݒu
									// z[0] N
									// z[1] 
									// z[2] 
	USHORT	OperationStartDate[3];	// ғJn
									// z[0] N
									// z[1] 
									// z[2] 
	USHORT	ProcessorType;			// vZT[ ivZT[ʁj
	USHORT	EmulsionNumber;			// [ ij
	CHAR	PrinterNickname[13];	// [U[`̃v^
	USHORT	SupportAngle;			// T|[g]px iPʁF0.1pxj
	USHORT	SupportIntoPrinter;		// L
	USHORT	SupportLongPaper;		// ڃvgΉ
	UCHAR	SorterStatus;			// \[^[̃gC̐
	UCHAR	CvpStatus;				// CVP󎚍s
	USHORT	SupportPaperFitting;	// T|[gy[p[tBbeBO
	USHORT	SupportEdgeEnhancement;	// T|[gGbW
	USHORT	SupportCMS;				// T|[gCMS
	USHORT	SupportWithBorder;		// T|[g
	USHORT	MachinTypeForProfile;	// vt@Cp̋@R[h
	UCHAR	MachinProfileVersion[7];// vt@Co[W
	USHORT	PaperTypeCode[6];		// y[p[^CvR[h
	UCHAR	OemCode;				// OEMR[h
									// 0:NKCdl
									// 1:FFdl
	USHORT	SetupAlgorithm;			// ZbgAbvASY
	USHORT	SupportDoubleSided;		// T|[gʈ
	ULONG	FadAttachNo;			// FADڑԍ
	USHORT	SupportInterrupt;		// f
} T_Nps6000H_0201H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0300H
//   Contents	 : v^Ԃ̎擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_0300H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0301H
//   Contents	 : v^Ԃ̎擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;					// 
									// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	UCHAR	PrinterStatus;			// v^Ŝ̏ iv^S̏ԁj
	UCHAR	AcceptStatus;			// t
	UCHAR	PrinterPossession;		// v^L̏
	UCHAR	AdvanceStatus;			// v^Ŝ̏ inŚj
	UCHAR	LaserStatus;			// w[U[̏ iw[U[j
	UCHAR	DevelopmentStatus;		// vZT[Ŝ̏ inŚj
	UCHAR	ProcessorStatus;		// ̏ ij
	UCHAR	ReplenisherStatus;		// [Ŝ̏ i[j
	UCHAR	ReplaceCartridgeStatus;	// [J[gbW̌̉ i[J[gbWj
	UCHAR	StartUpChecksStatus;	// nƓ_̎{
	UCHAR	RefillWaterStatus;		// I[gZbgAbvł̕␅̎{
	UCHAR	DailySetupStatus;		// I[gZbgAbvł̃fC[ZbgAbv̎{
	UCHAR	ControlStripStatus;		// I[gZbgAbvł̃Rg[Xgbv̎{
	UCHAR	InMaintenance;			// eiX
	UCHAR	FadStatus;				// FAD̏

} T_Nps6000H_0301H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0400H
//   Contents	 : y[p[̎擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_0400H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0401H
//   Contents	 : y[p[̎擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT			Result;						// 
												// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT			NumberOfPaper;				// 擾y[p[̐
	USHORT			PaperWidth[64];				// y[p[̕ iPʁF0.1mmj
	USHORT			PaperId[64];				// y[p[ID iʎj
	ULONG			PaperRemaind[64];			// y[p[c iPʁF0.1mmj
	UCHAR			PaperFeed[64];				// @
	UCHAR			PaperPresence[64];			// U
	CHAR			PaperName[64][32];			// y[p[

} T_Nps6000H_0401H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0500H
//   Contents	 : v^LJnv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Port;			// 摜Mp̃|[gԍ
	USHORT	PossessionMode;	// L[h
	USHORT	InterruptMode;	// 荞݃[h
	UCHAR	InMaintenance;	// eiX
	USHORT	PossessionNo;	// Lԍ		@@@RD-151Ή	2012.02.09	T.Mizushima
	ULONG	ExOptions;		// gIvV(Pvg) 2014.10.28 M.Yamamoto

} T_Nps6000H_0500H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0501H
//   Contents	 : v^LJn
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_0501H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0600H
//   Contents	 : v^LIv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;	// Lԍ
} T_Nps6000H_0600H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0601H
//   Contents	 : v^LI
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_0601H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0700H
//   Contents	 : tJnv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ
	ULONG	ImageCapacity;		// 摜e iPʁFBytej
	UCHAR	ImageFormat;		// 摜tH[}bg
	USHORT	ImageWidth;			// 摜̕ iPʁFPixelj
	USHORT	ImageHeight;		// 摜̍ iPʁFPixelj
	USHORT	PaperResolution;	// ͉𑜓x iPʁF0.1dpij
	USHORT	PaperWidth; 		// y[p[̕ iPʁF0.1mmj
	USHORT	PaperLength;		// y[p[̑蒷 iPʁF0.1mmj
	USHORT	PaperID;			// y[p[ID
	USHORT	Repeat;				// s[g
								// 1[v^ݒ̎擾]Ŏ擾[ő僊s[g]͈̔͂ŃZbgĉ
	USHORT	PaperFeed;			// @
	USHORT	Laminator;			// ~l[g
	USHORT	CvpInitialValue1;	// CVP1sڂ̒ʂԍ̏l
	USHORT	CvpPoint1;			// CVP1sڂ̒ʂԍ}ʒu
	USHORT	CvpInitialWidth1;	// CVP1sڂ̒ʂԍ󎚂錅
								// CvpLine1̃f[^Ɏw茅̒ʂԍZbg܂B
								// CvpPoint1Ŏw肵ʒuCvpInitialWidth1Ŏw肵ŁACvpInitialValue1̒ʂԍ󎚂܂
								// ʂԍ͉Elň󎚂܂BʂԍCvpInitialWidth1Ŏw肵ɖȂꍇ͋󔒕߂܂
								// CvpLine1w肳ĂȂꍇ́Aʂԍ󎚂܂B܂ACvpPoint1CvpInitialWidth1̘aCvpLine1̃f[^傫ꍇʂԍ󎚂܂
	USHORT	CvpInitialValue2;	// CVP2sڂ̒ʂԍ̏l
	USHORT	CvpPoint2;			// CVP2sڂ̒ʂԍ}ʒu
	USHORT	CvpInitialWidth2;	// CVP2sڂ̒ʂԍ󎚂錅
								// CvpLine2̃f[^Ɏw茅̒ʂԍZbg܂
								// CvpPoint2Ŏw肵ʒuCvpInitialWidth2Ŏw肵ŁACvpInitialValue2̒ʂԍ󎚂܂
								// ʂԍ͉Elň󎚂܂BʂԍCvpInitialWidth2Ŏw肵ɖȂꍇ͋󔒕߂܂
								// CvpLine2w肳ĂȂꍇ́Aʂԍ󎚂܂B܂ACvpPoint2CvpInitialWidth2̘aCvpLine2̃f[^傫ꍇʂԍ󎚂܂
	UCHAR	CvpLine1[256];		// CVP1s
								// 󎚂镶Ǝw@ɂẮAuYt1.m[cLN^[R[h\vQƂĂ
	UCHAR	CvpLine2[256];		// CVP2s
								// f[^̎wCVP1sڂɋLڂƓ
	USHORT	Angle;				// ]px
	UCHAR	PaperPresence;		// Uy[p[w
								// AB̃}KWɓy[p[ĂꍇɁAǂ̃}KW̃y[p[Ńvgsw肵܂
	SHORT	Espc;				// IJnʒu␳ iPʁF0.1mmj
	SHORT	Retry;				// MgC
	ULONG	OrderId;			// I[_[ʔԍ
	USHORT	PaperFitting;		// y[p[tBbeBO
	USHORT	EdgeEnhancement;	// GbW
	USHORT	CMS;				// CMS
	USHORT	WithBorderTop;		// 㕔 iPʁF0.1mmj
	USHORT	WithBorderBottom;	//  iPʁF0.1mmj
	USHORT	WithBorderLeft;		//  iPʁF0.1mmj
	USHORT	WithBorderRight;	// E iPʁF0.1mmj
	UCHAR	WithBorderColor[3];	// ̐F
								// z[0] Red
								// z[1] Green
								// z[2] Blue
	CHAR	PaperName[32];		// y[p[
	SHORT	PrintCenterOffset;	// 呖vgZ^[ʒuItZbgl(0.1mm)
	USHORT	CvpPrintSize;		// CVP󎚕TCY ( 0:, 1:, 2: )
	USHORT	PrintQuality;		// @ ( 0:v^ݒD, 1:W, 2:掿D )
	UCHAR	ImageEnLargeType;	// 摜gASY( 0:oCjA, 1:jAXglCo[ )
	USHORT	LoadingCount;		// [fBOJn		2011.11.1 A.Nagamatsu (D703/WG)
	USHORT	PrintedCount;		// ro				2011.11.1 A.Nagamatsu (D703/WG)
	ULONG	EventId;			// Cxgʎq			2011.11.1 A.Nagamatsu (D703/WG)
	USHORT	EventCodeMain;		// CxgR[hiԁj	2011.11.1 A.Nagamatsu (D703/WG)
} T_Nps6000H_0700H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0701H
//   Contents	 : tJn
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ
	ULONG	ReceiptNumber;	// tԍ
							// v^Ǘ郆j[NȔԍZbg܂

} T_Nps6000H_0701H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0800H
//   Contents	 : 摜MmFv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;	// Lԍ
	ULONG	ReceiptNumber;	// tԍ
							// tJnŃZbgꂽtԍZbg܂

} T_Nps6000H_0800H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0801H
//   Contents	 : 摜MmF
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ
	ULONG	ReceiptNumber;	// tԍ
							// tJnŃZbgꂽtԍZbg܂

} T_Nps6000H_0801H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0900H
//   Contents	 : vgv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	ReceiptNumber;	// tԍ

} T_Nps6000H_0900H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0901H
//   Contents	 : vg
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	ULONG	ReceiptNumber;	// tԍ
							// vg̎vŃZbgtԍZbg܂

} T_Nps6000H_0901H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0A00H
//   Contents	 : v^Cxgv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	EventId;	// Cxgʎq
						// v^CxgʒmŒʒmꂽCxgʎqZbg܂
	UCHAR	ActionId;	// Cxg̃ANV
						// ʒmꂽCxgɑ΂ANVZbg܂

} T_Nps6000H_0A00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0A01H
//   Contents	 : v^Cxg
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;		// 
						// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6000H_0A01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0B00H
//   Contents	 : gCύXv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_0B00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0B01H
//   Contents	 : gCύX
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_0B01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0C00H
//   Contents	 : vg擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_0C00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0C01H
//   Contents	 : vg擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	ReserverCount;	// v^҂
							// v^Ńvg҂ĂvgZbg܂
	USHORT	PrinterCount;	// v^
							// v^ŏ̃vgZbg܂
	USHORT	ProcessorCount;	// vZT[
							// vZbT[ŏ̃vgZbg܂
	ULONG	UsedMemory;		// gpʁ@(PʁFByte)

} T_Nps6000H_0C01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0D00H
//   Contents	 : vg~v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PrintStopStart;	// vg~ƒ~
							// v^̃vg~邩~邩Zbg܂

} T_Nps6000H_0D00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0D01H
//   Contents	 : vg~䉞
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;		// 
						// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6000H_0D01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0E00H
//   Contents	 : ڑJnv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : Y.Yoshinobu	2008.11.06	OEMڑΉ
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	OemCode;	// OEMR[h

} T_Nps6000H_0E00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0E01H
//   Contents	 : ڑJn
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;		// 
						// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	NpsVersion;	// NPS I/F ̃o[W
						// 1Byte W[ԍ
						// 1Byte }Ci[ԍ

} T_Nps6000H_0E01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0F00H
//   Contents	 : uU[v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	WorkingNumber;	// wߔԍ
							// 1F1 sb
							// 2F2 sbsb
							//      F
							// 9F9 sbsbsbEEEEE
							// 16FAJnw
							// 17FA~w

	ULONG	OnTime;			// ON iPʁF10msj
	ULONG	OffTime;		// OFF iPʁF10msj

	ULONG	Volume;			// 
							// 0Fݒl̉ʂŖ炷
							// 1Fʍŏ
							// 2Fʏ
							// 3Fʒ
							// 4Fʑ
							// 5Fʍő

} T_Nps6000H_0F00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_0F01H
//   Contents	 : uU[䉞
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;		// 
						// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6000H_0F01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1000H
//   Contents	 : \v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	WorkingNumber;	// wߔԍ
							// 16F_Jnw
							// 17F_~w

	ULONG	OnTime;			// ON iPʁF10msj
	ULONG	OffTime;		// OFF iPʁF10msj

} T_Nps6000H_1000H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1001H
//   Contents	 : \䉞
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;		// 
						// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6000H_1001H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1100H
//   Contents	 : vt@Cf[^擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PaperWidth;		// y[p[̕ iPʁF0.1mmj
	USHORT	PaperId;		// y[p[ID iʎj í͈F1`4j
	ULONG	DataGetPoint;	// f[^擾Jnʒu iPʁFBytej
							// ŏ0Zbg܂B͎̌擾݌vTCYɉĎ擾JnʒuύX܂
	USHORT	DataSizeMax;	// f[^擾őTCY iPʁFBytej

} T_Nps6000H_1100H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1101H
//   Contents	 : vt@Cf[^擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PaperWidth;			// y[p[̕ iPʁF0.1mmj
	USHORT	PaperId;			// y[p[ID iʎj í͈F1`4j
	ULONG	TotalDataSize;		// Sf[^TCY iPʁFBytej
	ULONG	DataGetPoint;		// f[^擾Jnʒu iPʁFBytej
								// vt@Cf[^擾vŎw肳ꂽAf[^擾Jnʒu̒lZbg܂
	USHORT	DataSize;			// f[^擾TCY iPʁFBytej
	UCHAR	ProfileData[65535];	// v^vt@Cf[^

} T_Nps6000H_1101H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1200H
//   Contents	 : vgIvVݒv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;	// Lԍ
	USHORT	SorterNum;		// vg̎d

} T_Nps6000H_1200H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1201H
//   Contents	 : vgIvVݒ艞
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_1201H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1300H
//   Contents	 : gp\y[p[̎擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_1300H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1301H
//   Contents	 : gp\y[p[̎擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;						// 
	USHORT	NumberOfPaper;				// 擾y[p[ڍ׏̐
	USHORT	PaperWidth[1024];			// y[p[̕ iPʁF0.1mmj
	USHORT	PaperLengthMin[1024];		// y[p[̑蒷̍ŏl iPʁF0.1mmj
	USHORT	PaperLengthMax[1024];		// y[p[̑蒷̍ől iPʁF0.1mmj
	USHORT	PaperId[1024];				// y[p[ID iʎj í͈jF1`4
	USHORT	PaperResolution[1024][8];	// ͉𑜓x iPʁF0.1dpij
	SHORT	PaperAllocationTop[1024];	// t㕔 iPʁF0.1mmj
	SHORT	PaperAllocationBottom[1024];// t iPʁF0.1mmj
	SHORT	PaperAllocationLeft[1024];	// t iPʁF0.1mmj
	SHORT	PaperAllocationRight[1024];	// tE iPʁF0.1mmj
	USHORT	SetupStatus[1024];			// ZbgAbv
	UCHAR	PaperFeed[1024];			// @
	USHORT	PaperTypeCode[1024];		// y[p[^CvR[h
	UCHAR	PaperKind[1024];			// y[p[ʎ
	UCHAR	MagazineID[1024];			// }KWID
	SHORT	WBAdjustLeft[1024];			// WB␳l iPʁF0.1mmj
	SHORT	WBAdjustRight[1024];		// WB␳lE iPʁF0.1mmj
	CHAR	PaperName[1024][32];		// y[p[
	UCHAR	PaperType[1024];			// y[p[^Cvi܎j
	UCHAR	Direction[1024];			// fBNV
	UCHAR	PrintQuality[1024];			// i
	USHORT	DoubleSidedPaper[1024];		// ʃy[p[
	USHORT	PaperInfo[1024];			// y[p[
	UCHAR	PaperTypeValid[1024];		// y[p[^CvuL/v		(2011.8.4 A.Nagamatsu)

} T_Nps6000H_1301H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1500H
//   Contents	 : ڑmF
//   Inheritance : 
//   Author/Date : Y.yoshinobu 2006.12.21
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_1500H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1501H
//   Contents	 : ڑmF
//   Inheritance : 
//   Author/Date : Y.yoshinobu 2006.12.21
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6000H_1501H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1600H
//   Contents	 : ʈJnv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2008.5.16
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_1600H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1601H
//   Contents	 : ʈJn
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.5.16
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_1601H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1700H
//   Contents	 : ʈIv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2008.5.16
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_1700H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1701H
//   Contents	 : ʈI
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.5.16
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_1701H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1800H
//   Contents	 : 󔒃vgv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2008.5.16
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ
	USHORT	PaperResolution;	// ͉𑜓x iPʁF0.1dpij
	USHORT	PaperWidth; 		// y[p[̕ iPʁF0.1mmj
	USHORT	PaperLength;		// y[p[̑蒷 iPʁF0.1mmj
	USHORT	PaperID;			// y[p[ID
	USHORT	Repeat;				// s[g
								// 1[v^ݒ̎擾]Ŏ擾[ő僊s[g]͈̔͂ŃZbgĉ
	USHORT	PaperFeed;			// @
	USHORT	Laminator;			// ~l[g
	UCHAR	PaperPresence;		// Uy[p[w
								// AB̃}KWɓy[p[ĂꍇɁAǂ̃}KW̃y[p[Ńvgsw肵܂
	ULONG	OrderId;			// I[_[ʔԍ
	CHAR	PaperName[32];		// y[p[
	USHORT	ClearInk;			// NACN i 0:łȂ, 1:ł j
	USHORT	PrintQuality;		// @ ( 0:v^ݒD, 1:W, 2:掿D )
	USHORT	LoadingCount;		// [fBOJn		2011.11.18 A.Nagamatsu (D703/WG)
	USHORT	PrintedCount;		// ro				2011.11.18 A.Nagamatsu (D703/WG)
	ULONG	EventId;			// Cxgʎq			2011.11.18 A.Nagamatsu (D703/WG)
	USHORT	EventCodeMain;		// CxgR[hiԁj	2011.11.18 A.Nagamatsu (D703/WG)

} T_Nps6000H_1800H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1801H
//   Contents	 : 󔒃vg
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.5.16
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;	// Lԍ
	ULONG	ReceiptNumber;	// tԍ
							// v^Ǘ郆j[NȔԍZbg܂

} T_Nps6000H_1801H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1900H
//   Contents	 : I[_[
//   Inheritance : 
//   Author/Date : T.Mizushima	2012.04.12		@@@RD-151Ή
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_1900H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_1901H
//   Contents	 : I[_[
//   Inheritance : 
//   Author/Date : T.Mizushima	2012.04.12		@@@RD-151Ή
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
	USHORT	PossessionNo;	// Lԍ

} T_Nps6000H_1901H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_F102H
//   Contents	 : v^ԕύXʒm
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	UCHAR	PrinterStatus;			// v^Ŝ̏ iv^S̏ԁj
	UCHAR	AcceptStatus;			// t
	UCHAR	PrinterPossession;		// v^L̏
	UCHAR	MagagineChange;			// }KW̑^
	UCHAR	AdvanceStatus;			// v^Ŝ̏ inŚj
	UCHAR	LaserStatus;			// w[U[̏ iw[U[j
	UCHAR	DevelopmentStatus;		// vZT[Ŝ̏ inŚj
	UCHAR	ProcessorStatus;		// ̏ ij
	UCHAR	ReplenisherStatus;		// [Ŝ̏ i[j
	UCHAR	ReplaceCartridgeStatus;	// [J[gbW̌̉ i[J[gbWj
	UCHAR	PaperInfoChange;		// Sy[p[̏
	UCHAR	StartUpChecksStatus;	// nƓ_̎{
	UCHAR	RefillWaterStatus;		// I[gZbgAbvł̕␅̎{
	UCHAR	DailySetupStatus;		// I[gZbgAbvł̃fC[ZbgAbv̎{
	UCHAR	ControlStripStatus;		// I[gZbgAbvł̃Rg[Xgbv̎{
	UCHAR	InMaintenance;			// eiX
	UCHAR	FadStatus;				// FAD̏

} T_Nps6000H_F102H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_F202H
//   Contents	 : v^Cxgʒm
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	EventCode;			// CxgR[h iԁj
	UCHAR	EventStatus;		// Cxg̔E
	USHORT	OccurredTime[8];	// 
								// z[0] N
								// z[1] 
								// z[2] 
								// z[3] 
								// z[4] 
								// z[5] b
								// z[6] ~b
								// z[7] j
	LONG	EventParam[4];		// Cxg̃p[^ ilj
								// CxgR[hv^񋟂G[e[ut@CibZ[Wꗗj
								// YG[bZ[WɊ܂܂""%NUM%""ƒu邽߂̒lZbg܂
								// bZ[W̒ɒup[^ꍇɂ͕Zbg܂
	ULONG	EventId;			// Cxgʎq
								// v^CxgvŃCxg̉sۂ̎ʎqZbg܂B
								// Cxgʎq́Av^ŔĂCxgj[NȔԍŊǗĉłȂ΂Ȃ܂
	CHAR	EventString[4][32];	// ͂ߍݕ

} T_Nps6000H_F202H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_F302H
//   Contents	 : vg󋵒ʒm
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	ReceiptNumber;		// tԍ
								// tJnŃZbgꂽtԍZbg܂

	UCHAR	PrintStatus;		// vg
								// 1FvgJn
								// 2FvgiIj
								// 3Fvgro
								// 4Fvgs
								// 5Fvg荞ݒfiĊJ҂j => [1F荞ݒf̍ĊJ]ŐLĊJ
								// 6Fvg荞ݒfiĊJ҂j => [0Fʏ]ŐLĊJ
								// 7FvgLZ
								// 8Fvg
								// 9Ft[NA			2011.11.1 A.Nagamatsu RgR
								// 10F[fBOJn				2011.11.1 A.Nagamatsu (D703/WG)

	USHORT	RepeatCount;		// s[g

} T_Nps6000H_F302H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_F502H
//   Contents	 : ㏈sʒm
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.11.28
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	FunctionCode;		// @\ʃR[h
								// 0:㏈Ȃ
								// 1:nƓ_
								// 2:IƓ_
								// 3:eiX
								// 4:v^[(ԕ\)
								// 5:o͋@o^
								// 6:܃io[ύX
								// 98:fC[ZbgAbv
								// 99:o[WAbv
	LONG	Parameter1;			// ėpp[^
								// @\ʃR[h[6:܃io[ύX]̏ꍇF}KWID
} T_Nps6000H_F502H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6000H_FFFFH
//   Contents	 : R}hT|[gʒm
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	InterfaceId;	// C^[tFCXID
	USHORT	CommandId;		// R}hID

} T_Nps6000H_FFFFH;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0100H
//   Contents	 : XVv
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PrinterTime[8];	// 
							// z[0] N
							// z[1] 
							// z[2] 
							// z[3] 
							// z[4] 
							// z[5] b
							// z[6] ~b
							// z[7] j

} T_Nps6001H_0100H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0101H
//   Contents	 : XV
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;		// 
						// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6001H_0101H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0200H
//   Contents	 : v^_v擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6001H_0200H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0201H
//   Contents	 : v^_v擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;			// 
							// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	NumberOfData;	// v^_vf[^̐
	USHORT	DumpId;			// v^_vf[^ID
	CHAR	DumpName[32];	// v^_vf[^̖O
							// v^_vf[^ƂāAt@Cɕۑ鎞̃t@CɎgp܂

} T_Nps6001H_0201H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0300H
//   Contents	 : v^_vf[^擾v
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	DumpId;			// v^_vf[^ID
	ULONG	DataGetPoint;	// f[^擾Jnʒu iPʁFBytej
							// ŏ0Zbg܂B͎̌擾݌vTCYɉĎ擾JnʒuύX܂
	USHORT	DataSizeMax;	// f[^擾őTCY iPʁFBytej

} T_Nps6001H_0300H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0301H
//   Contents	 : v^_vf[^擾
//   Inheritance : 
//   Author/Date : T.Isogai	2006.07.05
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	DumpId;				// v^_vf[^ID
	ULONG	TotalDataSize;		// Sf[^TCY iPʁFBytej
	ULONG	DataGetPoint;		// f[^擾Jnʒu iPʁFBytej
	USHORT	DataSize;			// f[^擾TCY iPʁFBytej
	UCHAR	DumpData[65535];	// v^_vf[^

} T_Nps6001H_0301H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0700H
//   Contents	 : ^[Qbg擾v
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.12.06
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6001H_0700H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0701H
//   Contents	 : ^[Qbg擾
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.12.06
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	UCHAR	RegionCode;			// nR[h
								// 0:{
								// 1:Wipj
								// 2:k
								// 3:[bp
	USHORT	NumberOfTarget;		// 擾^[Qbg̐
	FLOAT	MeasureColor[6][192];// v^[vt@CZiFlj
								// z[0]  ` [63]   Ll
								// z[64] ` [127]  Al
								// z[128] ` [191] Bl
	UCHAR	PaperType[6];		// y[p[^Cv i܎j
	USHORT	PaperTypeCode[6];	// ^[Qbgf[^iy[p[^CvR[hj
	FLOAT	TargetValue[6][60];	// ^[Qbgf[^iڕWlj
								// z[0]  ` [19]  Redl
								// z[20] ` [39] Greenl
								// z[40] ` [59] Bluel
	FLOAT	DMaxControl[6][3];	// ^[Qbgf[^iRg[lj
								// z[0] Redl
								// z[1] Greenl
								// z[2] Bluel
	CHAR	TypeName[6][26];	// ޖ

} T_Nps6001H_0701H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0800H
//   Contents	 : ^[Qbgf[^XVv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.12.06
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	UCHAR	PaperType;			// y[p[^Cv i܎j
	USHORT	PaperTypeCode;		// y[p[^CvR[h
	FLOAT	TargetValue[60];	// ^[Qbgf[^iڕWlj
								// z[0]  ` [19]  Redl
								// z[20] ` [39] Greenl
								// z[40] ` [59] Bluel"
	FLOAT	DMaxControl[3];		// ^[Qbgf[^iRg[lj
								// z[0] Redl
								// z[1] Greenl
								// z[2] Bluel"
	CHAR	TypeName[26];		// ޖ

} T_Nps6001H_0800H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0801H
//   Contents	 : ^[Qbgf[^XV
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.12.06
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6001H_0801H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0900H
//   Contents	 : vt@Co[WXVv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.12.06
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	UCHAR	MachinProfileVersion[7];// vt@Co[W

} T_Nps6001H_0900H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0901H
//   Contents	 : vt@Co[WXV
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.12.06
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6001H_0901H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0A00H
//   Contents	 : FADgpJnv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2008.12.24
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ
	CHAR	OrderKey[128];		// I[_[ʎq
	USHORT	PrintOut;			// vgro
								//   0: ʏgC֔roitoj
								//   1: FAD֔ro(FADɂăXbg[I]ʃXgbJ[̔ro𔻒f)
								//   2: ֔ro
	ULONG	TotalDataSize;		// Sf[^TCY iPʁFBytej
	ULONG	DataGetPoint;		// f[^MJnʒu iPʁFBytej
	USHORT	DataSize;			// f[^MTCY iPʁFBytej
	UCHAR	FadData[60000];		// FADf[^

} T_Nps6001H_0A00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0A01H
//   Contents	 : FADgpJn
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2006.12.24
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	ULONG	FadResult;			// FAD( Result43ȊȌꍇ͖gpł )
	USHORT	PossessionNo;		// Lԍ
	ULONG	DataGetPoint;		// f[^MJnʒu iPʁFBytej
	USHORT	DataSize;			// f[^MTCY iPʁFBytej

} T_Nps6001H_0A01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0B00H
//   Contents	 : vgJnv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2009.03.23
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6001H_0B00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0B01H
//   Contents	 : vgJn
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2009.03.23
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

} T_Nps6001H_0B01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0C00H
//   Contents	 : đJn
//   Inheritance : 
//   Author/Date : A.Nagamatsu 201.11.02
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ
	USHORT	OrderState;			// f̃I[_[
								// 0ijZbgꂽꍇ́A̍ڂ̓Zbg܂
	USHORT	MainSideState;		// ʃvg̕\ʊJnm点
	USHORT	BackSideState;		// ʃvg̗ʊJnm点
	USHORT	PrintSide;			// ʃvg̃vg

} T_Nps6001H_0C00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0C01H
//   Contents	 : đJn
//   Inheritance : 
//   Author/Date : A.Nagamatsu 201.11.02
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_0C01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0D00H
//   Contents	 : đI
//   Inheritance : 
//   Author/Date : A.Nagamatsu 201.11.02
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_0D00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0D01H
//   Contents	 : đI
//   Inheritance : 
//   Author/Date : A.Nagamatsu 201.11.02
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂

	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_0D01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0E00H
//   Contents	 : fLZ
//   Inheritance : 
//   Author/Date : A.Nagamatsu 201.11.02
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_0E00H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_0E01H
//   Contents	 : fLZ
//   Inheritance : 
//   Author/Date : A.Nagamatsu 201.11.02
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	OrderState;			// f̃I[_[
								// 0ijZbgꂽꍇ́A̍ڂ̓Zbg܂
	USHORT	MainSideState;		// ʃvg̕\ʊJnm点
	USHORT	BackSideState;		// ʃvg̗ʊJnm点
	USHORT	PrintSide;			// ʃvg̃vg

} T_Nps6001H_0E01H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_B006H
//   Contents	 : NWbgJnv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2007.02.20
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_B006H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_B007H
//   Contents	 : NWbgJn
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2007.02.20
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_B007H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_B008H
//   Contents	 : NWbgIv
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2007.02.20
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_B008H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_B009H
//   Contents	 : NWbgI
//   Inheritance : 
//   Author/Date : Y.Yoshinobu 2007.02.20
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	PossessionNo;		// Lԍ

} T_Nps6001H_B009H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6001H_F102H
//   Contents	 : v^Cxggʒm
//   Inheritance : 
//   Author/Date : A.Nagamatsu 201.11.02
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	ULONG	ReceiptNumber;		// tԍ
								// tJnŃZbgꂽtԍZbg܂

	ULONG	EventId;			// Cxgʎq
	USHORT	EventCodeMain;		// CxgR[hiԁj

} T_Nps6001H_F102H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6002H_7300H
//   Contents	 : [hύXv
//   Inheritance : 
//   Author/Date : T.Mizushima	2007.03.07
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	TargetCpu;			// ΏCPU (Œl:0xFFFF)
	USHORT	Mode;				// [h (4:[h)

} T_Nps6002H_7300H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6002H_7301H
//   Contents	 : [hύX
//   Inheritance : 
//   Author/Date : T.Mizushima	2007.03.07
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 

} T_Nps6002H_7301H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6002H_7304H
//   Contents	 : o[WmFv
//   Inheritance : 
//   Author/Date : T.Mizushima	2006.11.29
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6002H_7304H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6002H_7305H
//   Contents	 : o[WmF
//   Inheritance : 
//   Author/Date : T.Mizushima	2006.11.29
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	UCHAR	ptMainIF[2][20];	// v^I/F
	UCHAR	printerCtrl1[2][20];// v^Rg[ ()
	UCHAR	laserCtrl[2][20];	// [U[Rg[
	UCHAR	procCtrl[2][20];	// vZTRg[
	UCHAR	printerCtrl2[2][20];// v^Rg[ () QSS-37̂
	UCHAR	ptMainIF640[2][20];	// v^I/F (640dpiΉ@p)
	UCHAR	laserCtrl640[2][20];// [U[Rg[ (640dpiΉ@p)
} T_Nps6002H_7305H;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6002H_732AH
//   Contents	 : @Bdl擾
//   Inheritance : 
//   Author/Date : Y.Yoshinobu	2008.01.23
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{

} T_Nps6002H_732AH;

//////////////////////////////////////////////////////////////////////////////
//   Struct Name : T_Nps6002H_732BH
//   Contents	 : @Bdl擾
//   Inheritance : 
//   Author/Date : Y.Yoshinobu	2008.01.23
//   Update/Date : 
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	USHORT	Result;				// 
								// 0ȊOZbgꂽꍇɂ́A̍ڂ̓Zbg܂
	USHORT	MachineSubInfo;		// Tu@B
} T_Nps6002H_732BH;

#endif	// __NPSCOMMAND_H__