// NpsGetIPAddr.h: CNpsGetIPAddr NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#ifndef NPS_GET_IP_ADDR_H
#define NPS_GET_IP_ADDR_H

#include <iphlpapi.h>
#include "NpsCommand.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
// ֐`

// M̃Xbh̃Gg
unsigned int WINAPI NpsGetIPAddrEntry( LPVOID pParam );

//////////////////////////////////////////////////////////////////////
// NX`

class CNpsGetIPAddr  
{
public:
	static	DWORD	GetRealIPAddress( UCHAR MacAddress[], DWORD dwWaitTime );
	static	DWORD	GetLocalIPAddress( UCHAR MacAddress[] );

	explicit	CNpsGetIPAddr( const UCHAR MacAddress[] );
	virtual		~CNpsGetIPAddr();
	BOOL		SendCmd();
	BOOL		AnalyzePacket( LPBYTE lpBuffer, DWORD dwHostAddress );
	BOOL		ReadCmdHdr( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId );
	DWORD		GetIPAddress(){ return m_dwIPAddress; }

	//----------------------------------------------------------------------------
	// ֌W
	//----------------------------------------------------------------------------

	void	ThreadEnd();									// MXbhIv

	//----------------------------------------------------------------------------
	// MXbh֌W
	//----------------------------------------------------------------------------

	BOOL	ThreadInitInstance();							// MXbhJn

	void	ThreadExecProc();								// MXbh

	void	ThreadExitInstance();							// MXbhI


protected:
	CRITICAL_SECTION	m_csLock;
	SOCKET				m_Socket;							// Mp\Pbg
	DWORD				m_dwInAddr;							// PCIPAhX
	DWORD				m_dwIPAddress;						// zXg̎IPAhX
	UCHAR				m_ucMacAddress[6];					// zXgMACAhX

};

#endif // NPS_GET_IP_ADDR_H
