//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsImg.cpp
//	ABSTRACT  : CNpsImg NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.8.4
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsImg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsImg::CNpsImg()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.4
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsImg::CNpsImg()
{
	m_PortNo	= 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsImg::~CNpsImg()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.4
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsImg::~CNpsImg()
{
	Close();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::Open()
//	ABSTRACT : 摜Mp\PbgI[v Bind܂
//	FUNCTION : 摜Mp\PbgI[v Bind܂
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				TRUE	: 
//				FALSE	: s
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : Y.Yoshinobu	2008.02.19	|[gԍw肵
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsImg::Open( LPCTSTR lpszHostAddress, USHORT wImgPortNo, USHORT nPortNo )
{
	m_strHostAddress	= lpszHostAddress;
	m_wImgPortNo		= wImgPortNo;

	if( TRUE == IsOpenSocket() )
	{	
		// OpenĂ
		{	// Oo
			NPS_LOGOUT_FATAL( "===NPSIMG SOCKET ALREADY OPEN" );
		}
		return FALSE;
	}

	if( FALSE == Create() )
	{
		{	// Oo
			NPS_LOGOUT_FATAL( "===NPSIMG CREATE BLOCK FAIL" );
		}
		return FALSE;
	}

	// |[gԍ̍Ďgpݒ	2007.01.11 T.Mizushima
	SetReUsePort();

	// nPortNo  0 ̏ꍇ́A󂢂Ă|[gԍŊU
	// nPortNo w肳Ăꍇ́Aw肳ꂽ|[gԍ蓖Ă
	if( FALSE == Bind( nPortNo ) )
	{
		{	// Oo
			NPS_LOGOUT_FATAL( "===NPSIMG BIND FAIL" );
		}
		return FALSE;
	}

	m_PortNo = GetSocketPortNo();

	// >>> _7462Ή 2008.01.19 Yoshinobu
	// WinSockł̓ɂʐM̖Ή邽߂
	// \PbgIvVύX

	// NagleASY𖳌ɂ܂
	if ( TRUE == SetNoDelay( TRUE ) )
	{
		NPS_LOGOUT( "---SetNoDelay( TRUE ) SUCCESS" );
	}
	else
	{
		NPS_LOGOUT( "---SetNoDelay( TRUE ) FAIL" );
	}

	// Mobt@TCY0ɂ܂
	if ( TRUE == SetSendBufSize( 0 ) )
	{
		NPS_LOGOUT( "---SetSendBufSize( 0 ) SUCCESS" );
	}
	else
	{
		NPS_LOGOUT( "---SetSendBufSize( 0 ) FAIL" );
	}

	// <<< _7462Ή 2008.01.19 Yoshinobu

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::Connect()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				1:
//				2:ConnectɎs
//	
//	CREATE	 : T.Isogai	2006.9.19
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsImg::Connect()
{
	if( !CWS2Tcp2::Connect( m_strHostAddress, m_wImgPortNo ) )
	{
		{	// Oo
			CString str;
			str.Format( "===NPSIMG CONNECT FAIL ( %s, %d ) = %d", m_strHostAddress, m_wImgPortNo, GetLastError() );
			NPS_LOGOUT_FATAL( str );
		}
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::Close()
//	ABSTRACT : 摜Mp\PbgN[Y
//	FUNCTION : 摜Mp\PbgN[Y
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsImg::Close()
{
	BOOL bResult = TRUE;

	if( !CWS2Tcp2::Close() )
	{
		{
			CString	str;
			str.Format( "CNpsImg::Close() failed : WSAGetLastError()=%d", CWS2Tcp2::GetLastError() );
			NPS_LOGOUT_WARN( str );
		}
		bResult = FALSE;
	}

	m_PortNo = 0;

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::SendImageDataByMMF()
//	ABSTRACT : 摜f[^MiLnj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           DWORD    dwTransDataLength  摜̑MTCYiPʁFBytej
//	           DWORD    dwDataLength       摜f[^̃oCgTCYiPʁFBytej
//	           DWORD    dwOffset           摜f[^̊i[ĂItZbg
//	           LPCSTR   pName              t@C
//	           E_SendFunc eSendFunc        摜M
//	
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsImg::SendImageDataByMMF( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pName, E_SendFunc eSendFunc, LPDWORD lpdwTransmitTime )
{
	if ( FUNC_BMP2RAW == eSendFunc )
	{
		return SendRawByMmf( dwTransDataLength, dwDataLength, dwOffset, pName, lpdwTransmitTime );
	}

	DWORD dwStartTime;
	DWORD dwEndTime;

	{	// Oo
		NPS_LOGOUT( "---SendImageDataByMMF start" );
	}

	// ϐ̏
	*lpdwTransmitTime = 0;

	dwStartTime = GetTickCount();

	//////////////////////////////////////////////////////////////////////////////
	// f[^M 摜f[^
	long nResult=0;
	HANDLE	hFileMap;
	LPVOID	mapView;
	DWORD	dwAllocationGranularity;
	ULONG	SendSizeCount;
	ULONG	SendSize;

	// dwAllocationGranularity擾
	SYSTEM_INFO info;
	::GetSystemInfo( &info );
	dwAllocationGranularity = info.dwAllocationGranularity;

	// }bvnh擾
	hFileMap	= OpenFileMapping( FILE_MAP_READ, FALSE, pName );

	if( NULL == hFileMap )
	{
		NPS_LOGOUT_FATAL( "fail OpenFileMapping" );
		return 2;
	}

	SendSizeCount	= 0;

	while( 1 )
	{
		if( ( SendSizeCount + NPS_IMAGEDATASENDBYTE ) > dwDataLength )
		{
			SendSize	= dwDataLength - SendSizeCount;
		}
		else
		{
			SendSize	= NPS_IMAGEDATASENDBYTE;
		}

		// MapViewOfFiles߂̌vZ
		DWORD	dwDataOffset;
		DWORD	dwBytes;
		DWORD	dwMyOffset;

		dwDataOffset	= ( ( SendSizeCount + dwOffset ) / dwAllocationGranularity ) * dwAllocationGranularity;
		dwMyOffset		= ( SendSizeCount + dwOffset ) - dwDataOffset;
		dwBytes			= SendSize + dwMyOffset;

		// MapViewOfFile
		mapView	= MapViewOfFile( hFileMap, FILE_MAP_READ, 0, dwDataOffset, dwBytes );

		if( NULL == mapView )
		{
			NPS_LOGOUT_FATAL( "fail read image file" );
			nResult = 2;
			break;
		}

		// ]
		if( !Send( (void *) ( (BYTE*) mapView + dwMyOffset ), SendSize  ) )
		{
			UnmapViewOfFile( mapView );
			NPS_LOGOUT_FATAL( "fail Send" );
			nResult = 1;
			break;
		}

		UnmapViewOfFile( mapView );

		SendSizeCount	+= SendSize;

		if( SendSizeCount >= dwDataLength )
		{
			break;
		}
	}
			
	CloseHandle( hFileMap );

	// ]Ԃ̌vZ
	dwEndTime = GetTickCount();
	*lpdwTransmitTime = ( dwStartTime <= dwEndTime ) ? ( dwEndTime - dwStartTime ): ( dwEndTime + (0xFFFFFFFF - dwStartTime) );

	{	// Oo
		CString	str;
		str.Format( "---SendImageDataByMMF end ( %d mm second )", *lpdwTransmitTime );
		NPS_LOGOUT( str );
	}

	return nResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::SendImageDataByFile()
//	ABSTRACT : 摜f[^Mit@Cnj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           DWORD    dwTransDataLength  摜̑MTCYiPʁFBytej
//	           DWORD    dwDataLength       摜f[^̃oCgTCYiPʁFBytej
//	           DWORD    dwOffset           摜f[^̊i[ĂItZbg
//	           LPCSTR   pName              t@C
//	           E_SendFunc eSendFunc        摜M
//	
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : Y.Yoshinobu	2007.03.02
//	UPDATE   : N.Nakashima	2007.11.12	摜]ԂOo͂
//////////////////////////////////////////////////////////////////////////////
long CNpsImg::SendImageDataByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwWidth, DWORD dwHeight, DWORD dwOffset, LPCSTR pName, E_SendFunc eSendFunc, LPDWORD lpdwTransmitTime )
{

	if ( FUNC_BMP2RAW == eSendFunc )
	{
		return SendRawByFile( dwTransDataLength, dwDataLength, dwOffset, pName, lpdwTransmitTime );
	} else if ( FUNC_RAW2BMP == eSendFunc )
	{
		return SendBmpByFile( dwTransDataLength, dwDataLength, dwWidth, dwHeight, dwOffset, pName, lpdwTransmitTime );
	}

	//----------------------------------------
	// f[^M 摜f[^
	//----------------------------------------
	long nResult=0;
	FILE* fp;
	ULONG nSendSizeCount;
	ULONG nSendSize;
	DWORD dwStartTime;
	DWORD dwEndTime;
	DWORD dwSendStartTime	= 0;
	DWORD dwSendEndTime		= 0;
	DWORD dwSendTotalTime	= 0;
	BOOL  bRet				= FALSE;
	BYTE* pBuffer;

	{	// Oo
		CString	str;
		str.Format( "---SendImageDataByFile start ( %s )", pName );
		NPS_LOGOUT( str );
	}

	// ϐ̏
	*lpdwTransmitTime = 0;

	dwStartTime = GetTickCount();

	// t@C̃I[v
	fp = fopen( pName, "rb" );
	if ( NULL == fp )
	{
		CString str;
		str.Format( "===File open error. %s", pName );
		NPS_LOGOUT_FATAL( str );

		return 2;
	}

	// t@C|C^̈ړ
	if ( 0 != fseek( fp, dwOffset, SEEK_SET ) )
	{
		NPS_LOGOUT_FATAL( "===File seek error." );
		::fclose( fp );
		return 2;
	}

	// ǂݍݗ̈̍쐬
	try
	{
		pBuffer = new BYTE[ NPS_IMAGEDATASENDBYTE ];
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			TCHAR szCause[255];
			e->GetErrorMessage( szCause, 255 );
			str.Format( "===Memory allocation error [%d] ( %s )", NPS_IMAGEDATASENDBYTE, szCause );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		::fclose( fp );
		return 2;
	}

	// t@C]
	nSendSize = 0;
	nSendSizeCount = 0;
	while ( TRUE )
	{

		if( ( nSendSizeCount + NPS_IMAGEDATASENDBYTE ) > dwDataLength )
		{
			nSendSize = dwDataLength - nSendSizeCount;
		}
		else
		{
			nSendSize = NPS_IMAGEDATASENDBYTE;
		}

		// 摜̓ǂݍ
		if ( nSendSize != fread( pBuffer, sizeof(BYTE), nSendSize, fp ) )
		{
			NPS_LOGOUT_FATAL( "===File read error." );
			nResult = 2;
			break;
		}

		// 摜MJn 擾
		dwSendStartTime	= GetTickCount();

		// 摜M
		bRet = Send( (void *) pBuffer, nSendSize );

		// 摜MI 擾
		dwSendEndTime	= GetTickCount();

		// MԎZo
		dwSendTotalTime	+= ( dwSendStartTime <= dwSendEndTime ) ? ( dwSendEndTime - dwSendStartTime ) : ( dwSendEndTime + ( 0xFFFFFFFF - dwSendStartTime ) );

		if( !bRet )
		{	// 摜Ms
			NPS_LOGOUT_FATAL( "===Send Image error." );
			nResult = 1;
			break;
		}

		nSendSizeCount += nSendSize;

		if( nSendSizeCount >= dwDataLength )
		{
			break;
		}

	}

	// ǂݍݗ̈̊J
	delete [] pBuffer;

	// t@C̃N[Y
	::fclose( fp );

	// ]Ԃ̌vZ
	dwEndTime = GetTickCount();
	*lpdwTransmitTime = ( dwStartTime <= dwEndTime ) ? ( dwEndTime - dwStartTime ): ( dwEndTime + (0xFFFFFFFF - dwStartTime) );

	{	// Oo
		CString	str;
		str.Format( "---SendImageDataByFile end ( Total:%d [ms], Send:%d [ms] )", *lpdwTransmitTime, dwSendTotalTime );
		NPS_LOGOUT( str );
	}

	return nResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::SendCRCDataByFile()
//	ABSTRACT : CRCf[^Mit@Cnj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             摜]Ԃv邽߂Ƀ\PbgIvVύXđM
//             - Mobt@0Byteɂ
//             - NagleASY𖳌ɂ
//	
//	ARGUMENT : 
//	           DWORD    dwTransDataLength  摜̑MTCYiPʁFBytej
//	           DWORD    dwDataLength       摜f[^̃oCgTCYiPʁFBytej
//	           DWORD    dwOffset           摜f[^̊i[ĂItZbg
//	           LPCSTR   pName              CRCf[^̃t@C
//	           BOOL     lpdwTransmitTime   摜]
//	
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : Y.Yoshinobu 2007.03.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsImg::SendCRCDataByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pName, LPDWORD lpdwTransmitTime )
{
	//----------------------------------------
	// f[^M CRCf[^
	//----------------------------------------
	long nResult=0;
	FILE* fp;
	DWORD dwStartTime;					// vJn
	DWORD dwEndTime;					// vI
	DWORD dwFileSize;					// CRCf[^̃t@CTCY
	DWORD dwFileSizeReadEnd;			// CRCf[^̃t@CTCY
	DWORD dwSendEndSize;				// MIoCg
	DWORD dwSendSize;					// ɑMoCg
	BYTE* pBuffer;						// CRCf[^ǂݍރ̈
	CString strLog;

	{	// Oo
		CString	str;
		str.Format( "---SendCRCDataByFile start ( %s )", pName );
		NPS_LOGOUT( str );
	}

	// ϐ̏
	*lpdwTransmitTime = 0;

	dwFileSize = NkcComApi::GetFileSize( pName );

	// t@C̃I[v
	fp = fopen( pName, "rb" );
	if ( NULL == fp )
	{
		CString str;
		str.Format( "===File open error. %s", pName );
		NPS_LOGOUT_FATAL( str );

		return 2;
	}

	// t@C|C^̈ړ
	if ( 0 != fseek( fp, dwOffset, SEEK_SET ) )
	{
		NPS_LOGOUT_FATAL( "===File seek error." );
		::fclose( fp );
		return 2;
	}

	// ǂݍݗ̈̍쐬
	try
	{
		pBuffer = new BYTE[ dwFileSize ];
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			TCHAR szCause[255];
			e->GetErrorMessage( szCause, 255 );
			str.Format( "===Memory allocation error [%d] ( %s )", dwFileSize, szCause );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		::fclose( fp );
		return 2;
	}

	// 摜̓ǂݍ
	if ( dwFileSize != fread( pBuffer, sizeof(BYTE), dwFileSize, fp ) )
	{
		::fclose( fp );
		delete [] pBuffer;
		NPS_LOGOUT_FATAL( "===File read error." );
		return 2;
	}

	// t@C̃N[Y
	::fclose( fp );

	dwStartTime = GetTickCount();

	// t@C]
	for ( dwFileSizeReadEnd=0, dwSendEndSize=0, dwSendSize=0 ; dwTransDataLength > dwSendEndSize ; dwFileSizeReadEnd += dwSendSize, dwSendEndSize += dwSendSize )
	{
		dwSendSize = ( NPS_IMAGEDATASENDBYTE < (dwTransDataLength - dwSendEndSize) ) ? NPS_IMAGEDATASENDBYTE : (dwTransDataLength - dwSendEndSize) ;

		if ( dwSendSize > (dwFileSize - dwFileSizeReadEnd) )
		{
			dwSendSize = (dwFileSize - dwFileSizeReadEnd);
			dwFileSizeReadEnd = 0;
		}

		// 摜M
		if ( !Send( (void *) (pBuffer + dwFileSizeReadEnd), dwSendSize  ) )
		{
			strLog.Format( "===Send Image error. (%d)", dwSendSize );
			NPS_LOGOUT_FATAL( strLog );
			nResult = 1;
			break;
		}
	}

	dwEndTime = GetTickCount();

	// ǂݍݗ̈̊J
	delete [] pBuffer;

	// ]Ԃ̌vZ
	*lpdwTransmitTime = ( dwStartTime <= dwEndTime ) ? ( dwEndTime - dwStartTime ): ( dwEndTime + (0xFFFFFFFF - dwStartTime) );

	{	// Oo
		CString	str;
		str.Format( "---SendCRCDataByFile end ( %d mm second )", *lpdwTransmitTime );
		NPS_LOGOUT( str );
	}

	return nResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::SendRawByFile()
//	ABSTRACT : BMP -> RAW ϊĉ摜f[^Mit@Cnj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           DWORD    dwTransDataLength  摜̑MTCYiPʁFBytej
//	           DWORD    dwDataLength       摜f[^̃oCgTCYiPʁFBytej
//	           DWORD    dwOffset           摜f[^̊i[ĂItZbg
//	           LPCSTR   pFileName          t@C
//	
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : S.Heya 2007.03.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsImg::SendRawByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pFileName, LPDWORD lpdwTransmitTime )
{
	FILE*	fp = NULL;
	LPBYTE	lpHeader = NULL;
	LPBYTE	lpData = NULL;
	LPBYTE	lpSndData = NULL;

	LPBITMAPINFOHEADER lpbmih;

	long	nHeaderSize;
	long	nBytes;
	long	nWidthBytes;
	long	nLines;
	long	nPages;
	long	nDataSize;
	long	nFirstLines;
	long	nFirstData;

	DWORD	dwStartTime;
	DWORD	dwEndTime;

	long	nRes = 0;
	CString	str;

	{	// Oo
		str.Format("- SendRawByFile - Start - %s", pFileName);
		NPS_LOGOUT(str);
	}

	// ϐ̏
	*lpdwTransmitTime = 0;

	dwStartTime = GetTickCount();

	nHeaderSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	try
	{
		lpData = new BYTE[ NPS_IMAGEDATASENDBYTE ];
		lpSndData = new BYTE[ NPS_IMAGEDATASENDBYTE ];
		lpHeader = new BYTE[nHeaderSize];
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			TCHAR szCause[255];
			e->GetErrorMessage( szCause, 255 );
			str.Format( "- Sending Image - Memory Error ( %s )", szCause );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		nRes = 2;
		goto FINISH;
	}

	fp = fopen(pFileName, "rb");
	if (NULL == fp)
	{
		NPS_LOGOUT_FATAL("- Sending Image - Open Error");
		nRes = 2;
		goto FINISH;
	}

	if (0 != fseek(fp, dwOffset, SEEK_SET))
	{
		NPS_LOGOUT_FATAL("- Sending Image - Seek Error");
		nRes = 2;
		goto FINISH;
	}

	if (nHeaderSize != fread(lpHeader, sizeof(BYTE), nHeaderSize, fp))
	{
		NPS_LOGOUT_FATAL("- Sending Image - Read Error");
		nRes = 2;
		goto FINISH;
	}

	lpbmih = (LPBITMAPINFOHEADER)(lpHeader + sizeof(BITMAPFILEHEADER));

	nBytes = lpbmih->biBitCount / 8;
	nWidthBytes = NkcComApi::DIBWidthBytes((WORD)lpbmih->biWidth, lpbmih->biBitCount);
	nLines = NPS_IMAGEDATASENDBYTE / nWidthBytes;	// C/y[W
	nPages = lpbmih->biHeight / nLines;				// y[W
	nDataSize = nWidthBytes * nLines;				// 1ɓǂݍރoCg
	nFirstLines = lpbmih->biHeight % nLines;
	nFirstData = nFirstLines * nWidthBytes;			// ŏɓǂݍރoCg 

	if (nFirstData)
	{
		if (0 != fseek(fp, nDataSize * nPages + nHeaderSize + dwOffset, SEEK_SET))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Seek Error");
			nRes = 2;
			goto FINISH;
		}

		if (nFirstData != fread(lpData, sizeof(BYTE), nFirstData, fp))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Read Error");
			nRes = 2;
			goto FINISH;
		}

		LPBYTE lpWkData = lpSndData;
		long nSndSize = 0;

		for (nFirstLines--; nFirstLines >= 0; nFirstLines--)
		{
			LPBYTE lpLine = lpData + (nWidthBytes * nFirstLines);

			for (int ii = 0; ii < lpbmih->biWidth; ii++)
			{
				lpWkData[0] = lpLine[2];
				lpWkData[1] = lpLine[1];
				lpWkData[2] = lpLine[0];
				lpLine += nBytes;
				lpWkData += 3;
			}
			nSndSize += ii * 3;
		}

		if (!Send((void*)lpSndData, nSndSize))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Send Error");
			nRes = 1;
			goto FINISH;
		}
	}

	for (nPages--; nPages >= 0; nPages--)
	{
		if (0 != fseek(fp, nDataSize * nPages + nHeaderSize + dwOffset, SEEK_SET))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Seek Error");
			nRes = 2;
			goto FINISH;
		}

		if (nDataSize != fread(lpData, sizeof(BYTE), nDataSize, fp))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Read Error");
			nRes = 2;
			goto FINISH;
		}

		LPBYTE lpWkData = lpSndData;
		long nSndSize = 0;
		long n = nLines;

		for (n--; n >= 0; n--)
		{
			LPBYTE lpLine = lpData + (nWidthBytes * n);

			for (int ii = 0; ii < lpbmih->biWidth; ii++)
			{
				lpWkData[0] = lpLine[2];
				lpWkData[1] = lpLine[1];
				lpWkData[2] = lpLine[0];
				lpLine += nBytes;
				lpWkData += 3;
			}
			nSndSize += ii * 3;
		}

		if (!Send((void*)lpSndData, nSndSize))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Send Error");
			nRes = 1;
			goto FINISH;
		}
	}

	// ]Ԃ̌vZ
	dwEndTime = GetTickCount();
	*lpdwTransmitTime = ( dwStartTime <= dwEndTime ) ? ( dwEndTime - dwStartTime ): ( dwEndTime + (0xFFFFFFFF - dwStartTime) );

	{	// Oo
		str.Format( "- Sending Image - Complet - %d msec", *lpdwTransmitTime );
		NPS_LOGOUT( str );
	}


FINISH:
	if (fp)
		::fclose(fp);
	if (lpHeader)
		delete lpHeader;
	if (lpData)
		delete lpData;
	if (lpSndData)
		delete lpSndData;

	return nRes;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::SendBmpByFile()
//	ABSTRACT : RAW -> BMP ϊĉ摜f[^Mit@Cnj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           DWORD    dwTransDataLength  摜̑MTCYiPʁFBytej
//	           DWORD    dwDataLength       摜f[^̃oCgTCYiPʁFBytej
//	           DWORD    dwOffset           摜f[^̊i[ĂItZbg
//	           LPCSTR   pFileName          t@C
//	
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : Y.Yoshinobu 2008.01.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// 摜f[^M RAW -> BMPit@Cnj
long CNpsImg::SendBmpByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwWidth, DWORD dwHeight, DWORD dwOffset, LPCSTR pFileName, LPDWORD lpdwTransmitTime )
{
	FILE*	fp = NULL;
	LPBYTE	lpHeader = NULL;
	LPBYTE	lpData = NULL;
	LPBYTE	lpSndData = NULL;

	LPBITMAPFILEHEADER lpbmfh;
	LPBITMAPINFOHEADER lpbmih;

	long	nPos;

	long	nHeaderSize;
	long	nWidthBytes;
	long	nLines;
	long	nPages;
	long	nDataSize;
	long	nFirstLines;
	long	nFirstData;

	DWORD	dwStartTime;
	DWORD	dwEndTime;

	long	nRes = 0;
	CString	str;

	{	// Oo
		str.Format("- SendBmpByFile - Start - %s", pFileName);
		NPS_LOGOUT(str);
	}

	// ϐ̏
	*lpdwTransmitTime = 0;

	dwStartTime = GetTickCount();

	nHeaderSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	try
	{
		lpData = new BYTE[ NPS_IMAGEDATASENDBYTE ];
		lpSndData = new BYTE[ NPS_IMAGEDATASENDBYTE ];
		lpHeader = new BYTE[nHeaderSize];
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			TCHAR szCause[255];
			e->GetErrorMessage( szCause, 255 );
			str.Format( "- Sending Image - Memory Error ( %s )", szCause );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		nRes = 2;
		goto FINISH;
	}

	//----------------------------------------
	// BMPwb_[̍쐬ƑM
	//----------------------------------------
	::ZeroMemory( lpHeader, nHeaderSize );
	lpbmfh = (LPBITMAPFILEHEADER)lpHeader;
	lpbmih = (LPBITMAPINFOHEADER)(lpHeader + sizeof(BITMAPFILEHEADER));

	// BITMAPINFOHEADER \
	lpbmih->biSize = sizeof(BITMAPINFOHEADER);
	lpbmih->biWidth = dwWidth;
	lpbmih->biHeight = dwHeight;
	lpbmih->biPlanes = 1;
	lpbmih->biBitCount = 24;
	lpbmih->biCompression = BI_RGB;
	lpbmih->biSizeImage = NkcComApi::DIBWidthBytes( dwWidth, 24 ) * dwHeight;
	lpbmih->biXPelsPerMeter = 0;
	lpbmih->biYPelsPerMeter = 0;
	lpbmih->biClrUsed = 0;
	lpbmih->biClrImportant = 0;

	// BITMAPFILEHEADER \
	lpbmfh->bfType = 'MB';
	lpbmfh->bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbmih->biSizeImage;
	lpbmfh->bfReserved1 = 0;
	lpbmfh->bfReserved2 = 0;
	lpbmfh->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	// wb_[̑M
	if (!Send((void*)lpHeader, nHeaderSize))
	{
		NPS_LOGOUT_FATAL("- Sending Image - Send Error");
		nRes = 1;
		goto FINISH;
	}

	//----------------------------------------
	// f[^̓ǂݍ݂ƑM
	//----------------------------------------
	nWidthBytes = NkcComApi::DIBWidthBytes((WORD)lpbmih->biWidth, lpbmih->biBitCount);
	nLines = NPS_IMAGEDATASENDBYTE / nWidthBytes;		// C/y[W
	nPages = lpbmih->biHeight / nLines;					// y[W
	nDataSize = lpbmih->biWidth * nLines * 3;			// 1ɓǂݍރoCg
	nFirstLines = lpbmih->biHeight % nLines;
	nFirstData = nFirstLines * lpbmih->biWidth * 3;		// ŏɓǂݍރoCg 

	fp = fopen(pFileName, "rb");
	if (NULL == fp)
	{
		NPS_LOGOUT_FATAL("- Sending Image - Open Error");
		nRes = 2;
		goto FINISH;
	}

	if (0 != fseek(fp, dwOffset, SEEK_SET))
	{
		NPS_LOGOUT_FATAL("- Sending Image - Seek Error");
		nRes = 2;
		goto FINISH;
	}

	if (nFirstData)
	{
		if (0 != fseek(fp, nDataSize * nPages + dwOffset, SEEK_SET))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Seek Error");
			nRes = 2;
			goto FINISH;
		}

		if (nFirstData != fread(lpData, sizeof(BYTE), nFirstData, fp))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Read Error");
			nRes = 2;
			goto FINISH;
		}

		LPBYTE lpWkData = lpSndData;
		long nSndSize = 0;

		for (nFirstLines--; nFirstLines >= 0; nFirstLines--)
		{
			LPBYTE lpLine = lpData + (lpbmih->biWidth * nFirstLines * 3);

			for ( nPos = 0; nPos < lpbmih->biWidth; nPos++ )
			{
				lpWkData[0] = lpLine[2];
				lpWkData[1] = lpLine[1];
				lpWkData[2] = lpLine[0];
				lpLine += 3;
				lpWkData += 3;
			}
			nSndSize += nPos * 3;

			// 4byteBoundary lpWkData i߂
			for ( nPos = lpbmih->biWidth * 3 ; nWidthBytes > nPos ; nPos++ )
			{
				*lpWkData = 0x00;
				lpWkData++;
				nSndSize++;
			}
		}

		if (!Send((void*)lpSndData, nSndSize))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Send Error");
			nRes = 1;
			goto FINISH;
		}
	}

	for (nPages--; nPages >= 0; nPages--)
	{
		if (0 != fseek(fp, nDataSize * nPages + dwOffset, SEEK_SET))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Seek Error");
			nRes = 2;
			goto FINISH;
		}

		if (nDataSize != fread(lpData, sizeof(BYTE), nDataSize, fp))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Read Error");
			nRes = 2;
			goto FINISH;
		}

		LPBYTE lpWkData = lpSndData;
		long nSndSize = 0;
		long n = nLines;

		for (n--; n >= 0; n--)
		{
			LPBYTE lpLine = lpData + (lpbmih->biWidth * n * 3);

			for ( nPos = 0; nPos < lpbmih->biWidth; nPos++ )
			{
				lpWkData[0] = lpLine[2];
				lpWkData[1] = lpLine[1];
				lpWkData[2] = lpLine[0];
				lpLine += 3;
				lpWkData += 3;
			}
			nSndSize += nPos * 3;

			// 4byteBoundary lpWkData i߂
			for ( nPos = lpbmih->biWidth * 3 ; nWidthBytes > nPos ; nPos++ )
			{
				*lpWkData = 0x00;
				lpWkData++;
				nSndSize++;
			}
		}

		if (!Send((void*)lpSndData, nSndSize))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Send Error");
			nRes = 1;
			goto FINISH;
		}
	}

	// ]Ԃ̌vZ
	dwEndTime = GetTickCount();
	*lpdwTransmitTime = ( dwStartTime <= dwEndTime ) ? ( dwEndTime - dwStartTime ): ( dwEndTime + (0xFFFFFFFF - dwStartTime) );

	{	// Oo
		str.Format( "- Sending Image - Complet - %d msec", *lpdwTransmitTime );
		NPS_LOGOUT( str );
	}


FINISH:
	if (fp)
		::fclose(fp);
	if (lpHeader)
		delete lpHeader;
	if (lpData)
		delete lpData;
	if (lpSndData)
		delete lpSndData;

	return nRes;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::SendRawByMmf()
//	ABSTRACT : BMP -> RAW ϊĉ摜f[^MiLnj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           DWORD    dwTransDataLength  摜̑MTCYiPʁFBytej
//	           DWORD    dwDataLength       摜f[^̃oCgTCYiPʁFBytej
//	           DWORD    dwOffset           摜f[^̊i[ĂItZbg
//	           LPCSTR   pMmfName           L
//	
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : Y.Yoshinobu 2007.03.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsImg::SendRawByMmf( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pMmfName, LPDWORD lpdwTransmitTime )
{
	LPBYTE	lpSndData = NULL;
	LPBYTE	lpData = NULL;

	LPBITMAPINFOHEADER lpbmih;

	long	nHeaderSize;
	long	nBytes;
	long	nWidthBytes;
	long	nLines;
	long	nPages;
	long	nDataSize;
	long	nFirstLines;
	long	nFirstData;

	DWORD	dwStartTime;
	DWORD	dwEndTime;

	long	nRes = 0;
	CString	str;
	HANDLE	hFileMap = NULL;
	LPVOID	mapView = NULL;

	{	// Oo
		str.Format("- SendRawByMmf - Start - %s", pMmfName);
		NPS_LOGOUT(str);
	}

	// ϐ̏
	*lpdwTransmitTime = 0;

	dwStartTime = GetTickCount();

	nHeaderSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	try
	{
		lpSndData = new BYTE[ NPS_IMAGEDATASENDBYTE ];
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			TCHAR szCause[255];
			e->GetErrorMessage( szCause, 255 );
			str.Format( "- Sending Image - Memory Error ( %s )", szCause );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		nRes = 2;
		goto FINISH;
	}

	// }bvnh擾
	hFileMap = OpenFileMapping( FILE_MAP_READ, FALSE, pMmfName );

	if( NULL == hFileMap )
	{
		NPS_LOGOUT_FATAL("- Sending Image - OpenFileMapping Error");
		nRes = 2;
		goto FINISH;
	}

	mapView	= MapViewOfFile( hFileMap, FILE_MAP_READ, 0, 0, dwDataLength + dwOffset );

	if( NULL == mapView )
	{
		NPS_LOGOUT_FATAL( "- Sending Image - MapViewOfFile Error" );
		nRes = 2;
		goto FINISH;
	}

	lpbmih = (LPBITMAPINFOHEADER)( ((LPBYTE)mapView) + sizeof(BITMAPFILEHEADER) );

	nBytes = lpbmih->biBitCount / 8;
	nWidthBytes = NkcComApi::DIBWidthBytes((WORD)lpbmih->biWidth, lpbmih->biBitCount);
	nLines = NPS_IMAGEDATASENDBYTE / nWidthBytes;	// C/y[W
	nPages = lpbmih->biHeight / nLines;				// y[W
	nDataSize = nWidthBytes * nLines;				// 1ɓǂݍރoCg
	nFirstLines = lpbmih->biHeight % nLines;
	nFirstData = nFirstLines * nWidthBytes;			// ŏɓǂݍރoCg 

	if (nFirstData)
	{
		lpData = ((LPBYTE)mapView) + nDataSize * nPages + nHeaderSize + dwOffset;

		LPBYTE lpWkData = lpSndData;
		long nSndSize = 0;

		for (nFirstLines--; nFirstLines >= 0; nFirstLines--)
		{
			LPBYTE lpLine = lpData + (nWidthBytes * nFirstLines);

			for (int ii = 0; ii < lpbmih->biWidth; ii++)
			{
				lpWkData[0] = lpLine[2];
				lpWkData[1] = lpLine[1];
				lpWkData[2] = lpLine[0];
				lpLine += nBytes;
				lpWkData += 3;
			}
			nSndSize += ii * 3;
		}

		if (!Send((void*)lpSndData, nSndSize))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Send Error");
			nRes = 1;
			goto FINISH;
		}
	}

	for (nPages--; nPages >= 0; nPages--)
	{
		lpData = ((LPBYTE)mapView) + nDataSize * nPages + nHeaderSize + dwOffset;

		LPBYTE lpWkData = lpSndData;
		long nSndSize = 0;
		long n = nLines;

		for (n--; n >= 0; n--)
		{
			LPBYTE lpLine = lpData + (nWidthBytes * n);

			for (int ii = 0; ii < lpbmih->biWidth; ii++)
			{
				lpWkData[0] = lpLine[2];
				lpWkData[1] = lpLine[1];
				lpWkData[2] = lpLine[0];
				lpLine += nBytes;
				lpWkData += 3;
			}
			nSndSize += ii * 3;
		}

		if (!Send((void*)lpSndData, nSndSize))
		{
			NPS_LOGOUT_FATAL("- Sending Image - Send Error");
			nRes = 1;
			goto FINISH;
		}
	}

	// ]Ԃ̌vZ
	dwEndTime = GetTickCount();
	*lpdwTransmitTime = ( dwStartTime <= dwEndTime ) ? ( dwEndTime - dwStartTime ): ( dwEndTime + (0xFFFFFFFF - dwStartTime) );

	{	// Oo
		str.Format( "- Sending Image - Complet - %d msec", *lpdwTransmitTime );
		NPS_LOGOUT( str );
	}


FINISH:
	if (mapView)
		::UnmapViewOfFile(mapView);
	if (hFileMap)
		::CloseHandle(hFileMap);
	if (lpSndData)
		delete lpSndData;

	return nRes;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImg::SendImageData()
//	ABSTRACT : 摜f[^M
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           CImgSendParam* pobjParam    摜]
//	           LPDWORD lpdwTransmitTime    ]Ԋi[p|C^
//
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : Y.Yoshinobu 2007.02.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsImg::SendImageData( CImgSendParam* pobjParam, LPDWORD lpdwTransmitTime )
{
	DWORD dwValue;

	//------------------------------------------------------------
	// f[^[M C^[tFCXID & vp̃R}hID
	//------------------------------------------------------------
	dwValue = MAKELONG( htons( 0x5000 ), htons( 0xFFFF ) );
	if ( !Send( (void *) &dwValue, sizeof( ULONG ) ) )
	{
		return 1;
	}

	//------------------------------------------------------------
	// f[^M 摜TCY
	//------------------------------------------------------------
	dwValue = htonl( pobjParam->m_dwTransDataLength );
	if( !Send( (void *) &dwValue, sizeof( ULONG ) ) )
	{
		return 1;
	}

	//------------------------------------------------------------
	// 摜M
	//------------------------------------------------------------

	// 摜M
	if( IMGSRC_SHAREDMEM == pobjParam->m_dwSourceType )
	{	// 0FLn
		return SendImageDataByMMF(
					pobjParam->m_dwTransDataLength,
					pobjParam->m_dwFileDataLength,
					pobjParam->m_dwOffset,
					pobjParam->m_strFileName,
					pobjParam->m_eSendFunc,
					lpdwTransmitTime );
	}
	else if( IMGSRC_FILE == pobjParam->m_dwSourceType )
	{	// 1Ft@Cn
		switch ( pobjParam->m_eSendFunc )
		{
//		case 0x64:	// ʐMx摜
//		case 0x65:	// lbg[NȐff摜(CRC`FbNp)
		case FUNC_CRCDATA:
			// CRCf[^M
			return SendCRCDataByFile(
						pobjParam->m_dwTransDataLength,
						pobjParam->m_dwFileDataLength,
						pobjParam->m_dwOffset,
						pobjParam->m_strFileName,
						lpdwTransmitTime );
			break;
		default:
			// 摜f[^M
			return SendImageDataByFile(
						pobjParam->m_dwTransDataLength,
						pobjParam->m_dwFileDataLength,
						pobjParam->m_dwImgWidth,
						pobjParam->m_dwImgHeight,
						pobjParam->m_dwOffset,
						pobjParam->m_strFileName,
						pobjParam->m_eSendFunc,
						lpdwTransmitTime );
			break;
		}
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::CNpsImgManager()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsImgManager::CNpsImgManager()
{
	::InitializeCriticalSection( &m_csNpsImg );

	m_vNpsImg.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::~CNpsImgManager()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsImgManager::~CNpsImgManager()
{
	Clear();

	::DeleteCriticalSection( &m_csNpsImg );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::CreateSocket()
//	ABSTRACT : 摜]p\Pbg̍쐬
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//
//	RETURN   :     : |[gԍ (1`65535)
//             s    : 0
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CNpsImgManager::CreateSocket()
{
	CNpsImg* pobjNpsImg;
	USHORT nPortNo = 0;

	// NeBJZNVJn
	NkcComApi::CCSScopeLock	CSScopeLock( &m_csNpsImg );

	// 摜M\PbgIuWFNg
	try
	{
		pobjNpsImg = new CNpsImg;
	}
	catch (CMemoryException* e)
	{
		e->Delete();
		return nPortNo;
	}

	// \PbgI[v
	if ( FALSE == pobjNpsImg->Open( m_strIPAddress, m_wImgPortNo ) )
	{
		delete pobjNpsImg;
		return nPortNo;
	}

	// \Pbg̃|[gԍ擾
	nPortNo = pobjNpsImg->GetPortNo();

	if ( 0 == nPortNo )
	{
		delete pobjNpsImg;
		return nPortNo;
	}

	// \PbgIuWFNgRei֒ǉ
	m_vNpsImg.push_back( pobjNpsImg );

	{
		CString str;
		str.Format( "   CNpsImgManager::CreateSocket() nPortNo=%d m_vNpsImg.size=%d", nPortNo, m_vNpsImg.size() );
		NPS_LOGOUT( str );
	}

	return nPortNo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::CreateSocketByPortNo()
//	ABSTRACT : |[gԍw肵ĉ摜]p\Pbg쐬
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           USHORT nPortNo    |[gԍ
//
//	RETURN   :     : TRUE
//	           s    : FALSE
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsImgManager::CreateSocketByPortNo( const USHORT nPortNo )
{
	CNpsImg* pobjNpsImg;

	// NeBJZNVJn
	NkcComApi::CCSScopeLock	CSScopeLock( &m_csNpsImg );

	// Ƀ\Pbg݂ꍇɂ͍폜
	Delete( nPortNo, FALSE );

	// 摜M\PbgIuWFNg
	try
	{
		pobjNpsImg = new CNpsImg;
	}
	catch (CMemoryException* e)
	{
		e->Delete();
		return FALSE;
	}

	// \PbgI[v
	if ( FALSE == pobjNpsImg->Open( m_strIPAddress, m_wImgPortNo, nPortNo ) )
	{
		delete pobjNpsImg;
		return FALSE;
	}

	// \Pbg̃|[gԍ̊mF
	if ( nPortNo != pobjNpsImg->GetPortNo() )
	{
		delete pobjNpsImg;
		return FALSE;
	}

	// \PbgIuWFNgRei֒ǉ
	m_vNpsImg.push_back( pobjNpsImg );

	{
		CString str;
		str.Format( "   CNpsImgManager::CreateSocketByPortNo( nPortNo=%d ) = TRUE m_vNpsImg.size=%d", nPortNo, m_vNpsImg.size() );
		NPS_LOGOUT( str );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::IsOpenSocket()
//	ABSTRACT : \PbgI[vĂ邩mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//             USHORT nPortNo     |[gԍ
//
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsImgManager::IsOpenSocket( const USHORT nPortNo )
{
	BOOL bResult = FALSE;
	CNpsImg* pobjNpsImg;
	std::vector<CNpsImg*>::iterator itNpsImg;

	::EnterCriticalSection( &m_csNpsImg );

	for ( itNpsImg=m_vNpsImg.begin() ; m_vNpsImg.end() != itNpsImg ; itNpsImg++ )
	{
		pobjNpsImg = *itNpsImg;

		if ( nPortNo == pobjNpsImg->GetPortNo() )
		{
			bResult = pobjNpsImg->IsOpenSocket();
			break;
		}
	}

	if ( FALSE == bResult )
	{
		CString str;
		str.Format( "   CNpsImgManager::IsOpenSocket( nPortNo=%d ) = %s", nPortNo, ( TRUE == bResult ) ? "TRUE" : "FALSE" );
		NPS_LOGOUT( str );
	}

	::LeaveCriticalSection( &m_csNpsImg );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::Delete()
//	ABSTRACT : 摜]p\PbgIuWFNg̍폜
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//             USHORT nPortNo     |[gԍ
//             BOOL bEnableLock   rtO ( TRUE:rs, FALSE:r䂵Ȃ )
//
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsImgManager::Delete( const USHORT nPortNo, const BOOL bEnableLock )
{
	CNpsImg* pobjNpsImg;
	std::vector<CNpsImg*>::iterator itNpsImg;

	if ( TRUE == bEnableLock )
	{
		::EnterCriticalSection( &m_csNpsImg );
	}

	for ( itNpsImg=m_vNpsImg.begin() ; m_vNpsImg.end() != itNpsImg ; itNpsImg++ )
	{
		pobjNpsImg = *itNpsImg;

		if ( nPortNo == pobjNpsImg->GetPortNo() )
		{
			delete pobjNpsImg;
			m_vNpsImg.erase( itNpsImg );
			break;
		}
	}

	{
		CString str;
		str.Format( "   CNpsImgManager::Delete( nPortNo=%d ) m_vNpsImg.size=%d", nPortNo, m_vNpsImg.size() );
		NPS_LOGOUT( str );
	}

	if ( TRUE == bEnableLock )
	{
		::LeaveCriticalSection( &m_csNpsImg );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::Clear()
//	ABSTRACT : 摜]p\PbgIuWFNg̑S폜
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//             BOOL bEnableLock   rtO ( TRUE:rs, FALSE:r䂵Ȃ )
//
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// 摜]p\PbgIuWFNg̑S폜
void CNpsImgManager::Clear( const BOOL bEnableLock)
{
	CNpsImg* pobjNpsImg;
	std::vector<CNpsImg*>::iterator itNpsImg;

	if ( TRUE == bEnableLock )
	{
		::EnterCriticalSection( &m_csNpsImg );
	}

	{
		CString str;
		str.Format( "   CNpsImgManager::Clear() m_vNpsImg.size=%d", m_vNpsImg.size() );
		NPS_LOGOUT( str );
	}

	for ( itNpsImg=m_vNpsImg.begin() ; m_vNpsImg.end() != itNpsImg ; itNpsImg++ )
	{
		pobjNpsImg = *itNpsImg;
		delete pobjNpsImg;
	}
	m_vNpsImg.clear();

	if ( TRUE == bEnableLock )
	{
		::LeaveCriticalSection( &m_csNpsImg );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::Connect()
//	ABSTRACT : T[o[ւ̐ڑ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//             USHORT nPortNo     |[gԍ
//
//	RETURN   :     : TRUE
//	           s    : FALSE
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsImgManager::Connect( const USHORT nPortNo )
{
	BOOL bResult = FALSE;
	CNpsImg* pobjNpsImg;
	std::vector<CNpsImg*>::iterator itNpsImg;

	::EnterCriticalSection( &m_csNpsImg );

	for ( itNpsImg=m_vNpsImg.begin() ; m_vNpsImg.end() != itNpsImg ; itNpsImg++ )
	{
		pobjNpsImg = *itNpsImg;

		if ( nPortNo == pobjNpsImg->GetPortNo() )
		{
			if ( TRUE == pobjNpsImg->Connect() )
			{
				bResult = TRUE;
			}
			break;
		}
	}

	{
		CString str;
		str.Format( "   CNpsImgManager::Connect( nPortNo=%d ) = %s", nPortNo, ( TRUE == bResult ) ? "TRUE" : "FALSE" );
		NPS_LOGOUT( str );
	}

	::LeaveCriticalSection( &m_csNpsImg );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::ReConnect()
//	ABSTRACT : T[o[ւ̍Đڑ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//             USHORT nPortNo     |[gԍ
//
//	RETURN   :     : TRUE
//	           s    : FALSE
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsImgManager::ReConnect( const USHORT nPortNo )
{
	WORD wIdx;
	BOOL bResult = FALSE;
	CNpsImg* pobjNpsImg;
	std::vector<CNpsImg*>::iterator itNpsImg;

	::EnterCriticalSection( &m_csNpsImg );

	for ( itNpsImg=m_vNpsImg.begin() ; m_vNpsImg.end() != itNpsImg ; itNpsImg++ )
	{
		pobjNpsImg = *itNpsImg;

		if ( nPortNo == pobjNpsImg->GetPortNo() )
		{
			if ( TRUE == pobjNpsImg->Close() )
			{
				if ( TRUE == pobjNpsImg->Open( m_strIPAddress, m_wImgPortNo, nPortNo ) )
				{
					if ( nPortNo == pobjNpsImg->GetPortNo() )
					{
						// 30bԊuōő10܂ŃgCs (|[gTIME_WAIT̂҂)
						for ( wIdx=0 ; 10 > wIdx ; wIdx++ )
						{
							::Sleep( 30000 );
							{
								CString str;
								str.Format( "   CNpsImgManager::ReConnect( nPortNo=%d ) connect count %d", nPortNo, wIdx );
								NPS_LOGOUT( str );
							}
							if ( TRUE == pobjNpsImg->Connect() )
							{
								bResult = TRUE;
								break;
							}
						}
					}
				}
			}
			break;
		}
	}

	{
		CString str;
		str.Format( "   CNpsImgManager::ReConnect( nPortNo=%d ) = %s", nPortNo, ( TRUE == bResult ) ? "TRUE" : "FALSE" );
		NPS_LOGOUT( str );
	}

	::LeaveCriticalSection( &m_csNpsImg );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::SetHostAddress()
//	ABSTRACT : zXgAhXݒ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//	           LPCTSTR lpszHostAddress     T[o[̃AhX
//
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsImgManager::SetHostAddress( LPCTSTR lpszHostAddress, USHORT wImgPortNo )
{
	::EnterCriticalSection( &m_csNpsImg );

	m_strIPAddress = lpszHostAddress;
	m_wImgPortNo = wImgPortNo;

	::LeaveCriticalSection( &m_csNpsImg );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsImgManager::SendImageData()
//	ABSTRACT : 摜f[^M
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT : 
//             USHORT nPortNo     |[gԍ
//	           CImgSendParam* pobjParam    摜]
//	           LPDWORD lpdwTransmitTime    ]Ԋi[p|C^
//
//	RETURN   : I  0
//	           Ms  1
//	           Ǎs  2
//	
//	CREATE	 : Y.Yoshinobu 2008.02.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsImgManager::SendImageData( const USHORT nPortNo, CImgSendParam* pobjParam, LPDWORD lpdwTransmitTime )
{
	long nResult = 1;	// l͑MsƂ
	CNpsImg* pobjNpsImg;
	std::vector<CNpsImg*>::iterator itNpsImg;

	::EnterCriticalSection( &m_csNpsImg );

	{
		CString str;
		str.Format( "   CNpsImgManager::SendImageData( nPortNo=%d )", nPortNo );
		NPS_LOGOUT( str );
	}

	for ( itNpsImg=m_vNpsImg.begin() ; m_vNpsImg.end() != itNpsImg ; itNpsImg++ )
	{
		pobjNpsImg = *itNpsImg;

		if ( nPortNo == pobjNpsImg->GetPortNo() )
		{
			nResult = pobjNpsImg->SendImageData( pobjParam, lpdwTransmitTime );
			break;
		}
	}

	::LeaveCriticalSection( &m_csNpsImg );

	return nResult;
}
