#ifndef _NPSPRINTERCHECKER_H_
#define _NPSPRINTERCHECKER_H_

#include <vector>
#include "NpsCommand.h"
#include "NpsBcThread.h"

// Mobt@̃TCY
#define MAX_BUFFSIZE		65535

// v^[ƍNX							2008.10.24 S.Heya
class CNpsPrinterChecker
{
public:
	// RXgN^
	CNpsPrinterChecker();
	
	// fXgN^
	~CNpsPrinterChecker();

	// ƍv^[o^
	void AddCheckPrinter(const T_NpsPrinterInfo* pPrinterInfo);

	// v^[擾
	BOOL GetPrinterInfo(int nIndex, T_NpsPrinterInfo* pPrinterInfo);

	// v^[񐔎擾
	int GetPrinterCount() {	return (int)m_vPrinterInfo.size(); };

	// XbhN
	BOOL StartupThread();

	// Xbh
	UINT ThreadExecProc();

	// XbhIҋ@
	void WaitEndThread();


protected:
	// WinXbhNX
	CWinThread* m_pWinThread;

	// ƍ҂v^[擾
	T_NpsPrinterInfo* GetCheckPrinter();

	// ^C}[(R[obN֐)
	static void CALLBACK TimerProcEntry(UINT uID, UINT uMsg, LPARAM lpUser, DWORD dw1, DWORD dw2);

	// ^C}[
	void TimerProc();

	// v^[ڑ
	SOCKET Connect(const char* szAddr);

	 // R}hM
	ULONG SendCmd(const LPBYTE pBuff, ULONG nSize);

	// R}hM
	ULONG RecvCmd(LPBYTE pBuff, WORD wIfId, WORD wCmdId, UINT uDelay = 15000L);

	// f[^M
	ULONG RecvData(LPBYTE pBuff, ULONG nSize);

	// v^[ؒf
	void Disconnect();

	// ^C}[ID
	MMRESULT m_uTimerID;

	// mF҂Xg
	std::vector<T_NpsPrinterInfo*>	m_vCheckPrinter;

	// v^[Xg
	std::vector<T_NpsPrinterInfo*>	m_vPrinterInfo;

	// NeBJZbV
	CRITICAL_SECTION m_cs;

	// XbhICxg
	HANDLE	g_hExitEvent;

	// \Pbg
	SOCKET m_Socket;
};


#endif // _NPSPRINTERCHECKER_H_