//////////////////////////////////////////////////////////////////////////////
//   FILE NAME   : WS2Udp.h
//   ABSTRACT    : \Pbg񓯊ʐMNX (WinSock2.0Ή)
//
//                                     (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "WS2Udp.h"

extern BOOL g_bDetatch;

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::CWS2Udp
//   ABSTRACT : RXgN^
//   FUNCTION : \PbgǗNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CWS2Udp::CWS2Udp()
{
	int nPriority;
	#if defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_BELOW_NORMAL;
	#else  // defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_NORMAL;
	#endif // defined(NPS_THREAD_PRIORITY_BELOW)

	m_Socket      = INVALID_SOCKET;			// \Pbgnh𖳌ɂ܂
	m_bAutoDelete = FALSE;					// \PbgN[YɎIɍ폜Ȃ
	// CxgpXbh쐬
	m_ExitEvent    = WSACreateEvent();		// IpCxg
	m_NetworkEvent = WSACreateEvent();		// \PbgʐMpCxg
	m_pWinThread = AfxBeginThread( SocketEventThread, this, nPriority, 0, CREATE_SUSPENDED, NULL );
	m_pWinThread->m_bAutoDelete = FALSE;	// 폜Ȃ
	m_pWinThread->ResumeThread();			// Xbh̏Jn
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::~CWS2Udp
//   ABSTRACT : fXgN^
//   FUNCTION : \PbgǗNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CWS2Udp::~CWS2Udp()
{
	// \PbgJĂꍇAJ܂
	if( m_Socket != INVALID_SOCKET )
		Close();		// ؒf
	// Ip̃Cxgݒ肵܂
	WSASetEvent( m_ExitEvent );
	// XbhI҂
	if( g_bDetatch )
	{
		delete m_pWinThread;
	}
	else if( GetCurrentThreadId() != m_pWinThread->m_nThreadID )
	{
		// Xbhł͂ȂƂ
		HANDLE hThread;

		hThread = m_pWinThread->m_hThread;

#if defined(NPS_SINGLE_WAIT)
		::WaitForSingleObject( hThread, INFINITE );
#else  // NPS_SINGLE_WAIT
		while ( WAIT_OBJECT_0 != ::MsgWaitForMultipleObjects( 1, &hThread, FALSE, INFINITE, QS_ALLEVENTS ) )
		{
			MSG msg;
			CWinThread* pWinThread;
			while( PeekMessage( &msg , NULL , 0 , 0 , PM_NOREMOVE ) )
			{
				pWinThread = AfxGetThread();
				if ( NULL != pWinThread )
				{
					pWinThread->PumpMessage();
				}
				else
				{
					// ݎs̃XbhȂ̂ PeekMessage ̃[v𔲂
					NPS_LOGOUT_WARN( "---CWS2Udp::~CWS2Udp() AfxGetThread() is NULL" );
					break;
				}
			}
		}
#endif // NPS_SINGLE_WAIT

		delete m_pWinThread;			// XbhpNX̍폜
		m_pWinThread = NULL;
	}else{
		// XbhĝƂ
		m_pWinThread->m_bAutoDelete = TRUE;		// 폜
	}

	// e㏈
	WSACloseEvent( m_NetworkEvent );		// Cxg܂
	WSACloseEvent( m_ExitEvent    );		// Cxg܂
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::Create
//   ABSTRACT : \Pbg̍쐬
//   FUNCTION : \Pbg̍쐬(`1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::Create( int nAddressFamily , int nSocketType , int nProtocol )
{
	// \Pbg̍쐬s܂
	return Create( NULL , nAddressFamily , nSocketType , nProtocol );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::Create
//   ABSTRACT : \Pbg̍쐬
//   FUNCTION : \Pbg̍쐬(`2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::Create(
				LPWSAPROTOCOL_INFO lpProtocolInfo ,
  				int nAddressFamily ,
				int nSocketType    ,
				int nProtocol      )
{
	// \Pbg̍쐬s܂
	SOCKET		Socket = WSASocket(
					nAddressFamily ,
					nSocketType ,
					nProtocol ,
					lpProtocolInfo ,
					0 ,
					WSA_FLAG_OVERLAPPED );
	if( Socket == INVALID_SOCKET )
		return FALSE;		// \Pbg̍쐬G[

	// NXƌѕts܂
	if( !Attach( Socket , nAddressFamily ) )
		return FALSE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::Bind
//   ABSTRACT : \PbgɖOt܂
//   FUNCTION : \PbgɖOt܂(`1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::Bind( UINT nSocketPort , LPCTSTR lpszSocketAddress )
{
	USES_CONVERSION;

	SOCKADDR_IN		SockAddr;ZeroMemory( &SockAddr , sizeof( SockAddr ) );

	// \Pbg̐ݒ
	SockAddr.sin_family		= m_nAddressFamily;		// AhXt@~[
	// \PbgAhX
	LPSTR lpszAscii = T2A((LPTSTR)lpszSocketAddress);
	if( lpszAscii == NULL )
	{
		// AhXwȂ
		SockAddr.sin_addr.s_addr = htonl( INADDR_ANY );
	}else{
		// AhXw
		DWORD lResult = inet_addr(lpszAscii);
		if (lResult == INADDR_NONE)
		{
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
		SockAddr.sin_addr.s_addr = lResult;
	}
	// |[gԍݒ
	SockAddr.sin_port = htons((u_short)nSocketPort);

	// 
	return Bind( (SOCKADDR*)&SockAddr , sizeof( SockAddr ) );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::Bind
//   ABSTRACT : \PbgɖOt܂
//   FUNCTION : \PbgɖOt܂(`2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::Bind( const SOCKADDR* lpSockAddr, int nSockAddrLen )
{
	return bind( m_Socket , lpSockAddr , nSockAddrLen ) == 0;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::GetSocketPortNo
//   ABSTRACT : |[gԍ擾܂
//   FUNCTION : |[gԍ擾܂
//////////////////////////////////////////////////////////////////////////////
UINT  CWS2Udp::GetSocketPortNo()
{
	UINT		SocketPort;
	SOCKADDR	SockAddr;
	int			size;

	size	= sizeof( SockAddr );
	ZeroMemory( &SockAddr , size );
	getsockname( m_Socket, &SockAddr, &size );
	SocketPort	= (USHORT)( SockAddr.sa_data[0]<<8 ) + (UCHAR)SockAddr.sa_data[1];

	return SocketPort;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::Close
//   ABSTRACT : ܂
//   FUNCTION : ܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::Close()
{
	closesocket( m_Socket );
	m_Socket = INVALID_SOCKET;
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::Attach
//   ABSTRACT : w\PbgA^b`܂
//   FUNCTION : w\PbgA^b`܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::Attach( SOCKET sock , int nAddressFamily )
{
	ASSERT( m_Socket == INVALID_SOCKET );

	// \Pbgݒ
	m_Socket				= sock;
	m_nAddressFamily		= nAddressFamily;

	// A^b`sꂽƂ
	OnAttach();

	// \PbgCxgMݒ
	return SOCKET_ERROR != WSAEventSelect(
								m_Socket ,
								m_NetworkEvent ,
								FD_ACCEPT | FD_CLOSE | FD_CONNECT | FD_OOB |
								FD_QOS | FD_READ | FD_WRITE );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::GetLastError
//   ABSTRACT : G[擾܂
//   FUNCTION : G[擾܂
//////////////////////////////////////////////////////////////////////////////
int CWS2Udp::GetLastError()
{
	return WSAGetLastError();
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::SetAutoDelete
//   ABSTRACT : \PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
//   FUNCTION : \PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::SetAutoDelete( BOOL bAutoDelete )
{
	m_bAutoDelete = bAutoDelete;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::SocketEventThread
//   ABSTRACT : \PbgʐMCxgpXbh(1)
//   FUNCTION : \PbgʐMCxgpXbh(1)
//////////////////////////////////////////////////////////////////////////////
UINT CWS2Udp::SocketEventThread( LPVOID pParam )
{
	return ((CWS2Udp*)pParam)->SocketEvent();
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::SocketEvent
//   ABSTRACT : \PbgʐMCxgpXbh(2)
//   FUNCTION : \PbgʐMCxgpXbh(2)
//////////////////////////////////////////////////////////////////////////////
UINT CWS2Udp::SocketEvent()
{
	WSAEVENT		evt[2] = { m_ExitEvent , m_NetworkEvent };

	DWORD	dwState;
	while( WSA_WAIT_EVENT_0 + 1 == (dwState = WSAWaitForMultipleEvents( COUNTOF( evt ), evt, FALSE, WSA_INFINITE, TRUE )) )
	{
		DWORD	dwThreadID = GetCurrentThreadId();
		// lbg[NCxgʎo
		WSANETWORKEVENTS		NetEvent;
		ZeroMemory( &NetEvent , sizeof( NetEvent ) );
		if ( SOCKET_ERROR == WSAEnumNetworkEvents( m_Socket , m_NetworkEvent , &NetEvent ) )
		{
			{	// Oo
				CString str;
				str.Format( "---WSAEnumNetworkEvents( SOCKET_ERROR ) = %d", WSAGetLastError() );
				NPS_LOGOUT_WARN( str );
			}
			// CxgZbg
			if ( FALSE == WSAResetEvent( m_NetworkEvent ) )
			{
				{	// Oo
					CString str;
					str.Format( "---WSAResetEvent( FALSE ) = %d", WSAGetLastError() );
					NPS_LOGOUT_WARN( str );
				}
			}
			continue;
		}


		if( NetEvent.lNetworkEvents & FD_ACCEPT )
		{	OnAccept( NetEvent.iErrorCode[FD_ACCEPT_BIT] );				}
		if( NetEvent.lNetworkEvents & FD_CONNECT )
		{	OnConnect( NetEvent.iErrorCode[FD_CONNECT_BIT] );			}
		if( NetEvent.lNetworkEvents & FD_OOB )
		{	OnOOB( NetEvent.iErrorCode[FD_OOB_BIT] );					}
		if( NetEvent.lNetworkEvents & FD_QOS )
		{	OnQOS( NetEvent.iErrorCode[FD_QOS_BIT] );					}
		if( NetEvent.lNetworkEvents & FD_READ )
		{	OnReceive( NetEvent.iErrorCode[FD_READ_BIT] );				}
		if( NetEvent.lNetworkEvents & FD_WRITE )
		{	OnSend( NetEvent.iErrorCode[FD_WRITE_BIT] );				}
		if( NetEvent.lNetworkEvents & FD_CLOSE )
		{	OnClose( NetEvent.iErrorCode[FD_CLOSE_BIT] );				}
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::OnAccept
//   ABSTRACT : I[o[Ch
//   FUNCTION : Accept p
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::OnAccept( int nErrorCode )
{
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::OnClose
//   ABSTRACT : I[o[Ch
//   FUNCTION : Close p
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::OnClose( int nErrorCode )
{
	Close();		// \Pbg܂
	// NX̎폜莞͍폜s܂
	if( m_bAutoDelete )
		delete this;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::OnConnect
//   ABSTRACT : I[o[Ch
//   FUNCTION : OnConnect p
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::OnConnect( int nErrorCode )
{
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::OnOOB
//   ABSTRACT : I[o[Ch
//   FUNCTION : OOB p
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::OnOOB( int nErrorCode )
{
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::OnQOS
//   ABSTRACT : I[o[Ch
//   FUNCTION : QOS p
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::OnQOS( int nErrorCode )
{
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::OnReceive
//   ABSTRACT : I[o[Ch
//   FUNCTION : f[^M p
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::OnReceive( int nErrorCode )
{
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::OnSend
//   ABSTRACT : I[o[Ch
//   FUNCTION : f[^M p
//////////////////////////////////////////////////////////////////////////////
void CWS2Udp::OnSend( int nErrorCode )
{
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::SetOptBroadCast
//   ABSTRACT : u[hLXgMݒs
//   FUNCTION : u[hLXgMݒs
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::SetOptBroadCast(BOOL bFlag)
{
	if( setsockopt( m_Socket, SOL_SOCKET, SO_BROADCAST, (char*)&bFlag, sizeof(bFlag)) != 0 ){
		DWORD dwErrCD = ::WSAGetLastError();
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::SendTo
//   ABSTRACT : f[^̑Ms܂(1)
//   FUNCTION : f[^̑Ms܂(1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::SendTo( LPCTSTR lpszHostAddress, UINT nHostPort, const void* lpBuf, int nBufLen, DWORD dwFlags )
{
	USES_CONVERSION;

	ASSERT(lpszHostAddress != NULL);

	// ݒp\̍\z&
	SOCKADDR_IN SockAddr = {0};

	// \Pbg̐ݒ
	SockAddr.sin_family		= m_nAddressFamily;		// AhXt@~[
	LPSTR lpszAscii = T2A((LPTSTR)lpszHostAddress);	// T[o[AhXݒ
	SockAddr.sin_addr.s_addr = inet_addr(lpszAscii);
	if (SockAddr.sin_addr.s_addr == INADDR_NONE)
	{
		// zXgAIP AhX܂
		LPHOSTENT lphost;
		lphost = gethostbyname( lpszAscii );
		if (lphost != NULL)
		{
			SockAddr.sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		}else{
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}
	SockAddr.sin_port = htons((u_short)nHostPort);	// |[gԍݒ

	// Mf[^ݒpobt@
	WSABUF			WSABuf = {0};
	WSABuf.buf		= (char*)lpBuf;		// obt@ւ̃|C^[
	WSABuf.len		= nBufLen;			// f[^̒

	// Mv
	return SendTo( (SOCKADDR*)&SockAddr, sizeof(SockAddr), &WSABuf , 1 , dwFlags );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::SendTo
//   ABSTRACT : f[^̑Ms܂(2)
//   FUNCTION : f[^̑Ms܂(2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Udp::SendTo( const SOCKADDR* lpSockAddr, int nSockAddrLen, WSABUF* pBuf , int nCount , DWORD dwFlags )
{
	// Mpf[^낢낢̂ŁAf[^̃Rs[s܂
	WSABUF*		pCopyBuf = (WSABUF*)malloc( sizeof( WSABUF ) * nCount );
	CopyMemory( pCopyBuf , pBuf , sizeof( WSABUF ) * nCount );

	//I[o[bv̂߂̏s܂
	WSAOVERLAPPED	WSAov;					// OVERLPPED \
	WSAov.hEvent	= WSACreateEvent();		// Cxg쐬

	WSABUF*		pSendBuf = pCopyBuf;		// |C^[Rs[܂
	while( nCount > 0 )
	{
		// f[^̑Ms܂
		DWORD		dwSend;
		if( SOCKET_ERROR == WSASendTo( m_Socket , pSendBuf , nCount ,
										 &dwSend , dwFlags ,
										 lpSockAddr, nSockAddrLen,
										 &WSAov , NULL ) )
		{
			if( GetLastError() == WSA_IO_PENDING )
			{
				// OVERLAPPED Ȃ̂ŏI܂ő҂܂
				if ( TRUE != WSAGetOverlappedResult( m_Socket , &WSAov , &dwSend , TRUE , &dwFlags ) ) {
					if ( GetLastError() == WSAEHOSTUNREACH ) {
						free( pCopyBuf );
						WSACloseEvent( WSAov.hEvent );
						return FALSE;		// ȊO̗\ʃG[
					}
				}
			}else	{
				free( pCopyBuf );
				WSACloseEvent( WSAov.hEvent );
				return FALSE;		// ȊO̗\ʃG[
			}
		}
		// MTCYf
		while( dwSend > 0 && nCount > 0 )
		{
			DWORD	dwSendLength = min( pSendBuf->len , dwSend );
			pSendBuf->len -= dwSendLength;
			if( pSendBuf->len == 0 )
			{
				pSendBuf++;
				nCount--;
			}else{
				pSendBuf->buf += dwSendLength;
			}
			dwSend -= dwSendLength;
		}
	}
	
	// M㏈
	free( pCopyBuf );
	WSACloseEvent( WSAov.hEvent );

	return TRUE;

}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Udp::ReceiveFrom
//   ABSTRACT : f[^̎Ms܂
//   FUNCTION : f[^̎Ms܂
//////////////////////////////////////////////////////////////////////////////
int CWS2Udp::ReceiveFrom( void* lpBuf, int nBufLen, LPTSTR lpszHostAddress, int nHostAddressBufLen,
								UINT* pnHostPort, DWORD dwFlags)
{
	WSABUF wbDataBuf = {0};
	WSAOVERLAPPED woOverlapped = {0};
	DWORD dwBytesRecv = 0;
	DWORD dwFlg = dwFlags;
	SOCKADDR_IN SenderAddr = {0};
	int nSenderAddrSize = sizeof(SenderAddr);

	wbDataBuf.len = nBufLen;
	wbDataBuf.buf = (char*)lpBuf;

	::ZeroMemory( &woOverlapped, sizeof(WSAOVERLAPPED) );
	int nRet = WSARecvFrom(
						m_Socket, 
						&wbDataBuf, 
						1, 
						&dwBytesRecv, 
						&dwFlg, 
						(SOCKADDR *) &SenderAddr, 
						&nSenderAddrSize, 
						&woOverlapped, 
						NULL );

	if( nRet == SOCKET_ERROR ){
		DWORD dwErr = WSAGetLastError();
		if ( WSA_IO_PENDING == dwErr ) {
			// OVERLAPPED Ȃ̂ŏI܂ő҂܂
			BOOL bRet = WSAGetOverlappedResult( m_Socket, &woOverlapped, &dwBytesRecv, TRUE, &dwFlags );
			if ( FALSE == bRet ) {
				CString str;
				str.Format( "---WSAGetOverlappedResult ERROR" );
				NPS_LOGOUT_FATAL( str );
				return -1;
			}
		} else {
			CString str;
			str.Format( "---WSARecvFrom ERROR (%d)", dwErr );
			NPS_LOGOUT_FATAL( str );
			return -1;
		}
	}

	if( dwFlg & MSG_PARTIAL ){
		return -2;
	}

	// zXgAhX
	LPTSTR lpszAddr = inet_ntoa(SenderAddr.sin_addr);
	if(lpszAddr == NULL){
		return -3;
	}
	if((int)(strlen(lpszAddr)+1) > nHostAddressBufLen){
		return -4;
	}
	ZeroMemory(lpszHostAddress, nHostAddressBufLen);
	strcpy(lpszHostAddress, lpszAddr);

	// |[g
	u_short nPort = ntohs(SenderAddr.sin_port);
	*pnHostPort = nPort;

	return dwBytesRecv;		// MԂ܂
}
