// NpsClient.h : wb_[ t@C
//

#if !defined(AFX_NPSCLIENTDLG_H__4EB478A1_B656_48FF_94CA_68E44030BCD9__INCLUDED_)
#define AFX_NPSCLIENTDLG_H__4EB478A1_B656_48FF_94CA_68E44030BCD9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LogDlg.h"
#include "OrderManager.h"

// XR[v͈͂̃NeBJZNṼbNs܂
class CCSScopeLock
{
private:
	CRITICAL_SECTION*	m_pCS;
public:
	CCSScopeLock( CRITICAL_SECTION* pCS )	{ m_pCS	= pCS; ::EnterCriticalSection( m_pCS ); }
	~CCSScopeLock()	{ ::LeaveCriticalSection( m_pCS ); }
};

class CFrame;

/////////////////////////////////////////////////////////////////////////////
// CNpsClientDlg _CAO

class CNpsClientDlg : public CDialog
{
// \z
public:
	CNpsClientDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CNpsClientDlg)
	enum { IDD = IDD_NPSCLIENT_DIALOG };
	CComboBox	m_Combo_hPrinter;
	CListBox	m_ListCallback;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CNpsClientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CNpsClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonLibOpen();
	afx_msg void OnButtonLibClose();
	afx_msg void OnButtonSearchPrint();
	afx_msg void OnButtonSearchPrint2();
	afx_msg void OnButtonGetPrinter();
	afx_msg void OnButtonDevOpen();
	afx_msg void OnButtonDevGetPrinterVersion();
	afx_msg void OnButtonGetUnitInfo();
	afx_msg void OnButtonDevGetMagInfo();
	afx_msg void OnButtonGetSetUpInfo();
	afx_msg void OnButtonGetPrintNumInfo();
	afx_msg void OnButtonDevResetEvent();
	afx_msg void OnButtonDevConvertPictureSize();
	afx_msg void OnButtonDevIsReady();
	afx_msg void OnButtonDevStartOrder();
	afx_msg void OnButtonDevEndOrder();
	afx_msg void OnButtonDevPrint();
	afx_msg void OnButtonDevSort();
	afx_msg void OnButtonDevCancelPrintOrder();
	afx_msg void OnButtonDevGetPrintState();
	afx_msg void OnButtonDevSetTime();
	afx_msg void OnButtonDevGetTime();
	afx_msg void OnButtonDevCloseCheck();
	afx_msg void OnButtonDevGetRegMagInfo();
	afx_msg void OnButtonDevCtrlPrint();
	afx_msg void OnButtonDevNpsCommand1();
	afx_msg void OnButtonDevNpsCommand2();
	afx_msg void OnButtonDevClose();
	afx_msg void OnDestroy();
	afx_msg void OnButtonDevExpressOrder();
	afx_msg void OnButtonDevNpsNotice();
	afx_msg void OnButtonDevCancelPrintAll();
	afx_msg void OnButtonGetNpsVersion();
	afx_msg void OnButtonDevOccupyCheck();
	afx_msg void OnButtonDevGetProfile();
	afx_msg void OnButtonDevGetTransmitTime();
	afx_msg void OnButtonSetCompletionProcMode();
	afx_msg void OnButtonDevStartDuplex();
	afx_msg void OnButtonDevEndDuplex();
	afx_msg void OnButtonDevBlankPrint();
	afx_msg void OnButtonDevPrintIccsxml();
	afx_msg void OnButtonDevStartFad();
	afx_msg void OnButtonDevAdjustForPrint();
	afx_msg void OnButtonDevStartRetransmission();
	afx_msg void OnButtonDevEndRetransmission();
	afx_msg void OnButtonDevInterruptPrintOrder();
	afx_msg void OnButtonDevPrintResend();
	//}}AFX_MSG
	afx_msg LRESULT OnUmNkcNpsclientUnit( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnUmNkcNpsclientEvent( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnUmNkcNpsclientCompletion( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnUmNkcNpsclientEventEx( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()

	CLogDlg	m_objNpsLib;

	int	m_PrinterNum;
	int	m_LatestOrderId;

	/////////////////////////////////////////////////////////////////////////////
	// INIt@Cݒ
	CString	m_strSettingFilePath;

	void SaveSetting( CString strKey, int nData );
	int LoadSetting( CString strKey, int nDefault );

	void SaveSettingStr( CString strKey, CString strData );
	CString LoadSettingStr( CString strKey, CString strDefault );

	CRITICAL_SECTION	m_CS;	// NeBJZNV

	/////////////////////////////////////////////////////////////////////////////
	// DevPrintʏ
	typedef enum {
		eDevPrint = 0,
		eDevPrintIccsXml,
	} eDEVPRITNTTYPE;

	void	DevPrint( int eType = eDevPrint );
	long	DevPrintRequest(
					HPRINTER				hPrinter,
					NPSCOMPLETIONPROC		pEventProc,
					OrderManager::CFrame*	pFrame );

	/////////////////////////////////////////////////////////////////////////////
	// MMFǗ
	int		m_MMFNO;

	HANDLE	CreateMapFromFile( CString strFileName, CString strMapName );

	/////////////////////////////////////////////////////////////////////////////
	// R[obN

	// Cxgʒm֐
	static void CALLBACK CallbackEventStatic(
		PNPSEVENTINFO	pEventInfo	// Cxg
		);

	// jbgԕύXʒm֐
	static void CALLBACK CallbackUnitStatic(
		PNPSUNITNOTIFYINFO	pUnitInfo	// jbgԕω
		);

	// vgCxgʒmpR[obN֐
	static void CALLBACK CallbackCompletionStatic(
		DWORD		dwCompletionCode,	// R[h
		PVOID		pCompletionInfo		// Cxg
		);

	// Cxggʒm֐
	static void CALLBACK CallbackEventExStatic(
		PNPSEVENTINFOEX	pEventInfoEx	// Cxgg
		);

	// v^CxgʒmXgǗ
	void AddCallbackData( CString str, NPSEVENTINFO * pNpsEventInfo );
	void DeleteCallbackData( HANDLE hPrinter, DWORD dwErrHandle );

	// npsDevNpsCommand2R[obN
	static void CALLBACK CallbackRecvprocStatic(
		WORD		wIfId,		// C^[tFCXID
		WORD		wRecvCmdId,	// p̃R}hID
		LPVOID		lpRecvBuf,	// p̃R}h̃obt@
		WORD		RecvBufLen,	// p̃R}h̃obt@TCY
		long		Result		// 
		);

	void CALLBACK CallbackRecvproc(
		WORD		wIfId,		// C^[tFCXID
		WORD		wRecvCmdId,	// p̃R}hID
		LPVOID		lpRecvBuf,	// p̃R}h̃obt@
		WORD		RecvBufLen,	// p̃R}h̃obt@TCY
		long		Result		// 
		);

	// NPS񓯊ʐM̃R[obN֐
	static void CALLBACK CallbackNoticeprocStatic(
		HPRINTER	hPrinter,		// v^̃nh
		DWORD		dwIPAddress,	// v^IPAhX
		WORD		wIfId,			// C^[tFCXID
		WORD		wCmdId,			// R}hID
		LPVOID		lpBuf,			// R}h̃obt@
		WORD		wBufLen			// R}h̃obt@TCY
		);

	void CALLBACK CallbackNoticeproc(
		HPRINTER	hPrinter,		// v^̃nh
		DWORD		dwIPAddress,	// v^IPAhX
		WORD		wIfId,			// C^[tFCXID
		WORD		wCmdId,			// R}hID
		LPVOID		lpBuf,			// R}h̃obt@
		WORD		wBufLen			// R}h̃obt@TCY
		);

	/////////////////////////////////////////////////////////////////////////////
	// v^nhǗ
	void		AddPrinterHandle( HPRINTER hPrinter );
	HPRINTER	GetPrinterHandle();
	void		DeletePrinterHandle( HPRINTER hPrinter );
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_NPSCLIENTDLG_H__4EB478A1_B656_48FF_94CA_68E44030BCD9__INCLUDED_)
