// CmdBuffer.h: CCmdBuffer NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CMDBUFFER_H__704D364B_D91C_4D37_BFCA_E282F7217B37__INCLUDED_)
#define AFX_CMDBUFFER_H__704D364B_D91C_4D37_BFCA_E282F7217B37__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCmdBuffer  
{
public:
	CCmdBuffer();
	virtual ~CCmdBuffer();

	void Empty();

	int AddHeader( WORD wInterfaceId, WORD wCommandId );
	int AddTagChar ( WORD wTag, char nValue );
	int AddTagChar ( WORD wTag, char* pValue, int nCount );
	int AddTagShort( WORD wTag, short nValue );
	int AddTagShort( WORD wTag, short* pValue, int nCount );
	int AddTagLong ( WORD wTag, long nValue );
	int AddTagLong ( WORD wTag, long* pValue, int nCount );
	int AddTagFloat ( WORD wTag, FLOAT nValue );
	int AddTagFloat ( WORD wTag, FLOAT* pValue, int nCount );
	int AddTagFooter();

	LPBYTE GetBuffer();
	int GetBufferLen();

private:
	int		m_nBufferLen;
	BYTE	m_byBuffer[65535];
};

#endif // !defined(AFX_CMDBUFFER_H__704D364B_D91C_4D37_BFCA_E282F7217B37__INCLUDED_)
