// ServerUdpCmd.cpp: CServerUdpCmd NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "ServerUdpCmd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CServerUdpCmd::CServerUdpCmd()
{
	TRACE( "[%08X] CServerUdpCmd::CServerUdpCmd()\n", GetCurrentThreadId() );

	m_pServerSock=NULL;
}

CServerUdpCmd::~CServerUdpCmd()
{
	TRACE( "[%08X] CServerUdpCmd::~CServerUdpCmd()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerUdpCmd::ServerUdpCmdStart
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerUdpCmd::ServerUdpCmdStart()
{
	TRACE( "[%08X] CServerUdpCmd::ServerUdpCmdStart()\n", GetCurrentThreadId() );

	if (NULL != m_pServerSock)
	{
		TRACE( "T[o[\Pbg͊ɐς\n" );
		return;
	}

	m_pServerSock = new CWS2UdpCmd();
	BOOL bCreate = m_pServerSock->Create();
	if ( FALSE == bCreate )
	{
		TRACE( "T[o[\Pbg̐Ɏs\n" );
		return;
	}

	////////////////////////////////////////
	// T[o[IPAhX̎擾
	////////////////////////////////////////
	CString strIpAddress;
	CString	strInfoFile;
	strInfoFile = NkcComApi::MakeFullPath("NpsServer.ini");
	GetPrivateProfileString("Common",
							"IPAddress",
							"",
							strIpAddress.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);
	strIpAddress.ReleaseBuffer();
	strIpAddress.FreeExtra();

	////////////////////////////////////////
	// oCh
	////////////////////////////////////////
	BOOL bResult;
	if ( TRUE == strIpAddress.IsEmpty() )
	{
		bResult = m_pServerSock->Bind( SERVER_UDP_PORT );
	}
	else
	{
		bResult = m_pServerSock->Bind( SERVER_UDP_PORT, strIpAddress );
	}

	if ( FALSE == bResult )
	{
		CString str;
		str.Format( "Bind failed. [ %s : %d ]", strIpAddress, SERVER_UDP_PORT );
		::AfxMessageBox( str );
	}
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerUdpCmd::ServerUdpCmdEnd
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerUdpCmd::ServerUdpCmdEnd()
{
	TRACE( "[%08X] CServerUdpCmd::ServerUdpCmdEnd()\n", GetCurrentThreadId() );

	if(NULL == m_pServerSock){
		TRACE( "T[o[\Pbg͐Ă܂\n" );
		return;
	}

	// T[o[\Pbg̃N[Y
	m_pServerSock->Close();
	delete m_pServerSock;
	m_pServerSock = NULL;
}
