// WS2TcpCmd.h: CWS2TcpCmd NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WS2TCPCMD_H__80BBE70A_9A2F_4C72_9E27_8060C1C5280B__INCLUDED_)
#define AFX_WS2TCPCMD_H__80BBE70A_9A2F_4C72_9E27_8060C1C5280B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WS2Tcp.h"
#include "RecvNpsData.h"

class CWS2TcpCmd : public CWS2Tcp  
{
public:
	CWS2TcpCmd();
	virtual ~CWS2TcpCmd();

protected:
	virtual void OnReceive( int nErrorCode );	// Receive 󂯎Ƃ

private:
	void CmdAnalyze();
	// v^{̎擾
	BOOL RCmd_6000H_0100H();
	BOOL WCmd_6000H_0101H( USHORT nResult );
	// v^ݒ̎擾
	BOOL RCmd_6000H_0200H();
	BOOL WCmd_6000H_0201H( USHORT nResult );
	// v^Ԃ̎擾
	BOOL RCmd_6000H_0300H();
	BOOL WCmd_6000H_0301H( USHORT nResult );
	// y[p[̎擾
	BOOL RCmd_6000H_0400H();
	BOOL WCmd_6000H_0401H( USHORT nResult );
	// v^LJn
	BOOL RCmd_6000H_0500H();
	BOOL WCmd_6000H_0501H( USHORT nResult, USHORT nPossessionNo );
	// v^LI
	BOOL RCmd_6000H_0600H();
	BOOL WCmd_6000H_0601H( USHORT nResult, USHORT nPossessionNo );
	// tJn
	BOOL RCmd_6000H_0700H();
	BOOL WCmd_6000H_0701H( USHORT nResult, USHORT nPossessionNo, ULONG nReceiptNo );
	// 摜MmF
	BOOL RCmd_6000H_0800H();
	BOOL WCmd_6000H_0801H( USHORT nResult, USHORT nPossessionNo, ULONG nReceiptNo );
	// vg
	BOOL RCmd_6000H_0900H();
	BOOL WCmd_6000H_0901H( USHORT nResult, ULONG nReceiptNo );
	// v^Cxg
	BOOL RCmd_6000H_0A00H();
	BOOL WCmd_6000H_0A01H( USHORT nResult, ULONG nEventId, ULONG nEventCodeMain, ULONG nEventCodeSub );
	// gCύX
	BOOL RCmd_6000H_0B00H();
	BOOL WCmd_6000H_0B01H( USHORT nResult, USHORT nPossessionNo );
	// vg擾
	BOOL RCmd_6000H_0C00H();
	BOOL WCmd_6000H_0C01H( USHORT nResult );
	// vg~
	BOOL RCmd_6000H_0D00H();
	BOOL WCmd_6000H_0D01H( USHORT nResult );
	// ڑJn
	BOOL RCmd_6000H_0E00H();
	BOOL WCmd_6000H_0E01H( USHORT nResult );
	// uU[
	BOOL RCmd_6000H_0F00H();
	BOOL WCmd_6000H_0F01H( USHORT nResult );
	// \
	BOOL RCmd_6000H_1000H();
	BOOL WCmd_6000H_1001H( USHORT nResult );
	// vt@Cf[^擾
	BOOL RCmd_6000H_1100H();
	BOOL WCmd_6000H_1101H( USHORT nResult );
	// vgIvVݒ
	BOOL RCmd_6000H_1200H();
	BOOL WCmd_6000H_1201H( USHORT nResult, USHORT nPossessionNo );
	// Sy[p[̎擾
	BOOL RCmd_6000H_1300H();
	BOOL WCmd_6000H_1301H( USHORT nResult );
	// ڑmF
	BOOL RCmd_6000H_1500H();
	BOOL WCmd_6000H_1501H( USHORT nResult );
	// ʈJn
	BOOL RCmd_6000H_1600H();
	BOOL WCmd_6000H_1601H( USHORT nResult, USHORT nPossessionNo );
	// ʈI
	BOOL RCmd_6000H_1700H();
	BOOL WCmd_6000H_1701H( USHORT nResult, USHORT nPossessionNo );
	// 󔒃vg
	BOOL RCmd_6000H_1800H();
	BOOL WCmd_6000H_1801H( USHORT nResult, USHORT nPossessionNo, ULONG nReceiptNo );
	// I[_[
	BOOL RCmd_6000H_1900H();
	BOOL WCmd_6000H_1901H( USHORT nResult, USHORT nPossessionNo );
	// XV
	BOOL RCmd_6001H_0100H();
	BOOL WCmd_6001H_0101H( USHORT nResult, CString strDateTime );
	// v^_v擾
	BOOL RCmd_6001H_0200H();
	BOOL WCmd_6001H_0201H( USHORT nResult );
	// v^_vf[^擾
	BOOL RCmd_6001H_0300H();
	BOOL WCmd_6001H_0301H( USHORT nResult );
	// ^[Qbg擾
	BOOL RCmd_6001H_0700H();
	BOOL WCmd_6001H_0701H( USHORT nResult );
	// FADgpJn
	BOOL RCmd_6001H_0A00H();
	BOOL WCmd_6001H_0A01H( USHORT nResult, ULONG nFadResult, USHORT nPossessionNo, ULONG nDataGetPoint, USHORT nDataSize );
	// vgJn
	BOOL RCmd_6001H_0B00H();
	BOOL WCmd_6001H_0B01H( USHORT nResult );
	// đJn
	BOOL RCmd_6001H_0C00H();
	BOOL WCmd_6001H_0C01H( USHORT nResult, USHORT nPossessionNo );
	// đI
	BOOL RCmd_6001H_0D00H();
	BOOL WCmd_6001H_0D01H( USHORT nResult, USHORT nPossessionNo );
	// fLZ
	BOOL RCmd_6001H_0E00H();
	BOOL WCmd_6001H_0E01H( USHORT nResult );
	// o[WmF
	BOOL RCmd_6002H_7304H();
	BOOL WCmd_6002H_7305H( USHORT nResult );
	// NWbgݒ
	BOOL RCmd_6001H_B004H();
	BOOL WCmd_6001H_B005H( USHORT nResult );
	// NWbgJn
	BOOL RCmd_6001H_B006H();
	BOOL WCmd_6001H_B007H( USHORT nResult, USHORT nPossessionNo );
	// NWbgI
	BOOL RCmd_6001H_B008H();
	BOOL WCmd_6001H_B009H( USHORT nResult, USHORT nPossessionNo );
	// [hύXv
	BOOL RCmd_6002H_7300H();
	BOOL WCmd_6002H_7301H( USHORT nResult );
	// 엚擾
	BOOL RCmd_7003H_4001H();
	BOOL WCmd_7003H_4002H( USHORT nResult );
	// R}hT|[gʒm
	BOOL WCmd_6000H_FFFFH();

private:
	CRecvNpsData	m_objRecvNpsData;
};

#endif // !defined(AFX_WS2TCPCMD_H__80BBE70A_9A2F_4C72_9E27_8060C1C5280B__INCLUDED_)
