// WS2TcpImg.cpp: CWS2TcpImg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "WS2TcpImg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CWS2TcpImg::CWS2TcpImg()
{
	TRACE( "[%08X] CWS2TcpImg::CWS2TcpImg()\n", GetCurrentThreadId() );

	{	// M
		::ZeroMemory( m_byHeaderBuffer, sizeof(m_byHeaderBuffer) );
		m_wHeaderWritePoint = 0;
		m_wHeaderRemain = 8;
		m_dwImageRemain = 0;
		m_hFile = NULL;
	}
}

CWS2TcpImg::~CWS2TcpImg()
{
	TRACE( "[%08X] CWS2TcpImg::~CWS2TcpImg()\n", GetCurrentThreadId() );

	// Ǘ̈悩J
	::GetServerTcpImg()->RemoveServerSock( this );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpImg::OnReceive
//   ABSTRACT : I[o[Ch
//   FUNCTION : f[^M p
//	 UPDATE	  : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void CWS2TcpImg::OnReceive( int nErrorCode )
{
	CWS2Tcp::OnReceive( nErrorCode );

	//TRACE( "[%08X] CWS2TcpImg::OnReceive()\n", GetCurrentThreadId() );

	{	// M
		int nRecv;
		DWORD dwWork;
		DWORD dwByteWrite;
		CString strFileName;
		CString strFilePath;

		// R}hwb_̓ǂݍ
		while ( TRUE )
		{
			if ( 0 < m_wHeaderRemain ) {
				nRecv = Receive( &m_byHeaderBuffer[m_wHeaderWritePoint], m_wHeaderRemain );
				if ( 0 < nRecv ) {
					m_wHeaderWritePoint += nRecv;
					m_wHeaderRemain -= nRecv;

					if ( 0 == m_wHeaderRemain ) {
						memcpy( &dwWork, &m_byHeaderBuffer[4], sizeof(ULONG) );
						m_dwImageRemain = NkcComApi::ntohl( dwWork );
						{	// Oo
							CString str;
							str.Format( "RECV ====> [5000] [FFFF] RECV START ImageSize=%d", NkcComApi::ntohl( dwWork ) );
							NPS_LOGOUT( str );
						}

						// 摜t@C̃I[v
						if ( CFrame::WAITING == ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameStatus() ) {
							switch ( ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageFormat() )
							{
							case CFrame::JPEG:
								strFileName.Format( "Receive%d.jpg", ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() );
								break;
							case CFrame::BMP:
								strFileName.Format( "Receive%d.bmp", ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() );
								break;
							case CFrame::RGB24:
								strFileName.Format( "Receive%d.rgb", ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() );
								break;
							case CFrame::RGB48_H12_LSB:	// RGB48rbg J[_(12rbgL,LSB) 
								strFileName.Format( "Receive%d_RGB48_H12_LSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::RGB48_L12_LSB:	// RGB48rbg J[_(12rbgL,LSB)
								strFileName.Format( "Receive%d_RGB48_L12_LSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::BGR48_H12_LSB:	// BGR48rbg J[_(12rbgL,LSB)
								strFileName.Format( "Receive%d_BGR48_H12_LSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::BGR48_L12_LSB:	// BGR48rbg J[_(12rbgL,LSB)
								strFileName.Format( "Receive%d_BGR48_L12_LSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::RGB48_H12_MSB:	// RGB48rbg J[_(12rbgL,MSB)
								strFileName.Format( "Receive%d_RGB48_H12_MSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::RGB48_L12_MSB:	// RGB48rbg J[_(12rbgL,MSB)
								strFileName.Format( "Receive%d_RGB48_L12_MSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::BGR48_H12_MSB:	// BGR48rbg J[_(12rbgL,MSB)
								strFileName.Format( "Receive%d_BGR48_H12_MSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::BGR48_L12_MSB:	// BGR48rbg J[_(12rbgL,MSB)
								strFileName.Format( "Receive%d_BGR48_L12_MSB_W[%d]_H[%d].raw",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth(),
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight() );
								break;
							case CFrame::BMP_PATH:	// BMP (t@Cn)
								strFileName.Format( "Receive%d_FilePath.ini",
													::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() );
								break;
							case 0x64:	// ʐMx摜
							case 0x65:	// lbg[NȐff摜(CRC`FbNp)
								strFileName.Format( "Receive%d.dat", ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() );
								break;
							}
							strFilePath = NkcComApi::MakeFullPath( ::GetVirtualPrinter()->GetSpoolFolder(), strFileName );
							TRACE( "Image Recive Start (%s)\n", strFileName );
							::GetVirtualPrinter()->m_cPrintQue.SetReceivingFrameStatus( CFrame::RECEIVING );
							if ( 0 == ::GetVirtualPrinter()->m_cPrinterInfo.GetCreateSpoolFile() ) {
								m_hFile = ::CreateFile( strFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
							} else {
								m_hFile = INVALID_HANDLE_VALUE;
							}
						}
					}
				} else {
					//TRACE( "Err Receive\n" );
					return;
				}
			} else {
				break;
			}
		}

		while ( TRUE )
		{
			if ( 0 < m_dwImageRemain ) {
				nRecv = Receive( m_ByImageBuffer, min( m_dwImageRemain, sizeof(m_ByImageBuffer) ) );
				if ( 0 < nRecv ) {
					m_dwImageRemain -= nRecv;
					::GetVirtualPrinter()->m_cPrintQue.SetReceivingFrameImageReceivSize( m_dwImageRemain );
					if ( NULL != m_hFile ) {
						if ( INVALID_HANDLE_VALUE != m_hFile ) {
							::WriteFile( m_hFile, m_ByImageBuffer, nRecv, &dwByteWrite, NULL );
						}
					}
				} else {
					//TRACE( "Err Receive\n" );
					return;
				}
			} else {
				{	// Oo
					CString str;
					str.Format( "RECV ====> [5000] [FFFF] RECV END");
					NPS_LOGOUT( str );
				}
				// 摜t@C̃N[Y
				if ( NULL != m_hFile ) {
					if ( INVALID_HANDLE_VALUE != m_hFile ) {
						::CloseHandle(m_hFile);
						m_hFile = NULL;
					}
					TRACE( "Image Recive End\n" );
					::GetVirtualPrinter()->m_cPrintQue.SetReceivingFrameStatus( CFrame::RECEIVED );
				}

				// Raw => BMP ϊ
				if ( CFrame::RGB24 == ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageFormat() ) {
					if ( 0 == ::GetVirtualPrinter()->m_cPrinterInfo.GetCreateSpoolFile() ) {
						RawToBmp();
					}
				}

				// ϐ̏
				::ZeroMemory( m_byHeaderBuffer, sizeof(m_byHeaderBuffer) );
				m_wHeaderWritePoint = 0;
				m_wHeaderRemain = 8;
				m_dwImageRemain = 0;
				m_hFile = NULL;
				break;
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpImg::RawToBmp
//   ABSTRACT : 摜ϊ
//   FUNCTION :
//	 UPDATE	  : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
#define BFT_BITMAP	0x4d42   // 'BM'
#define WIDTHBYTES(bits)	(((bits) + 31) / 32 * 4)
void CWS2TcpImg::RawToBmp()
{
	int nline;
	int nPoint;
	BYTE rb;
	DWORD dwWidth;
	DWORD dwHeight;
	DWORD dwLineWidth;
	DWORD dwByteRead;
	DWORD dwByteWrite;
	HANDLE hFileRaw;
	HANDLE hFileBmp;
	CString strRawFileName;
	CString strRawFilePath;
	CString strBmpFileName;
	CString strBmpFilePath;
	BITMAPFILEHEADER hdr;		// rbg}bvt@C̃wb_[
	BITMAPINFOHEADER bi;		// rbg}bṽwb_[
	LPBYTE pBuffer;
	BOOL bResult=FALSE;

	::ZeroMemory( &hdr, sizeof(BITMAPFILEHEADER) );
	::ZeroMemory( &bi,  sizeof(BITMAPINFOHEADER) );

	dwWidth = ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageWidth();
	dwHeight = ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageHeight();

	dwLineWidth = WIDTHBYTES(24 * dwWidth);
	// BITMAPINFOHEADER \̂̏
	bi.biSize = sizeof(BITMAPINFOHEADER);
	bi.biWidth = dwWidth;
	bi.biHeight = dwHeight;
	bi.biPlanes = 1;
	bi.biBitCount = 24;
	bi.biCompression = BI_RGB;
	bi.biSizeImage = dwLineWidth * dwHeight;
	bi.biXPelsPerMeter = 0;
	bi.biYPelsPerMeter = 0;
	bi.biClrUsed = 0;
	bi.biClrImportant = 0;

	// BITMAPFILEHEADER \̂̏
	hdr.bfType = BFT_BITMAP;
	hdr.bfSize = sizeof(hdr) + bi.biSize + bi.biSizeImage;
	hdr.bfReserved1 = 0;
	hdr.bfReserved2 = 0;
	hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER)+ bi.biSize;

	strRawFileName.Format( "Receive%d.rgb", ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() );
	strRawFilePath = NkcComApi::MakeFullPath( ::GetVirtualPrinter()->GetSpoolFolder(), strRawFileName );
	strBmpFileName.Format( "Receive%d.bmp", ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() );
	strBmpFilePath = NkcComApi::MakeFullPath( ::GetVirtualPrinter()->GetSpoolFolder(), strBmpFileName );

	hFileRaw = ::CreateFile( strRawFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if ( INVALID_HANDLE_VALUE != hFileRaw ) {

		if ( ::GetFileSize( hFileRaw, NULL ) == ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameImageCapacity() ) {

			hFileBmp = ::CreateFile( strBmpFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
			if ( INVALID_HANDLE_VALUE != hFileBmp ) {

				// BMP Header
				::WriteFile( hFileBmp, &hdr, sizeof(hdr), &dwByteWrite, NULL );
				::WriteFile( hFileBmp, &bi, sizeof(bi), &dwByteWrite, NULL );

				// f[^ϊ
				pBuffer = new BYTE[dwLineWidth];
				::ZeroMemory( pBuffer, dwLineWidth );
				for ( nline=0 ; dwHeight > (DWORD)nline ; nline++ )
				{
					if ( 0xFFFFFFFF != SetFilePointer( hFileRaw, ((dwHeight-nline-1)*(dwWidth*3)), NULL, FILE_BEGIN ) ) {
						::ReadFile( hFileRaw, pBuffer, dwWidth*3, &dwByteRead, NULL );
						if ( dwByteRead == dwWidth*3 ) {
							for ( nPoint=0 ; dwWidth > (DWORD)nPoint ; nPoint++ )
							{	// RGB -> BGR ϊ
								rb	= *(pBuffer+(nPoint*3)+0);
								*(pBuffer+(nPoint*3)+0) = *(pBuffer+(nPoint*3)+2);
								*(pBuffer+(nPoint*3)+2) = rb;
							}
							::WriteFile( hFileBmp, pBuffer, dwLineWidth, &dwByteWrite, NULL );
						}
						::ZeroMemory( pBuffer, dwLineWidth );
					}
				}
				delete pBuffer;

				::CloseHandle(hFileBmp);

				bResult = TRUE;

			}

		}

		::CloseHandle(hFileRaw);

	}

	// ϊȂÃt@C(RAW)폜
	if ( TRUE == bResult ) {
		::DeleteFile( strRawFilePath );
	}
}
