//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : Dib24.h
//	ABSTRACT  : DIB ̃x[Xi24BitjNX
//	
//	CREATE    : Y.Yoshinobu	2004.1.5
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
// Dib24.h: CDib24 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIBBASE_H__49177BF9_44EF_41BA_935D_1B54FC8D8E8D__INCLUDED_)
#define AFX_DIBBASE_H__49177BF9_44EF_41BA_935D_1B54FC8D8E8D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define HBMP		HANDLE
#define HDIB		HANDLE
#define WIDTHBYTES(bits)	(((bits) + 31) / 32 * 4)
#define BFT_BITMAP	0x4d42   // 'BM'

class CDib24  
{
public:

	// \z/
	CDib24();
	virtual ~CDib24();

	// 쐬
	virtual BOOL Create( const DWORD dwWidth, const DWORD dwHeight, const DWORD dwResolution = 3000 );

	// 摜擾
	DWORD GetWidth();
	DWORD GetHeight();

	// FILE I/O
	BOOL WriteBMP( LPCTSTR lpFileName );

	// `摀
	BOOL FrameArea( const LPRECT lpRect, const COLORREF tColor, const int nWidth = 1 );
	BOOL FillRect( const LPRECT lpRect, const COLORREF tColor );
	BOOL TextArea( const LPRECT lpRect, LPCTSTR lpString, const int nFontHeight, const int nFontWeight, const BOOL bFontItalic, LPCTSTR lpFacename, const COLORREF tColor, const UINT nFormat );
	BOOL ScaleHorizontalArea( const LPRECT lpRect, const DWORD dwResolution, const COLORREF tColor );
	BOOL ScaleVerticalArea( const LPRECT lpRect, const DWORD dwResolution, const COLORREF tColor );

protected:

	// 
	void Initialize();

protected:

	HDC			m_hMemoryDC;
	BITMAPINFO	m_tBmpInfo;
	HBITMAP		m_hBitmap;
	HBITMAP		m_hBitmapOrg;
	LPBYTE		m_lpBits;
	DWORD		m_dwWidth;
	DWORD		m_dwHeight;
	DWORD		m_dwResolution;
};

#endif // !defined(AFX_DIBBASE_H__49177BF9_44EF_41BA_935D_1B54FC8D8E8D__INCLUDED_)
